from epyk.core.html.options import Options
from typing import Any

        
class OptionSeriesXrangeZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesXrangeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesXrangeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{point.x} - {point.x2}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}: <b>{point.yCategory}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesXrangeStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesXrangeStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesXrangeStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesXrangeStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesXrangeStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesXrangeStatesSelectMarker)

        
class OptionSeriesXrangeStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesXrangeStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesXrangeStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeStates(Options):

    @property
    def hover(self) -> 'OptionSeriesXrangeStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesXrangeStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesXrangeStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesXrangeStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesXrangeStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesXrangeStatesNormal)

    @property
    def select(self) -> 'OptionSeriesXrangeStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesXrangeStatesSelect)

        
class OptionSeriesXrangeStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesXrangeStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesXrangeStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesXrangeStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesXrangeStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesXrangeStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesXrangeStatesHoverMarker)

        
class OptionSeriesXrangeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesXrangeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesXrangeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesXrangeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesXrangeSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesXrangeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesXrangeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesXrangeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesXrangeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesXrangeSonificationTracksMappingLowpassResonance)

        
class OptionSeriesXrangeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesXrangeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesXrangeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesXrangeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesXrangeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesXrangeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesXrangeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesXrangeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesXrangeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesXrangeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesXrangeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesXrangeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesXrangeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesXrangeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesXrangeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesXrangeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesXrangeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesXrangeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesXrangeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesXrangeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesXrangeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesXrangeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesXrangeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesXrangeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesXrangeSonificationTracksMappingVolume)

        
class OptionSeriesXrangeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesXrangeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesXrangeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesXrangeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesXrangeSonificationTracksMappingHighpassResonance)

        
class OptionSeriesXrangeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesXrangeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesXrangeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesXrangeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesXrangeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesXrangeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesXrangeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesXrangeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesXrangeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesXrangeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesXrangeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesXrangeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesXrangeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesXrangeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesXrangeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesXrangeSonificationTracks)

        
class OptionSeriesXrangeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesXrangeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesXrangeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesXrangeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesXrangeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesXrangeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesXrangeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesXrangeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesXrangeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesXrangeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesXrangeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesXrangeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesXrangeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesXrangeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesXrangeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesXrangeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesXrangeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesXrangeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesXrangeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesXrangeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesXrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesXrangeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesXrangeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesXrangeSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesXrangeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesXrangeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesXrangeSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesXrangeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesXrangeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesXrangeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesXrangeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesXrangeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesXrangeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesXrangeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesXrangeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesXrangeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesXrangeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesXrangeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesXrangeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesXrangeSonificationContexttracksMappingVolume)

        
class OptionSeriesXrangeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesXrangeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesXrangeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesXrangeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesXrangeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesXrangeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesXrangeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesXrangeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesXrangeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesXrangeSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesXrangePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangePoint(Options):

    @property
    def events(self) -> 'OptionSeriesXrangePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesXrangePointEvents)

        
class OptionSeriesXrangePartialfill(Options):

    @property
    def fill(self):
        """The fill color to be used for partial fills.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(None)

    @fill.setter
    def fill(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesXrangeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesXrangeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesXrangeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesXrangeOnpointPosition)

        
class OptionSeriesXrangeMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesXrangeMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesXrangeMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesXrangeMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesXrangeMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesXrangeMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesXrangeMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesXrangeMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesXrangeMarkerStatesSelect)

        
class OptionSeriesXrangeMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesXrangeMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesXrangeMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesXrangeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesXrangeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesXrangeDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesXrangeDataDragdropGuideboxDefault)

        
class OptionSeriesXrangeDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesXrangeDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesXrangeDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesXrangeDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesXrangeDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrangeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesXrangeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesXrangeDragdropGuideboxDefault)

        
class OptionSeriesXrangeDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX1(self):
        """Allow x value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableX1.setter
    def draggableX1(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX2(self):
        """Allow x2 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableX2.setter
    def draggableX2(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesXrangeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesXrangeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesXrangeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesXrangeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesXrange(Options):

    @property
    def accessibility(self) -> 'OptionSeriesXrangeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesXrangeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """In an X-range series, this option makes all points of the same Y-axis category the same color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesXrangeData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesXrangeData)

    @property
    def dataLabels(self) -> 'OptionSeriesXrangeDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesXrangeDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesXrangeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesXrangeDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesXrangeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesXrangeEvents)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesXrangeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesXrangeLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesXrangeMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesXrangeMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesXrangeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesXrangeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def partialFill(self) -> 'OptionSeriesXrangePartialfill':
        """A partial fill for each point, typically used to visualize how much of a task is performed. """
        return self._config_sub_data("partialFill", OptionSeriesXrangePartialfill)

    @property
    def point(self) -> 'OptionSeriesXrangePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesXrangePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesXrangeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesXrangeSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesXrangeStates':
        """. """
        return self._config_sub_data("states", OptionSeriesXrangeStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesXrangeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesXrangeTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesXrangeZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesXrangeZones)

        
class OptionSeriesXrangeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesXrangeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesXrangeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesXrangeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesXrangeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesXrangeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesXrangeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDataPartialfill(Options):

    @property
    def amount(self):
        """The amount of the X-range point to be filled.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(None)

    @amount.setter
    def amount(self, num: float): self._config(num, js_type=False)

    @property
    def fill(self):
        """The fill color to be used for partial fills.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(None)

    @fill.setter
    def fill(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesXrangeDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesXrangeDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesXrangeDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesXrangeDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesXrangeDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesXrangeDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesXrangeDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesXrangeDataMarkerStatesSelect)

        
class OptionSeriesXrangeDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesXrangeDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesXrangeDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesXrangeDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesXrangeDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesXrangeDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesXrangeDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesXrangeDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesXrangeDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesXrangeDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesXrangeDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesXrangeDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesXrangeDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def partialFill(self) -> 'OptionSeriesXrangeDataPartialfill':
        """A partial fill for each point, typically used to visualize how much of a task is performed. """
        return self._config_sub_data("partialFill", OptionSeriesXrangeDataPartialfill)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The starting X value of the range point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def x2(self):
        """The ending X value of the range point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(None)

    @x2.setter
    def x2(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The Y value of the range point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/XRange/XRangeSeriesDefaults.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesXrangeDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesXrangeDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesXrangeDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesXrangeDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesXrangeDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesXrangeDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesXrangeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesXrangeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesXrangeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesXrangeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesXrangeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesXrangeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesXrangeAccessibilityPoint)

        
class OptionSeriesWordcloudZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesWordcloudTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesWordcloudTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}: <b>{point.weight}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesWordcloudStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesWordcloudStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesWordcloudStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesWordcloudStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWordcloudStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesWordcloudStatesSelectMarker)

        
class OptionSeriesWordcloudStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWordcloudStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesWordcloudStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesWordcloudStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudStates(Options):

    @property
    def hover(self) -> 'OptionSeriesWordcloudStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesWordcloudStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesWordcloudStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesWordcloudStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesWordcloudStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesWordcloudStatesNormal)

    @property
    def select(self) -> 'OptionSeriesWordcloudStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesWordcloudStatesSelect)

        
class OptionSeriesWordcloudStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesWordcloudStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesWordcloudStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesWordcloudStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesWordcloudStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWordcloudStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesWordcloudStatesHoverMarker)

        
class OptionSeriesWordcloudSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesWordcloudSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesWordcloudSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesWordcloudSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesWordcloudSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesWordcloudSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWordcloudSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWordcloudSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWordcloudSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWordcloudSonificationTracksMappingLowpassResonance)

        
class OptionSeriesWordcloudSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesWordcloudSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesWordcloudSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesWordcloudSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesWordcloudSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesWordcloudSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesWordcloudSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesWordcloudSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesWordcloudSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesWordcloudSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesWordcloudSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesWordcloudSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesWordcloudSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesWordcloudSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesWordcloudSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWordcloudSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWordcloudSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesWordcloudSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesWordcloudSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesWordcloudSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWordcloudSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesWordcloudSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesWordcloudSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesWordcloudSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesWordcloudSonificationTracksMappingVolume)

        
class OptionSeriesWordcloudSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWordcloudSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWordcloudSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWordcloudSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWordcloudSonificationTracksMappingHighpassResonance)

        
class OptionSeriesWordcloudSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWordcloudSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWordcloudSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWordcloudSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWordcloudSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWordcloudSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWordcloudSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesWordcloudSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesWordcloudSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesWordcloudSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesWordcloudSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesWordcloudSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWordcloudSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesWordcloudSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesWordcloudSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesWordcloudSonificationTracks)

        
class OptionSeriesWordcloudSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesWordcloudSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesWordcloudSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWordcloudSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWordcloudSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWordcloudSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWordcloudSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesWordcloudSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWordcloudSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWordcloudSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesWordcloudSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesWordcloudSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesWordcloudSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesWordcloudSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWordcloudSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWordcloudSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesWordcloudSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesWordcloudSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesWordcloudSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesWordcloudSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesWordcloudSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesWordcloudSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesWordcloudSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesWordcloudSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWordcloudSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesWordcloudSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWordcloudSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesWordcloudSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesWordcloudSonificationContexttracksMappingVolume)

        
class OptionSeriesWordcloudSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWordcloudSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWordcloudSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWordcloudSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWordcloudSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWordcloudSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWordcloudSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWordcloudSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWordcloudSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWordcloudSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesWordcloudRotation(Options):

    @property
    def from_(self):
        """The smallest degree of rotation for a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(0)

    @from_.setter
    def from_(self, num: float): self._config(num, js_type=False)

    @property
    def orientations(self):
        """The number of possible orientations for a word, within the range of <code>rotation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(2)

    @orientations.setter
    def orientations(self, num: float): self._config(num, js_type=False)

    @property
    def to(self):
        """The largest degree of rotation for a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(90)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudPoint(Options):

    @property
    def events(self) -> 'OptionSeriesWordcloudPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesWordcloudPointEvents)

        
class OptionSeriesWordcloudOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesWordcloudOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesWordcloudOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesWordcloudOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesWordcloudOnpointPosition)

        
class OptionSeriesWordcloudMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWordcloudMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesWordcloudMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesWordcloudMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesWordcloudMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesWordcloudMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesWordcloudMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesWordcloudMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesWordcloudMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesWordcloudMarkerStatesSelect)

        
class OptionSeriesWordcloudMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesWordcloudMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesWordcloudMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesWordcloudLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesWordcloudLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWordcloudDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWordcloudDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesWordcloudDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesWordcloudDataDragdropGuideboxDefault)

        
class OptionSeriesWordcloudDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesWordcloudDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesWordcloudDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesWordcloudDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesWordcloudDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWordcloudDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloudAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(500)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesWordcloudDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesWordcloudDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesWordcloudDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesWordcloudDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesWordcloudDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesWordcloudDataDragdrop)

    @property
    def events(self) -> 'OptionSeriesWordcloudDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesWordcloudDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name decides the text for a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def weight(self):
        """The weighting of a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(None)

    @weight.setter
    def weight(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesWordcloudDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesWordcloudDragdropGuideboxDefault)

        
class OptionSeriesWordcloudDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesWordcloudDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesWordcloudDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesWordcloudDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesWordcloudDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWordcloudEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWordcloud(Options):

    @property
    def accessibility(self) -> 'OptionSeriesWordcloudAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesWordcloudAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesWordcloudAnimation':
        """Enable or disable the initial animation when a series is displayed. """
        return self._config_sub_data("animation", OptionSeriesWordcloudAnimation)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesWordcloudData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesWordcloudData)

    @property
    def dataLabels(self) -> 'OptionSeriesWordcloudDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesWordcloudDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesWordcloudDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesWordcloudDragdrop)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesWordcloudEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesWordcloudEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesWordcloudLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesWordcloudLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWordcloudMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesWordcloudMarker)

    @property
    def maxFontSize(self):
        """The word with the largest weight will have a font size equal to this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(25)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """A threshold determining the minimum font size that can be applied to a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(1)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesWordcloudOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesWordcloudOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def placementStrategy(self):
        """This option decides which algorithm is used for placement, and rotation of a word.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get("center")

    @placementStrategy.setter
    def placementStrategy(self, text: str): self._config(text, js_type=False)

    @property
    def point(self) -> 'OptionSeriesWordcloudPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesWordcloudPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rotation(self) -> 'OptionSeriesWordcloudRotation':
        """Rotation options for the words in the wordcloud. """
        return self._config_sub_data("rotation", OptionSeriesWordcloudRotation)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesWordcloudSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesWordcloudSonification)

    @property
    def spiral(self):
        """Spiral used for placing a word after the initial position experienced a collision with either another word or the borders.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get("rectangular")

    @spiral.setter
    def spiral(self, text: str): self._config(text, js_type=False)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesWordcloudStates':
        """. """
        return self._config_sub_data("states", OptionSeriesWordcloudStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """CSS styles for the words.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Wordcloud/WordcloudSeriesDefaults.ts
        """
        return self._config_get({"fontFamily":"sans-serif", "fontWeight": "900"})

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesWordcloudTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesWordcloudTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesWordcloudZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesWordcloudZones)

        
class OptionSeriesWordcloudDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWordcloudDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesWordcloudDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesWordcloudDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesWordcloudDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesWordcloudDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesWordcloudDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesWordcloudDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWordcloudDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesWordcloudDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesWordcloudDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesWordcloudDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesWordcloudDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesWordcloudDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesWordcloudDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWordcloudAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWordcloudAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWordcloudAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesWordcloudAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesWordcloudAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesWordcloudAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesWordcloudAccessibilityPoint)

        
class OptionSeriesWindbarbZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesWindbarbTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesWindbarbTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The default point format for the wind barb tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}: <b>{point.value}</b> ({point.beaufort})<br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesWindbarbStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesWindbarbStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesWindbarbStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesWindbarbStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWindbarbStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesWindbarbStatesSelectMarker)

        
class OptionSeriesWindbarbStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesWindbarbStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesWindbarbStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbStates(Options):

    @property
    def hover(self) -> 'OptionSeriesWindbarbStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesWindbarbStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesWindbarbStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesWindbarbStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesWindbarbStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesWindbarbStatesNormal)

    @property
    def select(self) -> 'OptionSeriesWindbarbStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesWindbarbStatesSelect)

        
class OptionSeriesWindbarbStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesWindbarbStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesWindbarbStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesWindbarbStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesWindbarbStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWindbarbStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesWindbarbStatesHoverMarker)

        
class OptionSeriesWindbarbSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesWindbarbSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesWindbarbSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesWindbarbSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesWindbarbSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesWindbarbSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWindbarbSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWindbarbSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWindbarbSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWindbarbSonificationTracksMappingLowpassResonance)

        
class OptionSeriesWindbarbSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesWindbarbSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesWindbarbSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesWindbarbSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesWindbarbSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesWindbarbSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesWindbarbSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesWindbarbSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesWindbarbSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesWindbarbSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesWindbarbSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesWindbarbSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesWindbarbSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesWindbarbSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesWindbarbSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWindbarbSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWindbarbSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesWindbarbSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesWindbarbSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesWindbarbSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWindbarbSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesWindbarbSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesWindbarbSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesWindbarbSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesWindbarbSonificationTracksMappingVolume)

        
class OptionSeriesWindbarbSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWindbarbSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWindbarbSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWindbarbSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWindbarbSonificationTracksMappingHighpassResonance)

        
class OptionSeriesWindbarbSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWindbarbSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWindbarbSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWindbarbSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWindbarbSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWindbarbSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWindbarbSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesWindbarbSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesWindbarbSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesWindbarbSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesWindbarbSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesWindbarbSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWindbarbSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesWindbarbSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesWindbarbSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesWindbarbSonificationTracks)

        
class OptionSeriesWindbarbSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesWindbarbSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesWindbarbSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWindbarbSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWindbarbSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWindbarbSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWindbarbSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesWindbarbSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWindbarbSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWindbarbSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesWindbarbSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesWindbarbSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesWindbarbSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesWindbarbSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWindbarbSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWindbarbSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesWindbarbSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesWindbarbSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesWindbarbSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesWindbarbSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesWindbarbSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesWindbarbSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesWindbarbSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesWindbarbSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWindbarbSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesWindbarbSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWindbarbSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesWindbarbSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesWindbarbSonificationContexttracksMappingVolume)

        
class OptionSeriesWindbarbSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWindbarbSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWindbarbSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWindbarbSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWindbarbSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWindbarbSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWindbarbSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWindbarbSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWindbarbSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWindbarbSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesWindbarbPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbPoint(Options):

    @property
    def events(self) -> 'OptionSeriesWindbarbPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesWindbarbPointEvents)

        
class OptionSeriesWindbarbOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesWindbarbOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesWindbarbOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesWindbarbOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesWindbarbOnpointPosition)

        
class OptionSeriesWindbarbMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesWindbarbMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesWindbarbMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesWindbarbMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesWindbarbMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesWindbarbMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesWindbarbMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesWindbarbMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesWindbarbMarkerStatesSelect)

        
class OptionSeriesWindbarbMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesWindbarbMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesWindbarbMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesWindbarbLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesWindbarbLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesWindbarbDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesWindbarbDataDragdropGuideboxDefault)

        
class OptionSeriesWindbarbDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesWindbarbDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesWindbarbDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesWindbarbDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesWindbarbDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbDatagrouping(Options):

    @property
    def anchor(self):
        """Specifies how the points should be located on the X axis inside the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(start)

    @anchor.setter
    def anchor(self, value: Any): self._config(value, js_type=False)

    @property
    def approximation(self):
        """Approximation function for the data grouping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get("windbarb")

    @approximation.setter
    def approximation(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self):
        """Datetime formats for the header of the tooltip in a stock chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(None)

    @dateTimeLabelFormats.setter
    def dateTimeLabelFormats(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Whether to enable data grouping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def firstAnchor(self):
        """Specifies how the first grouped point is positioned on the xAxis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(start)

    @firstAnchor.setter
    def firstAnchor(self, value: Any): self._config(value, js_type=False)

    @property
    def forced(self):
        """When data grouping is forced, it runs no matter how small the intervals are.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(False)

    @forced.setter
    def forced(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupAll(self):
        """By default only points within the visible range are grouped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(False)

    @groupAll.setter
    def groupAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPixelWidth(self):
        """The approximate data group width.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(30)

    @groupPixelWidth.setter
    def groupPixelWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lastAnchor(self):
        """Specifies how the last grouped point is positioned on the xAxis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(start)

    @lastAnchor.setter
    def lastAnchor(self, value: Any): self._config(value, js_type=False)

    @property
    def smoothed(self):
        """Normally, a group is indexed by the start of that group, so for example when 30 daily values are grouped into one month, that month&#39;s x value will be the 1st of the month.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(False)

    @smoothed.setter
    def smoothed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def units(self):
        """An array determining what time intervals the data is allowed to be grouped to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DataGrouping/DataGrouping.ts
        """
        return self._config_get(None)

    @units.setter
    def units(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarbDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesWindbarbDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesWindbarbDragdropGuideboxDefault)

        
class OptionSeriesWindbarbDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesWindbarbDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesWindbarbDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesWindbarbDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesWindbarbDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWindbarb(Options):

    @property
    def accessibility(self) -> 'OptionSeriesWindbarbAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesWindbarbAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get("value")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesWindbarbData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesWindbarbData)

    @property
    def dataGrouping(self) -> 'OptionSeriesWindbarbDatagrouping':
        """Data grouping options for the wind barbs. """
        return self._config_sub_data("dataGrouping", OptionSeriesWindbarbDatagrouping)

    @property
    def dataLabels(self) -> 'OptionSeriesWindbarbDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesWindbarbDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesWindbarbDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesWindbarbDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesWindbarbDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesWindbarbDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesWindbarbEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesWindbarbEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesWindbarbLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesWindbarbLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The line width of the wind barb symbols.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWindbarbMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesWindbarbMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesWindbarbOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesWindbarbOnpoint)

    @property
    def onSeries(self):
        """The id of another series in the chart that the wind barbs are projected on.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(None)

    @onSeries.setter
    def onSeries(self, text: str): self._config(text, js_type=False)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesWindbarbPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesWindbarbPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesWindbarbSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesWindbarbSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesWindbarbStates':
        """. """
        return self._config_sub_data("states", OptionSeriesWindbarbStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesWindbarbTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesWindbarbTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def vectorLength(self):
        """Pixel length of the stems.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(20)

    @vectorLength.setter
    def vectorLength(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def xOffset(self):
        """Horizontal offset from the cartesian position, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(0)

    @xOffset.setter
    def xOffset(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yOffset(self):
        """Vertical offset from the cartesian position, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(-20)

    @yOffset.setter
    def yOffset(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesWindbarbZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesWindbarbZones)

        
class OptionSeriesWindbarbDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesWindbarbDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesWindbarbDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesWindbarbDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesWindbarbDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesWindbarbDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesWindbarbDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesWindbarbDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesWindbarbDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesWindbarbDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesWindbarbDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesWindbarbDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesWindbarbDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesWindbarbDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesWindbarbDataMarkerStatesSelect)

        
class OptionSeriesWindbarbDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesWindbarbDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesWindbarbDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesWindbarbDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesWindbarbDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesWindbarbDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesWindbarbDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def direction(self):
        """The wind direction in degrees, where 0 is north (pointing towards south).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Windbarb/WindbarbSeriesDefaults.ts
        """
        return self._config_get(None)

    @direction.setter
    def direction(self, num: float): self._config(num, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesWindbarbDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesWindbarbDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesWindbarbDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesWindbarbDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWindbarbDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesWindbarbDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesWindbarbDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesWindbarbDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesWindbarbDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesWindbarbDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesWindbarbDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesWindbarbDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWindbarbAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWindbarbAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWindbarbAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesWindbarbAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesWindbarbAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesWindbarbAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesWindbarbAccessibilityPoint)

        
class OptionSeriesWaterfallZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesWaterfallTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesWaterfallTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesWaterfallStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesWaterfallStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesWaterfallStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesWaterfallStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWaterfallStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesWaterfallStatesSelectMarker)

        
class OptionSeriesWaterfallStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWaterfallStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesWaterfallStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesWaterfallStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallStates(Options):

    @property
    def hover(self) -> 'OptionSeriesWaterfallStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesWaterfallStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesWaterfallStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesWaterfallStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesWaterfallStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesWaterfallStatesNormal)

    @property
    def select(self) -> 'OptionSeriesWaterfallStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesWaterfallStatesSelect)

        
class OptionSeriesWaterfallStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesWaterfallStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesWaterfallStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesWaterfallStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesWaterfallStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWaterfallStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesWaterfallStatesHoverMarker)

        
class OptionSeriesWaterfallSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesWaterfallSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesWaterfallSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesWaterfallSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesWaterfallSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesWaterfallSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWaterfallSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWaterfallSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWaterfallSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWaterfallSonificationTracksMappingLowpassResonance)

        
class OptionSeriesWaterfallSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesWaterfallSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesWaterfallSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesWaterfallSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesWaterfallSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesWaterfallSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesWaterfallSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesWaterfallSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesWaterfallSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesWaterfallSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesWaterfallSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesWaterfallSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesWaterfallSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesWaterfallSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesWaterfallSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWaterfallSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWaterfallSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesWaterfallSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesWaterfallSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesWaterfallSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWaterfallSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesWaterfallSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesWaterfallSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesWaterfallSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesWaterfallSonificationTracksMappingVolume)

        
class OptionSeriesWaterfallSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWaterfallSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWaterfallSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWaterfallSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWaterfallSonificationTracksMappingHighpassResonance)

        
class OptionSeriesWaterfallSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWaterfallSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWaterfallSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWaterfallSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWaterfallSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWaterfallSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWaterfallSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesWaterfallSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesWaterfallSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesWaterfallSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesWaterfallSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesWaterfallSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWaterfallSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesWaterfallSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesWaterfallSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesWaterfallSonificationTracks)

        
class OptionSeriesWaterfallSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesWaterfallSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesWaterfallSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWaterfallSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWaterfallSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWaterfallSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWaterfallSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesWaterfallSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWaterfallSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWaterfallSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesWaterfallSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesWaterfallSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesWaterfallSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesWaterfallSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWaterfallSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWaterfallSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesWaterfallSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesWaterfallSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesWaterfallSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesWaterfallSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesWaterfallSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesWaterfallSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesWaterfallSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesWaterfallSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesWaterfallSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesWaterfallSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesWaterfallSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesWaterfallSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesWaterfallSonificationContexttracksMappingVolume)

        
class OptionSeriesWaterfallSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesWaterfallSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesWaterfallSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesWaterfallSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesWaterfallSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesWaterfallSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesWaterfallSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesWaterfallSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesWaterfallSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesWaterfallSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesWaterfallPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallPoint(Options):

    @property
    def events(self) -> 'OptionSeriesWaterfallPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesWaterfallPointEvents)

        
class OptionSeriesWaterfallOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesWaterfallOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesWaterfallOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesWaterfallOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesWaterfallOnpointPosition)

        
class OptionSeriesWaterfallMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWaterfallMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesWaterfallMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesWaterfallMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesWaterfallMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesWaterfallMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesWaterfallMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesWaterfallMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesWaterfallMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesWaterfallMarkerStatesSelect)

        
class OptionSeriesWaterfallMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesWaterfallMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesWaterfallMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesWaterfallLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesWaterfallLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWaterfallDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWaterfallDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesWaterfallDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesWaterfallDataDragdropGuideboxDefault)

        
class OptionSeriesWaterfallDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesWaterfallDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesWaterfallDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesWaterfallDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesWaterfallDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWaterfallDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfallDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesWaterfallDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesWaterfallDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesWaterfallDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesWaterfallDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesWaterfallDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesWaterfallDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesWaterfallDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesWaterfallDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def isIntermediateSum(self):
        """When this property is true, the points acts as a summary column for the values added or substracted since the last intermediate sum, or since the start of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(False)

    @isIntermediateSum.setter
    def isIntermediateSum(self, flag: bool): self._config(flag, js_type=False)

    @property
    def isSum(self):
        """When this property is true, the point display the total sum across the entire series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(False)

    @isSum.setter
    def isSum(self, flag: bool): self._config(flag, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesWaterfallDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesWaterfallDragdropGuideboxDefault)

        
class OptionSeriesWaterfallDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesWaterfallDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesWaterfallDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesWaterfallDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesWaterfallDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWaterfallEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesWaterfall(Options):

    @property
    def accessibility(self) -> 'OptionSeriesWaterfallAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesWaterfallAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border of each waterfall column.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get("#333333")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the line connecting the columns of the waterfall series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get("Dot")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesWaterfallData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesWaterfallData)

    @property
    def dataLabels(self) -> 'OptionSeriesWaterfallDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesWaterfallDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesWaterfallDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesWaterfallDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesWaterfallDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesWaterfallDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesWaterfallEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesWaterfallEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesWaterfallLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesWaterfallLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """The color of the line that connects columns in a waterfall series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get("#333333")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting waterfall columns.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesWaterfallMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesWaterfallMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesWaterfallOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesWaterfallOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesWaterfallPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesWaterfallPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesWaterfallSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesWaterfallSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesWaterfallStates':
        """. """
        return self._config_sub_data("states", OptionSeriesWaterfallStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesWaterfallTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesWaterfallTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def upColor(self):
        """The color used specifically for positive point columns.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Waterfall/WaterfallSeriesDefaults.ts
        """
        return self._config_get(None)

    @upColor.setter
    def upColor(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesWaterfallZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesWaterfallZones)

        
class OptionSeriesWaterfallDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWaterfallDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesWaterfallDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesWaterfallDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesWaterfallDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesWaterfallDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesWaterfallDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesWaterfallDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWaterfallDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesWaterfallDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesWaterfallDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesWaterfallDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesWaterfallDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesWaterfallDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesWaterfallDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesWaterfallAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesWaterfallAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesWaterfallAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesWaterfallAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesWaterfallAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesWaterfallAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesWaterfallAccessibilityPoint)

        
class OptionSeriesVennTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesVennTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesVennTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get("{point.name}: {point.value}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesVennStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesVennStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVennStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesVennStatesSelectMarker)

        
class OptionSeriesVennStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVennStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesVennStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesVennStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(0.075)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVennStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesVennStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesVennStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesVennStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesVennStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesVennStatesNormal)

    @property
    def select(self) -> 'OptionSeriesVennStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesVennStatesSelect)

        
class OptionSeriesVennStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesVennStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesVennStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVennStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesVennStatesHoverMarker)

    @property
    def opacity(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVennSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVennSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVennSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVennSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesVennSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVennSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVennSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVennSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVennSonificationTracksMappingLowpassResonance)

        
class OptionSeriesVennSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVennSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVennSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVennSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVennSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVennSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVennSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVennSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVennSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVennSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVennSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVennSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVennSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVennSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVennSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVennSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVennSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVennSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesVennSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVennSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVennSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVennSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVennSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVennSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVennSonificationTracksMappingVolume)

        
class OptionSeriesVennSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVennSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVennSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVennSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVennSonificationTracksMappingHighpassResonance)

        
class OptionSeriesVennSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVennSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVennSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVennSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVennSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVennSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVennSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesVennSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesVennSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesVennSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesVennSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesVennSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVennSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesVennSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesVennSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesVennSonificationTracks)

        
class OptionSeriesVennSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesVennSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesVennSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVennSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVennSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVennSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesVennSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVennSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVennSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesVennSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesVennSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesVennSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVennSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVennSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVennSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVennSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesVennSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVennSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesVennSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVennSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVennSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVennSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVennSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVennSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesVennSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVennSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVennSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVennSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVennSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesVennSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVennSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVennSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVennSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVennSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesVennSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVennSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVennSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVennSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVennSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVennSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVennSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVennSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVennSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVennSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVennSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVennSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVennSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVennSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVennSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVennSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVennSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVennSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesVennSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVennSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVennSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVennSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVennSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVennSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVennSonificationContexttracksMappingVolume)

        
class OptionSeriesVennSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVennSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVennSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVennSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVennSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVennSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVennSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVennSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVennSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVennSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVennSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesVennPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennPoint(Options):

    @property
    def events(self) -> 'OptionSeriesVennPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesVennPointEvents)

        
class OptionSeriesVennOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesVennOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesVennOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesVennOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesVennOnpointPosition)

        
class OptionSeriesVennDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVennDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesVennDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesVennDataDragdropGuideboxDefault)

        
class OptionSeriesVennDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesVennDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesVennDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesVennDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesVennDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVennClusterEvents(Options):

    @property
    def drillToCluster(self):
        """Fires when the cluster point is clicked and <code>drillToCluster</code> is enabled.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @drillToCluster.setter
    def drillToCluster(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesVennDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesVennDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesVennDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesVennDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesVennDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesVennDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVennDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesVennDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sets(self):
        """The set or sets the options will be applied to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(None)

    @sets.setter
    def sets(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVennDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesVennDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesVennDragdropGuideboxDefault)

        
class OptionSeriesVennDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesVennDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesVennDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesVennDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesVennDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVennEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVenn(Options):

    @property
    def accessibility(self) -> 'OptionSeriesVennAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesVennAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderDashStyle(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get("solid")

    @borderDashStyle.setter
    def borderDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def brighten(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(0)

    @brighten.setter
    def brighten(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cluster(self) -> 'OptionSeriesVennCluster':
        """Options for marker clusters, the concept of sampling the data values into larger blocks in order to ease readability and increase performance of the JavaScript charts. """
        return self._config_sub_data("cluster", OptionSeriesVennCluster)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesVennData':
        """. """
        return self._config_sub_data("data", OptionSeriesVennData)

    @property
    def dataLabels(self) -> 'OptionSeriesVennDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesVennDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesVennDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesVennDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVennEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesVennEvents)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesVennOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesVennOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(0.75)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesVennPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesVennPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesVennSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesVennSonification)

    @property
    def states(self) -> 'OptionSeriesVennStates':
        """. """
        return self._config_sub_data("states", OptionSeriesVennStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesVennTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesVennTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVennDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesVennDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesVennDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesVennDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesVennDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesVennDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesVennDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Venn/VennSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVennDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesVennDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesVennDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesVennDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesVennDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesVennDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesVennDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennClusterZonesMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennClusterZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def from_(self):
        """The value where the zone starts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVennClusterZonesMarker':
        """Settings for the cluster marker belonging to the zone. """
        return self._config_sub_data("marker", OptionSeriesVennClusterZonesMarker)

    @property
    def to(self):
        """The value where the zone ends.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennClusterStatesHover(Options):

    @property
    def fillColor(self):
        """The fill color of the cluster marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennClusterStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVennClusterStatesHover':
        """. """
        return self._config_sub_data("hover", OptionSeriesVennClusterStatesHover)

        
class OptionSeriesVennClusterMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVennClusterLayoutalgorithm(Options):

    @property
    def distance(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>distance</code> is a maximum distance between point and cluster center so that this point will be inside the cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(40)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def gridSize(self):
        """When <code>type</code> is set to the <code>grid</code>, <code>gridSize</code> is a size of a grid square element either as a number defining pixels, or a percentage defining a percentage of the plot area width.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(50)

    @gridSize.setter
    def gridSize(self, num: float): self._config(num, js_type=False)

    @property
    def iterations(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>iterations</code> are the number of iterations that this algorithm will be repeated to find clusters positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @iterations.setter
    def iterations(self, num: float): self._config(num, js_type=False)

    @property
    def kmeansThreshold(self):
        """When <code>type</code> is set to <code>undefined</code> and there are more visible points than the kmeansThreshold the <code>grid</code> algorithm is used to find clusters, otherwise <code>kmeans</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(100)

    @kmeansThreshold.setter
    def kmeansThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used to combine points into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennCluster(Options):

    @property
    def allowOverlap(self):
        """When set to <code>false</code> prevent cluster overlapping - this option works only when <code>layoutAlgorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Options for the cluster marker animation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get({ "duration": 500 })

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesVennClusterDatalabels':
        """Options for the cluster data labels. """
        return self._config_sub_data("dataLabels", OptionSeriesVennClusterDatalabels)

    @property
    def drillToCluster(self):
        """Zoom the plot area to the cluster points range when a cluster is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @drillToCluster.setter
    def drillToCluster(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Whether to enable the marker-clusters module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVennClusterEvents':
        """. """
        return self._config_sub_data("events", OptionSeriesVennClusterEvents)

    @property
    def layoutAlgorithm(self) -> 'OptionSeriesVennClusterLayoutalgorithm':
        """Options for layout algorithm. """
        return self._config_sub_data("layoutAlgorithm", OptionSeriesVennClusterLayoutalgorithm)

    @property
    def marker(self) -> 'OptionSeriesVennClusterMarker':
        """Options for the cluster marker. """
        return self._config_sub_data("marker", OptionSeriesVennClusterMarker)

    @property
    def minimumClusterSize(self):
        """The minimum amount of points to be combined into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(2)

    @minimumClusterSize.setter
    def minimumClusterSize(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesVennClusterStates':
        """. """
        return self._config_sub_data("states", OptionSeriesVennClusterStates)

    @property
    def zones(self) -> 'OptionSeriesVennClusterZones':
        """An array defining zones within marker clusters. """
        return self._config_sub_data("zones", OptionSeriesVennClusterZones)

        
class OptionSeriesVennClusterDatalabelsStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("contrast")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennClusterDatalabels(Options):

    @property
    def align(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("{point.clusterPointsAmount}")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def inside(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesVennClusterDatalabelsStyle':
        """. """
        return self._config_sub_data("style", OptionSeriesVennClusterDatalabelsStyle)

    @property
    def verticalAlign(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVennAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVennAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesVennAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesVennAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesVennAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesVennAccessibilityPoint)

        
class OptionSeriesVectorZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesVectorTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesVectorTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get("[{point.x}, {point.y}] Length: {point.length} Direction: {point.direction}°")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesVectorStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesVectorStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesVectorStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesVectorStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVectorStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesVectorStatesSelectMarker)

        
class OptionSeriesVectorStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesVectorStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesVectorStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVectorStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesVectorStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesVectorStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesVectorStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesVectorStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesVectorStatesNormal)

    @property
    def select(self) -> 'OptionSeriesVectorStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesVectorStatesSelect)

        
class OptionSeriesVectorStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesVectorStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesVectorStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesVectorStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesVectorStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """Additonal line width for the vector errors when they are hovered.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVectorStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesVectorStatesHoverMarker)

        
class OptionSeriesVectorSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVectorSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVectorSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVectorSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVectorSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesVectorSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVectorSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVectorSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVectorSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVectorSonificationTracksMappingLowpassResonance)

        
class OptionSeriesVectorSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVectorSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVectorSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVectorSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVectorSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVectorSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVectorSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVectorSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVectorSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVectorSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVectorSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVectorSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVectorSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVectorSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVectorSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVectorSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVectorSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVectorSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesVectorSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVectorSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVectorSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVectorSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVectorSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVectorSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVectorSonificationTracksMappingVolume)

        
class OptionSeriesVectorSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVectorSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVectorSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVectorSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVectorSonificationTracksMappingHighpassResonance)

        
class OptionSeriesVectorSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVectorSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVectorSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVectorSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVectorSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVectorSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVectorSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesVectorSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesVectorSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesVectorSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesVectorSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesVectorSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVectorSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesVectorSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesVectorSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesVectorSonificationTracks)

        
class OptionSeriesVectorSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesVectorSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesVectorSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVectorSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVectorSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVectorSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesVectorSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVectorSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVectorSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesVectorSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesVectorSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesVectorSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVectorSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVectorSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVectorSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVectorSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesVectorSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVectorSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVectorSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVectorSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVectorSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVectorSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesVectorSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVectorSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVectorSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVectorSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVectorSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesVectorSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVectorSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVectorSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVectorSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVectorSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesVectorSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVectorSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVectorSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVectorSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVectorSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVectorSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVectorSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVectorSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVectorSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVectorSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVectorSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVectorSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVectorSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVectorSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVectorSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVectorSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVectorSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVectorSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesVectorSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVectorSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVectorSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVectorSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVectorSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVectorSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVectorSonificationContexttracksMappingVolume)

        
class OptionSeriesVectorSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVectorSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVectorSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVectorSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVectorSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVectorSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVectorSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVectorSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVectorSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVectorSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVectorSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesVectorPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorPoint(Options):

    @property
    def events(self) -> 'OptionSeriesVectorPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesVectorPointEvents)

        
class OptionSeriesVectorOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesVectorOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesVectorOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesVectorOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesVectorOnpointPosition)

        
class OptionSeriesVectorMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesVectorMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesVectorMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVectorMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesVectorMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesVectorMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesVectorMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesVectorMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesVectorMarkerStatesSelect)

        
class OptionSeriesVectorMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesVectorMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesVectorMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesVectorLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesVectorLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorClusterEvents(Options):

    @property
    def drillToCluster(self):
        """Fires when the cluster point is clicked and <code>drillToCluster</code> is enabled.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @drillToCluster.setter
    def drillToCluster(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesVectorDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesVectorDataDragdropGuideboxDefault)

        
class OptionSeriesVectorDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesVectorDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesVectorDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesVectorDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesVectorDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVectorDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesVectorDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesVectorDragdropGuideboxDefault)

        
class OptionSeriesVectorDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesVectorDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesVectorDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesVectorDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesVectorDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVector(Options):

    @property
    def accessibility(self) -> 'OptionSeriesVectorAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesVectorAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cluster(self) -> 'OptionSeriesVectorCluster':
        """Options for marker clusters, the concept of sampling the data values into larger blocks in order to ease readability and increase performance of the JavaScript charts. """
        return self._config_sub_data("cluster", OptionSeriesVectorCluster)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesVectorData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesVectorData)

    @property
    def dataLabels(self) -> 'OptionSeriesVectorDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesVectorDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesVectorDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesVectorDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesVectorDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesVectorDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVectorEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesVectorEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesVectorLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesVectorLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The line width for each vector arrow.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVectorMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesVectorMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesVectorOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesVectorOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesVectorPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesVectorPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rotationOrigin(self):
        """What part of the vector it should be rotated around.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get("center")

    @rotationOrigin.setter
    def rotationOrigin(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesVectorSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesVectorSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesVectorStates':
        """. """
        return self._config_sub_data("states", OptionSeriesVectorStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesVectorTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesVectorTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def vectorLength(self):
        """Maximum length of the arrows in the vector plot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get(20)

    @vectorLength.setter
    def vectorLength(self, num: float): self._config(num, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesVectorZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesVectorZones)

        
class OptionSeriesVectorDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesVectorDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesVectorDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesVectorDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesVectorDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesVectorDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesVectorDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesVectorDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesVectorDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVectorDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesVectorDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesVectorDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesVectorDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesVectorDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesVectorDataMarkerStatesSelect)

        
class OptionSeriesVectorDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesVectorDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesVectorDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesVectorDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesVectorDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesVectorDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesVectorDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def direction(self):
        """The vector direction in degrees, where 0 is north (pointing towards south).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get(None)

    @direction.setter
    def direction(self, num: float): self._config(num, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesVectorDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesVectorDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVectorDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesVectorDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def length(self):
        """The length of the vector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Vector/VectorSeriesDefaults.ts
        """
        return self._config_get(None)

    @length.setter
    def length(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVectorDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesVectorDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesVectorDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesVectorDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesVectorDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesVectorDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesVectorDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesVectorDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorClusterZonesMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorClusterZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def from_(self):
        """The value where the zone starts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVectorClusterZonesMarker':
        """Settings for the cluster marker belonging to the zone. """
        return self._config_sub_data("marker", OptionSeriesVectorClusterZonesMarker)

    @property
    def to(self):
        """The value where the zone ends.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorClusterStatesHover(Options):

    @property
    def fillColor(self):
        """The fill color of the cluster marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorClusterStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVectorClusterStatesHover':
        """. """
        return self._config_sub_data("hover", OptionSeriesVectorClusterStatesHover)

        
class OptionSeriesVectorClusterMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVectorClusterLayoutalgorithm(Options):

    @property
    def distance(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>distance</code> is a maximum distance between point and cluster center so that this point will be inside the cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(40)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def gridSize(self):
        """When <code>type</code> is set to the <code>grid</code>, <code>gridSize</code> is a size of a grid square element either as a number defining pixels, or a percentage defining a percentage of the plot area width.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(50)

    @gridSize.setter
    def gridSize(self, num: float): self._config(num, js_type=False)

    @property
    def iterations(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>iterations</code> are the number of iterations that this algorithm will be repeated to find clusters positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @iterations.setter
    def iterations(self, num: float): self._config(num, js_type=False)

    @property
    def kmeansThreshold(self):
        """When <code>type</code> is set to <code>undefined</code> and there are more visible points than the kmeansThreshold the <code>grid</code> algorithm is used to find clusters, otherwise <code>kmeans</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(100)

    @kmeansThreshold.setter
    def kmeansThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used to combine points into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorCluster(Options):

    @property
    def allowOverlap(self):
        """When set to <code>false</code> prevent cluster overlapping - this option works only when <code>layoutAlgorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Options for the cluster marker animation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get({ "duration": 500 })

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesVectorClusterDatalabels':
        """Options for the cluster data labels. """
        return self._config_sub_data("dataLabels", OptionSeriesVectorClusterDatalabels)

    @property
    def drillToCluster(self):
        """Zoom the plot area to the cluster points range when a cluster is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @drillToCluster.setter
    def drillToCluster(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Whether to enable the marker-clusters module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVectorClusterEvents':
        """. """
        return self._config_sub_data("events", OptionSeriesVectorClusterEvents)

    @property
    def layoutAlgorithm(self) -> 'OptionSeriesVectorClusterLayoutalgorithm':
        """Options for layout algorithm. """
        return self._config_sub_data("layoutAlgorithm", OptionSeriesVectorClusterLayoutalgorithm)

    @property
    def marker(self) -> 'OptionSeriesVectorClusterMarker':
        """Options for the cluster marker. """
        return self._config_sub_data("marker", OptionSeriesVectorClusterMarker)

    @property
    def minimumClusterSize(self):
        """The minimum amount of points to be combined into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(2)

    @minimumClusterSize.setter
    def minimumClusterSize(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesVectorClusterStates':
        """. """
        return self._config_sub_data("states", OptionSeriesVectorClusterStates)

    @property
    def zones(self) -> 'OptionSeriesVectorClusterZones':
        """An array defining zones within marker clusters. """
        return self._config_sub_data("zones", OptionSeriesVectorClusterZones)

        
class OptionSeriesVectorClusterDatalabelsStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("contrast")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorClusterDatalabels(Options):

    @property
    def align(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("{point.clusterPointsAmount}")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def inside(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesVectorClusterDatalabelsStyle':
        """. """
        return self._config_sub_data("style", OptionSeriesVectorClusterDatalabelsStyle)

    @property
    def verticalAlign(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVectorAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVectorAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesVectorAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesVectorAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesVectorAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesVectorAccessibilityPoint)

        
class OptionSeriesVariwideZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesVariwideTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesVariwideTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesVariwideStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesVariwideStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesVariwideStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesVariwideStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVariwideStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesVariwideStatesSelectMarker)

        
class OptionSeriesVariwideStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariwideStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesVariwideStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesVariwideStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVariwideStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesVariwideStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesVariwideStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesVariwideStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesVariwideStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesVariwideStatesNormal)

    @property
    def select(self) -> 'OptionSeriesVariwideStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesVariwideStatesSelect)

        
class OptionSeriesVariwideStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesVariwideStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesVariwideStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesVariwideStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesVariwideStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVariwideStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesVariwideStatesHoverMarker)

        
class OptionSeriesVariwideSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVariwideSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVariwideSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVariwideSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVariwideSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesVariwideSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariwideSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariwideSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariwideSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariwideSonificationTracksMappingLowpassResonance)

        
class OptionSeriesVariwideSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariwideSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVariwideSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVariwideSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVariwideSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVariwideSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVariwideSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVariwideSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVariwideSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVariwideSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVariwideSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVariwideSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVariwideSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVariwideSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVariwideSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVariwideSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVariwideSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVariwideSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesVariwideSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVariwideSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVariwideSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVariwideSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVariwideSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVariwideSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVariwideSonificationTracksMappingVolume)

        
class OptionSeriesVariwideSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariwideSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariwideSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariwideSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariwideSonificationTracksMappingHighpassResonance)

        
class OptionSeriesVariwideSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVariwideSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVariwideSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVariwideSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVariwideSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariwideSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariwideSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesVariwideSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesVariwideSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesVariwideSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesVariwideSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesVariwideSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariwideSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariwideSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesVariwideSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesVariwideSonificationTracks)

        
class OptionSeriesVariwideSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesVariwideSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesVariwideSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVariwideSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVariwideSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVariwideSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesVariwideSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVariwideSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVariwideSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesVariwideSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesVariwideSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesVariwideSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVariwideSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVariwideSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVariwideSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVariwideSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariwideSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariwideSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVariwideSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariwideSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariwideSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesVariwideSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVariwideSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVariwideSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesVariwideSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariwideSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariwideSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesVariwideSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVariwideSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVariwideSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVariwideSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVariwideSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVariwideSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVariwideSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVariwideSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVariwideSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesVariwideSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVariwideSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVariwideSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVariwideSonificationContexttracksMappingVolume)

        
class OptionSeriesVariwideSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVariwideSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVariwideSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVariwideSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVariwideSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariwideSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariwideSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariwideSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariwideSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariwideSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesVariwidePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwidePoint(Options):

    @property
    def events(self) -> 'OptionSeriesVariwidePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesVariwidePointEvents)

        
class OptionSeriesVariwideOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesVariwideOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesVariwideOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesVariwideOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesVariwideOnpointPosition)

        
class OptionSeriesVariwideMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariwideMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesVariwideMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesVariwideMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVariwideMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesVariwideMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesVariwideMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesVariwideMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesVariwideMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesVariwideMarkerStatesSelect)

        
class OptionSeriesVariwideMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesVariwideMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesVariwideMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesVariwideLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesVariwideLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariwideDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariwideDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesVariwideDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesVariwideDataDragdropGuideboxDefault)

        
class OptionSeriesVariwideDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesVariwideDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesVariwideDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesVariwideDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesVariwideDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariwideDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwideDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesVariwideDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesVariwideDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesVariwideDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesVariwideDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesVariwideDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesVariwideDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVariwideDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesVariwideDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def z(self):
        """The relative width for each column.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Variwide/VariwideSeriesDefaults.ts
        """
        return self._config_get(None)

    @z.setter
    def z(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesVariwideDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesVariwideDragdropGuideboxDefault)

        
class OptionSeriesVariwideDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesVariwideDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesVariwideDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesVariwideDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesVariwideDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariwideEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariwide(Options):

    @property
    def accessibility(self) -> 'OptionSeriesVariwideAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesVariwideAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesVariwideData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesVariwideData)

    @property
    def dataLabels(self) -> 'OptionSeriesVariwideDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesVariwideDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesVariwideDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesVariwideDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesVariwideDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesVariwideDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVariwideEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesVariwideEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """In a variwide chart, the group padding is 0 in order to express the horizontal stacking of items.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Variwide/VariwideSeriesDefaults.ts
        """
        return self._config_get(0)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesVariwideLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesVariwideLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVariwideMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesVariwideMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesVariwideOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesVariwideOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesVariwidePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesVariwidePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """In a variwide chart, the point padding is 0 in order to express the horizontal stacking of items.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Variwide/VariwideSeriesDefaults.ts
        """
        return self._config_get(0)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesVariwideSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesVariwideSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesVariwideStates':
        """. """
        return self._config_sub_data("states", OptionSeriesVariwideStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesVariwideTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesVariwideTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesVariwideZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesVariwideZones)

        
class OptionSeriesVariwideDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariwideDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesVariwideDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesVariwideDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesVariwideDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesVariwideDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesVariwideDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesVariwideDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariwideDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesVariwideDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesVariwideDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesVariwideDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesVariwideDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesVariwideDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesVariwideDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariwideAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariwideAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariwideAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesVariwideAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesVariwideAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesVariwideAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesVariwideAccessibilityPoint)

        
class OptionSeriesVariablepieZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesVariablepieTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesVariablepieTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}<br/>Value: {point.y}<br/>Size: {point.z}<br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesVariablepieStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesVariablepieStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesVariablepieStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesVariablepieStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVariablepieStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesVariablepieStatesSelectMarker)

        
class OptionSeriesVariablepieStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariablepieStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesVariablepieStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesVariablepieStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVariablepieStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesVariablepieStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesVariablepieStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesVariablepieStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesVariablepieStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesVariablepieStatesNormal)

    @property
    def select(self) -> 'OptionSeriesVariablepieStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesVariablepieStatesSelect)

        
class OptionSeriesVariablepieStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesVariablepieStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesVariablepieStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesVariablepieStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesVariablepieStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVariablepieStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesVariablepieStatesHoverMarker)

        
class OptionSeriesVariablepieSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVariablepieSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVariablepieSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVariablepieSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVariablepieSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesVariablepieSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariablepieSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariablepieSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariablepieSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariablepieSonificationTracksMappingLowpassResonance)

        
class OptionSeriesVariablepieSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariablepieSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVariablepieSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVariablepieSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVariablepieSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVariablepieSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVariablepieSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVariablepieSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVariablepieSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVariablepieSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVariablepieSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVariablepieSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVariablepieSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVariablepieSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVariablepieSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVariablepieSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVariablepieSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVariablepieSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesVariablepieSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVariablepieSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVariablepieSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVariablepieSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVariablepieSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVariablepieSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVariablepieSonificationTracksMappingVolume)

        
class OptionSeriesVariablepieSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariablepieSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariablepieSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariablepieSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariablepieSonificationTracksMappingHighpassResonance)

        
class OptionSeriesVariablepieSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVariablepieSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVariablepieSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVariablepieSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVariablepieSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariablepieSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariablepieSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesVariablepieSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesVariablepieSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesVariablepieSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesVariablepieSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesVariablepieSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariablepieSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariablepieSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesVariablepieSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesVariablepieSonificationTracks)

        
class OptionSeriesVariablepieSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesVariablepieSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesVariablepieSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVariablepieSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVariablepieSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVariablepieSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVariablepieSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariablepieSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariablepieSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariablepieSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesVariablepieSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesVariablepieSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesVariablepieSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesVariablepieSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariablepieSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariablepieSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesVariablepieSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesVariablepieSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesVariablepieSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesVariablepieSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesVariablepieSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesVariablepieSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesVariablepieSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesVariablepieSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesVariablepieSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesVariablepieSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesVariablepieSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesVariablepieSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesVariablepieSonificationContexttracksMappingVolume)

        
class OptionSeriesVariablepieSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesVariablepieSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesVariablepieSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesVariablepieSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesVariablepieSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesVariablepieSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesVariablepieSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesVariablepieSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesVariablepieSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesVariablepieSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesVariablepiePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepiePoint(Options):

    @property
    def events(self) -> 'OptionSeriesVariablepiePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesVariablepiePointEvents)

        
class OptionSeriesVariablepieOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesVariablepieOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesVariablepieOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesVariablepieOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesVariablepieOnpointPosition)

        
class OptionSeriesVariablepieMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariablepieMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesVariablepieMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesVariablepieMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesVariablepieMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesVariablepieMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesVariablepieMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesVariablepieMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesVariablepieMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesVariablepieMarkerStatesSelect)

        
class OptionSeriesVariablepieMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesVariablepieMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesVariablepieMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesVariablepieLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesVariablepieLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariablepieDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariablepieDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesVariablepieDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesVariablepieDataDragdropGuideboxDefault)

        
class OptionSeriesVariablepieDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesVariablepieDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesVariablepieDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesVariablepieDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesVariablepieDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariablepieDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepieData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesVariablepieDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesVariablepieDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesVariablepieDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesVariablepieDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesVariablepieDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesVariablepieDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVariablepieDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesVariablepieDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def legendIndex(self):
        """The sequential index of the data point in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sliced(self):
        """Whether to display a slice offset from the center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @sliced.setter
    def sliced(self, flag: bool): self._config(flag, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesVariablepieDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesVariablepieDragdropGuideboxDefault)

        
class OptionSeriesVariablepieDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesVariablepieDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesVariablepieDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesVariablepieDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesVariablepieDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariablepieEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesVariablepie(Options):

    @property
    def accessibility(self) -> 'OptionSeriesVariablepieAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesVariablepieAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the pie chart relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get([null, null])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesVariablepieData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesVariablepieData)

    @property
    def dataLabels(self) -> 'OptionSeriesVariablepieDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesVariablepieDatalabels)

    @property
    def depth(self):
        """The thickness of a 3D pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie3D/Pie3DSeries.ts
        """
        return self._config_get(0)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesVariablepieDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesVariablepieDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """The end angle of the pie in degrees where 0 is top and 90 is right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @endAngle.setter
    def endAngle(self, num: float): self._config(num, js_type=False)

    @property
    def events(self) -> 'OptionSeriesVariablepieEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesVariablepieEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def innerSize(self):
        """The size of the inner diameter for the pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @innerSize.setter
    def innerSize(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesVariablepieLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesVariablepieLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesVariablepieMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesVariablepieMarker)

    @property
    def maxPointSize(self):
        """The maximum size of the points&#39; radius related to chart&#39;s <code>plotArea</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get("100%")

    @maxPointSize.setter
    def maxPointSize(self, num: float): self._config(num, js_type=False)

    @property
    def minPointSize(self):
        """The minimum size of the points&#39; radius related to chart&#39;s <code>plotArea</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get("10%")

    @minPointSize.setter
    def minPointSize(self, num: float): self._config(num, js_type=False)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesVariablepieOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesVariablepieOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesVariablepiePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesVariablepiePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """The diameter of the pie relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def sizeBy(self):
        """Whether the pie slice&#39;s value should be represented by the area or the radius of the slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get(area)

    @sizeBy.setter
    def sizeBy(self, value: Any): self._config(value, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesVariablepieSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesVariablepieSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesVariablepieStates':
        """. """
        return self._config_sub_data("states", OptionSeriesVariablepieStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesVariablepieTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesVariablepieTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zMax(self):
        """The maximum possible z value for the point&#39;s radius calculation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @zMax.setter
    def zMax(self, num: float): self._config(num, js_type=False)

    @property
    def zMin(self):
        """The minimum possible z value for the point&#39;s radius calculation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/VariablePie/VariablePieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @zMin.setter
    def zMin(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesVariablepieZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesVariablepieZones)

        
class OptionSeriesVariablepieDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariablepieDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesVariablepieDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesVariablepieDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesVariablepieDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesVariablepieDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesVariablepieDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesVariablepieDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariablepieDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesVariablepieDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesVariablepieDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesVariablepieDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesVariablepieDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesVariablepieDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesVariablepieDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesVariablepieAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesVariablepieAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesVariablepieAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesVariablepieAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesVariablepieAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesVariablepieAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesVariablepieAccessibilityPoint)

        
class OptionSeriesTreemapZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapTraverseupbuttonPosition(Options):

    @property
    def align(self):
        """Horizontal alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("right")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def verticalAlign(self):
        """Vertical alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """Horizontal offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(-10)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Vertical offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(10)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapTraverseupbutton(Options):

    @property
    def position(self) -> 'OptionSeriesTreemapTraverseupbuttonPosition':
        """The position of the button. """
        return self._config_sub_data("position", OptionSeriesTreemapTraverseupbuttonPosition)

        
class OptionSeriesTreemapTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesTreemapTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesTreemapTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("<b>{point.name}</b>: {point.value}<br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesTreemapStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesTreemapStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesTreemapStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesTreemapStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTreemapStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesTreemapStatesSelectMarker)

        
class OptionSeriesTreemapStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesTreemapStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTreemapStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTreemapStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesTreemapStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesTreemapStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesTreemapStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesTreemapStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesTreemapStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTreemapStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesTreemapStatesSelect)

        
class OptionSeriesTreemapStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTreemapStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesTreemapStatesHoverAnimation)

    @property
    def brightness(self):
        """Brightness for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesTreemapStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesTreemapStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTreemapStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesTreemapStatesHoverMarker)

    @property
    def opacity(self):
        """The opacity of a point in treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0.75)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow option for hovered state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTreemapSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTreemapSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTreemapSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTreemapSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesTreemapSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreemapSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreemapSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreemapSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreemapSonificationTracksMappingLowpassResonance)

        
class OptionSeriesTreemapSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreemapSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTreemapSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTreemapSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTreemapSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTreemapSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTreemapSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTreemapSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTreemapSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTreemapSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTreemapSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTreemapSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTreemapSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTreemapSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTreemapSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTreemapSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTreemapSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTreemapSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesTreemapSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTreemapSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTreemapSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTreemapSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTreemapSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTreemapSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTreemapSonificationTracksMappingVolume)

        
class OptionSeriesTreemapSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreemapSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreemapSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreemapSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreemapSonificationTracksMappingHighpassResonance)

        
class OptionSeriesTreemapSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTreemapSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTreemapSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTreemapSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTreemapSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreemapSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreemapSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesTreemapSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesTreemapSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesTreemapSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesTreemapSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesTreemapSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreemapSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreemapSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesTreemapSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesTreemapSonificationTracks)

        
class OptionSeriesTreemapSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesTreemapSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesTreemapSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTreemapSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTreemapSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTreemapSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesTreemapSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTreemapSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTreemapSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesTreemapSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesTreemapSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesTreemapSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTreemapSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTreemapSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTreemapSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTreemapSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreemapSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreemapSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTreemapSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreemapSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreemapSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesTreemapSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTreemapSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTreemapSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesTreemapSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreemapSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreemapSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesTreemapSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTreemapSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTreemapSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTreemapSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTreemapSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTreemapSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTreemapSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTreemapSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTreemapSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesTreemapSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTreemapSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTreemapSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTreemapSonificationContexttracksMappingVolume)

        
class OptionSeriesTreemapSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTreemapSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTreemapSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTreemapSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTreemapSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreemapSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreemapSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreemapSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreemapSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreemapSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesTreemapPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapPoint(Options):

    @property
    def events(self) -> 'OptionSeriesTreemapPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesTreemapPointEvents)

        
class OptionSeriesTreemapOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesTreemapOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesTreemapOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesTreemapOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesTreemapOnpointPosition)

        
class OptionSeriesTreemapMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTreemapMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTreemapMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTreemapMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesTreemapMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesTreemapMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesTreemapMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTreemapMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesTreemapMarkerStatesSelect)

        
class OptionSeriesTreemapMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesTreemapMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesTreemapMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapLevelsColorvariation(Options):

    @property
    def key(self):
        """The key of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @key.setter
    def key(self, value: Any): self._config(value, js_type=False)

    @property
    def to(self):
        """The ending value of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapLevels(Options):

    @property
    def borderColor(self):
        """Can set a <code>borderColor</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderDashStyle(self):
        """Set the dash style of the border of all the point which lies on the level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderDashStyle.setter
    def borderDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set the borderWidth on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set a color on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorVariation(self) -> 'OptionSeriesTreemapLevelsColorvariation':
        """A configuration object to define how the color of a child varies from the parent&#39;s color. """
        return self._config_sub_data("colorVariation", OptionSeriesTreemapLevelsColorvariation)

    @property
    def dataLabels(self) -> 'OptionSeriesTreemapLevelsDatalabels':
        """Can set the options of dataLabels on each point which lies on the level. """
        return self._config_sub_data("dataLabels", OptionSeriesTreemapLevelsDatalabels)

    @property
    def layoutAlgorithm(self):
        """Can set the layoutAlgorithm option on a specific level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @layoutAlgorithm.setter
    def layoutAlgorithm(self, value: Any): self._config(value, js_type=False)

    @property
    def layoutStartingDirection(self):
        """Can set the layoutStartingDirection option on a specific level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @layoutStartingDirection.setter
    def layoutStartingDirection(self, value: Any): self._config(value, js_type=False)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTreemapLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTreemapLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTreemapLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTreemapLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesTreemapLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTreemapLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesTreemapLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesTreemapLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesTreemapDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesTreemapDataDragdropGuideboxDefault)

        
class OptionSeriesTreemapDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesTreemapDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesTreemapDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesTreemapDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesTreemapDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapBreadcrumbsEvents(Options):

    @property
    def click(self):
        """Fires when clicking on the breadcrumbs button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemapDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesTreemapDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesTreemapDragdropGuideboxDefault)

        
class OptionSeriesTreemapDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesTreemapDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesTreemapDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesTreemapDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesTreemapDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def setRootNode(self):
        """Fires on a request for change of root node for the tree, before the update is made.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @setRootNode.setter
    def setRootNode(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreemap(Options):

    @property
    def accessibility(self) -> 'OptionSeriesTreemapAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesTreemapAccessibility)

    @property
    def allowDrillToNode(self):
        """When enabled the user can click on a point which is a parent and zoom in on its children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowDrillToNode.setter
    def allowDrillToNode(self, flag: bool): self._config(flag, js_type=False)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def allowTraversingTree(self):
        """When enabled the user can click on a point which is a parent and zoom in on its children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowTraversingTree.setter
    def allowTraversingTree(self, flag: bool): self._config(flag, js_type=False)

    @property
    def alternateStartingDirection(self):
        """Enabling this option will make the treemap alternate the drawing direction between vertical and horizontal.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @alternateStartingDirection.setter
    def alternateStartingDirection(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(250)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderRadius(self):
        """The border radius for each treemap item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def breadcrumbs(self) -> 'OptionSeriesTreemapBreadcrumbs':
        """Options for the breadcrumbs, the navigation at the top leading the way up through the traversed levels. """
        return self._config_sub_data("breadcrumbs", OptionSeriesTreemapBreadcrumbs)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the <code>options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("colorValue")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesTreemapData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesTreemapData)

    @property
    def dataLabels(self) -> 'OptionSeriesTreemapDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesTreemapDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesTreemapDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesTreemapDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesTreemapEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesTreemapEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Whether to ignore hidden points when the layout algorithm runs.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def interactByLeaf(self):
        """This option decides if the user can interact with the parent nodes or just the leaf nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @interactByLeaf.setter
    def interactByLeaf(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesTreemapLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesTreemapLabel)

    @property
    def layoutAlgorithm(self):
        """This option decides which algorithm is used for setting position and dimensions of the points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("sliceAndDice")

    @layoutAlgorithm.setter
    def layoutAlgorithm(self, text: str): self._config(text, js_type=False)

    @property
    def layoutStartingDirection(self):
        """Defines which direction the layout algorithm will start drawing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("vertical")

    @layoutStartingDirection.setter
    def layoutStartingDirection(self, text: str): self._config(text, js_type=False)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levelIsConstant(self):
        """Used together with the levels and allowTraversingTree options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @levelIsConstant.setter
    def levelIsConstant(self, flag: bool): self._config(flag, js_type=False)

    @property
    def levels(self) -> 'OptionSeriesTreemapLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionSeriesTreemapLevels)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTreemapMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesTreemapMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesTreemapOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesTreemapOnpoint)

    @property
    def opacity(self):
        """The opacity of a point in treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0.15)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesTreemapPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesTreemapPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this series type or specific series item in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesTreemapSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesTreemapSonification)

    @property
    def sortIndex(self):
        """The sort index of the point inside the treemap level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @sortIndex.setter
    def sortIndex(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesTreemapStates':
        """A wrapper object for all the series options in specific states. """
        return self._config_sub_data("states", OptionSeriesTreemapStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesTreemapTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesTreemapTooltip)

    @property
    def traverseUpButton(self) -> 'OptionSeriesTreemapTraverseupbutton':
        """Options for the button appearing when traversing down in a treemap. """
        return self._config_sub_data("traverseUpButton", OptionSeriesTreemapTraverseupbutton)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesTreemapZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesTreemapZones)

        
class OptionSeriesTreemapDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTreemapDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTreemapDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTreemapDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTreemapDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesTreemapDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTreemapDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTreemapDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTreemapDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTreemapDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesTreemapDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesTreemapDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesTreemapDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTreemapDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesTreemapDataMarkerStatesSelect)

        
class OptionSeriesTreemapDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesTreemapDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesTreemapDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesTreemapDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesTreemapDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The color of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorValue(self):
        """Serves a purpose only if a <code>colorAxis</code> object is defined in the chart options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @colorValue.setter
    def colorValue(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesTreemapDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesTreemapDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesTreemapDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesTreemapDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesTreemapDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesTreemapDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTreemapDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesTreemapDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def parent(self):
        """Only for treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @parent.setter
    def parent(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTreemapDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTreemapDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTreemapDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTreemapDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesTreemapDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTreemapDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapBreadcrumbsSeparatorStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("#666666")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapBreadcrumbsSeparator(Options):

    @property
    def style(self) -> 'OptionSeriesTreemapBreadcrumbsSeparatorStyle':
        """CSS styles for the breadcrumbs separator. """
        return self._config_sub_data("style", OptionSeriesTreemapBreadcrumbsSeparatorStyle)

    @property
    def text(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("/")

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapBreadcrumbsPosition(Options):

    @property
    def align(self):
        """Horizontal alignment of the breadcrumbs buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("left")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def verticalAlign(self):
        """Vertical alignment of the breadcrumbs buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The X offset of the breadcrumbs button group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The Y offset of the breadcrumbs button group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapBreadcrumbs(Options):

    @property
    def buttonSpacing(self):
        """The default padding for each button and separator in each direction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(5)

    @buttonSpacing.setter
    def buttonSpacing(self, num: float): self._config(num, js_type=False)

    @property
    def buttonTheme(self) -> 'OptionSeriesTreemapBreadcrumbsButtontheme':
        """A collection of attributes for the buttons. """
        return self._config_sub_data("buttonTheme", OptionSeriesTreemapBreadcrumbsButtontheme)

    @property
    def events(self) -> 'OptionSeriesTreemapBreadcrumbsEvents':
        """. """
        return self._config_sub_data("events", OptionSeriesTreemapBreadcrumbsEvents)

    @property
    def floating(self):
        """When the breadcrumbs are floating, the plot area will not move to make space for it.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @floating.setter
    def floating(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the breadcrumbs button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format the breadcrumb text from scratch.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesTreemapBreadcrumbsPosition':
        """Positioning for the button row. """
        return self._config_sub_data("position", OptionSeriesTreemapBreadcrumbsPosition)

    @property
    def relativeTo(self):
        """What box to align the button to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("plotBox")

    @relativeTo.setter
    def relativeTo(self, text: str): self._config(text, js_type=False)

    @property
    def rtl(self):
        """Whether to reverse the order of buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @rtl.setter
    def rtl(self, flag: bool): self._config(flag, js_type=False)

    @property
    def separator(self) -> 'OptionSeriesTreemapBreadcrumbsSeparator':
        """Options object for Breadcrumbs separator. """
        return self._config_sub_data("separator", OptionSeriesTreemapBreadcrumbsSeparator)

    @property
    def showFullPath(self):
        """Show full path or only a single button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(True)

    @showFullPath.setter
    def showFullPath(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """CSS styles for all breadcrumbs.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def useHTML(self):
        """Whether to use HTML to render the breadcrumbs items texts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """The z index of the breadcrumbs group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(7)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreemapBreadcrumbsButtonthemeStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("#334eff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapBreadcrumbsButtontheme(Options):

    @property
    def style(self) -> 'OptionSeriesTreemapBreadcrumbsButtonthemeStyle':
        """. """
        return self._config_sub_data("style", OptionSeriesTreemapBreadcrumbsButtonthemeStyle)

        
class OptionSeriesTreemapAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreemapAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreemapAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesTreemapAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesTreemapAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesTreemapAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesTreemapAccessibilityPoint)

        
class OptionSeriesTreegraphTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesTreegraphTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesTreegraphTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def linkFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.id} → {point.toNode.id}")

    @linkFormat.setter
    def linkFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("{point.id}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesTreegraphStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesTreegraphStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesTreegraphStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesTreegraphStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTreegraphStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesTreegraphStatesSelectMarker)

        
class OptionSeriesTreegraphStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesTreegraphStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTreegraphStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTreegraphStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesTreegraphStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesTreegraphStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesTreegraphStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesTreegraphStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesTreegraphStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTreegraphStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesTreegraphStatesSelect)

        
class OptionSeriesTreegraphStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTreegraphStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesTreegraphStatesHoverAnimation)

    @property
    def brightness(self):
        """Brightness for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesTreegraphStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesTreegraphStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTreegraphStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesTreegraphStatesHoverMarker)

    @property
    def opacity(self):
        """The opacity of a point in treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0.75)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow option for hovered state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTreegraphSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTreegraphSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTreegraphSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTreegraphSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesTreegraphSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreegraphSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreegraphSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreegraphSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreegraphSonificationTracksMappingLowpassResonance)

        
class OptionSeriesTreegraphSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreegraphSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTreegraphSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTreegraphSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTreegraphSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTreegraphSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTreegraphSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTreegraphSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTreegraphSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTreegraphSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTreegraphSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTreegraphSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTreegraphSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTreegraphSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTreegraphSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTreegraphSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTreegraphSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTreegraphSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesTreegraphSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTreegraphSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTreegraphSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTreegraphSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTreegraphSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTreegraphSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTreegraphSonificationTracksMappingVolume)

        
class OptionSeriesTreegraphSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreegraphSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreegraphSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreegraphSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreegraphSonificationTracksMappingHighpassResonance)

        
class OptionSeriesTreegraphSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTreegraphSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTreegraphSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTreegraphSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTreegraphSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreegraphSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreegraphSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesTreegraphSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesTreegraphSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesTreegraphSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesTreegraphSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesTreegraphSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreegraphSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreegraphSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesTreegraphSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesTreegraphSonificationTracks)

        
class OptionSeriesTreegraphSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesTreegraphSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesTreegraphSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTreegraphSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTreegraphSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTreegraphSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTreegraphSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreegraphSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreegraphSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreegraphSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesTreegraphSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTreegraphSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTreegraphSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesTreegraphSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreegraphSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreegraphSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesTreegraphSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTreegraphSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTreegraphSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTreegraphSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTreegraphSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTreegraphSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTreegraphSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTreegraphSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTreegraphSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesTreegraphSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTreegraphSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTreegraphSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTreegraphSonificationContexttracksMappingVolume)

        
class OptionSeriesTreegraphSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTreegraphSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTreegraphSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTreegraphSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTreegraphSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTreegraphSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTreegraphSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTreegraphSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTreegraphSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTreegraphSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesTreegraphPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphPoint(Options):

    @property
    def events(self) -> 'OptionSeriesTreegraphPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesTreegraphPointEvents)

        
class OptionSeriesTreegraphOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesTreegraphOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesTreegraphOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesTreegraphOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesTreegraphOnpointPosition)

        
class OptionSeriesTreegraphMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTreegraphMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTreegraphMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTreegraphMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesTreegraphMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesTreegraphMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesTreegraphMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTreegraphMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesTreegraphMarkerStatesSelect)

        
class OptionSeriesTreegraphMarker(Options):

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(10)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesTreegraphMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesTreegraphMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphLink(Options):

    @property
    def color(self):
        """The color of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("#666666")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("default")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def curveFactor(self):
        """Modifier of the shape of the curved link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(0.5)

    @curveFactor.setter
    def curveFactor(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidth(self):
        """The line width of the links connecting nodes, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """Radius for the rounded corners of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(10)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the link shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(curved)

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphLevelsMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphLevelsMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphLevelsMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphLevelsMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTreegraphLevelsMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTreegraphLevelsMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphLevelsMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTreegraphLevelsMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesTreegraphLevelsMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesTreegraphLevelsMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesTreegraphLevelsMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTreegraphLevelsMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesTreegraphLevelsMarkerStatesSelect)

        
class OptionSeriesTreegraphLevelsMarker(Options):

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(10)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesTreegraphLevelsMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesTreegraphLevelsMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphLevelsColorvariation(Options):

    @property
    def key(self):
        """The key of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @key.setter
    def key(self, value: Any): self._config(value, js_type=False)

    @property
    def to(self):
        """The ending value of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphLevels(Options):

    @property
    def borderColor(self):
        """Can set a <code>borderColor</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderDashStyle(self):
        """Set the dash style of the border of all the point which lies on the level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderDashStyle.setter
    def borderDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set the borderWidth on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def collapsed(self):
        """Set collapsed status for nodes level-wise.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeries.ts
        """
        return self._config_get(None)

    @collapsed.setter
    def collapsed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """Can set a color on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorVariation(self) -> 'OptionSeriesTreegraphLevelsColorvariation':
        """A configuration object to define how the color of a child varies from the parent&#39;s color. """
        return self._config_sub_data("colorVariation", OptionSeriesTreegraphLevelsColorvariation)

    @property
    def dataLabels(self) -> 'OptionSeriesTreegraphLevelsDatalabels':
        """Can set the options of dataLabels on each point which lies on the level. """
        return self._config_sub_data("dataLabels", OptionSeriesTreegraphLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTreegraphLevelsMarker':
        """Set marker options for nodes at the level. """
        return self._config_sub_data("marker", OptionSeriesTreegraphLevelsMarker)

        
class OptionSeriesTreegraphLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTreegraphLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTreegraphLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTreegraphLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTreegraphLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesTreegraphLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTreegraphLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesTreegraphLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesTreegraphLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesTreegraphDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesTreegraphDataDragdropGuideboxDefault)

        
class OptionSeriesTreegraphDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesTreegraphDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesTreegraphDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesTreegraphDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesTreegraphDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraphDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def setRootNode(self):
        """Fires on a request for change of root node for the tree, before the update is made.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @setRootNode.setter
    def setRootNode(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTreegraph(Options):

    @property
    def accessibility(self) -> 'OptionSeriesTreegraphAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesTreegraphAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(250)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def collapseButton(self) -> 'OptionSeriesTreegraphCollapsebutton':
        """Options applied to collapse Button. """
        return self._config_sub_data("collapseButton", OptionSeriesTreegraphCollapsebutton)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the <code>options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesTreegraphData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesTreegraphData)

    @property
    def dataLabels(self) -> 'OptionSeriesTreegraphDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionSeriesTreegraphDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesTreegraphEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesTreegraphEvents)

    @property
    def fillSpace(self):
        """Whether the treegraph series should fill the entire plot area in the X axis direction, even when there are collapsed points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @fillSpace.setter
    def fillSpace(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesTreegraphLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesTreegraphLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionSeriesTreegraphLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionSeriesTreegraphLevels)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def link(self) -> 'OptionSeriesTreegraphLink':
        """. """
        return self._config_sub_data("link", OptionSeriesTreegraphLink)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTreegraphMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesTreegraphMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesTreegraphOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesTreegraphOnpoint)

    @property
    def opacity(self):
        """The opacity of a point in treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(0.15)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesTreegraphPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesTreegraphPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def reversed(self):
        """Flips the positions of the nodes of a treegraph along the horizontal axis (vertical if chart is inverted).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this series type or specific series item in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesTreegraphSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesTreegraphSonification)

    @property
    def states(self) -> 'OptionSeriesTreegraphStates':
        """A wrapper object for all the series options in specific states. """
        return self._config_sub_data("states", OptionSeriesTreegraphStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesTreegraphTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesTreegraphTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphDatalabelsStyle(Options):

    @property
    def textOverflow(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("none")

    @textOverflow.setter
    def textOverflow(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphDatalabelsLinktextpathAttributes(Options):

    @property
    def startOffset(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("50%")

    @startOffset.setter
    def startOffset(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDatalabelsLinktextpath(Options):

    @property
    def attributes(self) -> 'OptionSeriesTreegraphDatalabelsLinktextpathAttributes':
        """Presentation attributes for the text path. """
        return self._config_sub_data("attributes", OptionSeriesTreegraphDatalabelsLinktextpathAttributes)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTreegraphDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTreegraphDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTreegraphDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTreegraphDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkTextPath(self) -> 'OptionSeriesTreegraphDatalabelsLinktextpath':
        """Options for a <em>link</em> label text which should follow link connection. """
        return self._config_sub_data("linkTextPath", OptionSeriesTreegraphDatalabelsLinktextpath)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionSeriesTreegraphDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionSeriesTreegraphDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionSeriesTreegraphDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTreegraphDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTreegraphDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTreegraphDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTreegraphDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesTreegraphDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesTreegraphDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesTreegraphDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTreegraphDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesTreegraphDataMarkerStatesSelect)

        
class OptionSeriesTreegraphDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesTreegraphDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesTreegraphDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesTreegraphDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesTreegraphDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def collapseButton(self):
        """Options used for button, which toggles the collapse status of the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeries.ts
        """
        return self._config_get(None)

    @collapseButton.setter
    def collapseButton(self, text: str): self._config(text, js_type=False)

    @property
    def collapsed(self):
        """If point&#39;s children should be initially hidden.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeries.ts
        """
        return self._config_get(None)

    @collapsed.setter
    def collapsed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorValue(self):
        """Serves a purpose only if a <code>colorAxis</code> object is defined in the chart options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @colorValue.setter
    def colorValue(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesTreegraphDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesTreegraphDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesTreegraphDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesTreegraphDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesTreegraphDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesTreegraphDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTreegraphDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesTreegraphDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def parent(self):
        """Only for treemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @parent.setter
    def parent(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTreegraphDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTreegraphDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTreegraphDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTreegraphDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesTreegraphDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTreegraphDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphCollapsebuttonStyle(Options):

    @property
    def cursor(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("pointer")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("1em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphCollapsebutton(Options):

    @property
    def enabled(self):
        """Whether the button should be visible.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def height(self):
        """Height of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(18)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidth(self):
        """The line width of the button in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onlyOnHover(self):
        """Whether the button should be visible only when the node is hovered.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @onlyOnHover.setter
    def onlyOnHover(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The symbol of the collapse button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get("circle")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionSeriesTreegraphCollapsebuttonStyle':
        """CSS styles for the collapse button. """
        return self._config_sub_data("style", OptionSeriesTreegraphCollapsebuttonStyle)

    @property
    def width(self):
        """Width of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(18)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """Offset of the button in the x direction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Offset of the button in the y direction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treegraph/TreegraphSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTreegraphAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTreegraphAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTreegraphAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesTreegraphAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesTreegraphAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesTreegraphAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesTreegraphAccessibilityPoint)

        
class OptionSeriesTimelineTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesTimelineTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesTimelineTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {point.key}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("{point.description}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesTimelineStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesTimelineStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesTimelineStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesTimelineStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTimelineStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesTimelineStatesSelectMarker)

        
class OptionSeriesTimelineStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTimelineStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesTimelineStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTimelineStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTimelineStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesTimelineStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesTimelineStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesTimelineStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesTimelineStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesTimelineStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTimelineStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesTimelineStatesSelect)

        
class OptionSeriesTimelineStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTimelineStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesTimelineStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesTimelineStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesTimelineStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTimelineStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesTimelineStatesHoverMarker)

        
class OptionSeriesTimelineSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTimelineSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTimelineSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTimelineSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTimelineSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesTimelineSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTimelineSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTimelineSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTimelineSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTimelineSonificationTracksMappingLowpassResonance)

        
class OptionSeriesTimelineSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTimelineSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTimelineSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTimelineSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTimelineSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTimelineSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTimelineSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTimelineSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTimelineSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTimelineSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTimelineSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTimelineSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTimelineSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTimelineSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTimelineSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTimelineSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTimelineSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTimelineSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesTimelineSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTimelineSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTimelineSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTimelineSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTimelineSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTimelineSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTimelineSonificationTracksMappingVolume)

        
class OptionSeriesTimelineSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTimelineSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTimelineSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTimelineSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTimelineSonificationTracksMappingHighpassResonance)

        
class OptionSeriesTimelineSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTimelineSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTimelineSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTimelineSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTimelineSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTimelineSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTimelineSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesTimelineSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesTimelineSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesTimelineSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesTimelineSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesTimelineSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTimelineSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesTimelineSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesTimelineSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesTimelineSonificationTracks)

        
class OptionSeriesTimelineSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesTimelineSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesTimelineSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTimelineSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTimelineSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTimelineSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesTimelineSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTimelineSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTimelineSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesTimelineSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesTimelineSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesTimelineSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTimelineSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTimelineSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTimelineSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTimelineSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesTimelineSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTimelineSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTimelineSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTimelineSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTimelineSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesTimelineSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTimelineSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTimelineSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesTimelineSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTimelineSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTimelineSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesTimelineSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTimelineSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTimelineSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTimelineSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTimelineSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTimelineSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTimelineSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTimelineSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTimelineSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesTimelineSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTimelineSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTimelineSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTimelineSonificationContexttracksMappingVolume)

        
class OptionSeriesTimelineSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTimelineSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTimelineSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTimelineSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTimelineSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTimelineSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTimelineSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTimelineSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTimelineSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTimelineSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesTimelinePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelinePoint(Options):

    @property
    def events(self) -> 'OptionSeriesTimelinePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesTimelinePointEvents)

        
class OptionSeriesTimelineOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesTimelineOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesTimelineOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesTimelineOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesTimelineOnpointPosition)

        
class OptionSeriesTimelineMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTimelineMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTimelineMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTimelineMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTimelineMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesTimelineMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesTimelineMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesTimelineMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTimelineMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesTimelineMarkerStatesSelect)

        
class OptionSeriesTimelineMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(0)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(15)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(6)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesTimelineMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesTimelineMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("square")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesTimelineLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesTimelineLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTimelineDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTimelineDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesTimelineDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesTimelineDataDragdropGuideboxDefault)

        
class OptionSeriesTimelineDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesTimelineDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesTimelineDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesTimelineDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesTimelineDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTimelineDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimelineData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesTimelineDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesTimelineDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesTimelineDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesTimelineDataDatalabels)

    @property
    def description(self):
        """The description of event.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesTimelineDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesTimelineDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesTimelineDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesTimelineDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def label(self):
        """The label of event.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(None)

    @label.setter
    def label(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of event.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesTimelineDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesTimelineDragdropGuideboxDefault)

        
class OptionSeriesTimelineDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesTimelineDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesTimelineDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesTimelineDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesTimelineDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTimelineEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTimeline(Options):

    @property
    def accessibility(self) -> 'OptionSeriesTimelineAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesTimelineAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("x")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def data(self) -> 'OptionSeriesTimelineData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesTimelineData)

    @property
    def dataLabels(self) -> 'OptionSeriesTimelineDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesTimelineDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesTimelineDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesTimelineDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesTimelineEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesTimelineEvents)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesTimelineLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesTimelineLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(4)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTimelineMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesTimelineMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesTimelineOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesTimelineOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesTimelinePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesTimelinePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesTimelineSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesTimelineSonification)

    @property
    def states(self) -> 'OptionSeriesTimelineStates':
        """. """
        return self._config_sub_data("states", OptionSeriesTimelineStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesTimelineTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesTimelineTooltip)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTimelineDatalabelsStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("normal")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

    @property
    def textOutline(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("none")

    @textOutline.setter
    def textOutline(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def alternate(self):
        """Whether to position data labels alternately.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @alternate.setter
    def alternate(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTimelineDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTimelineDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("#999999")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("#333333")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """A pixel value defining the distance between the data label and the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @distance.setter
    def distance(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTimelineDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTimelineDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """Shadow options for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionSeriesTimelineDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionSeriesTimelineDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionSeriesTimelineDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTimelineDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Timeline/TimelineSeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTimelineDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTimelineDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTimelineDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTimelineDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTimelineDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesTimelineDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTimelineDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTimelineAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTimelineAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTimelineAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesTimelineAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesTimelineAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesTimelineAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesTimelineAccessibilityPoint)

        
class OptionSeriesTilemapZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesTilemapTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesTilemapTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("{point.x}, {point.y}: {point.value}<br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesTilemapStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesTilemapStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesTilemapStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesTilemapStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTilemapStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesTilemapStatesSelectMarker)

        
class OptionSeriesTilemapStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTilemapStatesHoverHaloAttributes(Options):

    @property
    def zIndex(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(3)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapStatesHoverHalo(Options):

    @property
    def attributes(self) -> 'OptionSeriesTilemapStatesHoverHaloAttributes':
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>. """
        return self._config_sub_data("attributes", OptionSeriesTilemapStatesHoverHaloAttributes)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(0.5)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(2)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesTilemapStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesTilemapStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapStates(Options):

    @property
    def hover(self) -> 'OptionSeriesTilemapStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesTilemapStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesTilemapStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesTilemapStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesTilemapStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesTilemapStatesNormal)

    @property
    def select(self) -> 'OptionSeriesTilemapStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesTilemapStatesSelect)

        
class OptionSeriesTilemapStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesTilemapStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesTilemapStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesTilemapStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesTilemapStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesTilemapStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesTilemapStatesHoverMarker)

        
class OptionSeriesTilemapSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTilemapSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTilemapSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTilemapSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTilemapSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesTilemapSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTilemapSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTilemapSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTilemapSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTilemapSonificationTracksMappingLowpassResonance)

        
class OptionSeriesTilemapSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTilemapSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTilemapSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTilemapSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTilemapSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTilemapSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTilemapSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTilemapSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTilemapSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTilemapSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTilemapSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTilemapSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTilemapSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTilemapSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTilemapSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTilemapSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTilemapSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTilemapSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesTilemapSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTilemapSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTilemapSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTilemapSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTilemapSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTilemapSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTilemapSonificationTracksMappingVolume)

        
class OptionSeriesTilemapSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTilemapSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTilemapSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTilemapSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTilemapSonificationTracksMappingHighpassResonance)

        
class OptionSeriesTilemapSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTilemapSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTilemapSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTilemapSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTilemapSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTilemapSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTilemapSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesTilemapSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesTilemapSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesTilemapSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesTilemapSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesTilemapSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTilemapSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesTilemapSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesTilemapSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesTilemapSonificationTracks)

        
class OptionSeriesTilemapSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesTilemapSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesTilemapSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTilemapSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTilemapSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTilemapSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesTilemapSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTilemapSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTilemapSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesTilemapSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesTilemapSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesTilemapSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTilemapSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTilemapSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTilemapSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTilemapSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesTilemapSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTilemapSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTilemapSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTilemapSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTilemapSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesTilemapSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesTilemapSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesTilemapSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesTilemapSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTilemapSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTilemapSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesTilemapSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesTilemapSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesTilemapSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesTilemapSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesTilemapSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesTilemapSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesTilemapSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesTilemapSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesTilemapSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesTilemapSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesTilemapSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesTilemapSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesTilemapSonificationContexttracksMappingVolume)

        
class OptionSeriesTilemapSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesTilemapSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesTilemapSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesTilemapSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesTilemapSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesTilemapSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesTilemapSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesTilemapSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesTilemapSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesTilemapSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesTilemapPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapPoint(Options):

    @property
    def events(self) -> 'OptionSeriesTilemapPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesTilemapPointEvents)

        
class OptionSeriesTilemapOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesTilemapOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesTilemapOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesTilemapOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesTilemapOnpointPosition)

        
class OptionSeriesTilemapLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesTilemapLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesTilemapLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTilemapDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTilemapDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesTilemapDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesTilemapDataDragdropGuideboxDefault)

        
class OptionSeriesTilemapDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesTilemapDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesTilemapDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesTilemapDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesTilemapDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTilemapDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemapData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesTilemapDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesTilemapDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The color of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesTilemapDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesTilemapDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesTilemapDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesTilemapDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesTilemapDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesTilemapDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def pointPadding(self):
        """Point padding for a single point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x coordinate of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y coordinate of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesTilemapDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesTilemapDragdropGuideboxDefault)

        
class OptionSeriesTilemapDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesTilemapDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesTilemapDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesTilemapDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesTilemapDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTilemapEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesTilemap(Options):

    @property
    def accessibility(self) -> 'OptionSeriesTilemapAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesTilemapAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Animation is disabled by default on the heatmap series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderRadius(self):
        """The border radius for each heatmap item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("value")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colsize(self):
        """The column size - how many X axis units each column in the tilemap should span.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(1)

    @colsize.setter
    def colsize(self, num: float): self._config(num, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesTilemapData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesTilemapData)

    @property
    def dataLabels(self) -> 'OptionSeriesTilemapDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesTilemapDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesTilemapDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesTilemapDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesTilemapEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesTilemapEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def interpolation(self):
        """Make the heatmap render its data points as an interpolated image.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @interpolation.setter
    def interpolation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesTilemapLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesTilemapLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def nullColor(self):
        """The color applied to null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("#f7f7f7")

    @nullColor.setter
    def nullColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesTilemapOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesTilemapOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesTilemapPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesTilemapPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """The padding between points in the tilemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(2)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rowsize(self):
        """The row size - how many Y axis units each tilemap row should span.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(1)

    @rowsize.setter
    def rowsize(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesTilemapSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesTilemapSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesTilemapStates':
        """. """
        return self._config_sub_data("states", OptionSeriesTilemapStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tileShape(self):
        """The shape of the tiles in the tilemap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Tilemap/TilemapSeriesDefaults.ts
        """
        return self._config_get(hexagon)

    @tileShape.setter
    def tileShape(self, value: Any): self._config(value, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesTilemapTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesTilemapTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesTilemapZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesTilemapZones)

        
class OptionSeriesTilemapDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTilemapDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTilemapDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTilemapDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTilemapDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTilemapDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesTilemapDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTilemapDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTilemapDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesTilemapDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesTilemapDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesTilemapDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesTilemapDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesTilemapDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesTilemapDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesTilemapAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesTilemapAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesTilemapAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesTilemapAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesTilemapAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesTilemapAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesTilemapAccessibilityPoint)

        
class OptionSeriesSunburstZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstTraverseupbuttonPosition(Options):

    @property
    def align(self):
        """Horizontal alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("right")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def verticalAlign(self):
        """Vertical alignment of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """Horizontal offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(-10)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Vertical offset of the button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(10)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstTraverseupbutton(Options):

    @property
    def position(self) -> 'OptionSeriesSunburstTraverseupbuttonPosition':
        """The position of the button. """
        return self._config_sub_data("position", OptionSeriesSunburstTraverseupbuttonPosition)

        
class OptionSeriesSunburstTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesSunburstTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesSunburstTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesSunburstStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesSunburstStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesSunburstStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesSunburstStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSunburstStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesSunburstStatesSelectMarker)

        
class OptionSeriesSunburstStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesSunburstStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesSunburstStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstStates(Options):

    @property
    def hover(self) -> 'OptionSeriesSunburstStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesSunburstStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesSunburstStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesSunburstStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesSunburstStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesSunburstStatesNormal)

    @property
    def select(self) -> 'OptionSeriesSunburstStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesSunburstStatesSelect)

        
class OptionSeriesSunburstStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesSunburstStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesSunburstStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesSunburstStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesSunburstStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSunburstStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesSunburstStatesHoverMarker)

        
class OptionSeriesSunburstSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSunburstSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSunburstSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSunburstSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSunburstSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesSunburstSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSunburstSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSunburstSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSunburstSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSunburstSonificationTracksMappingLowpassResonance)

        
class OptionSeriesSunburstSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSunburstSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSunburstSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSunburstSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSunburstSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSunburstSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSunburstSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSunburstSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSunburstSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSunburstSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSunburstSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSunburstSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSunburstSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSunburstSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSunburstSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSunburstSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSunburstSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSunburstSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesSunburstSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSunburstSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSunburstSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSunburstSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSunburstSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSunburstSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSunburstSonificationTracksMappingVolume)

        
class OptionSeriesSunburstSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSunburstSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSunburstSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSunburstSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSunburstSonificationTracksMappingHighpassResonance)

        
class OptionSeriesSunburstSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSunburstSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSunburstSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSunburstSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSunburstSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSunburstSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSunburstSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesSunburstSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesSunburstSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesSunburstSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesSunburstSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesSunburstSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSunburstSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesSunburstSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesSunburstSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesSunburstSonificationTracks)

        
class OptionSeriesSunburstSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesSunburstSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesSunburstSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSunburstSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSunburstSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSunburstSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesSunburstSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSunburstSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSunburstSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesSunburstSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesSunburstSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesSunburstSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSunburstSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSunburstSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSunburstSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSunburstSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesSunburstSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSunburstSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSunburstSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSunburstSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSunburstSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesSunburstSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSunburstSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSunburstSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesSunburstSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSunburstSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSunburstSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesSunburstSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSunburstSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSunburstSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSunburstSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSunburstSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSunburstSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSunburstSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSunburstSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSunburstSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesSunburstSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSunburstSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSunburstSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSunburstSonificationContexttracksMappingVolume)

        
class OptionSeriesSunburstSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSunburstSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSunburstSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSunburstSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSunburstSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSunburstSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSunburstSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSunburstSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSunburstSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSunburstSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesSunburstPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstPoint(Options):

    @property
    def events(self) -> 'OptionSeriesSunburstPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesSunburstPointEvents)

        
class OptionSeriesSunburstOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesSunburstOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesSunburstOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesSunburstOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesSunburstOnpointPosition)

        
class OptionSeriesSunburstMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesSunburstMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesSunburstMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesSunburstMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesSunburstMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesSunburstMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesSunburstMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesSunburstMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesSunburstMarkerStatesSelect)

        
class OptionSeriesSunburstMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesSunburstMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesSunburstMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstLevelsize(Options):

    @property
    def unit(self):
        """How to interpret <code>levelSize.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get("weight")

    @unit.setter
    def unit(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstLevelsColorvariation(Options):

    @property
    def key(self):
        """The key of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @key.setter
    def key(self, text: str): self._config(text, js_type=False)

    @property
    def to(self):
        """The ending value of a color variation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstLevels(Options):

    @property
    def borderColor(self):
        """Can set a <code>borderColor</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderDashStyle(self):
        """Can set a <code>borderDashStyle</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderDashStyle.setter
    def borderDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set a <code>borderWidth</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set a <code>color</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Determines whether the chart should receive one color per point based on this level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorVariation(self) -> 'OptionSeriesSunburstLevelsColorvariation':
        """Can set a <code>colorVariation</code> on all points which lies on the same level. """
        return self._config_sub_data("colorVariation", OptionSeriesSunburstLevelsColorvariation)

    @property
    def dataLabels(self) -> 'OptionSeriesSunburstLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lies on the same level. """
        return self._config_sub_data("dataLabels", OptionSeriesSunburstLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def levelSize(self):
        """Can set a <code>levelSize</code> on all points which lies on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @levelSize.setter
    def levelSize(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstLevelsDatalabelsStyle(Options):

    @property
    def textOverflow(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get("ellipsis")

    @textOverflow.setter
    def textOverflow(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstLevelsDatalabels(Options):

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSunburstLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSunburstLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSunburstLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSunburstLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def rotationMode(self):
        """Decides how the data label will be rotated relative to the perimeter of the sunburst.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(circular)

    @rotationMode.setter
    def rotationMode(self, value: Any): self._config(value, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesSunburstLevelsDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionSeriesSunburstLevelsDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionSeriesSunburstLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSunburstLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesSunburstLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesSunburstLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesSunburstDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesSunburstDataDragdropGuideboxDefault)

        
class OptionSeriesSunburstDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesSunburstDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesSunburstDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesSunburstDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesSunburstDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstBreadcrumbsEvents(Options):

    @property
    def click(self):
        """Fires when clicking on the breadcrumbs button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburstDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesSunburstDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesSunburstDragdropGuideboxDefault)

        
class OptionSeriesSunburstDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesSunburstDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesSunburstDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesSunburstDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesSunburstDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSunburst(Options):

    @property
    def accessibility(self) -> 'OptionSeriesSunburstAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesSunburstAccessibility)

    @property
    def allowDrillToNode(self):
        """When enabled the user can click on a point which is a parent and zoom in on its children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowDrillToNode.setter
    def allowDrillToNode(self, flag: bool): self._config(flag, js_type=False)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def allowTraversingTree(self):
        """When enabled the user can click on a point which is a parent and zoom in on its children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowTraversingTree.setter
    def allowTraversingTree(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def breadcrumbs(self) -> 'OptionSeriesSunburstBreadcrumbs':
        """Options for the breadcrumbs, the navigation at the top leading the way up through the traversed levels. """
        return self._config_sub_data("breadcrumbs", OptionSeriesSunburstBreadcrumbs)

    @property
    def center(self):
        """The center of the sunburst chart relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(["50%", "50%"])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesSunburstData':
        """. """
        return self._config_sub_data("data", OptionSeriesSunburstData)

    @property
    def dataLabels(self) -> 'OptionSeriesSunburstDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesSunburstDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesSunburstDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesSunburstDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesSunburstEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesSunburstEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesSunburstLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesSunburstLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levelIsConstant(self):
        """Used together with the levels and <code>allowDrillToNode</code> options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @levelIsConstant.setter
    def levelIsConstant(self, flag: bool): self._config(flag, js_type=False)

    @property
    def levels(self) -> 'OptionSeriesSunburstLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionSeriesSunburstLevels)

    @property
    def levelSize(self) -> 'OptionSeriesSunburstLevelsize':
        """Determines the width of the ring per level. """
        return self._config_sub_data("levelSize", OptionSeriesSunburstLevelsize)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSunburstMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesSunburstMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesSunburstOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesSunburstOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesSunburstPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesSunburstPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rootId(self):
        """Which point to use as a root in the visualization.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @rootId.setter
    def rootId(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """The diameter of the pie relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesSunburstSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesSunburstSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesSunburstStates':
        """. """
        return self._config_sub_data("states", OptionSeriesSunburstStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesSunburstTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesSunburstTooltip)

    @property
    def traverseUpButton(self) -> 'OptionSeriesSunburstTraverseupbutton':
        """Options for the button appearing when traversing down in a sunburst. """
        return self._config_sub_data("traverseUpButton", OptionSeriesSunburstTraverseupbutton)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesSunburstZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesSunburstZones)

        
class OptionSeriesSunburstDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstDatalabelsStyle(Options):

    @property
    def textOverflow(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get("ellipsis")

    @textOverflow.setter
    def textOverflow(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSunburstDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSunburstDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSunburstDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSunburstDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def rotationMode(self):
        """Decides how the data label will be rotated relative to the perimeter of the sunburst.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(circular)

    @rotationMode.setter
    def rotationMode(self, value: Any): self._config(value, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesSunburstDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionSeriesSunburstDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionSeriesSunburstDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSunburstDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesSunburstDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesSunburstDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesSunburstDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesSunburstDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesSunburstDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesSunburstDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesSunburstDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesSunburstDataMarkerStatesSelect)

        
class OptionSeriesSunburstDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesSunburstDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesSunburstDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesSunburstDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesSunburstDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The color of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorValue(self):
        """Serves a purpose only if a <code>colorAxis</code> object is defined in the chart options.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Treemap/TreemapSeriesDefaults.ts
        """
        return self._config_get(None)

    @colorValue.setter
    def colorValue(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesSunburstDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesSunburstDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesSunburstDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesSunburstDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesSunburstDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesSunburstDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSunburstDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesSunburstDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def parent(self):
        """Use this option to build a tree structure.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(None)

    @parent.setter
    def parent(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sliced(self):
        """Whether to display a slice offset from the center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sunburst/SunburstSeriesDefaults.ts
        """
        return self._config_get(False)

    @sliced.setter
    def sliced(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSunburstDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSunburstDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSunburstDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSunburstDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesSunburstDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSunburstDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstBreadcrumbsSeparatorStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("#666666")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstBreadcrumbsSeparator(Options):

    @property
    def style(self) -> 'OptionSeriesSunburstBreadcrumbsSeparatorStyle':
        """CSS styles for the breadcrumbs separator. """
        return self._config_sub_data("style", OptionSeriesSunburstBreadcrumbsSeparatorStyle)

    @property
    def text(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("/")

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstBreadcrumbsPosition(Options):

    @property
    def align(self):
        """Horizontal alignment of the breadcrumbs buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("left")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def verticalAlign(self):
        """Vertical alignment of the breadcrumbs buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The X offset of the breadcrumbs button group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The Y offset of the breadcrumbs button group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstBreadcrumbs(Options):

    @property
    def buttonSpacing(self):
        """The default padding for each button and separator in each direction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(5)

    @buttonSpacing.setter
    def buttonSpacing(self, num: float): self._config(num, js_type=False)

    @property
    def buttonTheme(self) -> 'OptionSeriesSunburstBreadcrumbsButtontheme':
        """A collection of attributes for the buttons. """
        return self._config_sub_data("buttonTheme", OptionSeriesSunburstBreadcrumbsButtontheme)

    @property
    def events(self) -> 'OptionSeriesSunburstBreadcrumbsEvents':
        """. """
        return self._config_sub_data("events", OptionSeriesSunburstBreadcrumbsEvents)

    @property
    def floating(self):
        """When the breadcrumbs are floating, the plot area will not move to make space for it.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @floating.setter
    def floating(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the breadcrumbs button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format the breadcrumb text from scratch.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesSunburstBreadcrumbsPosition':
        """Positioning for the button row. """
        return self._config_sub_data("position", OptionSeriesSunburstBreadcrumbsPosition)

    @property
    def relativeTo(self):
        """What box to align the button to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("plotBox")

    @relativeTo.setter
    def relativeTo(self, text: str): self._config(text, js_type=False)

    @property
    def rtl(self):
        """Whether to reverse the order of buttons.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @rtl.setter
    def rtl(self, flag: bool): self._config(flag, js_type=False)

    @property
    def separator(self) -> 'OptionSeriesSunburstBreadcrumbsSeparator':
        """Options object for Breadcrumbs separator. """
        return self._config_sub_data("separator", OptionSeriesSunburstBreadcrumbsSeparator)

    @property
    def showFullPath(self):
        """Show full path or only a single button.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(True)

    @showFullPath.setter
    def showFullPath(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """CSS styles for all breadcrumbs.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def useHTML(self):
        """Whether to use HTML to render the breadcrumbs items texts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """The z index of the breadcrumbs group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get(7)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSunburstBreadcrumbsButtonthemeStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Breadcrumbs/BreadcrumbsDefaults.ts
        """
        return self._config_get("#334eff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstBreadcrumbsButtontheme(Options):

    @property
    def style(self) -> 'OptionSeriesSunburstBreadcrumbsButtonthemeStyle':
        """. """
        return self._config_sub_data("style", OptionSeriesSunburstBreadcrumbsButtonthemeStyle)

        
class OptionSeriesSunburstAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSunburstAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSunburstAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesSunburstAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesSunburstAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesSunburstAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesSunburstAccessibilityPoint)

        
class OptionSeriesStreamgraphZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesStreamgraphTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesStreamgraphTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesStreamgraphStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesStreamgraphStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesStreamgraphStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesStreamgraphStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesStreamgraphStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesStreamgraphStatesSelectMarker)

        
class OptionSeriesStreamgraphStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesStreamgraphStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesStreamgraphStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphStates(Options):

    @property
    def hover(self) -> 'OptionSeriesStreamgraphStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesStreamgraphStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesStreamgraphStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesStreamgraphStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesStreamgraphStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesStreamgraphStatesNormal)

    @property
    def select(self) -> 'OptionSeriesStreamgraphStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesStreamgraphStatesSelect)

        
class OptionSeriesStreamgraphStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesStreamgraphStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesStreamgraphStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesStreamgraphStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesStreamgraphStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesStreamgraphStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesStreamgraphStatesHoverMarker)

        
class OptionSeriesStreamgraphSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesStreamgraphSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesStreamgraphSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesStreamgraphSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesStreamgraphSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesStreamgraphSonificationTracksMappingLowpassResonance)

        
class OptionSeriesStreamgraphSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesStreamgraphSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesStreamgraphSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesStreamgraphSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesStreamgraphSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesStreamgraphSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesStreamgraphSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesStreamgraphSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesStreamgraphSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesStreamgraphSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesStreamgraphSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesStreamgraphSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesStreamgraphSonificationTracksMappingVolume)

        
class OptionSeriesStreamgraphSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesStreamgraphSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesStreamgraphSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesStreamgraphSonificationTracksMappingHighpassResonance)

        
class OptionSeriesStreamgraphSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesStreamgraphSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesStreamgraphSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesStreamgraphSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesStreamgraphSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesStreamgraphSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesStreamgraphSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesStreamgraphSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesStreamgraphSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesStreamgraphSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesStreamgraphSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesStreamgraphSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesStreamgraphSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesStreamgraphSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesStreamgraphSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesStreamgraphSonificationTracks)

        
class OptionSeriesStreamgraphSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesStreamgraphSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesStreamgraphSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesStreamgraphSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesStreamgraphSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesStreamgraphSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesStreamgraphSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesStreamgraphSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesStreamgraphSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesStreamgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesStreamgraphSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesStreamgraphSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesStreamgraphSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesStreamgraphSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesStreamgraphSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesStreamgraphSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesStreamgraphSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesStreamgraphSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesStreamgraphSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesStreamgraphSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesStreamgraphSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesStreamgraphSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesStreamgraphSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesStreamgraphSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesStreamgraphSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesStreamgraphSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesStreamgraphSonificationContexttracksMappingVolume)

        
class OptionSeriesStreamgraphSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesStreamgraphSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesStreamgraphSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesStreamgraphSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesStreamgraphSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesStreamgraphSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesStreamgraphSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesStreamgraphSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesStreamgraphSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesStreamgraphPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphPoint(Options):

    @property
    def events(self) -> 'OptionSeriesStreamgraphPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesStreamgraphPointEvents)

        
class OptionSeriesStreamgraphOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesStreamgraphOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesStreamgraphOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesStreamgraphOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesStreamgraphOnpointPosition)

        
class OptionSeriesStreamgraphMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesStreamgraphMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesStreamgraphMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesStreamgraphMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesStreamgraphMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesStreamgraphMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesStreamgraphMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesStreamgraphMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesStreamgraphMarkerStatesSelect)

        
class OptionSeriesStreamgraphMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesStreamgraphMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesStreamgraphMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesStreamgraphLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesStreamgraphLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesStreamgraphDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesStreamgraphDataDragdropGuideboxDefault)

        
class OptionSeriesStreamgraphDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesStreamgraphDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesStreamgraphDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesStreamgraphDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesStreamgraphDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraphDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesStreamgraphDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesStreamgraphDragdropGuideboxDefault)

        
class OptionSeriesStreamgraphDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesStreamgraphDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesStreamgraphDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesStreamgraphDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesStreamgraphDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesStreamgraph(Options):

    @property
    def accessibility(self) -> 'OptionSeriesStreamgraphAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesStreamgraphAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesStreamgraphData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesStreamgraphData)

    @property
    def dataLabels(self) -> 'OptionSeriesStreamgraphDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesStreamgraphDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesStreamgraphDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesStreamgraphDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesStreamgraphDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesStreamgraphDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesStreamgraphEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesStreamgraphEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesStreamgraphLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesStreamgraphLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesStreamgraphMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesStreamgraphMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesStreamgraphOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesStreamgraphOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesStreamgraphPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesStreamgraphPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesStreamgraphSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesStreamgraphSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Streamgraph/StreamgraphSeriesDefaults.ts
        """
        return self._config_get("stream")

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesStreamgraphStates':
        """. """
        return self._config_sub_data("states", OptionSeriesStreamgraphStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesStreamgraphTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesStreamgraphTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(False)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesStreamgraphZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesStreamgraphZones)

        
class OptionSeriesStreamgraphDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesStreamgraphDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesStreamgraphDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesStreamgraphDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesStreamgraphDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesStreamgraphDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesStreamgraphDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesStreamgraphDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesStreamgraphDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesStreamgraphDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesStreamgraphDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesStreamgraphDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesStreamgraphDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesStreamgraphDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesStreamgraphDataMarkerStatesSelect)

        
class OptionSeriesStreamgraphDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesStreamgraphDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesStreamgraphDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesStreamgraphDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesStreamgraphDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesStreamgraphDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesStreamgraphDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesStreamgraphDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesStreamgraphDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesStreamgraphDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesStreamgraphDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesStreamgraphDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesStreamgraphDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesStreamgraphDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesStreamgraphDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesStreamgraphDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesStreamgraphDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesStreamgraphDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesStreamgraphDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesStreamgraphAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesStreamgraphAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesStreamgraphAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesStreamgraphAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesStreamgraphAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesStreamgraphAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesStreamgraphAccessibilityPoint)

        
class OptionSeriesSplineZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesSplineTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesSplineTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesSplineStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesSplineStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesSplineStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesSplineStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSplineStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesSplineStatesSelectMarker)

        
class OptionSeriesSplineStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesSplineStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesSplineStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineStates(Options):

    @property
    def hover(self) -> 'OptionSeriesSplineStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesSplineStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesSplineStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesSplineStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesSplineStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesSplineStatesNormal)

    @property
    def select(self) -> 'OptionSeriesSplineStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesSplineStatesSelect)

        
class OptionSeriesSplineStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesSplineStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesSplineStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesSplineStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesSplineStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSplineStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesSplineStatesHoverMarker)

        
class OptionSeriesSplineSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSplineSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSplineSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSplineSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSplineSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesSplineSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSplineSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSplineSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSplineSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSplineSonificationTracksMappingLowpassResonance)

        
class OptionSeriesSplineSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSplineSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSplineSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSplineSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSplineSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSplineSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSplineSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSplineSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSplineSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSplineSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSplineSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSplineSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSplineSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSplineSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSplineSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSplineSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSplineSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSplineSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesSplineSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSplineSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSplineSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSplineSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSplineSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSplineSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSplineSonificationTracksMappingVolume)

        
class OptionSeriesSplineSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSplineSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSplineSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSplineSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSplineSonificationTracksMappingHighpassResonance)

        
class OptionSeriesSplineSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSplineSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSplineSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSplineSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSplineSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSplineSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSplineSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesSplineSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesSplineSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesSplineSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesSplineSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesSplineSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSplineSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesSplineSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesSplineSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesSplineSonificationTracks)

        
class OptionSeriesSplineSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesSplineSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesSplineSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSplineSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSplineSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSplineSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesSplineSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSplineSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSplineSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesSplineSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesSplineSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesSplineSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSplineSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSplineSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSplineSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSplineSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesSplineSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSplineSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSplineSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSplineSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSplineSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSplineSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesSplineSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSplineSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSplineSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSplineSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSplineSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesSplineSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSplineSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSplineSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSplineSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSplineSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesSplineSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSplineSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSplineSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSplineSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSplineSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSplineSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSplineSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSplineSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSplineSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSplineSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSplineSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSplineSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSplineSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSplineSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSplineSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSplineSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSplineSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSplineSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesSplineSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSplineSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSplineSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSplineSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSplineSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSplineSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSplineSonificationContexttracksMappingVolume)

        
class OptionSeriesSplineSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSplineSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSplineSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSplineSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSplineSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSplineSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSplineSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSplineSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSplineSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSplineSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSplineSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesSplinePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplinePoint(Options):

    @property
    def events(self) -> 'OptionSeriesSplinePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesSplinePointEvents)

        
class OptionSeriesSplineOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesSplineOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesSplineOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesSplineOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesSplineOnpointPosition)

        
class OptionSeriesSplineMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesSplineMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesSplineMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesSplineMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesSplineMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesSplineMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesSplineMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesSplineMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesSplineMarkerStatesSelect)

        
class OptionSeriesSplineMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesSplineMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesSplineMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesSplineLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesSplineLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesSplineDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesSplineDataDragdropGuideboxDefault)

        
class OptionSeriesSplineDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesSplineDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesSplineDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesSplineDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesSplineDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSplineDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesSplineDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesSplineDragdropGuideboxDefault)

        
class OptionSeriesSplineDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesSplineDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesSplineDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesSplineDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesSplineDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSpline(Options):

    @property
    def accessibility(self) -> 'OptionSeriesSplineAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesSplineAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesSplineData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesSplineData)

    @property
    def dataLabels(self) -> 'OptionSeriesSplineDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesSplineDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesSplineDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesSplineDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesSplineDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesSplineDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesSplineEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesSplineEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesSplineLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesSplineLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSplineMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesSplineMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesSplineOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesSplineOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesSplinePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesSplinePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesSplineSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesSplineSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesSplineStates':
        """. """
        return self._config_sub_data("states", OptionSeriesSplineStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesSplineTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesSplineTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesSplineZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesSplineZones)

        
class OptionSeriesSplineDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSplineDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSplineDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSplineDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSplineDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesSplineDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSplineDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesSplineDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesSplineDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesSplineDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesSplineDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesSplineDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesSplineDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesSplineDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesSplineDataMarkerStatesSelect)

        
class OptionSeriesSplineDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesSplineDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesSplineDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesSplineDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesSplineDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesSplineDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesSplineDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesSplineDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesSplineDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesSplineDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesSplineDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSplineDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesSplineDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSplineDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSplineDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSplineDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSplineDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesSplineDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSplineDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSplineAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSplineAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSplineAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesSplineAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesSplineAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesSplineAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesSplineAccessibilityPoint)

        
class OptionSeriesSolidgaugeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesSolidgaugeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesSolidgaugeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSolidgaugeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSolidgaugeSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesSolidgaugeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSolidgaugeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSolidgaugeSonificationTracksMappingLowpassResonance)

        
class OptionSeriesSolidgaugeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSolidgaugeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSolidgaugeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSolidgaugeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSolidgaugeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSolidgaugeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSolidgaugeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSolidgaugeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSolidgaugeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesSolidgaugeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSolidgaugeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSolidgaugeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSolidgaugeSonificationTracksMappingVolume)

        
class OptionSeriesSolidgaugeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSolidgaugeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSolidgaugeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSolidgaugeSonificationTracksMappingHighpassResonance)

        
class OptionSeriesSolidgaugeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSolidgaugeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSolidgaugeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSolidgaugeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSolidgaugeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSolidgaugeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSolidgaugeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesSolidgaugeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesSolidgaugeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesSolidgaugeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesSolidgaugeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSolidgaugeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesSolidgaugeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesSolidgaugeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesSolidgaugeSonificationTracks)

        
class OptionSeriesSolidgaugeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesSolidgaugeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSolidgaugeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSolidgaugeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSolidgaugeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesSolidgaugeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSolidgaugeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSolidgaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesSolidgaugeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSolidgaugeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSolidgaugeSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSolidgaugeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSolidgaugeSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSolidgaugeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSolidgaugeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSolidgaugeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSolidgaugeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSolidgaugeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSolidgaugeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSolidgaugeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSolidgaugeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesSolidgaugeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSolidgaugeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSolidgaugeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSolidgaugeSonificationContexttracksMappingVolume)

        
class OptionSeriesSolidgaugeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSolidgaugeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSolidgaugeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSolidgaugeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSolidgaugeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSolidgaugeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSolidgaugeSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesSolidgaugePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugePoint(Options):

    @property
    def events(self) -> 'OptionSeriesSolidgaugePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesSolidgaugePointEvents)

        
class OptionSeriesSolidgaugeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesSolidgaugeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesSolidgaugeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesSolidgaugeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesSolidgaugeOnpointPosition)

        
class OptionSeriesSolidgaugeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesSolidgaugeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesSolidgaugeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSolidgaugeDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSolidgaugeDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesSolidgaugeDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesSolidgaugeDataDragdropGuideboxDefault)

        
class OptionSeriesSolidgaugeDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesSolidgaugeDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesSolidgaugeDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesSolidgaugeDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesSolidgaugeDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSolidgaugeDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgaugeData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesSolidgaugeDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesSolidgaugeDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesSolidgaugeDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesSolidgaugeDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesSolidgaugeDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesSolidgaugeDataDragdrop)

    @property
    def events(self) -> 'OptionSeriesSolidgaugeDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesSolidgaugeDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def innerRadius(self):
        """The inner radius of an individual point in a solid gauge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(None)

    @innerRadius.setter
    def innerRadius(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def radius(self):
        """The outer radius of an individual point in a solid gauge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesSolidgaugeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesSolidgaugeDragdropGuideboxDefault)

        
class OptionSeriesSolidgaugeDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesSolidgaugeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesSolidgaugeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesSolidgaugeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesSolidgaugeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSolidgaugeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSolidgauge(Options):

    @property
    def accessibility(self) -> 'OptionSeriesSolidgaugeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesSolidgaugeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """Whether to give each point an individual color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def data(self) -> 'OptionSeriesSolidgaugeData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesSolidgaugeData)

    @property
    def dataLabels(self) -> 'OptionSeriesSolidgaugeDatalabels':
        """Data labels for the gauge. """
        return self._config_sub_data("dataLabels", OptionSeriesSolidgaugeDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesSolidgaugeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesSolidgaugeDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesSolidgaugeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesSolidgaugeEvents)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def innerRadius(self):
        """The inner radius for points in a solid gauge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get('"60%"')

    @innerRadius.setter
    def innerRadius(self, text: str): self._config(text, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesSolidgaugeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesSolidgaugeLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """Whether the strokes of the solid gauge should be <code>round</code> or <code>square</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesSolidgaugeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesSolidgaugeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def overshoot(self):
        """Allow the gauge to overshoot the end of the perimeter axis by this many degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(0)

    @overshoot.setter
    def overshoot(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesSolidgaugePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesSolidgaugePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The outer radius for points in a solid gauge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get('"100%"')

    @radius.setter
    def radius(self, text: str): self._config(text, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rounded(self):
        """Whether to draw rounded edges on the gauge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(False)

    @rounded.setter
    def rounded(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesSolidgaugeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesSolidgaugeSonification)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesSolidgaugeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesSolidgaugeTooltip)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSolidgaugeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSolidgaugeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSolidgaugeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#cccccc")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSolidgaugeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSolidgaugeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesSolidgaugeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSolidgaugeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SolidGauge/SolidGaugeSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(2)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSolidgaugeDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSolidgaugeDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSolidgaugeDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSolidgaugeDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSolidgaugeDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesSolidgaugeDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSolidgaugeDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSolidgaugeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSolidgaugeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSolidgaugeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesSolidgaugeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesSolidgaugeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesSolidgaugeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesSolidgaugeAccessibilityPoint)

        
class OptionSeriesScatter3dZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesScatter3dTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesScatter3dTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter3D/Scatter3DSeriesDefaults.ts
        """
        return self._config_get("x: <b>{point.x}</b><br/>y: <b>{point.y}</b><br/>z: <b>{point.z}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesScatter3dStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesScatter3dStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesScatter3dStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesScatter3dStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesScatter3dStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesScatter3dStatesSelectMarker)

        
class OptionSeriesScatter3dStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesScatter3dStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesScatter3dStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dStates(Options):

    @property
    def hover(self) -> 'OptionSeriesScatter3dStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesScatter3dStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesScatter3dStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesScatter3dStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesScatter3dStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesScatter3dStatesNormal)

    @property
    def select(self) -> 'OptionSeriesScatter3dStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesScatter3dStatesSelect)

        
class OptionSeriesScatter3dStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesScatter3dStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesScatter3dStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesScatter3dStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesScatter3dStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesScatter3dStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesScatter3dStatesHoverMarker)

        
class OptionSeriesScatter3dSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesScatter3dSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesScatter3dSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesScatter3dSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesScatter3dSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesScatter3dSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatter3dSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatter3dSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatter3dSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatter3dSonificationTracksMappingLowpassResonance)

        
class OptionSeriesScatter3dSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatter3dSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesScatter3dSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesScatter3dSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesScatter3dSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesScatter3dSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesScatter3dSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesScatter3dSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesScatter3dSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesScatter3dSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesScatter3dSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesScatter3dSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesScatter3dSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesScatter3dSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesScatter3dSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesScatter3dSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesScatter3dSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesScatter3dSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesScatter3dSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesScatter3dSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesScatter3dSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesScatter3dSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesScatter3dSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesScatter3dSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesScatter3dSonificationTracksMappingVolume)

        
class OptionSeriesScatter3dSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatter3dSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatter3dSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatter3dSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatter3dSonificationTracksMappingHighpassResonance)

        
class OptionSeriesScatter3dSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesScatter3dSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesScatter3dSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesScatter3dSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesScatter3dSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatter3dSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatter3dSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesScatter3dSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesScatter3dSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesScatter3dSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesScatter3dSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesScatter3dSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatter3dSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatter3dSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesScatter3dSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesScatter3dSonificationTracks)

        
class OptionSeriesScatter3dSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesScatter3dSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesScatter3dSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesScatter3dSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesScatter3dSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesScatter3dSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesScatter3dSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatter3dSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatter3dSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatter3dSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesScatter3dSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesScatter3dSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesScatter3dSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesScatter3dSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatter3dSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatter3dSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesScatter3dSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesScatter3dSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesScatter3dSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesScatter3dSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesScatter3dSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesScatter3dSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesScatter3dSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesScatter3dSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesScatter3dSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesScatter3dSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesScatter3dSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesScatter3dSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesScatter3dSonificationContexttracksMappingVolume)

        
class OptionSeriesScatter3dSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesScatter3dSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesScatter3dSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesScatter3dSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesScatter3dSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatter3dSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatter3dSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatter3dSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatter3dSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatter3dSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesScatter3dPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dPoint(Options):

    @property
    def events(self) -> 'OptionSeriesScatter3dPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesScatter3dPointEvents)

        
class OptionSeriesScatter3dOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesScatter3dOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesScatter3dOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesScatter3dOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesScatter3dOnpointPosition)

        
class OptionSeriesScatter3dMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesScatter3dMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesScatter3dMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesScatter3dMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesScatter3dMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesScatter3dMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesScatter3dMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesScatter3dMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesScatter3dMarkerStatesSelect)

        
class OptionSeriesScatter3dMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesScatter3dMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesScatter3dMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesScatter3dLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesScatter3dLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesScatter3dDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesScatter3dDataDragdropGuideboxDefault)

        
class OptionSeriesScatter3dDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesScatter3dDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesScatter3dDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesScatter3dDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesScatter3dDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesScatter3dDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesScatter3dDragdropGuideboxDefault)

        
class OptionSeriesScatter3dDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesScatter3dDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesScatter3dDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesScatter3dDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesScatter3dDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatter3dJitter(Options):

    @property
    def x(self):
        """The maximal X offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The maximal Y offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3d(Options):

    @property
    def accessibility(self) -> 'OptionSeriesScatter3dAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesScatter3dAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesScatter3dData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesScatter3dData)

    @property
    def dataLabels(self) -> 'OptionSeriesScatter3dDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesScatter3dDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesScatter3dDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesScatter3dDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesScatter3dDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesScatter3dDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesScatter3dEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesScatter3dEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def jitter(self) -> 'OptionSeriesScatter3dJitter':
        """Apply a jitter effect for the rendered markers. """
        return self._config_sub_data("jitter", OptionSeriesScatter3dJitter)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesScatter3dLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesScatter3dLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesScatter3dMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesScatter3dMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesScatter3dOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesScatter3dOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesScatter3dPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesScatter3dPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesScatter3dSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesScatter3dSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesScatter3dStates':
        """. """
        return self._config_sub_data("states", OptionSeriesScatter3dStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesScatter3dTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesScatter3dTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesScatter3dZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesScatter3dZones)

        
class OptionSeriesScatter3dDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesScatter3dDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesScatter3dDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesScatter3dDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesScatter3dDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesScatter3dDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesScatter3dDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesScatter3dDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesScatter3dDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesScatter3dDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesScatter3dDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesScatter3dDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesScatter3dDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesScatter3dDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesScatter3dDataMarkerStatesSelect)

        
class OptionSeriesScatter3dDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesScatter3dDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesScatter3dDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesScatter3dDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesScatter3dDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesScatter3dDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesScatter3dDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesScatter3dDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesScatter3dDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesScatter3dDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesScatter3dDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesScatter3dDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesScatter3dDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def z(self):
        """The z value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter3D/Scatter3DSeriesDefaults.ts
        """
        return self._config_get(None)

    @z.setter
    def z(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesScatter3dDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesScatter3dDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesScatter3dDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesScatter3dDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesScatter3dDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesScatter3dDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter3dAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatter3dAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatter3dAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesScatter3dAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesScatter3dAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesScatter3dAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesScatter3dAccessibilityPoint)

        
class OptionSeriesScatterZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesScatterTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesScatterTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("x: <b>{point.x}</b><br/>y: <b>{point.y}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesScatterStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesScatterStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesScatterStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesScatterStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesScatterStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesScatterStatesSelectMarker)

        
class OptionSeriesScatterStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesScatterStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesScatterStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterStates(Options):

    @property
    def hover(self) -> 'OptionSeriesScatterStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesScatterStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesScatterStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesScatterStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesScatterStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesScatterStatesNormal)

    @property
    def select(self) -> 'OptionSeriesScatterStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesScatterStatesSelect)

        
class OptionSeriesScatterStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesScatterStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesScatterStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesScatterStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesScatterStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesScatterStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesScatterStatesHoverMarker)

        
class OptionSeriesScatterSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesScatterSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesScatterSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesScatterSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesScatterSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesScatterSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatterSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatterSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatterSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatterSonificationTracksMappingLowpassResonance)

        
class OptionSeriesScatterSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatterSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesScatterSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesScatterSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesScatterSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesScatterSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesScatterSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesScatterSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesScatterSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesScatterSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesScatterSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesScatterSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesScatterSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesScatterSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesScatterSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesScatterSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesScatterSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesScatterSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesScatterSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesScatterSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesScatterSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesScatterSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesScatterSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesScatterSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesScatterSonificationTracksMappingVolume)

        
class OptionSeriesScatterSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatterSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatterSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatterSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatterSonificationTracksMappingHighpassResonance)

        
class OptionSeriesScatterSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesScatterSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesScatterSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesScatterSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesScatterSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatterSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatterSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesScatterSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesScatterSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesScatterSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesScatterSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesScatterSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatterSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatterSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesScatterSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesScatterSonificationTracks)

        
class OptionSeriesScatterSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesScatterSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesScatterSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesScatterSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesScatterSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesScatterSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesScatterSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesScatterSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesScatterSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesScatterSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesScatterSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesScatterSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesScatterSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesScatterSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesScatterSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesScatterSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatterSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatterSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesScatterSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesScatterSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatterSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatterSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesScatterSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesScatterSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesScatterSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesScatterSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesScatterSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesScatterSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatterSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatterSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatterSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatterSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesScatterSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatterSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesScatterSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesScatterSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesScatterSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesScatterSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesScatterSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesScatterSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesScatterSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesScatterSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesScatterSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesScatterSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesScatterSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesScatterSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesScatterSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesScatterSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesScatterSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesScatterSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesScatterSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesScatterSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesScatterSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesScatterSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesScatterSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesScatterSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesScatterSonificationContexttracksMappingVolume)

        
class OptionSeriesScatterSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesScatterSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesScatterSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesScatterSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesScatterSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesScatterSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesScatterSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesScatterSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesScatterSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesScatterSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesScatterSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesScatterPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterPoint(Options):

    @property
    def events(self) -> 'OptionSeriesScatterPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesScatterPointEvents)

        
class OptionSeriesScatterOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesScatterOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesScatterOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesScatterOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesScatterOnpointPosition)

        
class OptionSeriesScatterMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesScatterMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesScatterMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesScatterMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesScatterMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesScatterMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesScatterMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesScatterMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesScatterMarkerStatesSelect)

        
class OptionSeriesScatterMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesScatterMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesScatterMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesScatterLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesScatterLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterClusterEvents(Options):

    @property
    def drillToCluster(self):
        """Fires when the cluster point is clicked and <code>drillToCluster</code> is enabled.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @drillToCluster.setter
    def drillToCluster(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesScatterDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesScatterDataDragdropGuideboxDefault)

        
class OptionSeriesScatterDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesScatterDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesScatterDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesScatterDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesScatterDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesScatterDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesScatterDragdropGuideboxDefault)

        
class OptionSeriesScatterDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesScatterDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesScatterDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesScatterDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesScatterDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesScatterJitter(Options):

    @property
    def x(self):
        """The maximal X offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The maximal Y offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatter(Options):

    @property
    def accessibility(self) -> 'OptionSeriesScatterAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesScatterAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cluster(self) -> 'OptionSeriesScatterCluster':
        """Options for marker clusters, the concept of sampling the data values into larger blocks in order to ease readability and increase performance of the JavaScript charts. """
        return self._config_sub_data("cluster", OptionSeriesScatterCluster)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesScatterData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesScatterData)

    @property
    def dataLabels(self) -> 'OptionSeriesScatterDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesScatterDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesScatterDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesScatterDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesScatterDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesScatterDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesScatterEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesScatterEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def jitter(self) -> 'OptionSeriesScatterJitter':
        """Apply a jitter effect for the rendered markers. """
        return self._config_sub_data("jitter", OptionSeriesScatterJitter)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesScatterLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesScatterLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesScatterMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesScatterMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesScatterOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesScatterOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesScatterPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesScatterPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesScatterSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesScatterSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesScatterStates':
        """. """
        return self._config_sub_data("states", OptionSeriesScatterStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesScatterTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesScatterTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesScatterZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesScatterZones)

        
class OptionSeriesScatterDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesScatterDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesScatterDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesScatterDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesScatterDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesScatterDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesScatterDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesScatterDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesScatterDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesScatterDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesScatterDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesScatterDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesScatterDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesScatterDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesScatterDataMarkerStatesSelect)

        
class OptionSeriesScatterDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesScatterDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesScatterDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesScatterDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesScatterDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesScatterDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesScatterDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesScatterDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesScatterDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesScatterDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesScatterDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesScatterDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesScatterDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesScatterDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesScatterDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesScatterDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesScatterDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesScatterDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesScatterDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterClusterZonesMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterClusterZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def from_(self):
        """The value where the zone starts.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesScatterClusterZonesMarker':
        """Settings for the cluster marker belonging to the zone. """
        return self._config_sub_data("marker", OptionSeriesScatterClusterZonesMarker)

    @property
    def to(self):
        """The value where the zone ends.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterClusterStatesHover(Options):

    @property
    def fillColor(self):
        """The fill color of the cluster marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterClusterStates(Options):

    @property
    def hover(self) -> 'OptionSeriesScatterClusterStatesHover':
        """. """
        return self._config_sub_data("hover", OptionSeriesScatterClusterStatesHover)

        
class OptionSeriesScatterClusterMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(15)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("cluster")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesScatterClusterLayoutalgorithm(Options):

    @property
    def distance(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>distance</code> is a maximum distance between point and cluster center so that this point will be inside the cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(40)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def gridSize(self):
        """When <code>type</code> is set to the <code>grid</code>, <code>gridSize</code> is a size of a grid square element either as a number defining pixels, or a percentage defining a percentage of the plot area width.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(50)

    @gridSize.setter
    def gridSize(self, num: float): self._config(num, js_type=False)

    @property
    def iterations(self):
        """When <code>type</code> is set to <code>kmeans</code>, <code>iterations</code> are the number of iterations that this algorithm will be repeated to find clusters positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @iterations.setter
    def iterations(self, num: float): self._config(num, js_type=False)

    @property
    def kmeansThreshold(self):
        """When <code>type</code> is set to <code>undefined</code> and there are more visible points than the kmeansThreshold the <code>grid</code> algorithm is used to find clusters, otherwise <code>kmeans</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(100)

    @kmeansThreshold.setter
    def kmeansThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used to combine points into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterCluster(Options):

    @property
    def allowOverlap(self):
        """When set to <code>false</code> prevent cluster overlapping - this option works only when <code>layoutAlgorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Options for the cluster marker animation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get({ "duration": 500 })

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesScatterClusterDatalabels':
        """Options for the cluster data labels. """
        return self._config_sub_data("dataLabels", OptionSeriesScatterClusterDatalabels)

    @property
    def drillToCluster(self):
        """Zoom the plot area to the cluster points range when a cluster is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @drillToCluster.setter
    def drillToCluster(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Whether to enable the marker-clusters module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesScatterClusterEvents':
        """. """
        return self._config_sub_data("events", OptionSeriesScatterClusterEvents)

    @property
    def layoutAlgorithm(self) -> 'OptionSeriesScatterClusterLayoutalgorithm':
        """Options for layout algorithm. """
        return self._config_sub_data("layoutAlgorithm", OptionSeriesScatterClusterLayoutalgorithm)

    @property
    def marker(self) -> 'OptionSeriesScatterClusterMarker':
        """Options for the cluster marker. """
        return self._config_sub_data("marker", OptionSeriesScatterClusterMarker)

    @property
    def minimumClusterSize(self):
        """The minimum amount of points to be combined into a cluster.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(2)

    @minimumClusterSize.setter
    def minimumClusterSize(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesScatterClusterStates':
        """. """
        return self._config_sub_data("states", OptionSeriesScatterClusterStates)

    @property
    def zones(self) -> 'OptionSeriesScatterClusterZones':
        """An array defining zones within marker clusters. """
        return self._config_sub_data("zones", OptionSeriesScatterClusterZones)

        
class OptionSeriesScatterClusterDatalabelsStyle(Options):

    @property
    def color(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("contrast")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterClusterDatalabels(Options):

    @property
    def align(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("{point.clusterPointsAmount}")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def inside(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesScatterClusterDatalabelsStyle':
        """. """
        return self._config_sub_data("style", OptionSeriesScatterClusterDatalabelsStyle)

    @property
    def verticalAlign(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesScatterAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesScatterAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesScatterAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesScatterAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesScatterAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesScatterAccessibilityPoint)

        
class OptionSeriesSankeyTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeyTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesSankeyTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesSankeyTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the pointer or stay fixed on the item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.name}: <b>{point.sum}</b><br/>")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the chart&#39;s tooltip, as opposed to links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.name} → {point.toNode.name}: <b>{point.weight}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeyStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesSankeyStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesSankeyStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesSankeyStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesSankeyStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSankeyStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesSankeyStatesSelectMarker)

        
class OptionSeriesSankeyStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesSankeyStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesSankeyStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyStates(Options):

    @property
    def hover(self) -> 'OptionSeriesSankeyStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesSankeyStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesSankeyStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionSeriesSankeyStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesSankeyStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesSankeyStatesNormal)

    @property
    def select(self) -> 'OptionSeriesSankeyStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesSankeyStatesSelect)

        
class OptionSeriesSankeyStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesSankeyStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesSankeyStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesSankeyStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesSankeyStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSankeyStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesSankeyStatesHoverMarker)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeySonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSankeySonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSankeySonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSankeySonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSankeySonificationTracksMappingTremoloSpeed)

        
class OptionSeriesSankeySonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSankeySonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSankeySonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSankeySonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSankeySonificationTracksMappingLowpassResonance)

        
class OptionSeriesSankeySonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSankeySonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSankeySonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSankeySonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSankeySonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSankeySonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSankeySonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSankeySonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSankeySonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSankeySonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSankeySonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSankeySonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSankeySonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSankeySonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSankeySonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSankeySonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSankeySonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSankeySonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesSankeySonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSankeySonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSankeySonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSankeySonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSankeySonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSankeySonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSankeySonificationTracksMappingVolume)

        
class OptionSeriesSankeySonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSankeySonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSankeySonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSankeySonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSankeySonificationTracksMappingHighpassResonance)

        
class OptionSeriesSankeySonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSankeySonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSankeySonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSankeySonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSankeySonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSankeySonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSankeySonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesSankeySonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesSankeySonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesSankeySonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesSankeySonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesSankeySonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSankeySonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesSankeySonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesSankeySonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesSankeySonificationTracks)

        
class OptionSeriesSankeySonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesSankeySonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesSankeySonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSankeySonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSankeySonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSankeySonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesSankeySonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSankeySonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSankeySonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesSankeySonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesSankeySonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesSankeySonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSankeySonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSankeySonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSankeySonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSankeySonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesSankeySonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSankeySonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSankeySonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSankeySonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSankeySonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSankeySonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesSankeySonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesSankeySonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesSankeySonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesSankeySonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesSankeySonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesSankeySonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSankeySonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSankeySonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSankeySonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSankeySonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesSankeySonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesSankeySonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesSankeySonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesSankeySonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesSankeySonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesSankeySonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesSankeySonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesSankeySonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesSankeySonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesSankeySonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesSankeySonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesSankeySonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesSankeySonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesSankeySonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesSankeySonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesSankeySonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesSankeySonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesSankeySonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesSankeySonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesSankeySonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesSankeySonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesSankeySonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesSankeySonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesSankeySonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesSankeySonificationContexttracksMappingVolume)

        
class OptionSeriesSankeySonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesSankeySonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesSankeySonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesSankeySonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesSankeySonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesSankeySonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesSankeySonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeySonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesSankeySonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesSankeySonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesSankeySonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesSankeySonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesSankeyPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeyPoint(Options):

    @property
    def events(self) -> 'OptionSeriesSankeyPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesSankeyPointEvents)

        
class OptionSeriesSankeyOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyNodesDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyNodesDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeyOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesSankeyOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesSankeyOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesSankeyOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesSankeyOnpointPosition)

        
class OptionSeriesSankeyNodes(Options):

    @property
    def color(self):
        """The color of the auto generated node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """The color index of the auto generated node, especially for use in styled mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def column(self):
        """An optional column index of where to place the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @column.setter
    def column(self, num: float): self._config(num, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesSankeyNodesDatalabels':
        """Individual data label for each node. """
        return self._config_sub_data("dataLabels", OptionSeriesSankeyNodesDatalabels)

    @property
    def id(self):
        """The id of the auto-generated node, refering to the <code>from</code> or <code>to</code> setting of the link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def level(self):
        """An optional level index of where to place the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name to display for the node in data labels and tooltips.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def offset(self):
        """This option is deprecated, use <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @offset.setter
    def offset(self, num: float): self._config(num, js_type=False)

    @property
    def offsetHorizontal(self):
        """The horizontal offset of a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @offsetHorizontal.setter
    def offsetHorizontal(self, num: float): self._config(num, js_type=False)

    @property
    def offsetVertical(self):
        """The vertical offset of a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @offsetVertical.setter
    def offsetVertical(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyNodesDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyNodesDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSankeyNodesDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSankeyNodesDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSankeyNodesDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSankeyNodesDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesSankeyNodesDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSankeyNodesDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesSankeyMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesSankeyMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesSankeyMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesSankeyMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesSankeyMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesSankeyMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesSankeyMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesSankeyMarkerStatesSelect)

        
class OptionSeriesSankeyMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesSankeyMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesSankeyMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyLevelsStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyLevelsStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesSankeyLevelsStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesSankeyLevelsStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyLevelsStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyLevelsStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyLevelsStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyLevelsStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesSankeyLevelsStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesSankeyLevelsStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyLevelsStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesSankeyLevelsStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesSankeyLevelsStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeyLevelsStates(Options):

    @property
    def hover(self) -> 'OptionSeriesSankeyLevelsStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesSankeyLevelsStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesSankeyLevelsStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionSeriesSankeyLevelsStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesSankeyLevelsStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesSankeyLevelsStatesNormal)

    @property
    def select(self) -> 'OptionSeriesSankeyLevelsStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesSankeyLevelsStatesSelect)

        
class OptionSeriesSankeyLevels(Options):

    @property
    def borderColor(self):
        """Can set <code>borderColor</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set <code>borderWidth</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set <code>color</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Can set <code>colorByPoint</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesSankeyLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lay on the same level. """
        return self._config_sub_data("dataLabels", OptionSeriesSankeyLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Can set <code>linkOpacity</code> on all points which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesSankeyLevelsStates':
        """Can set <code>states</code> on all nodes and points which lay on the same level. """
        return self._config_sub_data("states", OptionSeriesSankeyLevelsStates)

        
class OptionSeriesSankeyLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSankeyLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSankeyLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSankeyLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSankeyLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesSankeyLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSankeyLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeyDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankeyDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeyData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesSankeyDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesSankeyDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The color for the individual <em>link</em>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesSankeyDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesSankeyDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesSankeyDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesSankeyDataEvents)

    @property
    def from_(self):
        """The node that the link runs from.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, text: str): self._config(text, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def outgoing(self):
        """Whether the link goes out of the system.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @outgoing.setter
    def outgoing(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def to(self):
        """The node that the link runs to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, text: str): self._config(text, js_type=False)

    @property
    def weight(self):
        """The weight of the link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @weight.setter
    def weight(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesSankey(Options):

    @property
    def accessibility(self) -> 'OptionSeriesSankeyAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesSankeyAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def curveFactor(self):
        """Higher numbers makes the links in a sankey diagram or dependency wheelrender more curved.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.33)

    @curveFactor.setter
    def curveFactor(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesSankeyData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesSankeyData)

    @property
    def dataLabels(self) -> 'OptionSeriesSankeyDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionSeriesSankeyDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesSankeyEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesSankeyEvents)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionSeriesSankeyLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionSeriesSankeyLevels)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkColorMode(self):
        """Determines color mode for sankey links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("from")

    @linkColorMode.setter
    def linkColorMode(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesSankeyMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesSankeyMarker)

    @property
    def minLinkWidth(self):
        """The minimal width for a line of a sankey.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @minLinkWidth.setter
    def minLinkWidth(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def nodeAlignment(self):
        """Determines which side of the chart the nodes are to be aligned to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeAlignment.setter
    def nodeAlignment(self, value: Any): self._config(value, js_type=False)

    @property
    def nodePadding(self):
        """The padding between nodes in a sankey diagram or dependency wheel, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(10)

    @nodePadding.setter
    def nodePadding(self, num: float): self._config(num, js_type=False)

    @property
    def nodes(self) -> 'OptionSeriesSankeyNodes':
        """A collection of options for the individual nodes. """
        return self._config_sub_data("nodes", OptionSeriesSankeyNodes)

    @property
    def nodeWidth(self):
        """The pixel width of each node in a sankey diagram or dependency wheel, or the height in case the chart is inverted.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(20)

    @nodeWidth.setter
    def nodeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesSankeyOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesSankeyOnpoint)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesSankeyPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesSankeyPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesSankeySonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesSankeySonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesSankeyStates':
        """. """
        return self._config_sub_data("states", OptionSeriesSankeyStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesSankeyTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesSankeyTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSankeyDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSankeyDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSankeyDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSankeyDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesSankeyDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSankeyDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesSankeyDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesSankeyDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesSankeyDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesSankeyDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesSankeyDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesSankeyDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesSankeyAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesSankeyAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesSankeyAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesSankeyAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesSankeyAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesSankeyAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesSankeyAccessibilityPoint)

        
class OptionSeriesPyramid3dZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesPyramid3dTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesPyramid3dTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesPyramid3dStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPyramid3dStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPyramid3dStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPyramid3dStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPyramid3dStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPyramid3dStatesSelectMarker)

        
class OptionSeriesPyramid3dStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramid3dStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesPyramid3dStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPyramid3dStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPyramid3dStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesPyramid3dStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesPyramid3dStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesPyramid3dStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesPyramid3dStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesPyramid3dStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPyramid3dStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesPyramid3dStatesSelect)

        
class OptionSeriesPyramid3dStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPyramid3dStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPyramid3dStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPyramid3dStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPyramid3dStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPyramid3dStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPyramid3dStatesHoverMarker)

        
class OptionSeriesPyramid3dSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPyramid3dSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPyramid3dSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesPyramid3dSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramid3dSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramid3dSonificationTracksMappingLowpassResonance)

        
class OptionSeriesPyramid3dSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPyramid3dSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPyramid3dSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPyramid3dSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPyramid3dSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPyramid3dSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPyramid3dSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPyramid3dSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPyramid3dSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPyramid3dSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPyramid3dSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPyramid3dSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPyramid3dSonificationTracksMappingVolume)

        
class OptionSeriesPyramid3dSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramid3dSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramid3dSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramid3dSonificationTracksMappingHighpassResonance)

        
class OptionSeriesPyramid3dSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPyramid3dSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPyramid3dSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPyramid3dSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPyramid3dSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramid3dSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramid3dSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesPyramid3dSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesPyramid3dSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesPyramid3dSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesPyramid3dSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesPyramid3dSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramid3dSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramid3dSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesPyramid3dSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesPyramid3dSonificationTracks)

        
class OptionSeriesPyramid3dSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesPyramid3dSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesPyramid3dSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPyramid3dSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPyramid3dSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPyramid3dSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPyramid3dSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramid3dSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramid3dSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramid3dSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesPyramid3dSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPyramid3dSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPyramid3dSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramid3dSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramid3dSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPyramid3dSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPyramid3dSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPyramid3dSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPyramid3dSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPyramid3dSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPyramid3dSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPyramid3dSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPyramid3dSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPyramid3dSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPyramid3dSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPyramid3dSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPyramid3dSonificationContexttracksMappingVolume)

        
class OptionSeriesPyramid3dSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPyramid3dSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPyramid3dSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPyramid3dSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramid3dSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramid3dSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramid3dSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramid3dSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramid3dSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesPyramid3dPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dPoint(Options):

    @property
    def events(self) -> 'OptionSeriesPyramid3dPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesPyramid3dPointEvents)

        
class OptionSeriesPyramid3dOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesPyramid3dOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesPyramid3dOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesPyramid3dOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesPyramid3dOnpointPosition)

        
class OptionSeriesPyramid3dMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramid3dMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPyramid3dMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPyramid3dMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPyramid3dMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesPyramid3dMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesPyramid3dMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesPyramid3dMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPyramid3dMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesPyramid3dMarkerStatesSelect)

        
class OptionSeriesPyramid3dMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPyramid3dMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesPyramid3dMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesPyramid3dLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesPyramid3dLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramid3dDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramid3dDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesPyramid3dDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesPyramid3dDataDragdropGuideboxDefault)

        
class OptionSeriesPyramid3dDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesPyramid3dDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesPyramid3dDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesPyramid3dDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesPyramid3dDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramid3dDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3dData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPyramid3dDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesPyramid3dDataAccessibility)

    @property
    def borderColor(self):
        """The color of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesPyramid3dDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesPyramid3dDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesPyramid3dDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesPyramid3dDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPyramid3dDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesPyramid3dDataEvents)

    @property
    def gradientForSides(self):
        """By deafult sides fill is set to a gradient through this option being set to <code>true</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(None)

    @gradientForSides.setter
    def gradientForSides(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesPyramid3dDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesPyramid3dDragdropGuideboxDefault)

        
class OptionSeriesPyramid3dDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesPyramid3dDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesPyramid3dDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesPyramid3dDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesPyramid3dDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramid3dEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid3d(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPyramid3dAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesPyramid3dAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesPyramid3dData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesPyramid3dData)

    @property
    def dataLabels(self) -> 'OptionSeriesPyramid3dDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesPyramid3dDatalabels)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesPyramid3dDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesPyramid3dDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(0)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPyramid3dEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesPyramid3dEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def gradientForSides(self):
        """By deafult sides fill is set to a gradient through this option being set to <code>true</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @gradientForSides.setter
    def gradientForSides(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def height(self):
        """The height of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("100%")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesPyramid3dLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesPyramid3dLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPyramid3dMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesPyramid3dMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesPyramid3dOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesPyramid3dOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesPyramid3dPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesPyramid3dPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def reversed(self):
        """A reversed pyramid3d is funnel3d, but the latter supports neck related options: neckHeight and neckWidth.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pyramid3D/Pyramid3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesPyramid3dSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesPyramid3dSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPyramid3dStates':
        """. """
        return self._config_sub_data("states", OptionSeriesPyramid3dStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesPyramid3dTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesPyramid3dTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def width(self):
        """The max width of the series compared to the width of the plot area, or the pixel width if it is a number.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("90%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesPyramid3dZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesPyramid3dZones)

        
class OptionSeriesPyramid3dDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramid3dDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("right")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPyramid3dDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPyramid3dDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPyramid3dDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPyramid3dDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("allow")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPyramid3dDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPyramid3dDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pyramid3D/Pyramid3DSeriesDefaults.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramid3dDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPyramid3dDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPyramid3dDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPyramid3dDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPyramid3dDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPyramid3dDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPyramid3dDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramid3dAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramid3dAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramid3dAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesPyramid3dAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesPyramid3dAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesPyramid3dAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesPyramid3dAccessibilityPoint)

        
class OptionSeriesPyramidZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesPyramidTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesPyramidTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesPyramidStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPyramidStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPyramidStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPyramidStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPyramidStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPyramidStatesSelectMarker)

        
class OptionSeriesPyramidStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramidStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesPyramidStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPyramidStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPyramidStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesPyramidStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesPyramidStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesPyramidStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesPyramidStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesPyramidStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPyramidStatesSelect':
        """Options for a selected funnel item. """
        return self._config_sub_data("select", OptionSeriesPyramidStatesSelect)

        
class OptionSeriesPyramidStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPyramidStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPyramidStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPyramidStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPyramidStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPyramidStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPyramidStatesHoverMarker)

        
class OptionSeriesPyramidSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPyramidSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPyramidSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPyramidSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPyramidSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesPyramidSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramidSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramidSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramidSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramidSonificationTracksMappingLowpassResonance)

        
class OptionSeriesPyramidSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramidSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPyramidSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPyramidSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPyramidSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPyramidSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPyramidSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPyramidSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPyramidSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPyramidSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPyramidSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPyramidSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPyramidSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPyramidSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPyramidSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPyramidSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPyramidSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPyramidSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPyramidSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPyramidSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPyramidSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPyramidSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPyramidSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPyramidSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPyramidSonificationTracksMappingVolume)

        
class OptionSeriesPyramidSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramidSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramidSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramidSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramidSonificationTracksMappingHighpassResonance)

        
class OptionSeriesPyramidSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPyramidSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPyramidSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPyramidSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPyramidSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramidSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramidSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesPyramidSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesPyramidSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesPyramidSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesPyramidSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesPyramidSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramidSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramidSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesPyramidSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesPyramidSonificationTracks)

        
class OptionSeriesPyramidSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesPyramidSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesPyramidSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPyramidSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPyramidSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPyramidSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesPyramidSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPyramidSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPyramidSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesPyramidSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesPyramidSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesPyramidSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPyramidSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPyramidSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPyramidSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPyramidSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramidSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramidSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPyramidSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramidSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesPyramidSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPyramidSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPyramidSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesPyramidSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramidSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramidSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesPyramidSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPyramidSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPyramidSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPyramidSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPyramidSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPyramidSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPyramidSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPyramidSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPyramidSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPyramidSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPyramidSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPyramidSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPyramidSonificationContexttracksMappingVolume)

        
class OptionSeriesPyramidSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPyramidSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPyramidSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPyramidSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPyramidSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPyramidSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPyramidSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPyramidSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPyramidSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPyramidSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesPyramidPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidPoint(Options):

    @property
    def events(self) -> 'OptionSeriesPyramidPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesPyramidPointEvents)

        
class OptionSeriesPyramidOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesPyramidOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesPyramidOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesPyramidOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesPyramidOnpointPosition)

        
class OptionSeriesPyramidMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramidMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPyramidMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPyramidMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPyramidMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesPyramidMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesPyramidMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesPyramidMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPyramidMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesPyramidMarkerStatesSelect)

        
class OptionSeriesPyramidMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPyramidMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesPyramidMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesPyramidLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesPyramidLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramidDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramidDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesPyramidDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesPyramidDataDragdropGuideboxDefault)

        
class OptionSeriesPyramidDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesPyramidDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesPyramidDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesPyramidDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesPyramidDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramidDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramidData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPyramidDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesPyramidDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesPyramidDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesPyramidDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesPyramidDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesPyramidDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPyramidDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesPyramidDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def legendIndex(self):
        """The sequential index of the data point in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesPyramidDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesPyramidDragdropGuideboxDefault)

        
class OptionSeriesPyramidDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesPyramidDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesPyramidDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesPyramidDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesPyramidDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramidEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPyramid(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPyramidAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesPyramidAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Initial animation is by default disabled for the funnel chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding all points or series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(["50%", "50%"])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesPyramidData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesPyramidData)

    @property
    def dataLabels(self) -> 'OptionSeriesPyramidDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesPyramidDatalabels)

    @property
    def depth(self):
        """The thickness of a 3D pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie3D/Pie3DSeries.ts
        """
        return self._config_get(0)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesPyramidDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesPyramidDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """The end angle of the pie in degrees where 0 is top and 90 is right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @endAngle.setter
    def endAngle(self, num: float): self._config(num, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPyramidEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesPyramidEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def height(self):
        """The height of the funnel or pyramid.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("100%")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesPyramidLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesPyramidLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPyramidMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesPyramidMarker)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def neckHeight(self):
        """The height of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("25%")

    @neckHeight.setter
    def neckHeight(self, num: float): self._config(num, js_type=False)

    @property
    def neckWidth(self):
        """The width of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("30%")

    @neckWidth.setter
    def neckWidth(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesPyramidOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesPyramidOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesPyramidPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesPyramidPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def reversed(self):
        """A reversed funnel has the widest area down.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesPyramidSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesPyramidSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPyramidStates':
        """Options for the series states. """
        return self._config_sub_data("states", OptionSeriesPyramidStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesPyramidTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesPyramidTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def width(self):
        """The width of the funnel compared to the width of the plot area, or the pixel width if it is a number.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("90%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesPyramidZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesPyramidZones)

        
class OptionSeriesPyramidDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramidDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPyramidDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPyramidDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPyramidDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPyramidDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPyramidDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPyramidDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramidDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPyramidDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPyramidDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPyramidDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPyramidDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPyramidDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPyramidDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPyramidAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPyramidAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPyramidAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesPyramidAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesPyramidAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesPyramidAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesPyramidAccessibilityPoint)

        
class OptionSeriesPolygonZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesPolygonTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesPolygonTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get("")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesPolygonStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPolygonStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPolygonStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPolygonStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPolygonStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPolygonStatesSelectMarker)

        
class OptionSeriesPolygonStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesPolygonStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPolygonStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPolygonStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesPolygonStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesPolygonStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesPolygonStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesPolygonStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesPolygonStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPolygonStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesPolygonStatesSelect)

        
class OptionSeriesPolygonStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPolygonStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPolygonStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPolygonStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPolygonStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPolygonStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPolygonStatesHoverMarker)

        
class OptionSeriesPolygonSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPolygonSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPolygonSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPolygonSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPolygonSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesPolygonSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPolygonSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPolygonSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPolygonSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPolygonSonificationTracksMappingLowpassResonance)

        
class OptionSeriesPolygonSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPolygonSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPolygonSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPolygonSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPolygonSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPolygonSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPolygonSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPolygonSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPolygonSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPolygonSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPolygonSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPolygonSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPolygonSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPolygonSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPolygonSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPolygonSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPolygonSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPolygonSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPolygonSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPolygonSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPolygonSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPolygonSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPolygonSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPolygonSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPolygonSonificationTracksMappingVolume)

        
class OptionSeriesPolygonSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPolygonSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPolygonSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPolygonSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPolygonSonificationTracksMappingHighpassResonance)

        
class OptionSeriesPolygonSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPolygonSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPolygonSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPolygonSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPolygonSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPolygonSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPolygonSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesPolygonSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesPolygonSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesPolygonSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesPolygonSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesPolygonSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPolygonSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesPolygonSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesPolygonSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesPolygonSonificationTracks)

        
class OptionSeriesPolygonSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesPolygonSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesPolygonSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPolygonSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPolygonSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPolygonSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesPolygonSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPolygonSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPolygonSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesPolygonSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesPolygonSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesPolygonSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPolygonSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPolygonSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPolygonSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPolygonSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesPolygonSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPolygonSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPolygonSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPolygonSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPolygonSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesPolygonSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPolygonSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPolygonSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesPolygonSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPolygonSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPolygonSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesPolygonSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPolygonSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPolygonSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPolygonSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPolygonSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPolygonSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPolygonSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPolygonSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPolygonSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPolygonSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPolygonSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPolygonSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPolygonSonificationContexttracksMappingVolume)

        
class OptionSeriesPolygonSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPolygonSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPolygonSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPolygonSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPolygonSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPolygonSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPolygonSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPolygonSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPolygonSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPolygonSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesPolygonPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonPoint(Options):

    @property
    def events(self) -> 'OptionSeriesPolygonPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesPolygonPointEvents)

        
class OptionSeriesPolygonOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesPolygonOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesPolygonOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesPolygonOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesPolygonOnpointPosition)

        
class OptionSeriesPolygonMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPolygonMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPolygonMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPolygonMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesPolygonMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesPolygonMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesPolygonMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPolygonMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesPolygonMarkerStatesSelect)

        
class OptionSeriesPolygonMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPolygonMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesPolygonMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesPolygonLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesPolygonLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesPolygonDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesPolygonDataDragdropGuideboxDefault)

        
class OptionSeriesPolygonDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesPolygonDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesPolygonDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesPolygonDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesPolygonDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygonDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesPolygonDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesPolygonDragdropGuideboxDefault)

        
class OptionSeriesPolygonDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesPolygonDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesPolygonDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesPolygonDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesPolygonDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPolygon(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPolygonAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesPolygonAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesPolygonData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesPolygonData)

    @property
    def dataLabels(self) -> 'OptionSeriesPolygonDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesPolygonDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesPolygonDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesPolygonDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesPolygonDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesPolygonDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPolygonEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesPolygonEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesPolygonLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesPolygonLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPolygonMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesPolygonMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesPolygonOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesPolygonOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesPolygonPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesPolygonPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesPolygonSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesPolygonSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPolygonStates':
        """. """
        return self._config_sub_data("states", OptionSeriesPolygonStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesPolygonTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesPolygonTooltip)

    @property
    def trackByArea(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Polygon/PolygonSeriesDefaults.ts
        """
        return self._config_get(True)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesPolygonZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesPolygonZones)

        
class OptionSeriesPolygonDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPolygonDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPolygonDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPolygonDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPolygonDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPolygonDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPolygonDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPolygonDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPolygonDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPolygonDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesPolygonDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesPolygonDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesPolygonDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPolygonDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesPolygonDataMarkerStatesSelect)

        
class OptionSeriesPolygonDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPolygonDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesPolygonDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPolygonDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesPolygonDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesPolygonDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesPolygonDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesPolygonDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesPolygonDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPolygonDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesPolygonDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPolygonDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesPolygonDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPolygonDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPolygonDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPolygonDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPolygonDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPolygonDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPolygonDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPolygonAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPolygonAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPolygonAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesPolygonAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesPolygonAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesPolygonAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesPolygonAccessibilityPoint)

        
class OptionSeriesPieZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesPieTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesPieTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesPieStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPieStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPieStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPieStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPieStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPieStatesSelectMarker)

        
class OptionSeriesPieStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPieStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesPieStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPieStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPieStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesPieStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesPieStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesPieStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesPieStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesPieStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPieStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesPieStatesSelect)

        
class OptionSeriesPieStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPieStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPieStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPieStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPieStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPieStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPieStatesHoverMarker)

        
class OptionSeriesPieSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPieSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPieSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPieSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPieSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesPieSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPieSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPieSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPieSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPieSonificationTracksMappingLowpassResonance)

        
class OptionSeriesPieSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPieSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPieSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPieSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPieSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPieSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPieSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPieSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPieSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPieSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPieSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPieSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPieSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPieSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPieSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPieSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPieSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPieSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPieSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPieSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPieSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPieSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPieSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPieSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPieSonificationTracksMappingVolume)

        
class OptionSeriesPieSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPieSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPieSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPieSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPieSonificationTracksMappingHighpassResonance)

        
class OptionSeriesPieSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPieSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPieSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPieSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPieSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPieSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPieSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesPieSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesPieSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesPieSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesPieSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesPieSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPieSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesPieSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesPieSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesPieSonificationTracks)

        
class OptionSeriesPieSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesPieSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesPieSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPieSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPieSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPieSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesPieSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPieSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPieSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesPieSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesPieSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesPieSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPieSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPieSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPieSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPieSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesPieSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPieSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesPieSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPieSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPieSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPieSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPieSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPieSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesPieSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPieSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPieSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPieSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPieSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesPieSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPieSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPieSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPieSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPieSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesPieSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPieSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPieSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPieSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPieSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPieSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPieSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPieSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPieSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPieSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPieSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPieSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPieSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPieSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPieSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPieSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPieSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPieSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPieSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPieSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPieSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPieSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPieSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPieSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPieSonificationContexttracksMappingVolume)

        
class OptionSeriesPieSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPieSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPieSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPieSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPieSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPieSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPieSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPieSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPieSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPieSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPieSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesPiePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPiePoint(Options):

    @property
    def events(self) -> 'OptionSeriesPiePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesPiePointEvents)

        
class OptionSeriesPieOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesPieOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesPieOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesPieOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesPieOnpointPosition)

        
class OptionSeriesPieMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPieMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPieMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPieMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPieMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesPieMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesPieMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesPieMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPieMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesPieMarkerStatesSelect)

        
class OptionSeriesPieMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPieMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesPieMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesPieLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesPieLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPieDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPieDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesPieDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesPieDataDragdropGuideboxDefault)

        
class OptionSeriesPieDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesPieDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesPieDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesPieDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesPieDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPieDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPieData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPieDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesPieDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesPieDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesPieDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesPieDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesPieDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPieDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesPieDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def legendIndex(self):
        """The sequential index of the data point in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sliced(self):
        """Whether to display a slice offset from the center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @sliced.setter
    def sliced(self, flag: bool): self._config(flag, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesPieDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesPieDragdropGuideboxDefault)

        
class OptionSeriesPieDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesPieDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesPieDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesPieDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesPieDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPieEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPie(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPieAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesPieAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the pie chart relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get([null, null])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesPieData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesPieData)

    @property
    def dataLabels(self) -> 'OptionSeriesPieDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesPieDatalabels)

    @property
    def depth(self):
        """The thickness of a 3D pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie3D/Pie3DSeries.ts
        """
        return self._config_get(0)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesPieDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesPieDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """The end angle of the pie in degrees where 0 is top and 90 is right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @endAngle.setter
    def endAngle(self, num: float): self._config(num, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPieEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesPieEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def innerSize(self):
        """The size of the inner diameter for the pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @innerSize.setter
    def innerSize(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesPieLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesPieLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPieMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesPieMarker)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesPieOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesPieOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesPiePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesPiePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """The diameter of the pie relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesPieSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesPieSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPieStates':
        """. """
        return self._config_sub_data("states", OptionSeriesPieStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesPieTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesPieTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesPieZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesPieZones)

        
class OptionSeriesPieDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPieDatalabels(Options):

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPieDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPieDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPieDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPieDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPieDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPieDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPieDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPieDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPieDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPieDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPieDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPieDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPieDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPieAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPieAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPieAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesPieAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesPieAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesPieAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesPieAccessibilityPoint)

        
class OptionSeriesPictorialTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesPictorialTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesPictorialTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesPictorialStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPictorialStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPictorialStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPictorialStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPictorialStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPictorialStatesSelectMarker)

        
class OptionSeriesPictorialStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPictorialStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesPictorialStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPictorialStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPictorialStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesPictorialStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesPictorialStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesPictorialStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesPictorialStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesPictorialStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPictorialStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesPictorialStatesSelect)

        
class OptionSeriesPictorialStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPictorialStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPictorialStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPictorialStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPictorialStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPictorialStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPictorialStatesHoverMarker)

        
class OptionSeriesPictorialSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPictorialSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPictorialSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPictorialSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPictorialSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesPictorialSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPictorialSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPictorialSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPictorialSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPictorialSonificationTracksMappingLowpassResonance)

        
class OptionSeriesPictorialSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPictorialSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPictorialSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPictorialSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPictorialSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPictorialSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPictorialSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPictorialSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPictorialSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPictorialSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPictorialSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPictorialSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPictorialSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPictorialSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPictorialSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPictorialSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPictorialSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPictorialSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPictorialSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPictorialSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPictorialSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPictorialSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPictorialSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPictorialSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPictorialSonificationTracksMappingVolume)

        
class OptionSeriesPictorialSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPictorialSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPictorialSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPictorialSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPictorialSonificationTracksMappingHighpassResonance)

        
class OptionSeriesPictorialSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPictorialSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPictorialSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPictorialSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPictorialSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPictorialSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPictorialSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesPictorialSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesPictorialSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesPictorialSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesPictorialSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesPictorialSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPictorialSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesPictorialSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesPictorialSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesPictorialSonificationTracks)

        
class OptionSeriesPictorialSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesPictorialSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesPictorialSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPictorialSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPictorialSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPictorialSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesPictorialSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPictorialSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPictorialSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesPictorialSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesPictorialSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesPictorialSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPictorialSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPictorialSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPictorialSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPictorialSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesPictorialSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPictorialSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPictorialSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPictorialSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPictorialSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesPictorialSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPictorialSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPictorialSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesPictorialSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPictorialSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPictorialSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesPictorialSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPictorialSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPictorialSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPictorialSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPictorialSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPictorialSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPictorialSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPictorialSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPictorialSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPictorialSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPictorialSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPictorialSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPictorialSonificationContexttracksMappingVolume)

        
class OptionSeriesPictorialSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPictorialSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPictorialSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPictorialSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPictorialSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPictorialSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPictorialSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPictorialSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPictorialSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPictorialSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesPictorialPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialPoint(Options):

    @property
    def events(self) -> 'OptionSeriesPictorialPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesPictorialPointEvents)

        
class OptionSeriesPictorialPaths(Options):

    @property
    def definition(self):
        """The definition defines a path to be drawn.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pictorial/PictorialSeries.ts
        """
        return self._config_get(None)

    @definition.setter
    def definition(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The max option determines height of the image.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pictorial/PictorialSeries.ts
        """
        return self._config_get(yAxis.max)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesPictorialLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesPictorialLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPictorialDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPictorialDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorialDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPictorialDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesPictorialDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesPictorialDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesPictorialDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPictorialDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesPictorialDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPictorial(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPictorialAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesPictorialAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def data(self) -> 'OptionSeriesPictorialData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesPictorialData)

    @property
    def dataLabels(self) -> 'OptionSeriesPictorialDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesPictorialDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPictorialEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesPictorialEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesPictorialLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesPictorialLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def paths(self) -> 'OptionSeriesPictorialPaths':
        """The paths include options describing the point image. """
        return self._config_sub_data("paths", OptionSeriesPictorialPaths)

    @property
    def point(self) -> 'OptionSeriesPictorialPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesPictorialPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesPictorialSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesPictorialSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPictorialStates':
        """. """
        return self._config_sub_data("states", OptionSeriesPictorialStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesPictorialTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesPictorialTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPictorialDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPictorialDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPictorialDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPictorialDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPictorialDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPictorialDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPictorialDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPictorialDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPictorialDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPictorialDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPictorialDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPictorialDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPictorialDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPictorialDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPictorialAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPictorialAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPictorialAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesPictorialAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesPictorialAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesPictorialAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesPictorialAccessibilityPoint)

        
class OptionSeriesParetoZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesParetoTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesParetoTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesParetoStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesParetoStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesParetoStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesParetoStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesParetoStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesParetoStatesSelectMarker)

        
class OptionSeriesParetoStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesParetoStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesParetoStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesParetoStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoStates(Options):

    @property
    def hover(self) -> 'OptionSeriesParetoStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesParetoStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesParetoStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesParetoStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesParetoStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesParetoStatesNormal)

    @property
    def select(self) -> 'OptionSeriesParetoStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesParetoStatesSelect)

        
class OptionSeriesParetoStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesParetoStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesParetoStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesParetoStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesParetoStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesParetoStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesParetoStatesHoverMarker)

        
class OptionSeriesParetoSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesParetoSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesParetoSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesParetoSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesParetoSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesParetoSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesParetoSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesParetoSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesParetoSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesParetoSonificationTracksMappingLowpassResonance)

        
class OptionSeriesParetoSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesParetoSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesParetoSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesParetoSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesParetoSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesParetoSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesParetoSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesParetoSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesParetoSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesParetoSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesParetoSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesParetoSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesParetoSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesParetoSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesParetoSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesParetoSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesParetoSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesParetoSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesParetoSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesParetoSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesParetoSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesParetoSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesParetoSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesParetoSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesParetoSonificationTracksMappingVolume)

        
class OptionSeriesParetoSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesParetoSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesParetoSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesParetoSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesParetoSonificationTracksMappingHighpassResonance)

        
class OptionSeriesParetoSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesParetoSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesParetoSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesParetoSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesParetoSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesParetoSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesParetoSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesParetoSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesParetoSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesParetoSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesParetoSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesParetoSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesParetoSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesParetoSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesParetoSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesParetoSonificationTracks)

        
class OptionSeriesParetoSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesParetoSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesParetoSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesParetoSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesParetoSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesParetoSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesParetoSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesParetoSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesParetoSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesParetoSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesParetoSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesParetoSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesParetoSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesParetoSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesParetoSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesParetoSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesParetoSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesParetoSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesParetoSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesParetoSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesParetoSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesParetoSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesParetoSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesParetoSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesParetoSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesParetoSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesParetoSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesParetoSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesParetoSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesParetoSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesParetoSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesParetoSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesParetoSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesParetoSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesParetoSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesParetoSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesParetoSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesParetoSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesParetoSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesParetoSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesParetoSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesParetoSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesParetoSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesParetoSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesParetoSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesParetoSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesParetoSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesParetoSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesParetoSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesParetoSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesParetoSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesParetoSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesParetoSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesParetoSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesParetoSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesParetoSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesParetoSonificationContexttracksMappingVolume)

        
class OptionSeriesParetoSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesParetoSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesParetoSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesParetoSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesParetoSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesParetoSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesParetoSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesParetoSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesParetoSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesParetoSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesParetoSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesParetoPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesParetoPoint(Options):

    @property
    def events(self) -> 'OptionSeriesParetoPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesParetoPointEvents)

        
class OptionSeriesParetoOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesParetoOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesParetoOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesParetoOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesParetoOnpointPosition)

        
class OptionSeriesParetoMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesParetoMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesParetoMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesParetoMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesParetoMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesParetoMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesParetoMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesParetoMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesParetoMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesParetoMarkerStatesSelect)

        
class OptionSeriesParetoMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesParetoMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesParetoMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesParetoLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesParetoLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesParetoDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesParetoDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesParetoDragdropGuideboxDefault)

        
class OptionSeriesParetoDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesParetoDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesParetoDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesParetoDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesParetoDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesParetoEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPareto(Options):

    @property
    def accessibility(self) -> 'OptionSeriesParetoAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesParetoAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def baseSeries(self):
        """An integer identifying the index to use for the base series, or a string representing the id of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ParetoSeries/ParetoSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @baseSeries.setter
    def baseSeries(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesParetoDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesParetoDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesParetoDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesParetoDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesParetoDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesParetoDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesParetoEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesParetoEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesParetoLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesParetoLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesParetoMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesParetoMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesParetoOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesParetoOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesParetoPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesParetoPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesParetoSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesParetoSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesParetoStates':
        """. """
        return self._config_sub_data("states", OptionSeriesParetoStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesParetoTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesParetoTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(3)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesParetoZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesParetoZones)

        
class OptionSeriesParetoDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesParetoDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesParetoDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesParetoDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesParetoDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesParetoDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesParetoDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesParetoDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesParetoAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesParetoAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesParetoAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesParetoAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesParetoAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesParetoAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesParetoAccessibilityPoint)

        
class OptionSeriesPackedbubbleZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesPackedbubbleTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesPackedbubbleTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("Value: {point.value}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesPackedbubbleStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPackedbubbleStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPackedbubbleStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPackedbubbleStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPackedbubbleStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPackedbubbleStatesSelectMarker)

        
class OptionSeriesPackedbubbleStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(5)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesPackedbubbleStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPackedbubbleStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPackedbubbleStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesPackedbubbleStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesPackedbubbleStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesPackedbubbleStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesPackedbubbleStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesPackedbubbleStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPackedbubbleStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesPackedbubbleStatesSelect)

        
class OptionSeriesPackedbubbleStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPackedbubbleStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesPackedbubbleStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesPackedbubbleStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesPackedbubbleStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPackedbubbleStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesPackedbubbleStatesHoverMarker)

        
class OptionSeriesPackedbubbleSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPackedbubbleSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPackedbubbleSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesPackedbubbleSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPackedbubbleSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPackedbubbleSonificationTracksMappingLowpassResonance)

        
class OptionSeriesPackedbubbleSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPackedbubbleSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPackedbubbleSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPackedbubbleSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPackedbubbleSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPackedbubbleSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPackedbubbleSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPackedbubbleSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPackedbubbleSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPackedbubbleSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPackedbubbleSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPackedbubbleSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPackedbubbleSonificationTracksMappingVolume)

        
class OptionSeriesPackedbubbleSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPackedbubbleSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPackedbubbleSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPackedbubbleSonificationTracksMappingHighpassResonance)

        
class OptionSeriesPackedbubbleSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPackedbubbleSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPackedbubbleSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPackedbubbleSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPackedbubbleSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPackedbubbleSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPackedbubbleSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesPackedbubbleSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesPackedbubbleSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesPackedbubbleSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesPackedbubbleSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPackedbubbleSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesPackedbubbleSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesPackedbubbleSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesPackedbubbleSonificationTracks)

        
class OptionSeriesPackedbubbleSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesPackedbubbleSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPackedbubbleSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPackedbubbleSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPackedbubbleSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesPackedbubbleSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPackedbubbleSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPackedbubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesPackedbubbleSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesPackedbubbleSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesPackedbubbleSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPackedbubbleSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPackedbubbleSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesPackedbubbleSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesPackedbubbleSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesPackedbubbleSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesPackedbubbleSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesPackedbubbleSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesPackedbubbleSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesPackedbubbleSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesPackedbubbleSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesPackedbubbleSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesPackedbubbleSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesPackedbubbleSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesPackedbubbleSonificationContexttracksMappingVolume)

        
class OptionSeriesPackedbubbleSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesPackedbubbleSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesPackedbubbleSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesPackedbubbleSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesPackedbubbleSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesPackedbubbleSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesPackedbubbleSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesPackedbubblePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubblePoint(Options):

    @property
    def events(self) -> 'OptionSeriesPackedbubblePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesPackedbubblePointEvents)

        
class OptionSeriesPackedbubbleParentnode(Options):

    @property
    def allowPointSelect(self):
        """Allow this series&#39; parent nodes to be selected by clicking on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesPackedbubbleOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesPackedbubbleOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesPackedbubbleOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesPackedbubbleOnpointPosition)

        
class OptionSeriesPackedbubbleMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesPackedbubbleMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesPackedbubbleMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesPackedbubbleMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesPackedbubbleMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesPackedbubbleMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesPackedbubbleMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesPackedbubbleMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesPackedbubbleMarkerStatesSelect)

        
class OptionSeriesPackedbubbleMarker(Options):

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """The fill opacity of the bubble markers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0.5)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPackedbubbleMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesPackedbubbleMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleLayoutalgorithmParentnodeoptionsMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, value: Any): self._config(value, js_type=False)

    @property
    def fillOpacity(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(1)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, value: Any): self._config(value, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleLayoutalgorithmParentnodeoptions(Options):

    @property
    def friction(self):
        """Friction applied on forces to prevent nodes rushing to fast to the desired positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(-0.981)

    @friction.setter
    def friction(self, num: float): self._config(num, js_type=False)

    @property
    def gravitationalConstant(self):
        """Gravitational const used in the barycenter force of the algorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(0.03)

    @gravitationalConstant.setter
    def gravitationalConstant(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositionRadius(self):
        """When <code>initialPositions</code> are set to &#39;circle&#39;, <code>initialPositionRadius</code> is a distance from the center of circle, in which nodes are created.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(100)

    @initialPositionRadius.setter
    def initialPositionRadius(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositions(self):
        """Initial layout algorithm for positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(circle)

    @initialPositions.setter
    def initialPositions(self, value: Any): self._config(value, js_type=False)

    @property
    def integration(self):
        """Integration type.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(euler)

    @integration.setter
    def integration(self, value: Any): self._config(value, js_type=False)

    @property
    def linkLength(self):
        """Ideal length (px) of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkLength.setter
    def linkLength(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPackedbubbleLayoutalgorithmParentnodeoptionsMarker':
        """Styling options for parentNodes markers. """
        return self._config_sub_data("marker", OptionSeriesPackedbubbleLayoutalgorithmParentnodeoptionsMarker)

    @property
    def maxIterations(self):
        """Max number of iterations before algorithm will stop.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(400)

    @maxIterations.setter
    def maxIterations(self, num: float): self._config(num, js_type=False)

    @property
    def maxSpeed(self):
        """Verlet integration only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(50)

    @maxSpeed.setter
    def maxSpeed(self, num: float): self._config(num, js_type=False)

    @property
    def seriesInteraction(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @seriesInteraction.setter
    def seriesInteraction(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used when positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(reingold-fruchterman)

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleLayoutalgorithm(Options):

    @property
    def bubblePadding(self):
        """The distance between two bubbles, when the algorithm starts to treat two bubbles as overlapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(5)

    @bubblePadding.setter
    def bubblePadding(self, num: float): self._config(num, js_type=False)

    @property
    def dragBetweenSeries(self):
        """In case of split series, this option allows user to drag and drop points between series, for changing point related series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @dragBetweenSeries.setter
    def dragBetweenSeries(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enableSimulation(self):
        """Experimental.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @enableSimulation.setter
    def enableSimulation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def friction(self):
        """Friction applied on forces to prevent nodes rushing to fast to the desired positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(-0.981)

    @friction.setter
    def friction(self, num: float): self._config(num, js_type=False)

    @property
    def gravitationalConstant(self):
        """Gravitational const used in the barycenter force of the algorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(0.01)

    @gravitationalConstant.setter
    def gravitationalConstant(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositionRadius(self):
        """When <code>initialPositions</code> are set to &#39;circle&#39;, <code>initialPositionRadius</code> is a distance from the center of circle, in which nodes are created.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(20)

    @initialPositionRadius.setter
    def initialPositionRadius(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositions(self):
        """Initial layout algorithm for positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(circle)

    @initialPositions.setter
    def initialPositions(self, value: Any): self._config(value, js_type=False)

    @property
    def integration(self):
        """Integration type.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(euler)

    @integration.setter
    def integration(self, value: Any): self._config(value, js_type=False)

    @property
    def linkLength(self):
        """Ideal length (px) of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkLength.setter
    def linkLength(self, num: float): self._config(num, js_type=False)

    @property
    def maxIterations(self):
        """Max number of iterations before algorithm will stop.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(1000)

    @maxIterations.setter
    def maxIterations(self, num: float): self._config(num, js_type=False)

    @property
    def maxSpeed(self):
        """Max speed that node can get in one iteration.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(5)

    @maxSpeed.setter
    def maxSpeed(self, num: float): self._config(num, js_type=False)

    @property
    def parentNodeLimit(self):
        """Whether bubbles should interact with their parentNode to keep them inside.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @parentNodeLimit.setter
    def parentNodeLimit(self, flag: bool): self._config(flag, js_type=False)

    @property
    def parentNodeOptions(self) -> 'OptionSeriesPackedbubbleLayoutalgorithmParentnodeoptions':
        """Layout algorithm options for parent nodes. """
        return self._config_sub_data("parentNodeOptions", OptionSeriesPackedbubbleLayoutalgorithmParentnodeoptions)

    @property
    def seriesInteraction(self):
        """Whether series should interact with each other or not.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @seriesInteraction.setter
    def seriesInteraction(self, flag: bool): self._config(flag, js_type=False)

    @property
    def splitSeries(self):
        """Whether to split series into individual groups or to mix all series together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @splitSeries.setter
    def splitSeries(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used when positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(reingold-fruchterman)

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesPackedbubbleLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesPackedbubbleLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesPackedbubbleDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesPackedbubbleDataDragdropGuideboxDefault)

        
class OptionSeriesPackedbubbleDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesPackedbubbleDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesPackedbubbleDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesPackedbubbleDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesPackedbubbleDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubbleDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPackedbubbleDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesPackedbubbleDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesPackedbubbleDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesPackedbubbleDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesPackedbubbleDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesPackedbubbleDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPackedbubbleDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesPackedbubbleDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesPackedbubble(Options):

    @property
    def accessibility(self) -> 'OptionSeriesPackedbubbleAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesPackedbubbleAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """If there are more points in the series than the <code>animationLimit</code>, the animation won&#39;t run.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(250)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("z")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(False)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesPackedbubbleData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesPackedbubbleData)

    @property
    def dataLabels(self) -> 'OptionSeriesPackedbubbleDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesPackedbubbleDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def displayNegative(self):
        """Whether to display negative sized bubbles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(True)

    @displayNegative.setter
    def displayNegative(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggable(self):
        """Flag to determine if nodes are draggable or not.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @draggable.setter
    def draggable(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesPackedbubbleEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesPackedbubbleEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesPackedbubbleLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesPackedbubbleLabel)

    @property
    def layoutAlgorithm(self) -> 'OptionSeriesPackedbubbleLayoutalgorithm':
        """Options for layout algorithm when simulation is enabled. """
        return self._config_sub_data("layoutAlgorithm", OptionSeriesPackedbubbleLayoutalgorithm)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesPackedbubbleMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesPackedbubbleMarker)

    @property
    def maxSize(self):
        """Maximum bubble size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("50%")

    @maxSize.setter
    def maxSize(self, num: float): self._config(num, js_type=False)

    @property
    def minSize(self):
        """Minimum bubble size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("10%")

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """When a point&#39;s Z value is below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesPackedbubbleOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesPackedbubbleOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def parentNode(self) -> 'OptionSeriesPackedbubbleParentnode':
        """Series options for parent nodes. """
        return self._config_sub_data("parentNode", OptionSeriesPackedbubbleParentnode)

    @property
    def point(self) -> 'OptionSeriesPackedbubblePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesPackedbubblePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sizeBy(self):
        """Whether the bubble&#39;s value should be represented by the area or the width of the bubble.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("area")

    @sizeBy.setter
    def sizeBy(self, text: str): self._config(text, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(False)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesPackedbubbleSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesPackedbubbleSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesPackedbubbleStates':
        """. """
        return self._config_sub_data("states", OptionSeriesPackedbubbleStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesPackedbubbleTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesPackedbubbleTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def useSimulation(self):
        """An option is giving a possibility to choose between using simulation for calculating bubble positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @useSimulation.setter
    def useSimulation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesPackedbubbleZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesPackedbubbleZones)

    @property
    def zThreshold(self):
        """When <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @zThreshold.setter
    def zThreshold(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleDatalabelsStyle(Options):

    @property
    def transition(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("opacity 2000ms")

    @transition.setter
    def transition(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleDatalabelsParentnodetextpath(Options):

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPackedbubbleDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPackedbubbleDatalabelsAnimation)

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPackedbubbleDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPackedbubbleDatalabelsFilter)

    @property
    def format(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label for a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(0)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def parentNodeFormat(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @parentNodeFormat.setter
    def parentNodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def parentNodeFormatter(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PackedBubble/PackedBubbleSeriesDefaults.ts
        """
        return self._config_get(None)

    @parentNodeFormatter.setter
    def parentNodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def parentNodeTextPath(self) -> 'OptionSeriesPackedbubbleDatalabelsParentnodetextpath':
        """. """
        return self._config_sub_data("parentNodeTextPath", OptionSeriesPackedbubbleDatalabelsParentnodetextpath)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionSeriesPackedbubbleDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionSeriesPackedbubbleDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionSeriesPackedbubbleDatalabelsTextpath':
        """Options for a <em>node</em> label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPackedbubbleDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesPackedbubbleDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesPackedbubbleDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesPackedbubbleDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesPackedbubbleDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesPackedbubbleDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesPackedbubbleDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesPackedbubbleAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesPackedbubbleAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesPackedbubbleAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesPackedbubbleAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesPackedbubbleAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesPackedbubbleAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesPackedbubbleAccessibilityPoint)

        
class OptionSeriesOrganizationZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesOrganizationTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesOrganizationTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the pointer or stay fixed on the item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("{point.name}<br>{point.title}<br>{point.description}")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the chart&#39;s tooltip, as opposed to links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.name} → {point.toNode.name}: <b>{point.weight}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesOrganizationStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesOrganizationStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesOrganizationStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesOrganizationStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesOrganizationStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesOrganizationStatesSelectMarker)

        
class OptionSeriesOrganizationStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesOrganizationStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesOrganizationStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationStates(Options):

    @property
    def hover(self) -> 'OptionSeriesOrganizationStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesOrganizationStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesOrganizationStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionSeriesOrganizationStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesOrganizationStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesOrganizationStatesNormal)

    @property
    def select(self) -> 'OptionSeriesOrganizationStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesOrganizationStatesSelect)

        
class OptionSeriesOrganizationStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesOrganizationStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesOrganizationStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesOrganizationStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesOrganizationStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesOrganizationStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesOrganizationStatesHoverMarker)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesOrganizationSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesOrganizationSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesOrganizationSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesOrganizationSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesOrganizationSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesOrganizationSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesOrganizationSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesOrganizationSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesOrganizationSonificationTracksMappingLowpassResonance)

        
class OptionSeriesOrganizationSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesOrganizationSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesOrganizationSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesOrganizationSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesOrganizationSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesOrganizationSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesOrganizationSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesOrganizationSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesOrganizationSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesOrganizationSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesOrganizationSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesOrganizationSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesOrganizationSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesOrganizationSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesOrganizationSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesOrganizationSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesOrganizationSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesOrganizationSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesOrganizationSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesOrganizationSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesOrganizationSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesOrganizationSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesOrganizationSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesOrganizationSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesOrganizationSonificationTracksMappingVolume)

        
class OptionSeriesOrganizationSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesOrganizationSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesOrganizationSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesOrganizationSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesOrganizationSonificationTracksMappingHighpassResonance)

        
class OptionSeriesOrganizationSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesOrganizationSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesOrganizationSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesOrganizationSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesOrganizationSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesOrganizationSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesOrganizationSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesOrganizationSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesOrganizationSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesOrganizationSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesOrganizationSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesOrganizationSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesOrganizationSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesOrganizationSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesOrganizationSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesOrganizationSonificationTracks)

        
class OptionSeriesOrganizationSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesOrganizationSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesOrganizationSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesOrganizationSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesOrganizationSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesOrganizationSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesOrganizationSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesOrganizationSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesOrganizationSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesOrganizationSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesOrganizationSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesOrganizationSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesOrganizationSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesOrganizationSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesOrganizationSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesOrganizationSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesOrganizationSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesOrganizationSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesOrganizationSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesOrganizationSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesOrganizationSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesOrganizationSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesOrganizationSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesOrganizationSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesOrganizationSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesOrganizationSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesOrganizationSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesOrganizationSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesOrganizationSonificationContexttracksMappingVolume)

        
class OptionSeriesOrganizationSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesOrganizationSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesOrganizationSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesOrganizationSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesOrganizationSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesOrganizationSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesOrganizationSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesOrganizationSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesOrganizationSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesOrganizationSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesOrganizationPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationPoint(Options):

    @property
    def events(self) -> 'OptionSeriesOrganizationPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesOrganizationPointEvents)

        
class OptionSeriesOrganizationOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationNodesDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationNodesDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesOrganizationOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesOrganizationOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesOrganizationOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesOrganizationOnpointPosition)

        
class OptionSeriesOrganizationNodes(Options):

    @property
    def color(self):
        """The color of the auto generated node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """The color index of the auto generated node, especially for use in styled mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def column(self):
        """An optional column index of where to place the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @column.setter
    def column(self, num: float): self._config(num, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesOrganizationNodesDatalabels':
        """Individual data label for each node. """
        return self._config_sub_data("dataLabels", OptionSeriesOrganizationNodesDatalabels)

    @property
    def description(self):
        """The job description for the node card, will be inserted by the default <code>dataLabel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def id(self):
        """The id of the auto-generated node, refering to the <code>from</code> or <code>to</code> setting of the link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def image(self):
        """An image for the node card, will be inserted by the default <code>dataLabel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @image.setter
    def image(self, text: str): self._config(text, js_type=False)

    @property
    def layout(self):
        """Layout for the node&#39;s children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(normal)

    @layout.setter
    def layout(self, value: Any): self._config(value, js_type=False)

    @property
    def level(self):
        """An optional level index of where to place the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name to display for the node in data labels and tooltips.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def offset(self):
        """This option is deprecated, use <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @offset.setter
    def offset(self, num: float): self._config(num, js_type=False)

    @property
    def offsetHorizontal(self):
        """The horizontal offset of a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @offsetHorizontal.setter
    def offsetHorizontal(self, num: float): self._config(num, js_type=False)

    @property
    def offsetVertical(self):
        """The vertical offset of a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @offsetVertical.setter
    def offsetVertical(self, num: float): self._config(num, js_type=False)

    @property
    def title(self):
        """The job title for the node card, will be inserted by the default <code>dataLabel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @title.setter
    def title(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationNodesDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationNodesDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesOrganizationNodesDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesOrganizationNodesDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesOrganizationNodesDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesOrganizationNodesDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesOrganizationNodesDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesOrganizationNodesDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesOrganizationMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesOrganizationMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesOrganizationMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesOrganizationMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesOrganizationMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesOrganizationMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesOrganizationMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesOrganizationMarkerStatesSelect)

        
class OptionSeriesOrganizationMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesOrganizationMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesOrganizationMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationLink(Options):

    @property
    def color(self):
        """The color of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("#666666")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width of the links connecting nodes, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def offset(self):
        """Modifier of the shape of the curved link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(0.5)

    @offset.setter
    def offset(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """Radius for the rounded corners of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(10)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the link shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get('default')

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationLevelsStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationLevelsStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesOrganizationLevelsStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesOrganizationLevelsStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationLevelsStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationLevelsStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationLevelsStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationLevelsStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesOrganizationLevelsStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesOrganizationLevelsStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationLevelsStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesOrganizationLevelsStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesOrganizationLevelsStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationLevelsStates(Options):

    @property
    def hover(self) -> 'OptionSeriesOrganizationLevelsStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesOrganizationLevelsStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesOrganizationLevelsStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionSeriesOrganizationLevelsStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesOrganizationLevelsStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesOrganizationLevelsStatesNormal)

    @property
    def select(self) -> 'OptionSeriesOrganizationLevelsStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesOrganizationLevelsStatesSelect)

        
class OptionSeriesOrganizationLevels(Options):

    @property
    def borderColor(self):
        """Can set <code>borderColor</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set <code>borderWidth</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set <code>color</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Can set <code>colorByPoint</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesOrganizationLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lay on the same level. """
        return self._config_sub_data("dataLabels", OptionSeriesOrganizationLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Can set <code>linkOpacity</code> on all points which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesOrganizationLevelsStates':
        """Can set <code>states</code> on all nodes and points which lay on the same level. """
        return self._config_sub_data("states", OptionSeriesOrganizationLevelsStates)

        
class OptionSeriesOrganizationLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesOrganizationLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesOrganizationLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesOrganizationLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesOrganizationLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesOrganizationLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesOrganizationLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesOrganizationLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesOrganizationLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganizationData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesOrganizationDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesOrganizationDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The color for the individual <em>link</em>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesOrganizationDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesOrganizationDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesOrganizationDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesOrganizationDataEvents)

    @property
    def from_(self):
        """The node that the link runs from.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, text: str): self._config(text, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def outgoing(self):
        """Whether the link goes out of the system.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @outgoing.setter
    def outgoing(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def to(self):
        """The node that the link runs to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, text: str): self._config(text, js_type=False)

    @property
    def weight(self):
        """The weight of the link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @weight.setter
    def weight(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesOrganizationDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesOrganizationDragdropGuideboxDefault)

        
class OptionSeriesOrganizationDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesOrganizationDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesOrganizationDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesOrganizationDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesOrganizationDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesOrganization(Options):

    @property
    def accessibility(self) -> 'OptionSeriesOrganizationAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesOrganizationAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The border color of the node cards.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("#666666")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius of the node cards.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesOrganizationData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesOrganizationData)

    @property
    def dataLabels(self) -> 'OptionSeriesOrganizationDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionSeriesOrganizationDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesOrganizationDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesOrganizationDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesOrganizationEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesOrganizationEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def hangingIndent(self):
        """The indentation in pixels of hanging nodes, nodes which parent has <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(20)

    @hangingIndent.setter
    def hangingIndent(self, num: float): self._config(num, js_type=False)

    @property
    def hangingIndentTranslation(self):
        """Defines the indentation of a <code>hanging</code> layout parent&#39;s children.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(inherit)

    @hangingIndentTranslation.setter
    def hangingIndentTranslation(self, value: Any): self._config(value, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesOrganizationLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesOrganizationLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionSeriesOrganizationLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionSeriesOrganizationLevels)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def link(self) -> 'OptionSeriesOrganizationLink':
        """Link Styling options. """
        return self._config_sub_data("link", OptionSeriesOrganizationLink)

    @property
    def linkColor(self):
        """The color of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkColor.setter
    def linkColor(self, text: str): self._config(text, js_type=False)

    @property
    def linkColorMode(self):
        """Determines color mode for sankey links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("from")

    @linkColorMode.setter
    def linkColorMode(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def linkLineWidth(self):
        """The line width of the links connecting nodes, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkLineWidth.setter
    def linkLineWidth(self, text: str): self._config(text, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def linkRadius(self):
        """Radius for the rounded corners of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkRadius.setter
    def linkRadius(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesOrganizationMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesOrganizationMarker)

    @property
    def minLinkWidth(self):
        """The minimal width for a line of a sankey.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @minLinkWidth.setter
    def minLinkWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minNodeLength(self):
        """In a horizontal chart, the minimum width of the <strong>hanging</strong> nodes only, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(10)

    @minNodeLength.setter
    def minNodeLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def nodeAlignment(self):
        """Determines which side of the chart the nodes are to be aligned to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeAlignment.setter
    def nodeAlignment(self, value: Any): self._config(value, js_type=False)

    @property
    def nodePadding(self):
        """The padding between nodes in a sankey diagram or dependency wheel, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(10)

    @nodePadding.setter
    def nodePadding(self, num: float): self._config(num, js_type=False)

    @property
    def nodes(self) -> 'OptionSeriesOrganizationNodes':
        """A collection of options for the individual nodes. """
        return self._config_sub_data("nodes", OptionSeriesOrganizationNodes)

    @property
    def nodeWidth(self):
        """In a horizontal chart, the width of the nodes in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(50)

    @nodeWidth.setter
    def nodeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesOrganizationOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesOrganizationOnpoint)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesOrganizationPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesOrganizationPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesOrganizationSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesOrganizationSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesOrganizationStates':
        """. """
        return self._config_sub_data("states", OptionSeriesOrganizationStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesOrganizationTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesOrganizationTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesOrganizationZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesOrganizationZones)

        
class OptionSeriesOrganizationDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationDatalabelsStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("0.9em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("normal")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationDatalabelsLinktextpathAttributes(Options):

    @property
    def startOffset(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("95%")

    @startOffset.setter
    def startOffset(self, num: float): self._config(num, js_type=False)

    @property
    def textAnchor(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get("end")

    @textAnchor.setter
    def textAnchor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationDatalabelsLinktextpath(Options):

    @property
    def attributes(self) -> 'OptionSeriesOrganizationDatalabelsLinktextpathAttributes':
        """. """
        return self._config_sub_data("attributes", OptionSeriesOrganizationDatalabelsLinktextpathAttributes)

        
class OptionSeriesOrganizationDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesOrganizationDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesOrganizationDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesOrganizationDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesOrganizationDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkFormat(self):
        """The format string specifying what to show for <em>links</em> in the organization chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkFormat.setter
    def linkFormat(self, text: str): self._config(text, js_type=False)

    @property
    def linkFormatter(self):
        """Callback to format data labels for <em>links</em> in the organization chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkFormatter.setter
    def linkFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def linkTextPath(self) -> 'OptionSeriesOrganizationDatalabelsLinktextpath':
        """Options for a <em>link</em> label text which should follow link connection. """
        return self._config_sub_data("linkTextPath", OptionSeriesOrganizationDatalabelsLinktextpath)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the organization chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionSeriesOrganizationDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionSeriesOrganizationDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionSeriesOrganizationDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesOrganizationDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Organization/OrganizationSeriesDefaults.ts
        """
        return self._config_get(True)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesOrganizationDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesOrganizationDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesOrganizationDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesOrganizationDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesOrganizationDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesOrganizationDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesOrganizationAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesOrganizationAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesOrganizationAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesOrganizationAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesOrganizationAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesOrganizationAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesOrganizationAccessibilityPoint)

        
class OptionSeriesNetworkgraphZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesNetworkgraphTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesNetworkgraphTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesNetworkgraphStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesNetworkgraphStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesNetworkgraphStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesNetworkgraphStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesNetworkgraphStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesNetworkgraphStatesSelectMarker)

        
class OptionSeriesNetworkgraphStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesNetworkgraphStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(50)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesNetworkgraphStatesInactiveAnimation':
        """Animation when not hovering over the node. """
        return self._config_sub_data("animation", OptionSeriesNetworkgraphStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity of inactive links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(0.3)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphStates(Options):

    @property
    def hover(self) -> 'OptionSeriesNetworkgraphStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesNetworkgraphStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesNetworkgraphStatesInactive':
        """The opposite state of a hover for a single point link. """
        return self._config_sub_data("inactive", OptionSeriesNetworkgraphStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesNetworkgraphStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesNetworkgraphStatesNormal)

    @property
    def select(self) -> 'OptionSeriesNetworkgraphStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesNetworkgraphStatesSelect)

        
class OptionSeriesNetworkgraphStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesNetworkgraphStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesNetworkgraphStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesNetworkgraphStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesNetworkgraphStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesNetworkgraphStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesNetworkgraphStatesHoverMarker)

        
class OptionSeriesNetworkgraphSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesNetworkgraphSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesNetworkgraphSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesNetworkgraphSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesNetworkgraphSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesNetworkgraphSonificationTracksMappingLowpassResonance)

        
class OptionSeriesNetworkgraphSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesNetworkgraphSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesNetworkgraphSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesNetworkgraphSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesNetworkgraphSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesNetworkgraphSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesNetworkgraphSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesNetworkgraphSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesNetworkgraphSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesNetworkgraphSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesNetworkgraphSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesNetworkgraphSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesNetworkgraphSonificationTracksMappingVolume)

        
class OptionSeriesNetworkgraphSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesNetworkgraphSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesNetworkgraphSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesNetworkgraphSonificationTracksMappingHighpassResonance)

        
class OptionSeriesNetworkgraphSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesNetworkgraphSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesNetworkgraphSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesNetworkgraphSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesNetworkgraphSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesNetworkgraphSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesNetworkgraphSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesNetworkgraphSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesNetworkgraphSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesNetworkgraphSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesNetworkgraphSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesNetworkgraphSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesNetworkgraphSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesNetworkgraphSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesNetworkgraphSonificationTracks)

        
class OptionSeriesNetworkgraphSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesNetworkgraphSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesNetworkgraphSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesNetworkgraphSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesNetworkgraphSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesNetworkgraphSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesNetworkgraphSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesNetworkgraphSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesNetworkgraphSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesNetworkgraphSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesNetworkgraphSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesNetworkgraphSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesNetworkgraphSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesNetworkgraphSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesNetworkgraphSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesNetworkgraphSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesNetworkgraphSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesNetworkgraphSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesNetworkgraphSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesNetworkgraphSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesNetworkgraphSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesNetworkgraphSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesNetworkgraphSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesNetworkgraphSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesNetworkgraphSonificationContexttracksMappingVolume)

        
class OptionSeriesNetworkgraphSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesNetworkgraphSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesNetworkgraphSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesNetworkgraphSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesNetworkgraphSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesNetworkgraphSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesNetworkgraphSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesNetworkgraphPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphPoint(Options):

    @property
    def events(self) -> 'OptionSeriesNetworkgraphPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesNetworkgraphPointEvents)

        
class OptionSeriesNetworkgraphOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesNetworkgraphOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesNetworkgraphOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesNetworkgraphOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesNetworkgraphOnpointPosition)

        
class OptionSeriesNetworkgraphNodesMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphNodesMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesNetworkgraphNodesMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphNodesMarkerStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(50)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphNodesMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesNetworkgraphNodesMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesNetworkgraphNodesMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphNodesMarkerStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesNetworkgraphNodesMarkerStatesInactiveAnimation':
        """Animation when not hovering over the node. """
        return self._config_sub_data("animation", OptionSeriesNetworkgraphNodesMarkerStatesInactiveAnimation)

    @property
    def opacity(self):
        """Opacity of inactive markers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(0.3)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphNodesMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesNetworkgraphNodesMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesNetworkgraphNodesMarkerStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesNetworkgraphNodesMarkerStatesInactive':
        """The opposite state of a hover for a single point node. """
        return self._config_sub_data("inactive", OptionSeriesNetworkgraphNodesMarkerStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesNetworkgraphNodesMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesNetworkgraphNodesMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesNetworkgraphNodesMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesNetworkgraphNodesMarkerStatesSelect)

        
class OptionSeriesNetworkgraphNodesMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesNetworkgraphNodesMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesNetworkgraphNodesMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphNodes(Options):

    @property
    def color(self):
        """The color of the auto generated node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """The color index of the auto generated node, especially for use in styled mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def dataLabels(self):
        """Individual data label for each node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @dataLabels.setter
    def dataLabels(self, value: Any): self._config(value, js_type=False)

    @property
    def id(self):
        """The id of the auto-generated node, refering to the <code>from</code> or <code>to</code> setting of the link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesNetworkgraphNodesMarker':
        """Options for the node markers. """
        return self._config_sub_data("marker", OptionSeriesNetworkgraphNodesMarker)

    @property
    def mass(self):
        """Mass of the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @mass.setter
    def mass(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name to display for the node in data labels and tooltips.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesNetworkgraphMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphMarkerStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(50)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesNetworkgraphMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesNetworkgraphMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphMarkerStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesNetworkgraphMarkerStatesInactiveAnimation':
        """Animation when not hovering over the node. """
        return self._config_sub_data("animation", OptionSeriesNetworkgraphMarkerStatesInactiveAnimation)

    @property
    def opacity(self):
        """Opacity of inactive markers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(0.3)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesNetworkgraphMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesNetworkgraphMarkerStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesNetworkgraphMarkerStatesInactive':
        """The opposite state of a hover for a single point node. """
        return self._config_sub_data("inactive", OptionSeriesNetworkgraphMarkerStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesNetworkgraphMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesNetworkgraphMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesNetworkgraphMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesNetworkgraphMarkerStatesSelect)

        
class OptionSeriesNetworkgraphMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesNetworkgraphMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesNetworkgraphMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphLink(Options):

    @property
    def color(self):
        """Color of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("rgba(100, 100, 100, 0.5)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def opacity(self):
        """Opacity of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Width (px) of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphLayoutalgorithm(Options):

    @property
    def approximation(self):
        """Approximation used to calculate repulsive forces affecting nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(none)

    @approximation.setter
    def approximation(self, value: Any): self._config(value, js_type=False)

    @property
    def attractiveForce(self):
        """Attraction force applied on a node which is conected to another node by a link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("function (d, k) { return k * k / d; }")

    @attractiveForce.setter
    def attractiveForce(self, text: str): self._config(text, js_type=True)

    @property
    def enableSimulation(self):
        """Experimental.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @enableSimulation.setter
    def enableSimulation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def friction(self):
        """Friction applied on forces to prevent nodes rushing to fast to the desired positions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(-0.981)

    @friction.setter
    def friction(self, num: float): self._config(num, js_type=False)

    @property
    def gravitationalConstant(self):
        """Gravitational const used in the barycenter force of the algorithm.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(0.0625)

    @gravitationalConstant.setter
    def gravitationalConstant(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositionRadius(self):
        """When <code>initialPositions</code> are set to &#39;circle&#39;, <code>initialPositionRadius</code> is a distance from the center of circle, in which nodes are created.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1)

    @initialPositionRadius.setter
    def initialPositionRadius(self, num: float): self._config(num, js_type=False)

    @property
    def initialPositions(self):
        """Initial layout algorithm for positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(circle)

    @initialPositions.setter
    def initialPositions(self, value: Any): self._config(value, js_type=False)

    @property
    def integration(self):
        """Integration type.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(euler)

    @integration.setter
    def integration(self, value: Any): self._config(value, js_type=False)

    @property
    def linkLength(self):
        """Ideal length (px) of the link between two nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkLength.setter
    def linkLength(self, num: float): self._config(num, js_type=False)

    @property
    def maxIterations(self):
        """Max number of iterations before algorithm will stop.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1000)

    @maxIterations.setter
    def maxIterations(self, num: float): self._config(num, js_type=False)

    @property
    def maxSpeed(self):
        """Verlet integration only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(10)

    @maxSpeed.setter
    def maxSpeed(self, num: float): self._config(num, js_type=False)

    @property
    def repulsiveForce(self):
        """Repulsive force applied on a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("function (d, k) { return k * k / d; }")

    @repulsiveForce.setter
    def repulsiveForce(self, text: str): self._config(text, js_type=True)

    @property
    def theta(self):
        """Barnes-Hut approximation only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(0.5)

    @theta.setter
    def theta(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of the algorithm used when positioning nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(reingold-fruchterman)

    @type.setter
    def type(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(1000)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesNetworkgraphDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesNetworkgraphDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesNetworkgraphDataDragdropGuideboxDefault)

        
class OptionSeriesNetworkgraphDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesNetworkgraphDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesNetworkgraphDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesNetworkgraphDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesNetworkgraphDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesNetworkgraphDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraphDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesNetworkgraphDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesNetworkgraphDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesNetworkgraphDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesNetworkgraphDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesNetworkgraphDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesNetworkgraphDataDragdrop)

    @property
    def events(self) -> 'OptionSeriesNetworkgraphDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesNetworkgraphDataEvents)

    @property
    def from_(self):
        """The node that the link runs from.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, text: str): self._config(text, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def to(self):
        """The node that the link runs to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def afterSimulation(self):
        """Fires after the simulation is ended and the layout is stable.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @afterSimulation.setter
    def afterSimulation(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesNetworkgraph(Options):

    @property
    def accessibility(self) -> 'OptionSeriesNetworkgraphAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesNetworkgraphAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesNetworkgraphData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesNetworkgraphData)

    @property
    def dataLabels(self) -> 'OptionSeriesNetworkgraphDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesNetworkgraphDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def draggable(self):
        """Flag to determine if nodes are draggable or not.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @draggable.setter
    def draggable(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesNetworkgraphEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesNetworkgraphEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def layoutAlgorithm(self) -> 'OptionSeriesNetworkgraphLayoutalgorithm':
        """. """
        return self._config_sub_data("layoutAlgorithm", OptionSeriesNetworkgraphLayoutalgorithm)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def link(self) -> 'OptionSeriesNetworkgraphLink':
        """Link style options. """
        return self._config_sub_data("link", OptionSeriesNetworkgraphLink)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesNetworkgraphMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesNetworkgraphMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def nodes(self) -> 'OptionSeriesNetworkgraphNodes':
        """A collection of options for the individual nodes. """
        return self._config_sub_data("nodes", OptionSeriesNetworkgraphNodes)

    @property
    def onPoint(self) -> 'OptionSeriesNetworkgraphOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesNetworkgraphOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesNetworkgraphPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesNetworkgraphPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesNetworkgraphSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesNetworkgraphSonification)

    @property
    def states(self) -> 'OptionSeriesNetworkgraphStates':
        """. """
        return self._config_sub_data("states", OptionSeriesNetworkgraphStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesNetworkgraphTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesNetworkgraphTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesNetworkgraphZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesNetworkgraphZones)

        
class OptionSeriesNetworkgraphDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesNetworkgraphDatalabelsStyle(Options):

    @property
    def transition(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("opacity 2000ms")

    @transition.setter
    def transition(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphDatalabelsLinktextpath(Options):

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesNetworkgraphDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesNetworkgraphDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesNetworkgraphDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesNetworkgraphDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesNetworkgraphDatalabelsFilter)

    @property
    def format(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label for a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkFormat.setter
    def linkFormat(self, text: str): self._config(text, js_type=False)

    @property
    def linkFormatter(self):
        """Callback to format data labels for <em>links</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(None)

    @linkFormatter.setter
    def linkFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def linkTextPath(self) -> 'OptionSeriesNetworkgraphDatalabelsLinktextpath':
        """Options for a <em>link</em> label text which should follow link connection. """
        return self._config_sub_data("linkTextPath", OptionSeriesNetworkgraphDatalabelsLinktextpath)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self) -> 'OptionSeriesNetworkgraphDatalabelsStyle':
        """Styles for the label. """
        return self._config_sub_data("style", OptionSeriesNetworkgraphDatalabelsStyle)

    @property
    def textPath(self) -> 'OptionSeriesNetworkgraphDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesNetworkgraphDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesNetworkgraphDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesNetworkgraphDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesNetworkgraphDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesNetworkgraphDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesNetworkgraphDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesNetworkgraphDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesNetworkgraphDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesNetworkgraphAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesNetworkgraphAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesNetworkgraphAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesNetworkgraphAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesNetworkgraphAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesNetworkgraphAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesNetworkgraphAccessibilityPoint)

        
class OptionSeriesLollipopZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesLollipopTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesLollipopTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesLollipopStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesLollipopStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesLollipopStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesLollipopStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesLollipopStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesLollipopStatesSelectMarker)

        
class OptionSeriesLollipopStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesLollipopStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesLollipopStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopStates(Options):

    @property
    def hover(self) -> 'OptionSeriesLollipopStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesLollipopStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesLollipopStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesLollipopStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesLollipopStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesLollipopStatesNormal)

    @property
    def select(self) -> 'OptionSeriesLollipopStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesLollipopStatesSelect)

        
class OptionSeriesLollipopStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesLollipopStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesLollipopStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesLollipopStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesLollipopStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesLollipopStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesLollipopStatesHoverMarker)

        
class OptionSeriesLollipopSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesLollipopSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesLollipopSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesLollipopSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesLollipopSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesLollipopSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLollipopSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLollipopSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLollipopSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLollipopSonificationTracksMappingLowpassResonance)

        
class OptionSeriesLollipopSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesLollipopSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesLollipopSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesLollipopSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesLollipopSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesLollipopSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesLollipopSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesLollipopSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesLollipopSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesLollipopSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesLollipopSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesLollipopSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesLollipopSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesLollipopSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesLollipopSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesLollipopSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesLollipopSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesLollipopSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesLollipopSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesLollipopSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesLollipopSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesLollipopSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesLollipopSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesLollipopSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesLollipopSonificationTracksMappingVolume)

        
class OptionSeriesLollipopSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLollipopSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLollipopSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLollipopSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLollipopSonificationTracksMappingHighpassResonance)

        
class OptionSeriesLollipopSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesLollipopSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesLollipopSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesLollipopSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesLollipopSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesLollipopSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesLollipopSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesLollipopSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesLollipopSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesLollipopSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesLollipopSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesLollipopSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesLollipopSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesLollipopSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesLollipopSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesLollipopSonificationTracks)

        
class OptionSeriesLollipopSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesLollipopSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesLollipopSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesLollipopSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesLollipopSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesLollipopSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesLollipopSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesLollipopSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesLollipopSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesLollipopSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesLollipopSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesLollipopSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesLollipopSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesLollipopSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesLollipopSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesLollipopSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesLollipopSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesLollipopSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesLollipopSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesLollipopSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLollipopSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesLollipopSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesLollipopSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesLollipopSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesLollipopSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLollipopSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLollipopSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesLollipopSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesLollipopSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesLollipopSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesLollipopSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesLollipopSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesLollipopSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesLollipopSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesLollipopSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesLollipopSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesLollipopSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesLollipopSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesLollipopSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesLollipopSonificationContexttracksMappingVolume)

        
class OptionSeriesLollipopSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesLollipopSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesLollipopSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesLollipopSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesLollipopSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesLollipopSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesLollipopSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLollipopSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLollipopSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLollipopSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesLollipopPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopPoint(Options):

    @property
    def events(self) -> 'OptionSeriesLollipopPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesLollipopPointEvents)

        
class OptionSeriesLollipopOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesLollipopOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesLollipopOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesLollipopOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesLollipopOnpointPosition)

        
class OptionSeriesLollipopMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesLollipopMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesLollipopMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesLollipopMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesLollipopMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesLollipopMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesLollipopMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesLollipopMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesLollipopMarkerStatesSelect)

        
class OptionSeriesLollipopMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesLollipopMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesLollipopMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopLowmarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopLowmarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopLowmarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopLowmarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesLollipopLowmarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesLollipopLowmarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopLowmarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesLollipopLowmarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesLollipopLowmarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesLollipopLowmarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesLollipopLowmarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesLollipopLowmarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesLollipopLowmarkerStatesSelect)

        
class OptionSeriesLollipopLowmarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesLollipopLowmarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesLollipopLowmarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesLollipopLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesLollipopLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesLollipopDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesLollipopDataDragdropGuideboxDefault)

        
class OptionSeriesLollipopDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesLollipopDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesLollipopDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesLollipopDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesLollipopDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipopDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesLollipopDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesLollipopDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def connectorColor(self):
        """Color of the line that connects the dumbbell point&#39;s values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """Pixel width of the line that connects the dumbbell point&#39;s values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesLollipopDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesLollipopDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesLollipopDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesLollipopDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesLollipopDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesLollipopDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesLollipopDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesLollipopDragdropGuideboxDefault)

        
class OptionSeriesLollipopDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesLollipopDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesLollipopDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesLollipopDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesLollipopDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLollipop(Options):

    @property
    def accessibility(self) -> 'OptionSeriesLollipopAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesLollipopAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("low")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorColor(self):
        """Color of the line that connects the dumbbell point&#39;s values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesLollipopData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesLollipopData)

    @property
    def dataLabels(self) -> 'OptionSeriesLollipopDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionSeriesLollipopDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesLollipopDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesLollipopDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesLollipopDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesLollipopDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesLollipopEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesLollipopEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked lollipop points or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Lollipop/LollipopSeries.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesLollipopLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesLollipopLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def lowMarker(self) -> 'OptionSeriesLollipopLowmarker':
        """Options for the lower markers of the dumbbell-like series. """
        return self._config_sub_data("lowMarker", OptionSeriesLollipopLowmarker)

    @property
    def marker(self) -> 'OptionSeriesLollipopMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesLollipopMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesLollipopOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesLollipopOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesLollipopPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesLollipopPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesLollipopSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesLollipopSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesLollipopStates':
        """. """
        return self._config_sub_data("states", OptionSeriesLollipopStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesLollipopTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesLollipopTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesLollipopZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesLollipopZones)

        
class OptionSeriesLollipopDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Lollipop/LollipopSeries.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesLollipopDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesLollipopDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesLollipopDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesLollipopDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesLollipopDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesLollipopDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Lollipop/LollipopSeries.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesLollipopDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesLollipopDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesLollipopDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesLollipopDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesLollipopDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesLollipopDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLollipopAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLollipopAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLollipopAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesLollipopAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesLollipopAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesLollipopAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesLollipopAccessibilityPoint)

        
class OptionSeriesLineZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesLineTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesLineTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesLineStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesLineStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesLineStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesLineStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesLineStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesLineStatesSelectMarker)

        
class OptionSeriesLineStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLineStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesLineStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesLineStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineStates(Options):

    @property
    def hover(self) -> 'OptionSeriesLineStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesLineStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesLineStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesLineStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesLineStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesLineStatesNormal)

    @property
    def select(self) -> 'OptionSeriesLineStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesLineStatesSelect)

        
class OptionSeriesLineStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesLineStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesLineStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesLineStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesLineStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesLineStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesLineStatesHoverMarker)

        
class OptionSeriesLineSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesLineSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesLineSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesLineSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesLineSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesLineSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLineSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLineSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLineSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLineSonificationTracksMappingLowpassResonance)

        
class OptionSeriesLineSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesLineSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesLineSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesLineSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesLineSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesLineSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesLineSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesLineSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesLineSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesLineSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesLineSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesLineSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesLineSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesLineSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesLineSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesLineSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesLineSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesLineSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesLineSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesLineSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesLineSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesLineSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesLineSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesLineSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesLineSonificationTracksMappingVolume)

        
class OptionSeriesLineSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLineSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLineSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLineSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLineSonificationTracksMappingHighpassResonance)

        
class OptionSeriesLineSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesLineSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesLineSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesLineSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesLineSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesLineSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesLineSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesLineSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesLineSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesLineSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesLineSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesLineSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesLineSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesLineSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesLineSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesLineSonificationTracks)

        
class OptionSeriesLineSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesLineSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesLineSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesLineSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesLineSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesLineSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesLineSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesLineSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesLineSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesLineSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesLineSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesLineSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesLineSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesLineSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesLineSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesLineSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesLineSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesLineSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesLineSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesLineSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesLineSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesLineSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLineSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLineSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesLineSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesLineSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesLineSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesLineSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesLineSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesLineSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLineSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLineSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLineSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLineSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesLineSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesLineSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesLineSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesLineSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesLineSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesLineSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesLineSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesLineSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesLineSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesLineSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesLineSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesLineSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesLineSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesLineSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesLineSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesLineSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesLineSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesLineSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesLineSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesLineSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesLineSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesLineSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesLineSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesLineSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesLineSonificationContexttracksMappingVolume)

        
class OptionSeriesLineSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesLineSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesLineSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesLineSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesLineSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesLineSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesLineSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesLineSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesLineSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesLineSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesLineSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesLinePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLinePoint(Options):

    @property
    def events(self) -> 'OptionSeriesLinePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesLinePointEvents)

        
class OptionSeriesLineOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesLineOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesLineOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesLineOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesLineOnpointPosition)

        
class OptionSeriesLineMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLineMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesLineMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesLineMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesLineMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesLineMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesLineMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesLineMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesLineMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesLineMarkerStatesSelect)

        
class OptionSeriesLineMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesLineMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesLineMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesLineLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesLineLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLineDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLineDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesLineDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesLineDataDragdropGuideboxDefault)

        
class OptionSeriesLineDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesLineDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesLineDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesLineDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesLineDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLineDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesLineDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesLineDragdropGuideboxDefault)

        
class OptionSeriesLineDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesLineDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesLineDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesLineDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesLineDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLineEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLine(Options):

    @property
    def accessibility(self) -> 'OptionSeriesLineAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesLineAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesLineData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesLineData)

    @property
    def dataLabels(self) -> 'OptionSeriesLineDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesLineDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesLineDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesLineDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesLineDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesLineDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesLineEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesLineEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesLineLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesLineLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesLineMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesLineMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesLineOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesLineOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesLinePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesLinePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesLineSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesLineSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesLineStates':
        """. """
        return self._config_sub_data("states", OptionSeriesLineStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesLineTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesLineTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesLineZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesLineZones)

        
class OptionSeriesLineDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLineDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesLineDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesLineDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesLineDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesLineDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesLineDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesLineDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLineDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesLineDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesLineDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesLineDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesLineDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesLineDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesLineDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesLineDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesLineDataMarkerStatesSelect)

        
class OptionSeriesLineDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesLineDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesLineDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesLineDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesLineDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesLineDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesLineDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesLineDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesLineDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesLineDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesLineDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesLineDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesLineDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesLineDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesLineDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesLineDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesLineDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesLineDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesLineDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesLineDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesLineAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesLineAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesArcdiagramDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesArcdiagramDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The color for the individual <em>link</em>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesArcdiagramDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesArcdiagramDataEvents)

    @property
    def from_(self):
        """The node that the link runs from.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, text: str): self._config(text, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def to(self):
        """The node that the link runs to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, text: str): self._config(text, js_type=False)

    @property
    def weight(self):
        """The weight of the link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @weight.setter
    def weight(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesLineAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesLineAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesLineAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesLineAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesLineAccessibilityPoint)

        
class OptionSeriesArearangeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArearangeDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesArearangeDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesArearangeDataDragdropGuideboxDefault)

        
class OptionSeriesArearangeDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesArearangeDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesArearangeDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesArearangeDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesArearangeDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArearangeDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesArearangeDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesArearangeDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesArearangeDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesArearangeDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesArearangeDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesArearangeDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesArearangeDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesArearangeDataEvents)

    @property
    def high(self):
        """The high or maximum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @high.setter
    def high(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def low(self):
        """The low or minimum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @low.setter
    def low(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesArearangeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesArearangeDragdropGuideboxDefault)

        
class OptionSeriesArearangeDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesArearangeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesArearangeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesArearangeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesArearangeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesAreaDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesAreaDataDragdropGuideboxDefault)

        
class OptionSeriesAreaDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesAreaDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesAreaDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesAreaDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesAreaDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesAreaDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesAreaDragdropGuideboxDefault)

        
class OptionSeriesAreaDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesAreaDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesAreaDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesAreaDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesAreaDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplinerangeDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesAreasplinerangeDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesAreasplinerangeDataDragdropGuideboxDefault)

        
class OptionSeriesAreasplinerangeDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesAreasplinerangeDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesAreasplinerangeDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesAreasplinerangeDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesAreasplinerangeDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplinerangeDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesAreasplinerangeDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesAreasplinerangeDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesAreasplinerangeDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesAreasplinerangeDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesAreasplinerangeDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesAreasplinerangeDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesAreasplinerangeDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesAreasplinerangeDataEvents)

    @property
    def high(self):
        """The high or maximum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @high.setter
    def high(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def low(self):
        """The low or minimum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @low.setter
    def low(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesAreasplinerangeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesAreasplinerangeDragdropGuideboxDefault)

        
class OptionSeriesAreasplinerangeDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesAreasplinerangeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesAreasplinerangeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesAreasplinerangeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesAreasplinerangeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesAreasplineDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesAreasplineDataDragdropGuideboxDefault)

        
class OptionSeriesAreasplineDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesAreasplineDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesAreasplineDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesAreasplineDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesAreasplineDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesAreasplineDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesAreasplineDragdropGuideboxDefault)

        
class OptionSeriesAreasplineDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesAreasplineDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesAreasplineDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesAreasplineDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesAreasplineDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesBellcurveDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesBellcurveDragdropGuideboxDefault)

        
class OptionSeriesBellcurveDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesBellcurveDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesBellcurveDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesBellcurveDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesBellcurveDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesBarDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesBarDataDragdropGuideboxDefault)

        
class OptionSeriesBarDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesBarDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesBarDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesBarDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesBarDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesBarDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesBarDataAccessibility)

    @property
    def borderColor(self):
        """The color of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesBarDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesBarDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesBarDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesBarDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesBarDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesBarDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesBarDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesBarDragdropGuideboxDefault)

        
class OptionSeriesBarDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesBarDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesBarDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesBarDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesBarDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubbleDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesBubbleDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesBubbleDataDragdropGuideboxDefault)

        
class OptionSeriesBubbleDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesBubbleDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesBubbleDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesBubbleDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesBubbleDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubbleDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesBubbleDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesBubbleDragdropGuideboxDefault)

        
class OptionSeriesBubbleDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesBubbleDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesBubbleDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesBubbleDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesBubbleDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubbleEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBoxplotDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesBoxplotDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesBoxplotDataDragdropGuideboxDefault)

        
class OptionSeriesBoxplotDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesBoxplotDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesBoxplotDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesBoxplotDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesBoxplotDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBoxplotDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesBoxplotDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesBoxplotDataAccessibility)

    @property
    def boxDashStyle(self):
        """The dash style of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @boxDashStyle.setter
    def boxDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesBoxplotDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesBoxplotDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesBoxplotDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesBoxplotDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesBoxplotDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesBoxplotDataEvents)

    @property
    def high(self):
        """The <code>high</code> value for each data point, signifying the highest value in the sample set.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @high.setter
    def high(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def low(self):
        """The <code>low</code> value for each data point, signifying the lowest value in the sample set.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @low.setter
    def low(self, num: float): self._config(num, js_type=False)

    @property
    def median(self):
        """The median for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @median.setter
    def median(self, num: float): self._config(num, js_type=False)

    @property
    def medianDashStyle(self):
        """The dash style of the median.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @medianDashStyle.setter
    def medianDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def q1(self):
        """The lower quartile for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @q1.setter
    def q1(self, num: float): self._config(num, js_type=False)

    @property
    def q3(self):
        """The higher quartile for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @q3.setter
    def q3(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def stemDashStyle(self):
        """The dash style of the stem.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @stemDashStyle.setter
    def stemDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def whiskerDashStyle(self):
        """The dash style of the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @whiskerDashStyle.setter
    def whiskerDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesBoxplotDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesBoxplotDragdropGuideboxDefault)

        
class OptionSeriesBoxplotDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableQ1(self):
        """Allow Q1 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableQ1.setter
    def draggableQ1(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableQ3(self):
        """Allow Q3 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableQ3.setter
    def draggableQ3(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesBoxplotDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesBoxplotDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesBoxplotDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesBoxplotDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBoxplotEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleJitter(Options):

    @property
    def x(self):
        """The maximal X offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The maximal Y offset for the random jitter effect.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesColumnDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesColumnDataDragdropGuideboxDefault)

        
class OptionSeriesColumnDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesColumnDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesColumnDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesColumnDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesColumnDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesColumnDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesColumnDataAccessibility)

    @property
    def borderColor(self):
        """The color of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesColumnDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesColumnDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesColumnDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesColumnDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesColumnDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesColumnDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesColumnDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesColumnDragdropGuideboxDefault)

        
class OptionSeriesColumnDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesColumnDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesColumnDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesColumnDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesColumnDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesBulletDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesBulletDataDragdropGuideboxDefault)

        
class OptionSeriesBulletDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesBulletDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesBulletDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesBulletDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesBulletDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesBulletDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesBulletDragdropGuideboxDefault)

        
class OptionSeriesBulletDragdrop(Options):

    @property
    def draggableTarget(self):
        """Allow target value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableTarget.setter
    def draggableTarget(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesBulletDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesBulletDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesBulletDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesBulletDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeBorderradius(Options):

    @property
    def where(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ColumnRange/ColumnRangeSeries.ts
        """
        return self._config_get("all")

    @where.setter
    def where(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrangeDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesColumnrangeDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesColumnrangeDataDragdropGuideboxDefault)

        
class OptionSeriesColumnrangeDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesColumnrangeDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesColumnrangeDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesColumnrangeDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesColumnrangeDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrangeDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesColumnrangeDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesColumnrangeDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesColumnrangeDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesColumnrangeDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesColumnrangeDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesColumnrangeDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesColumnrangeDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesColumnrangeDataEvents)

    @property
    def high(self):
        """The high or maximum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @high.setter
    def high(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def low(self):
        """The low or minimum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @low.setter
    def low(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesColumnrangeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesColumnrangeDragdropGuideboxDefault)

        
class OptionSeriesColumnrangeDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesColumnrangeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesColumnrangeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesColumnrangeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesColumnrangeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesColumnpyramidDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesColumnpyramidDataDragdropGuideboxDefault)

        
class OptionSeriesColumnpyramidDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesColumnpyramidDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesColumnpyramidDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesColumnpyramidDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesColumnpyramidDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesColumnpyramidDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesColumnpyramidDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesColumnpyramidDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesColumnpyramidDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesColumnpyramidDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesColumnpyramidDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesColumnpyramidDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesColumnpyramidDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesColumnpyramidDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesColumnpyramidDragdropGuideboxDefault)

        
class OptionSeriesColumnpyramidDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesColumnpyramidDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesColumnpyramidDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesColumnpyramidDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesColumnpyramidDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheelDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesDependencywheelDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesDependencywheelDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The color for the individual <em>link</em>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesDependencywheelDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesDependencywheelDataEvents)

    @property
    def from_(self):
        """The node that the link runs from.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @from_.setter
    def from_(self, text: str): self._config(text, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def to(self):
        """The node that the link runs to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @to.setter
    def to(self, text: str): self._config(text, js_type=False)

    @property
    def weight(self):
        """The weight of the link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @weight.setter
    def weight(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesDependencywheelDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesDependencywheelDragdropGuideboxDefault)

        
class OptionSeriesDependencywheelDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesDependencywheelDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesDependencywheelDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesDependencywheelDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesDependencywheelDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinderDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinderDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesCylinderDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesCylinderDataDragdropGuideboxDefault)

        
class OptionSeriesCylinderDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesCylinderDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesCylinderDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesCylinderDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesCylinderDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinderDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesCylinderDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesCylinderDataAccessibility)

    @property
    def borderColor(self):
        """The color of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesCylinderDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesCylinderDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesCylinderDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesCylinderDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesCylinderDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesCylinderDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesCylinderDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesCylinderDragdropGuideboxDefault)

        
class OptionSeriesCylinderDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesCylinderDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesCylinderDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesCylinderDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesCylinderDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinderEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesErrorbarDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesErrorbarDataDragdropGuideboxDefault)

        
class OptionSeriesErrorbarDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesErrorbarDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesErrorbarDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesErrorbarDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesErrorbarDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesErrorbarDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesErrorbarDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesErrorbarDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesErrorbarDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesErrorbarDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesErrorbarDataDragdrop)

    @property
    def events(self) -> 'OptionSeriesErrorbarDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesErrorbarDataEvents)

    @property
    def high(self):
        """The high or maximum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @high.setter
    def high(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def low(self):
        """The low or minimum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @low.setter
    def low(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesErrorbarDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesErrorbarDragdropGuideboxDefault)

        
class OptionSeriesErrorbarDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableQ1(self):
        """Allow Q1 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableQ1.setter
    def draggableQ1(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableQ3(self):
        """Allow Q3 value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableQ3.setter
    def draggableQ3(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesErrorbarDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesErrorbarDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesErrorbarDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesErrorbarDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesDumbbellDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesDumbbellDataDragdropGuideboxDefault)

        
class OptionSeriesDumbbellDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesDumbbellDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesDumbbellDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesDumbbellDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesDumbbellDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesDumbbellDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesDumbbellDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def connectorColor(self):
        """Color of the line that connects the dumbbell point&#39;s values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """Pixel width of the line that connects the dumbbell point&#39;s values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesDumbbellDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesDumbbellDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesDumbbellDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesDumbbellDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesDumbbellDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesDumbbellDataEvents)

    @property
    def high(self):
        """The high or maximum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @high.setter
    def high(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def low(self):
        """The low or minimum value for each data point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @low.setter
    def low(self, num: float): self._config(num, js_type=False)

    @property
    def lowColor(self):
        """Color of the start markers in a dumbbell graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get("#333333")

    @lowColor.setter
    def lowColor(self, text: str): self._config(text, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesDumbbellDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesDumbbellDragdropGuideboxDefault)

        
class OptionSeriesDumbbellDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellDragdrop(Options):

    @property
    def draggableHigh(self):
        """Allow high value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableHigh.setter
    def draggableHigh(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableLow(self):
        """Allow low value to be dragged individually.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropProps.ts
        """
        return self._config_get(True)

    @draggableLow.setter
    def draggableLow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesDumbbellDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesDumbbellDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesDumbbellDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesDumbbellDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnel3dDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesFunnel3dDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesFunnel3dDataDragdropGuideboxDefault)

        
class OptionSeriesFunnel3dDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesFunnel3dDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesFunnel3dDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesFunnel3dDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesFunnel3dDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnel3dDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesFunnel3dDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesFunnel3dDataAccessibility)

    @property
    def borderColor(self):
        """The color of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesFunnel3dDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesFunnel3dDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesFunnel3dDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesFunnel3dDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesFunnel3dDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesFunnel3dDataEvents)

    @property
    def gradientForSides(self):
        """By deafult sides fill is set to a gradient through this option being set to <code>true</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(None)

    @gradientForSides.setter
    def gradientForSides(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """The mouse cursor to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def pathFormatter(self):
        """Function to define the SVG path to use for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @pathFormatter.setter
    def pathFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesFunnel3dDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesFunnel3dDragdropGuideboxDefault)

        
class OptionSeriesFunnel3dDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesFunnel3dDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesFunnel3dDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesFunnel3dDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesFunnel3dDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnelDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnelDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesFunnelDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesFunnelDataDragdropGuideboxDefault)

        
class OptionSeriesFunnelDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesFunnelDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesFunnelDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesFunnelDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesFunnelDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnelDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesFunnelDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesFunnelDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesFunnelDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesFunnelDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesFunnelDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesFunnelDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesFunnelDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesFunnelDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def legendIndex(self):
        """The sequential index of the data point in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesFunnelDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesFunnelDragdropGuideboxDefault)

        
class OptionSeriesFunnelDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesFunnelDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesFunnelDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesFunnelDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesFunnelDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnelEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHeatmapDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesHeatmapDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesHeatmapDataDragdropGuideboxDefault)

        
class OptionSeriesHeatmapDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesHeatmapDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesHeatmapDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesHeatmapDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesHeatmapDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHeatmapDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesGaugeDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesGaugeDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesGaugeDataDragdropGuideboxDefault)

        
class OptionSeriesGaugeDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesGaugeDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesGaugeDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesGaugeDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesGaugeDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesGaugeDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesGaugeDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesGaugeDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesGaugeDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesGaugeDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesGaugeDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesGaugeDataDragdrop)

    @property
    def events(self) -> 'OptionSeriesGaugeDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesGaugeDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesGaugeDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesGaugeDragdropGuideboxDefault)

        
class OptionSeriesGaugeDial(Options):

    @property
    def backgroundColor(self):
        """The background or fill color of the gauge&#39;s dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#000000")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def baseLength(self):
        """The length of the dial&#39;s base part, relative to the total radius or length of the dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("70%")

    @baseLength.setter
    def baseLength(self, text: str): self._config(text, js_type=False)

    @property
    def baseWidth(self):
        """The pixel width of the base of the gauge dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(3)

    @baseWidth.setter
    def baseWidth(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The border color or stroke of the gauge&#39;s dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#cccccc")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the gauge dial border in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def path(self):
        """An array with an SVG path for the custom dial.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(None)

    @path.setter
    def path(self, value: Any): self._config(value, js_type=False)

    @property
    def radius(self):
        """The radius or length of the dial, in percentages relative to the radius of the gauge itself.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("80%")

    @radius.setter
    def radius(self, text: str): self._config(text, js_type=False)

    @property
    def rearLength(self):
        """The length of the dial&#39;s rear end, the part that extends out on the other side of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("10%")

    @rearLength.setter
    def rearLength(self, text: str): self._config(text, js_type=False)

    @property
    def topWidth(self):
        """The width of the top of the dial, closest to the perimeter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(1)

    @topWidth.setter
    def topWidth(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesGaugeDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesGaugeDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesGaugeDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesGaugeDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesGaugeEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemDataAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the data point, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Set to false to disable accessibility functionality for a specific point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesItemDataDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemDataDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemDataDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemDataDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemDataDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesItemDataDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesItemDataDragdropGuideboxDefault)

        
class OptionSeriesItemDataDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesItemDataDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesItemDataDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesItemDataDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesItemDataDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesItemDataEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesItemDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesItemDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesItemDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesItemDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesItemDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesItemDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesItemDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesItemDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def legendIndex(self):
        """The sequential index of the data point in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesItemDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesItemDragdropGuideboxDefault)

        
class OptionSeriesItemDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesItemDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesItemDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesItemDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesItemDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHistogramDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramDragdropGuideboxDefault(Options):

    @property
    def className(self):
        """CSS class name of the guide box in this state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-box-default")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Guide box fill color.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.1)")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def cursor(self):
        """Guide box cursor.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("move")

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """Color of the border around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#888")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Width of the line around the guide box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Guide box zIndex.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(900)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramDragdropDraghandle(Options):

    @property
    def className(self):
        """The class name of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("highcharts-drag-handle")

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The fill color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("#fff")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The line color of the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get("rgba(0, 0, 0, 0.6)")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The line width for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index for the drag handles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(901)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramDragdropGuidebox(Options):

    @property
    def default(self) -> 'OptionSeriesHistogramDragdropGuideboxDefault':
        """Style options for the guide box default state. """
        return self._config_sub_data("default", OptionSeriesHistogramDragdropGuideboxDefault)

        
class OptionSeriesHistogramDatasorting(Options):

    @property
    def enabled(self):
        """Enable or disable data sorting for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def matchByName(self):
        """Whether to allow matching points by name in an update.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @matchByName.setter
    def matchByName(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sortKey(self):
        """Determines what data value should be used to sort by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @sortKey.setter
    def sortKey(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramDragdrop(Options):

    @property
    def draggableX(self):
        """Enable dragging in the X dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableX.setter
    def draggableX(self, flag: bool): self._config(flag, js_type=False)

    @property
    def draggableY(self):
        """Enable dragging in the Y dimension.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @draggableY.setter
    def draggableY(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragHandle(self) -> 'OptionSeriesHistogramDragdropDraghandle':
        """Options for the drag handles available in column series. """
        return self._config_sub_data("dragHandle", OptionSeriesHistogramDragdropDraghandle)

    @property
    def dragMaxX(self):
        """Set the maximum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxX.setter
    def dragMaxX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMaxY(self):
        """Set the maximum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMaxY.setter
    def dragMaxY(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinX(self):
        """Set the minimum X value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinX.setter
    def dragMinX(self, num: float): self._config(num, js_type=False)

    @property
    def dragMinY(self):
        """Set the minimum Y value the points can be moved to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragMinY.setter
    def dragMinY(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionX(self):
        """The X precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionX.setter
    def dragPrecisionX(self, num: float): self._config(num, js_type=False)

    @property
    def dragPrecisionY(self):
        """The Y precision value to drag to for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(0)

    @dragPrecisionY.setter
    def dragPrecisionY(self, num: float): self._config(num, js_type=False)

    @property
    def dragSensitivity(self):
        """The amount of pixels to drag the pointer before it counts as a drag operation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(2)

    @dragSensitivity.setter
    def dragSensitivity(self, num: float): self._config(num, js_type=False)

    @property
    def groupBy(self):
        """Group the points by a property.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @groupBy.setter
    def groupBy(self, text: str): self._config(text, js_type=False)

    @property
    def guideBox(self) -> 'OptionSeriesHistogramDragdropGuidebox':
        """Style options for the guide box. """
        return self._config_sub_data("guideBox", OptionSeriesHistogramDragdropGuidebox)

    @property
    def liveRedraw(self):
        """Update points as they are dragged.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(True)

    @liveRedraw.setter
    def liveRedraw(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHistogramEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the series&#39; name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemEvents(Options):

    @property
    def afterAnimate(self):
        """Fires after the series has finished its initial animation, or in case animation is disabled, immediately as the series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @afterAnimate.setter
    def afterAnimate(self, value: Any): self._config(value, js_type=False)

    @property
    def checkboxClick(self):
        """Fires when the checkbox next to the point name in the legend is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @checkboxClick.setter
    def checkboxClick(self, value: Any): self._config(value, js_type=False)

    @property
    def click(self):
        """Fires when the series is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def hide(self):
        """Fires when the series is hidden after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @hide.setter
    def hide(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def show(self):
        """Fires when the series is shown after chart generation time, either by clicking the legend item or by calling <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @show.setter
    def show(self, value: Any): self._config(value, js_type=False)

        
class OptionSeries(Options):

    @property
    def name(self):
        return self._config_get("")

    @name.setter
    def name(self, value: str): self._config(value, js_type=False)
    
    @property
    def color(self):
        return self._config_get("")

    @color.setter
    def color(self, value: str): self._config(value, js_type=False)
    
    @property
    def data(self):
        return self._config_get([])

    @data.setter
    def data(self, values: list): self._config(values, js_type=False)
    
    @property
    def marker(self) -> 'OptionSeriesItemMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesItemMarker)

    @property
    def arcdiagram(self) -> 'OptionSeriesArcdiagram':
        """An <code>arcdiagram</code> series. """
        return self._config_sub_data("arcdiagram", OptionSeriesArcdiagram)

    @property
    def area(self) -> 'OptionSeriesArea':
        """A <code>area</code> series. """
        return self._config_sub_data("area", OptionSeriesArea)

    @property
    def arearange(self) -> 'OptionSeriesArearange':
        """A <code>arearange</code> series. """
        return self._config_sub_data("arearange", OptionSeriesArearange)

    @property
    def areaspline(self) -> 'OptionSeriesAreaspline':
        """A <code>areaspline</code> series. """
        return self._config_sub_data("areaspline", OptionSeriesAreaspline)

    @property
    def areasplinerange(self) -> 'OptionSeriesAreasplinerange':
        """A <code>areasplinerange</code> series. """
        return self._config_sub_data("areasplinerange", OptionSeriesAreasplinerange)

    @property
    def bar(self) -> 'OptionSeriesBar':
        """A <code>bar</code> series. """
        return self._config_sub_data("bar", OptionSeriesBar)

    @property
    def bellcurve(self) -> 'OptionSeriesBellcurve':
        """A <code>bellcurve</code> series. """
        return self._config_sub_data("bellcurve", OptionSeriesBellcurve)

    @property
    def boxplot(self) -> 'OptionSeriesBoxplot':
        """A <code>boxplot</code> series. """
        return self._config_sub_data("boxplot", OptionSeriesBoxplot)

    @property
    def bubble(self) -> 'OptionSeriesBubble':
        """A <code>bubble</code> series. """
        return self._config_sub_data("bubble", OptionSeriesBubble)

    @property
    def bullet(self) -> 'OptionSeriesBullet':
        """A <code>bullet</code> series. """
        return self._config_sub_data("bullet", OptionSeriesBullet)

    @property
    def column(self) -> 'OptionSeriesColumn':
        """A <code>column</code> series. """
        return self._config_sub_data("column", OptionSeriesColumn)

    @property
    def columnpyramid(self) -> 'OptionSeriesColumnpyramid':
        """A <code>columnpyramid</code> series. """
        return self._config_sub_data("columnpyramid", OptionSeriesColumnpyramid)

    @property
    def columnrange(self) -> 'OptionSeriesColumnrange':
        """A <code>columnrange</code> series. """
        return self._config_sub_data("columnrange", OptionSeriesColumnrange)

    @property
    def cylinder(self) -> 'OptionSeriesCylinder':
        """A <code>cylinder</code> series. """
        return self._config_sub_data("cylinder", OptionSeriesCylinder)

    @property
    def dependencywheel(self) -> 'OptionSeriesDependencywheel':
        """A <code>dependencywheel</code> series. """
        return self._config_sub_data("dependencywheel", OptionSeriesDependencywheel)

    @property
    def dumbbell(self) -> 'OptionSeriesDumbbell':
        """The <code>dumbbell</code> series. """
        return self._config_sub_data("dumbbell", OptionSeriesDumbbell)

    @property
    def errorbar(self) -> 'OptionSeriesErrorbar':
        """A <code>errorbar</code> series. """
        return self._config_sub_data("errorbar", OptionSeriesErrorbar)

    @property
    def funnel(self) -> 'OptionSeriesFunnel':
        """A <code>funnel</code> series. """
        return self._config_sub_data("funnel", OptionSeriesFunnel)

    @property
    def funnel3d(self) -> 'OptionSeriesFunnel3d':
        """A <code>funnel3d</code> series. """
        return self._config_sub_data("funnel3d", OptionSeriesFunnel3d)

    @property
    def gauge(self) -> 'OptionSeriesGauge':
        """A <code>gauge</code> series. """
        return self._config_sub_data("gauge", OptionSeriesGauge)

    @property
    def heatmap(self) -> 'OptionSeriesHeatmap':
        """A <code>heatmap</code> series. """
        return self._config_sub_data("heatmap", OptionSeriesHeatmap)

    @property
    def histogram(self) -> 'OptionSeriesHistogram':
        """A <code>histogram</code> series. """
        return self._config_sub_data("histogram", OptionSeriesHistogram)

    @property
    def item(self) -> 'OptionSeriesItem':
        """An <code>item</code> series. """
        return self._config_sub_data("item", OptionSeriesItem)

    @property
    def line(self) -> 'OptionSeriesLine':
        """A <code>line</code> series. """
        return self._config_sub_data("line", OptionSeriesLine)

    @property
    def lollipop(self) -> 'OptionSeriesLollipop':
        """The <code>lollipop</code> series. """
        return self._config_sub_data("lollipop", OptionSeriesLollipop)

    @property
    def networkgraph(self) -> 'OptionSeriesNetworkgraph':
        """A <code>networkgraph</code> series. """
        return self._config_sub_data("networkgraph", OptionSeriesNetworkgraph)

    @property
    def organization(self) -> 'OptionSeriesOrganization':
        """An <code>organization</code> series. """
        return self._config_sub_data("organization", OptionSeriesOrganization)

    @property
    def packedbubble(self) -> 'OptionSeriesPackedbubble':
        """A <code>packedbubble</code> series. """
        return self._config_sub_data("packedbubble", OptionSeriesPackedbubble)

    @property
    def pareto(self) -> 'OptionSeriesPareto':
        """A <code>pareto</code> series. """
        return self._config_sub_data("pareto", OptionSeriesPareto)

    @property
    def pictorial(self) -> 'OptionSeriesPictorial':
        """A <code>pictorial</code> series. """
        return self._config_sub_data("pictorial", OptionSeriesPictorial)

    @property
    def pie(self) -> 'OptionSeriesPie':
        """A <code>pie</code> series. """
        return self._config_sub_data("pie", OptionSeriesPie)

    @property
    def polygon(self) -> 'OptionSeriesPolygon':
        """A <code>polygon</code> series. """
        return self._config_sub_data("polygon", OptionSeriesPolygon)

    @property
    def pyramid(self) -> 'OptionSeriesPyramid':
        """A <code>pyramid</code> series. """
        return self._config_sub_data("pyramid", OptionSeriesPyramid)

    @property
    def pyramid3d(self) -> 'OptionSeriesPyramid3d':
        """A <code>pyramid3d</code> series. """
        return self._config_sub_data("pyramid3d", OptionSeriesPyramid3d)

    @property
    def sankey(self) -> 'OptionSeriesSankey':
        """A <code>sankey</code> series. """
        return self._config_sub_data("sankey", OptionSeriesSankey)

    @property
    def scatter(self) -> 'OptionSeriesScatter':
        """A <code>scatter</code> series. """
        return self._config_sub_data("scatter", OptionSeriesScatter)

    @property
    def scatter3d(self) -> 'OptionSeriesScatter3d':
        """A <code>scatter3d</code> series. """
        return self._config_sub_data("scatter3d", OptionSeriesScatter3d)

    @property
    def solidgauge(self) -> 'OptionSeriesSolidgauge':
        """A <code>solidgauge</code> series. """
        return self._config_sub_data("solidgauge", OptionSeriesSolidgauge)

    @property
    def spline(self) -> 'OptionSeriesSpline':
        """A <code>spline</code> series. """
        return self._config_sub_data("spline", OptionSeriesSpline)

    @property
    def streamgraph(self) -> 'OptionSeriesStreamgraph':
        """A <code>streamgraph</code> series. """
        return self._config_sub_data("streamgraph", OptionSeriesStreamgraph)

    @property
    def sunburst(self) -> 'OptionSeriesSunburst':
        """A <code>sunburst</code> series. """
        return self._config_sub_data("sunburst", OptionSeriesSunburst)

    @property
    def tilemap(self) -> 'OptionSeriesTilemap':
        """A <code>tilemap</code> series. """
        return self._config_sub_data("tilemap", OptionSeriesTilemap)

    @property
    def timeline(self) -> 'OptionSeriesTimeline':
        """The <code>timeline</code> series. """
        return self._config_sub_data("timeline", OptionSeriesTimeline)

    @property
    def treegraph(self) -> 'OptionSeriesTreegraph':
        """A <code>treegraph</code> series. """
        return self._config_sub_data("treegraph", OptionSeriesTreegraph)

    @property
    def treemap(self) -> 'OptionSeriesTreemap':
        """A <code>treemap</code> series. """
        return self._config_sub_data("treemap", OptionSeriesTreemap)

    @property
    def variablepie(self) -> 'OptionSeriesVariablepie':
        """A <code>variablepie</code> series. """
        return self._config_sub_data("variablepie", OptionSeriesVariablepie)

    @property
    def variwide(self) -> 'OptionSeriesVariwide':
        """A <code>variwide</code> series. """
        return self._config_sub_data("variwide", OptionSeriesVariwide)

    @property
    def vector(self) -> 'OptionSeriesVector':
        """A <code>vector</code> series. """
        return self._config_sub_data("vector", OptionSeriesVector)

    @property
    def venn(self) -> 'OptionSeriesVenn':
        """A <code>venn</code> series. """
        return self._config_sub_data("venn", OptionSeriesVenn)

    @property
    def waterfall(self) -> 'OptionSeriesWaterfall':
        """A <code>waterfall</code> series. """
        return self._config_sub_data("waterfall", OptionSeriesWaterfall)

    @property
    def windbarb(self) -> 'OptionSeriesWindbarb':
        """A <code>windbarb</code> series. """
        return self._config_sub_data("windbarb", OptionSeriesWindbarb)

    @property
    def wordcloud(self) -> 'OptionSeriesWordcloud':
        """A <code>wordcloud</code> series. """
        return self._config_sub_data("wordcloud", OptionSeriesWordcloud)

    @property
    def xrange(self) -> 'OptionSeriesXrange':
        """An <code>xrange</code> series. """
        return self._config_sub_data("xrange", OptionSeriesXrange)

        
class OptionSeriesItemZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesItemTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesItemTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesItemStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesItemStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesItemStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesItemStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesItemStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesItemStatesSelectMarker)

        
class OptionSeriesItemStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesItemStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesItemStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesItemStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemStates(Options):

    @property
    def hover(self) -> 'OptionSeriesItemStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesItemStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesItemStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesItemStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesItemStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesItemStatesNormal)

    @property
    def select(self) -> 'OptionSeriesItemStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesItemStatesSelect)

        
class OptionSeriesItemStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesItemStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesItemStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesItemStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesItemStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesItemStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesItemStatesHoverMarker)

        
class OptionSeriesItemSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesItemSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesItemSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesItemSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesItemSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesItemSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesItemSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesItemSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesItemSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesItemSonificationTracksMappingLowpassResonance)

        
class OptionSeriesItemSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesItemSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesItemSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesItemSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesItemSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesItemSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesItemSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesItemSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesItemSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesItemSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesItemSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesItemSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesItemSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesItemSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesItemSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesItemSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesItemSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesItemSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesItemSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesItemSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesItemSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesItemSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesItemSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesItemSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesItemSonificationTracksMappingVolume)

        
class OptionSeriesItemSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesItemSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesItemSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesItemSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesItemSonificationTracksMappingHighpassResonance)

        
class OptionSeriesItemSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesItemSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesItemSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesItemSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesItemSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesItemSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesItemSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesItemSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesItemSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesItemSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesItemSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesItemSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesItemSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesItemSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesItemSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesItemSonificationTracks)

        
class OptionSeriesItemSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesItemSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesItemSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesItemSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesItemSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesItemSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesItemSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesItemSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesItemSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesItemSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesItemSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesItemSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesItemSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesItemSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesItemSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesItemSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesItemSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesItemSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesItemSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesItemSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesItemSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesItemSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesItemSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesItemSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesItemSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesItemSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesItemSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesItemSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesItemSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesItemSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesItemSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesItemSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesItemSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesItemSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesItemSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesItemSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesItemSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesItemSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesItemSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesItemSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesItemSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesItemSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesItemSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesItemSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesItemSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesItemSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesItemSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesItemSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesItemSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesItemSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesItemSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesItemSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesItemSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesItemSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesItemSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesItemSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesItemSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesItemSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesItemSonificationContexttracksMappingVolume)

        
class OptionSeriesItemSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesItemSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesItemSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesItemSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesItemSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesItemSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesItemSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesItemSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesItemSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesItemSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesItemSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesItemPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesItemPoint(Options):

    @property
    def events(self) -> 'OptionSeriesItemPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesItemPointEvents)

        
class OptionSeriesItemOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesItemOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesItemOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesItemOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesItemOnpointPosition)

        
class OptionSeriesItemMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesItemMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesItemMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesItemMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesItemMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesItemMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesItemMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesItemMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesItemMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesItemMarkerStatesSelect)

        
class OptionSeriesItemMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesItemMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesItemMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesItemLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesItemLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesItem(Options):

    @property
    def accessibility(self) -> 'OptionSeriesItemAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesItemAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the pie chart relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get([null, null])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(False)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesItemData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesItemData)

    @property
    def dataLabels(self) -> 'OptionSeriesItemDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesItemDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesItemDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesItemDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """In circular view, the end angle of the item layout, in degrees where 0 is up.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @endAngle.setter
    def endAngle(self, value: Any): self._config(value, js_type=False)

    @property
    def events(self) -> 'OptionSeriesItemEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesItemEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def innerSize(self):
        """In circular view, the size of the inner diameter of the circle.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("40%")

    @innerSize.setter
    def innerSize(self, text: str): self._config(text, js_type=False)

    @property
    def itemPadding(self):
        """The padding between the items, given in relative size where the size of the item is 1.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @itemPadding.setter
    def itemPadding(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesItemLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesItemLabel)

    @property
    def layout(self):
        """The layout of the items in rectangular view.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("vertical")

    @layout.setter
    def layout(self, text: str): self._config(text, js_type=False)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesItemMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesItemMarker)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesItemOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesItemOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesItemPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesItemPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rows(self):
        """The number of rows to display in the rectangular or circular view.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @rows.setter
    def rows(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get(True)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """The diameter of the pie relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesItemSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesItemSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def startAngle(self):
        """In circular view, the start angle of the item layout, in degrees where 0 is up.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Item/ItemSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @startAngle.setter
    def startAngle(self, value: Any): self._config(value, js_type=False)

    @property
    def states(self) -> 'OptionSeriesItemStates':
        """. """
        return self._config_sub_data("states", OptionSeriesItemStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesItemTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesItemTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesItemZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesItemZones)

        
class OptionSeriesItemDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesItemDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesItemDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesItemDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesItemDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesItemDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesItemDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesItemDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesItemDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesItemDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesItemDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesItemDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesItemDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesItemDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesItemDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesItemAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesItemAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesItemAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesItemAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesItemAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesItemAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesItemAccessibilityPoint)

        
class OptionSeriesHistogramZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesHistogramTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesHistogramTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{point.x} - {point.x2}</span><br/><span style="color:{point.color}">●</span> {series.name} <b>{point.y}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesHistogramStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesHistogramStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesHistogramStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesHistogramStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesHistogramStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesHistogramStatesSelectMarker)

        
class OptionSeriesHistogramStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHistogramStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesHistogramStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesHistogramStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramStates(Options):

    @property
    def hover(self) -> 'OptionSeriesHistogramStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesHistogramStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesHistogramStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesHistogramStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesHistogramStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesHistogramStatesNormal)

    @property
    def select(self) -> 'OptionSeriesHistogramStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesHistogramStatesSelect)

        
class OptionSeriesHistogramStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesHistogramStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesHistogramStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesHistogramStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesHistogramStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesHistogramStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesHistogramStatesHoverMarker)

        
class OptionSeriesHistogramSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesHistogramSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesHistogramSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesHistogramSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesHistogramSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesHistogramSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHistogramSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHistogramSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHistogramSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHistogramSonificationTracksMappingLowpassResonance)

        
class OptionSeriesHistogramSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesHistogramSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesHistogramSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesHistogramSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesHistogramSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesHistogramSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesHistogramSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesHistogramSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesHistogramSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesHistogramSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesHistogramSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesHistogramSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesHistogramSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesHistogramSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesHistogramSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesHistogramSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesHistogramSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesHistogramSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesHistogramSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesHistogramSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesHistogramSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesHistogramSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesHistogramSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesHistogramSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesHistogramSonificationTracksMappingVolume)

        
class OptionSeriesHistogramSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHistogramSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHistogramSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHistogramSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHistogramSonificationTracksMappingHighpassResonance)

        
class OptionSeriesHistogramSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesHistogramSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesHistogramSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesHistogramSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesHistogramSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesHistogramSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesHistogramSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesHistogramSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesHistogramSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesHistogramSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesHistogramSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesHistogramSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesHistogramSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesHistogramSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesHistogramSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesHistogramSonificationTracks)

        
class OptionSeriesHistogramSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesHistogramSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesHistogramSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesHistogramSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesHistogramSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesHistogramSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesHistogramSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesHistogramSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesHistogramSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesHistogramSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesHistogramSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesHistogramSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesHistogramSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesHistogramSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesHistogramSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesHistogramSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesHistogramSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesHistogramSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesHistogramSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesHistogramSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHistogramSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesHistogramSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesHistogramSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesHistogramSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesHistogramSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHistogramSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHistogramSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesHistogramSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesHistogramSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesHistogramSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesHistogramSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesHistogramSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesHistogramSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesHistogramSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesHistogramSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesHistogramSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesHistogramSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesHistogramSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesHistogramSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesHistogramSonificationContexttracksMappingVolume)

        
class OptionSeriesHistogramSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesHistogramSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesHistogramSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesHistogramSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesHistogramSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesHistogramSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesHistogramSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHistogramSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHistogramSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHistogramSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesHistogramPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHistogramPoint(Options):

    @property
    def events(self) -> 'OptionSeriesHistogramPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesHistogramPointEvents)

        
class OptionSeriesHistogramOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesHistogramOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesHistogramOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesHistogramOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesHistogramOnpointPosition)

        
class OptionSeriesHistogramMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHistogramMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesHistogramMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesHistogramMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesHistogramMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesHistogramMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesHistogramMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesHistogramMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesHistogramMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesHistogramMarkerStatesSelect)

        
class OptionSeriesHistogramMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesHistogramMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesHistogramMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesHistogramLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesHistogramLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHistogram(Options):

    @property
    def accessibility(self) -> 'OptionSeriesHistogramAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesHistogramAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def baseSeries(self):
        """An integer identifying the index to use for the base series, or a string representing the id of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get(None)

    @baseSeries.setter
    def baseSeries(self, num: float): self._config(num, js_type=False)

    @property
    def binsNumber(self):
        """A preferable number of bins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get(square-root)

    @binsNumber.setter
    def binsNumber(self, value: Any): self._config(value, js_type=False)

    @property
    def binWidth(self):
        """Width of each bin.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @binWidth.setter
    def binWidth(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesHistogramDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesHistogramDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesHistogramDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesHistogramDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesHistogramDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesHistogramDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesHistogramEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesHistogramEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get(False)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get(0)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesHistogramLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesHistogramLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesHistogramMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesHistogramMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesHistogramOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesHistogramOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesHistogramPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesHistogramPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get(0)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Histogram/HistogramSeriesDefaults.ts
        """
        return self._config_get("between")

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesHistogramSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesHistogramSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesHistogramStates':
        """. """
        return self._config_sub_data("states", OptionSeriesHistogramStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesHistogramTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesHistogramTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesHistogramZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesHistogramZones)

        
class OptionSeriesHistogramDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHistogramDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesHistogramDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesHistogramDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesHistogramDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesHistogramDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesHistogramDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesHistogramDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHistogramAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHistogramAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHistogramAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesHistogramAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesHistogramAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesHistogramAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesHistogramAccessibilityPoint)

        
class OptionSeriesHeatmapZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesHeatmapTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesHeatmapTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("{point.x}, {point.y}: {point.value}<br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesHeatmapStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesHeatmapStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesHeatmapStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesHeatmapStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesHeatmapStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesHeatmapStatesSelectMarker)

        
class OptionSeriesHeatmapStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHeatmapStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesHeatmapStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesHeatmapStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapStates(Options):

    @property
    def hover(self) -> 'OptionSeriesHeatmapStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesHeatmapStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesHeatmapStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesHeatmapStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesHeatmapStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesHeatmapStatesNormal)

    @property
    def select(self) -> 'OptionSeriesHeatmapStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesHeatmapStatesSelect)

        
class OptionSeriesHeatmapStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesHeatmapStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesHeatmapStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesHeatmapStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesHeatmapStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesHeatmapStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesHeatmapStatesHoverMarker)

        
class OptionSeriesHeatmapSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesHeatmapSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesHeatmapSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesHeatmapSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesHeatmapSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesHeatmapSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHeatmapSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHeatmapSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHeatmapSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHeatmapSonificationTracksMappingLowpassResonance)

        
class OptionSeriesHeatmapSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesHeatmapSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesHeatmapSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesHeatmapSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesHeatmapSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesHeatmapSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesHeatmapSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesHeatmapSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesHeatmapSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesHeatmapSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesHeatmapSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesHeatmapSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesHeatmapSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesHeatmapSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesHeatmapSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesHeatmapSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesHeatmapSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesHeatmapSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesHeatmapSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesHeatmapSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesHeatmapSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesHeatmapSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesHeatmapSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesHeatmapSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesHeatmapSonificationTracksMappingVolume)

        
class OptionSeriesHeatmapSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHeatmapSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHeatmapSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHeatmapSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHeatmapSonificationTracksMappingHighpassResonance)

        
class OptionSeriesHeatmapSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesHeatmapSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesHeatmapSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesHeatmapSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesHeatmapSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesHeatmapSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesHeatmapSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesHeatmapSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesHeatmapSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesHeatmapSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesHeatmapSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesHeatmapSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesHeatmapSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesHeatmapSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesHeatmapSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesHeatmapSonificationTracks)

        
class OptionSeriesHeatmapSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesHeatmapSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesHeatmapSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesHeatmapSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesHeatmapSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesHeatmapSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesHeatmapSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesHeatmapSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesHeatmapSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHeatmapSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesHeatmapSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesHeatmapSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesHeatmapSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesHeatmapSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHeatmapSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHeatmapSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesHeatmapSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesHeatmapSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesHeatmapSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesHeatmapSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesHeatmapSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesHeatmapSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesHeatmapSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesHeatmapSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesHeatmapSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesHeatmapSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesHeatmapSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesHeatmapSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesHeatmapSonificationContexttracksMappingVolume)

        
class OptionSeriesHeatmapSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesHeatmapSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesHeatmapSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesHeatmapSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesHeatmapSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesHeatmapSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesHeatmapSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesHeatmapSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesHeatmapSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesHeatmapSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesHeatmapPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesHeatmapPoint(Options):

    @property
    def events(self) -> 'OptionSeriesHeatmapPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesHeatmapPointEvents)

        
class OptionSeriesHeatmapOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesHeatmapOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesHeatmapOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesHeatmapOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesHeatmapOnpointPosition)

        
class OptionSeriesHeatmapMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHeatmapMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesHeatmapMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesHeatmapMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesHeatmapMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesHeatmapMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesHeatmapMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesHeatmapMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesHeatmapMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesHeatmapMarkerStatesSelect)

        
class OptionSeriesHeatmapMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesHeatmapMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesHeatmapMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("rect")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesHeatmapLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesHeatmapLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHeatmap(Options):

    @property
    def accessibility(self) -> 'OptionSeriesHeatmapAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesHeatmapAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Animation is disabled by default on the heatmap series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderRadius(self):
        """The border radius for each heatmap item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("value")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colsize(self):
        """The column size - how many X axis units each column in the heatmap should span.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(1)

    @colsize.setter
    def colsize(self, num: float): self._config(num, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesHeatmapData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesHeatmapData)

    @property
    def dataLabels(self) -> 'OptionSeriesHeatmapDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesHeatmapDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesHeatmapDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesHeatmapDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesHeatmapEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesHeatmapEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def interpolation(self):
        """Make the heatmap render its data points as an interpolated image.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @interpolation.setter
    def interpolation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesHeatmapLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesHeatmapLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesHeatmapMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesHeatmapMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def nullColor(self):
        """The color applied to null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("#f7f7f7")

    @nullColor.setter
    def nullColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesHeatmapOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesHeatmapOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesHeatmapPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesHeatmapPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between the points in the heatmap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def rowsize(self):
        """The row size - how many Y axis units each heatmap row should span.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(1)

    @rowsize.setter
    def rowsize(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesHeatmapSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesHeatmapSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesHeatmapStates':
        """. """
        return self._config_sub_data("states", OptionSeriesHeatmapStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesHeatmapTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesHeatmapTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesHeatmapZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesHeatmapZones)

        
class OptionSeriesHeatmapDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHeatmapDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesHeatmapDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesHeatmapDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesHeatmapDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesHeatmapDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesHeatmapDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesHeatmapDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on select state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHeatmapDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesHeatmapDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesHeatmapDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Set the marker&#39;s fixed height on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def heightPlus(self):
        """The number of pixels to increase the height of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @heightPlus.setter
    def heightPlus(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Set the marker&#39;s fixed width on hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def widthPlus(self):
        """The number of pixels to increase the width of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @widthPlus.setter
    def widthPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesHeatmapDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesHeatmapDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesHeatmapDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesHeatmapDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesHeatmapDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesHeatmapDataMarkerStatesSelect)

        
class OptionSeriesHeatmapDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesHeatmapDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesHeatmapDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesHeatmapDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesHeatmapDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """The color of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesHeatmapDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesHeatmapDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesHeatmapDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesHeatmapDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesHeatmapDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesHeatmapDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesHeatmapDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesHeatmapDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def pointPadding(self):
        """Point padding for a single point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Heatmap/HeatmapSeriesDefaults.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHeatmapDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesHeatmapDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesHeatmapDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesHeatmapDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesHeatmapDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesHeatmapDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesHeatmapDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesHeatmapAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesHeatmapAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesHeatmapAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesHeatmapAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesHeatmapAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesHeatmapAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesHeatmapAccessibilityPoint)

        
class OptionSeriesGaugeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesGaugeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesGaugeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("")

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesGaugeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesGaugeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesGaugeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesGaugeSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesGaugeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesGaugeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesGaugeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesGaugeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesGaugeSonificationTracksMappingLowpassResonance)

        
class OptionSeriesGaugeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesGaugeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesGaugeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesGaugeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesGaugeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesGaugeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesGaugeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesGaugeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesGaugeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesGaugeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesGaugeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesGaugeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesGaugeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesGaugeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesGaugeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesGaugeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesGaugeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesGaugeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesGaugeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesGaugeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesGaugeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesGaugeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesGaugeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesGaugeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesGaugeSonificationTracksMappingVolume)

        
class OptionSeriesGaugeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesGaugeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesGaugeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesGaugeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesGaugeSonificationTracksMappingHighpassResonance)

        
class OptionSeriesGaugeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesGaugeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesGaugeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesGaugeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesGaugeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesGaugeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesGaugeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesGaugeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesGaugeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesGaugeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesGaugeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesGaugeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesGaugeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesGaugeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesGaugeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesGaugeSonificationTracks)

        
class OptionSeriesGaugeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesGaugeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesGaugeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesGaugeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesGaugeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesGaugeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesGaugeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesGaugeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesGaugeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesGaugeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesGaugeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesGaugeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesGaugeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesGaugeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesGaugeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesGaugeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesGaugeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesGaugeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesGaugeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesGaugeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesGaugeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesGaugeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesGaugeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesGaugeSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesGaugeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesGaugeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesGaugeSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesGaugeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesGaugeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesGaugeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesGaugeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesGaugeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesGaugeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesGaugeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesGaugeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesGaugeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesGaugeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesGaugeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesGaugeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesGaugeSonificationContexttracksMappingVolume)

        
class OptionSeriesGaugeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesGaugeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesGaugeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesGaugeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesGaugeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesGaugeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesGaugeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesGaugeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesGaugeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesGaugeSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesGaugePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesGaugePoint(Options):

    @property
    def events(self) -> 'OptionSeriesGaugePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesGaugePointEvents)

        
class OptionSeriesGaugePivot(Options):

    @property
    def backgroundColor(self):
        """The background color or fill of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#000000")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border or stroke color of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#cccccc")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The border or stroke width of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The pixel radius of the pivot.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(5)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesGaugeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesGaugeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesGaugeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesGaugeOnpointPosition)

        
class OptionSeriesGaugeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesGaugeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesGaugeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesGauge(Options):

    @property
    def accessibility(self) -> 'OptionSeriesGaugeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesGaugeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def data(self) -> 'OptionSeriesGaugeData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesGaugeData)

    @property
    def dataLabels(self) -> 'OptionSeriesGaugeDatalabels':
        """Data labels for the gauge. """
        return self._config_sub_data("dataLabels", OptionSeriesGaugeDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dial(self) -> 'OptionSeriesGaugeDial':
        """Options for the dial or arrow pointer of the gauge. """
        return self._config_sub_data("dial", OptionSeriesGaugeDial)

    @property
    def dragDrop(self) -> 'OptionSeriesGaugeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesGaugeDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesGaugeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesGaugeEvents)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesGaugeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesGaugeLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesGaugeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesGaugeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def overshoot(self):
        """Allow the dial to overshoot the end of the perimeter axis by this many degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(None)

    @overshoot.setter
    def overshoot(self, num: float): self._config(num, js_type=False)

    @property
    def pivot(self) -> 'OptionSeriesGaugePivot':
        """Options for the pivot or the center point of the gauge. """
        return self._config_sub_data("pivot", OptionSeriesGaugePivot)

    @property
    def point(self) -> 'OptionSeriesGaugePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesGaugePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesGaugeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesGaugeSonification)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesGaugeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesGaugeTooltip)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def wrap(self):
        """When this option is <code>true</code>, the dial will wrap around the axes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(True)

    @wrap.setter
    def wrap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesGaugeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesGaugeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesGaugeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("#cccccc")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(False)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesGaugeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesGaugeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesGaugeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesGaugeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get("top")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(15)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Gauge/GaugeSeries.ts
        """
        return self._config_get(2)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesGaugeDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesGaugeDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesGaugeDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesGaugeDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesGaugeDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesGaugeDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesGaugeDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesGaugeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesGaugeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesGaugeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesGaugeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesGaugeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesGaugeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesGaugeAccessibilityPoint)

        
class OptionSeriesFunnel3dZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesFunnel3dTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesFunnel3dTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesFunnel3dStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesFunnel3dStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesFunnel3dStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesFunnel3dStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesFunnel3dStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesFunnel3dStatesSelectMarker)

        
class OptionSeriesFunnel3dStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnel3dStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesFunnel3dStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesFunnel3dStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dStates(Options):

    @property
    def hover(self) -> 'OptionSeriesFunnel3dStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesFunnel3dStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesFunnel3dStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesFunnel3dStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesFunnel3dStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesFunnel3dStatesNormal)

    @property
    def select(self) -> 'OptionSeriesFunnel3dStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesFunnel3dStatesSelect)

        
class OptionSeriesFunnel3dStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesFunnel3dStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesFunnel3dStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesFunnel3dStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesFunnel3dStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesFunnel3dStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesFunnel3dStatesHoverMarker)

        
class OptionSeriesFunnel3dSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesFunnel3dSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesFunnel3dSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesFunnel3dSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnel3dSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnel3dSonificationTracksMappingLowpassResonance)

        
class OptionSeriesFunnel3dSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesFunnel3dSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesFunnel3dSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesFunnel3dSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesFunnel3dSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesFunnel3dSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesFunnel3dSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesFunnel3dSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesFunnel3dSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesFunnel3dSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesFunnel3dSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesFunnel3dSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesFunnel3dSonificationTracksMappingVolume)

        
class OptionSeriesFunnel3dSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnel3dSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnel3dSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnel3dSonificationTracksMappingHighpassResonance)

        
class OptionSeriesFunnel3dSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesFunnel3dSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesFunnel3dSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesFunnel3dSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesFunnel3dSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnel3dSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnel3dSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesFunnel3dSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesFunnel3dSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesFunnel3dSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesFunnel3dSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesFunnel3dSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnel3dSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnel3dSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesFunnel3dSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesFunnel3dSonificationTracks)

        
class OptionSeriesFunnel3dSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesFunnel3dSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesFunnel3dSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesFunnel3dSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesFunnel3dSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesFunnel3dSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesFunnel3dSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnel3dSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnel3dSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnel3dSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesFunnel3dSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesFunnel3dSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesFunnel3dSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnel3dSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnel3dSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesFunnel3dSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesFunnel3dSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesFunnel3dSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesFunnel3dSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesFunnel3dSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesFunnel3dSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesFunnel3dSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesFunnel3dSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesFunnel3dSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesFunnel3dSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesFunnel3dSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesFunnel3dSonificationContexttracksMappingVolume)

        
class OptionSeriesFunnel3dSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesFunnel3dSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesFunnel3dSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesFunnel3dSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnel3dSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnel3dSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnel3dSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnel3dSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnel3dSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesFunnel3dPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnel3dPoint(Options):

    @property
    def events(self) -> 'OptionSeriesFunnel3dPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesFunnel3dPointEvents)

        
class OptionSeriesFunnel3dOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesFunnel3dOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesFunnel3dOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesFunnel3dOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesFunnel3dOnpointPosition)

        
class OptionSeriesFunnel3dMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnel3dMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesFunnel3dMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesFunnel3dMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesFunnel3dMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesFunnel3dMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesFunnel3dMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesFunnel3dMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesFunnel3dMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesFunnel3dMarkerStatesSelect)

        
class OptionSeriesFunnel3dMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesFunnel3dMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesFunnel3dMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesFunnel3dLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesFunnel3dLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnel3d(Options):

    @property
    def accessibility(self) -> 'OptionSeriesFunnel3dAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesFunnel3dAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesFunnel3dData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesFunnel3dData)

    @property
    def dataLabels(self) -> 'OptionSeriesFunnel3dDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesFunnel3dDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesFunnel3dDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesFunnel3dDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesFunnel3dDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesFunnel3dDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(0)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesFunnel3dEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesFunnel3dEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def gradientForSides(self):
        """By deafult sides fill is set to a gradient through this option being set to <code>true</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(True)

    @gradientForSides.setter
    def gradientForSides(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def height(self):
        """The height of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("100%")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesFunnel3dLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesFunnel3dLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesFunnel3dMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesFunnel3dMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def neckHeight(self):
        """The height of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("25%")

    @neckHeight.setter
    def neckHeight(self, num: float): self._config(num, js_type=False)

    @property
    def neckWidth(self):
        """The width of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("30%")

    @neckWidth.setter
    def neckWidth(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesFunnel3dOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesFunnel3dOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesFunnel3dPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesFunnel3dPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def reversed(self):
        """A reversed funnel has the widest area down.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesFunnel3dSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesFunnel3dSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesFunnel3dStates':
        """. """
        return self._config_sub_data("states", OptionSeriesFunnel3dStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesFunnel3dTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesFunnel3dTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def width(self):
        """The max width of the series compared to the width of the plot area, or the pixel width if it is a number.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("90%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesFunnel3dZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesFunnel3dZones)

        
class OptionSeriesFunnel3dDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnel3dDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("right")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesFunnel3dDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesFunnel3dDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesFunnel3dDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesFunnel3dDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get(False)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel3D/Funnel3DSeriesDefaults.ts
        """
        return self._config_get("allow")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesFunnel3dDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesFunnel3dDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnel3dDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesFunnel3dDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesFunnel3dDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesFunnel3dDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesFunnel3dDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesFunnel3dDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesFunnel3dDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnel3dAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnel3dAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnel3dAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesFunnel3dAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesFunnel3dAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesFunnel3dAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesFunnel3dAccessibilityPoint)

        
class OptionSeriesFunnelZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesFunnelTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesFunnelTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesFunnelStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesFunnelStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesFunnelStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesFunnelStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesFunnelStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesFunnelStatesSelectMarker)

        
class OptionSeriesFunnelStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnelStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesFunnelStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesFunnelStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelStates(Options):

    @property
    def hover(self) -> 'OptionSeriesFunnelStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesFunnelStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesFunnelStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesFunnelStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesFunnelStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesFunnelStatesNormal)

    @property
    def select(self) -> 'OptionSeriesFunnelStatesSelect':
        """Options for a selected funnel item. """
        return self._config_sub_data("select", OptionSeriesFunnelStatesSelect)

        
class OptionSeriesFunnelStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesFunnelStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesFunnelStatesHoverAnimation)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesFunnelStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesFunnelStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesFunnelStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesFunnelStatesHoverMarker)

        
class OptionSeriesFunnelSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesFunnelSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesFunnelSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesFunnelSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesFunnelSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesFunnelSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnelSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnelSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnelSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnelSonificationTracksMappingLowpassResonance)

        
class OptionSeriesFunnelSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnelSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesFunnelSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesFunnelSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesFunnelSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesFunnelSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesFunnelSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesFunnelSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesFunnelSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesFunnelSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesFunnelSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesFunnelSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesFunnelSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesFunnelSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesFunnelSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesFunnelSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesFunnelSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesFunnelSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesFunnelSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesFunnelSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesFunnelSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesFunnelSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesFunnelSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesFunnelSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesFunnelSonificationTracksMappingVolume)

        
class OptionSeriesFunnelSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnelSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnelSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnelSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnelSonificationTracksMappingHighpassResonance)

        
class OptionSeriesFunnelSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesFunnelSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesFunnelSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesFunnelSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesFunnelSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnelSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnelSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesFunnelSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesFunnelSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesFunnelSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesFunnelSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesFunnelSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnelSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnelSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesFunnelSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesFunnelSonificationTracks)

        
class OptionSeriesFunnelSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesFunnelSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesFunnelSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesFunnelSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesFunnelSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesFunnelSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesFunnelSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesFunnelSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesFunnelSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesFunnelSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesFunnelSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesFunnelSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesFunnelSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesFunnelSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesFunnelSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesFunnelSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnelSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnelSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesFunnelSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnelSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnelSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesFunnelSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesFunnelSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesFunnelSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesFunnelSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnelSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnelSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesFunnelSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesFunnelSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesFunnelSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesFunnelSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesFunnelSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesFunnelSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesFunnelSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesFunnelSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesFunnelSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesFunnelSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesFunnelSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesFunnelSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesFunnelSonificationContexttracksMappingVolume)

        
class OptionSeriesFunnelSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesFunnelSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesFunnelSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesFunnelSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesFunnelSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesFunnelSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesFunnelSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesFunnelSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesFunnelSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesFunnelSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesFunnelPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def legendItemClick(self):
        """Fires when the legend item belonging to the pie point (slice) is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @legendItemClick.setter
    def legendItemClick(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesFunnelPoint(Options):

    @property
    def events(self) -> 'OptionSeriesFunnelPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesFunnelPointEvents)

        
class OptionSeriesFunnelOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesFunnelOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesFunnelOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesFunnelOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesFunnelOnpointPosition)

        
class OptionSeriesFunnelMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnelMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesFunnelMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesFunnelMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesFunnelMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesFunnelMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesFunnelMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesFunnelMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesFunnelMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesFunnelMarkerStatesSelect)

        
class OptionSeriesFunnelMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesFunnelMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesFunnelMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesFunnelLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesFunnelLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnel(Options):

    @property
    def accessibility(self) -> 'OptionSeriesFunnelAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesFunnelAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Initial animation is by default disabled for the funnel chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(False)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding all points or series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(1)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(["50%", "50%"])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The color of the pie series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to use instead of the global <a href="#colors">colors</a>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesFunnelData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesFunnelData)

    @property
    def dataLabels(self) -> 'OptionSeriesFunnelDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesFunnelDatalabels)

    @property
    def depth(self):
        """The thickness of a 3D pie.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie3D/Pie3DSeries.ts
        """
        return self._config_get(0)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesFunnelDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesFunnelDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def endAngle(self):
        """The end angle of the pie in degrees where 0 is top and 90 is right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @endAngle.setter
    def endAngle(self, num: float): self._config(num, js_type=False)

    @property
    def events(self) -> 'OptionSeriesFunnelEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesFunnelEvents)

    @property
    def fillColor(self):
        """If the total sum of the pie&#39;s values is 0, the series is represented as an empty circle .

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def height(self):
        """The height of the funnel or pyramid.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("100%")

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def ignoreHiddenPoint(self):
        """Equivalent to <a href="#chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @ignoreHiddenPoint.setter
    def ignoreHiddenPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesFunnelLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesFunnelLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesFunnelMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesFunnelMarker)

    @property
    def minSize(self):
        """The minimum size for a pie in response to auto margins.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(80)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def neckHeight(self):
        """The height of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("25%")

    @neckHeight.setter
    def neckHeight(self, num: float): self._config(num, js_type=False)

    @property
    def neckWidth(self):
        """The width of the neck, the lower part of the funnel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("30%")

    @neckWidth.setter
    def neckWidth(self, num: float): self._config(num, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesFunnelOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesFunnelOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesFunnelPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesFunnelPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def reversed(self):
        """A reversed funnel has the widest area down.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def slicedOffset(self):
        """If a point is sliced, moved out from the center, how many pixels should it be moved?.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(10)

    @slicedOffset.setter
    def slicedOffset(self, num: float): self._config(num, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesFunnelSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesFunnelSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def startAngle(self):
        """The start angle of the pie slices in degrees where 0 is top and 90 right.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesFunnelStates':
        """Options for the series states. """
        return self._config_sub_data("states", OptionSeriesFunnelStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def thickness(self):
        """Thickness describing the ring size for a donut type chart, overriding <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @thickness.setter
    def thickness(self, num: float): self._config(num, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesFunnelTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesFunnelTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def width(self):
        """The width of the funnel compared to the width of the plot area, or the pixel width if it is a number.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("90%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesFunnelZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesFunnelZones)

        
class OptionSeriesFunnelDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnelDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def alignTo(self):
        """Alignment method for data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @alignTo.setter
    def alignTo(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesFunnelDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesFunnelDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def connectorColor(self):
        """The color of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def connectorPadding(self):
        """The distance from the data label to the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(5)

    @connectorPadding.setter
    def connectorPadding(self, num: float): self._config(num, js_type=False)

    @property
    def connectorShape(self):
        """Specifies the method that is used to generate the connector path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("crookedLine")

    @connectorShape.setter
    def connectorShape(self, text: str): self._config(text, js_type=False)

    @property
    def connectorWidth(self):
        """The width of the line connecting the data label to the pie slice.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get(1)

    @connectorWidth.setter
    def connectorWidth(self, num: float): self._config(num, js_type=False)

    @property
    def crookDistance(self):
        """Works only if <code>connectorShape</code> is <code>&#39;crookedLine&#39;</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @crookDistance.setter
    def crookDistance(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """The distance of the data label from the pie&#39;s edge.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(30)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesFunnelDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesFunnelDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get("function () { return this.point.isNull ? void 0 : this.point.name; }")

    @formatter.setter
    def formatter(self, text: str): self._config(text, js_type=True)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def softConnector(self):
        """Whether to render the connector as a soft arc or a line with a sharp break.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(True)

    @softConnector.setter
    def softConnector(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Pie/PieSeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesFunnelDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesFunnelDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Funnel/FunnelSeriesDefaults.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnelDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesFunnelDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesFunnelDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesFunnelDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesFunnelDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesFunnelDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesFunnelDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesFunnelAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesFunnelAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesFunnelAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesFunnelAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesFunnelAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesFunnelAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesFunnelAccessibilityPoint)

        
class OptionSeriesErrorbarZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesErrorbarTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesErrorbarTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesErrorbarStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesErrorbarStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesErrorbarStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesErrorbarStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesErrorbarStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesErrorbarStatesSelectMarker)

        
class OptionSeriesErrorbarStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesErrorbarStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesErrorbarStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesErrorbarStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarStates(Options):

    @property
    def hover(self) -> 'OptionSeriesErrorbarStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesErrorbarStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesErrorbarStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesErrorbarStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesErrorbarStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesErrorbarStatesNormal)

    @property
    def select(self) -> 'OptionSeriesErrorbarStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesErrorbarStatesSelect)

        
class OptionSeriesErrorbarStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesErrorbarStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesErrorbarStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesErrorbarStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesErrorbarStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesErrorbarStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesErrorbarStatesHoverMarker)

        
class OptionSeriesErrorbarSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesErrorbarSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesErrorbarSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesErrorbarSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesErrorbarSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesErrorbarSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesErrorbarSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesErrorbarSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesErrorbarSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesErrorbarSonificationTracksMappingLowpassResonance)

        
class OptionSeriesErrorbarSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesErrorbarSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesErrorbarSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesErrorbarSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesErrorbarSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesErrorbarSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesErrorbarSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesErrorbarSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesErrorbarSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesErrorbarSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesErrorbarSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesErrorbarSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesErrorbarSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesErrorbarSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesErrorbarSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesErrorbarSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesErrorbarSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesErrorbarSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesErrorbarSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesErrorbarSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesErrorbarSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesErrorbarSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesErrorbarSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesErrorbarSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesErrorbarSonificationTracksMappingVolume)

        
class OptionSeriesErrorbarSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesErrorbarSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesErrorbarSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesErrorbarSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesErrorbarSonificationTracksMappingHighpassResonance)

        
class OptionSeriesErrorbarSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesErrorbarSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesErrorbarSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesErrorbarSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesErrorbarSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesErrorbarSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesErrorbarSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesErrorbarSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesErrorbarSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesErrorbarSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesErrorbarSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesErrorbarSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesErrorbarSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesErrorbarSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesErrorbarSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesErrorbarSonificationTracks)

        
class OptionSeriesErrorbarSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesErrorbarSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesErrorbarSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesErrorbarSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesErrorbarSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesErrorbarSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesErrorbarSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesErrorbarSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesErrorbarSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesErrorbarSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesErrorbarSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesErrorbarSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesErrorbarSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesErrorbarSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesErrorbarSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesErrorbarSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesErrorbarSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesErrorbarSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesErrorbarSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesErrorbarSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesErrorbarSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesErrorbarSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesErrorbarSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesErrorbarSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesErrorbarSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesErrorbarSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesErrorbarSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesErrorbarSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesErrorbarSonificationContexttracksMappingVolume)

        
class OptionSeriesErrorbarSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesErrorbarSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesErrorbarSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesErrorbarSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesErrorbarSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesErrorbarSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesErrorbarSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesErrorbarSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesErrorbarSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesErrorbarSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesErrorbarPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesErrorbarPoint(Options):

    @property
    def events(self) -> 'OptionSeriesErrorbarPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesErrorbarPointEvents)

        
class OptionSeriesErrorbarOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesErrorbarOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesErrorbarOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesErrorbarOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesErrorbarOnpointPosition)

        
class OptionSeriesErrorbarMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesErrorbarMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesErrorbarMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesErrorbarMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesErrorbarMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesErrorbarMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesErrorbarMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesErrorbarMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesErrorbarMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesErrorbarMarkerStatesSelect)

        
class OptionSeriesErrorbarMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesErrorbarMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesErrorbarMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesErrorbarLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesErrorbarLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesErrorbar(Options):

    @property
    def accessibility(self) -> 'OptionSeriesErrorbarAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesErrorbarAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boxDashStyle(self):
        """The dash style of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @boxDashStyle.setter
    def boxDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the bars.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("high")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesErrorbarData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesErrorbarData)

    @property
    def dataLabels(self) -> 'OptionSeriesErrorbarDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesErrorbarDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesErrorbarDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesErrorbarDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesErrorbarDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesErrorbarDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesErrorbarEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesErrorbarEvents)

    @property
    def fillColor(self):
        """The fill color of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get(False)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesErrorbarLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesErrorbarLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line surrounding the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The parent series of the error bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get(":previous")

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesErrorbarMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesErrorbarMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def medianColor(self):
        """The color of the median line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @medianColor.setter
    def medianColor(self, text: str): self._config(text, js_type=False)

    @property
    def medianDashStyle(self):
        """The dash style of the median.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @medianDashStyle.setter
    def medianDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def medianWidth(self):
        """The pixel width of the median line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(2)

    @medianWidth.setter
    def medianWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesErrorbarOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesErrorbarOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesErrorbarPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesErrorbarPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesErrorbarSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesErrorbarSonification)

    @property
    def states(self) -> 'OptionSeriesErrorbarStates':
        """. """
        return self._config_sub_data("states", OptionSeriesErrorbarStates)

    @property
    def stemColor(self):
        """The color of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @stemColor.setter
    def stemColor(self, text: str): self._config(text, js_type=False)

    @property
    def stemDashStyle(self):
        """The dash style of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @stemDashStyle.setter
    def stemDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def stemWidth(self):
        """The width of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @stemWidth.setter
    def stemWidth(self, num: float): self._config(num, js_type=False)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesErrorbarTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesErrorbarTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def whiskerColor(self):
        """The color of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @whiskerColor.setter
    def whiskerColor(self, text: str): self._config(text, js_type=False)

    @property
    def whiskerDashStyle(self):
        """The dash style of the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @whiskerDashStyle.setter
    def whiskerDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def whiskerLength(self):
        """The length of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("50%")

    @whiskerLength.setter
    def whiskerLength(self, num: float): self._config(num, js_type=False)

    @property
    def whiskerWidth(self):
        """The line width of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ErrorBar/ErrorBarSeriesDefaults.ts
        """
        return self._config_get(None)

    @whiskerWidth.setter
    def whiskerWidth(self, num: float): self._config(num, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesErrorbarZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesErrorbarZones)

        
class OptionSeriesErrorbarDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesErrorbarDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesErrorbarDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesErrorbarDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesErrorbarDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesErrorbarDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesErrorbarDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesErrorbarDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesErrorbarAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesErrorbarAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesErrorbarAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesErrorbarAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesErrorbarAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesErrorbarAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesErrorbarAccessibilityPoint)

        
class OptionSeriesDumbbellZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesDumbbellTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesDumbbellTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesDumbbellStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesDumbbellStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesDumbbellStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesDumbbellStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesDumbbellStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesDumbbellStatesSelectMarker)

        
class OptionSeriesDumbbellStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesDumbbellStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesDumbbellStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellStates(Options):

    @property
    def hover(self) -> 'OptionSeriesDumbbellStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesDumbbellStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesDumbbellStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesDumbbellStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesDumbbellStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesDumbbellStatesNormal)

    @property
    def select(self) -> 'OptionSeriesDumbbellStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesDumbbellStatesSelect)

        
class OptionSeriesDumbbellStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesDumbbellStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesDumbbellStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesDumbbellStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesDumbbellStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesDumbbellStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesDumbbellStatesHoverMarker)

        
class OptionSeriesDumbbellSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesDumbbellSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesDumbbellSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesDumbbellSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesDumbbellSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesDumbbellSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDumbbellSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDumbbellSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDumbbellSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDumbbellSonificationTracksMappingLowpassResonance)

        
class OptionSeriesDumbbellSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesDumbbellSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesDumbbellSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesDumbbellSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesDumbbellSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesDumbbellSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesDumbbellSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesDumbbellSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesDumbbellSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesDumbbellSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesDumbbellSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesDumbbellSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesDumbbellSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesDumbbellSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesDumbbellSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesDumbbellSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesDumbbellSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesDumbbellSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesDumbbellSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesDumbbellSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesDumbbellSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesDumbbellSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesDumbbellSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesDumbbellSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesDumbbellSonificationTracksMappingVolume)

        
class OptionSeriesDumbbellSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDumbbellSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDumbbellSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDumbbellSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDumbbellSonificationTracksMappingHighpassResonance)

        
class OptionSeriesDumbbellSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesDumbbellSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesDumbbellSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesDumbbellSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesDumbbellSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesDumbbellSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesDumbbellSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesDumbbellSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesDumbbellSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesDumbbellSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesDumbbellSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesDumbbellSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesDumbbellSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesDumbbellSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesDumbbellSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesDumbbellSonificationTracks)

        
class OptionSeriesDumbbellSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesDumbbellSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesDumbbellSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesDumbbellSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesDumbbellSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesDumbbellSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesDumbbellSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesDumbbellSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesDumbbellSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDumbbellSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesDumbbellSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesDumbbellSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesDumbbellSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesDumbbellSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDumbbellSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDumbbellSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesDumbbellSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesDumbbellSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesDumbbellSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesDumbbellSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesDumbbellSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesDumbbellSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesDumbbellSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesDumbbellSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesDumbbellSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesDumbbellSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesDumbbellSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesDumbbellSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesDumbbellSonificationContexttracksMappingVolume)

        
class OptionSeriesDumbbellSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesDumbbellSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesDumbbellSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesDumbbellSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesDumbbellSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesDumbbellSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesDumbbellSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDumbbellSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDumbbellSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDumbbellSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesDumbbellPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDumbbellPoint(Options):

    @property
    def events(self) -> 'OptionSeriesDumbbellPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesDumbbellPointEvents)

        
class OptionSeriesDumbbellOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesDumbbellOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesDumbbellOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesDumbbellOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesDumbbellOnpointPosition)

        
class OptionSeriesDumbbellMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesDumbbellMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesDumbbellMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesDumbbellMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesDumbbellMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesDumbbellMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesDumbbellMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesDumbbellMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesDumbbellMarkerStatesSelect)

        
class OptionSeriesDumbbellMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesDumbbellMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesDumbbellMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellLowmarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellLowmarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellLowmarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellLowmarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesDumbbellLowmarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesDumbbellLowmarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellLowmarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesDumbbellLowmarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesDumbbellLowmarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesDumbbellLowmarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesDumbbellLowmarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesDumbbellLowmarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesDumbbellLowmarkerStatesSelect)

        
class OptionSeriesDumbbellLowmarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesDumbbellLowmarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesDumbbellLowmarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesDumbbellLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesDumbbellLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbell(Options):

    @property
    def accessibility(self) -> 'OptionSeriesDumbbellAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesDumbbellAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("low")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorColor(self):
        """Color of the line that connects the dumbbell point&#39;s values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Dumbbell/DumbbellSeriesDefaults.ts
        """
        return self._config_get(None)

    @connectorColor.setter
    def connectorColor(self, text: str): self._config(text, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesDumbbellData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesDumbbellData)

    @property
    def dataLabels(self) -> 'OptionSeriesDumbbellDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionSeriesDumbbellDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesDumbbellDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesDumbbellDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesDumbbellDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesDumbbellDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesDumbbellEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesDumbbellEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesDumbbellLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesDumbbellLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def lowMarker(self) -> 'OptionSeriesDumbbellLowmarker':
        """Options for the lower markers of the dumbbell-like series. """
        return self._config_sub_data("lowMarker", OptionSeriesDumbbellLowmarker)

    @property
    def marker(self) -> 'OptionSeriesDumbbellMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesDumbbellMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesDumbbellOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesDumbbellOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesDumbbellPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesDumbbellPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesDumbbellSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesDumbbellSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesDumbbellStates':
        """. """
        return self._config_sub_data("states", OptionSeriesDumbbellStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesDumbbellTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesDumbbellTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesDumbbellZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesDumbbellZones)

        
class OptionSeriesDumbbellDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesDumbbellDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesDumbbellDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesDumbbellDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesDumbbellDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesDumbbellDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesDumbbellDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesDumbbellDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesDumbbellDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesDumbbellDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesDumbbellDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesDumbbellDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesDumbbellDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDumbbellAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDumbbellAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDumbbellAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesDumbbellAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesDumbbellAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesDumbbellAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesDumbbellAccessibilityPoint)

        
class OptionSeriesDependencywheelZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesDependencywheelTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesDependencywheelTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the pointer or stay fixed on the item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.name}: <b>{point.sum}</b><br/>")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the chart&#39;s tooltip, as opposed to links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.name} → {point.toNode.name}: <b>{point.weight}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesDependencywheelStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesDependencywheelStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesDependencywheelStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesDependencywheelStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesDependencywheelStatesSelectMarker)

        
class OptionSeriesDependencywheelStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheelStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesDependencywheelStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelStates(Options):

    @property
    def hover(self) -> 'OptionSeriesDependencywheelStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesDependencywheelStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesDependencywheelStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionSeriesDependencywheelStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesDependencywheelStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesDependencywheelStatesNormal)

    @property
    def select(self) -> 'OptionSeriesDependencywheelStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesDependencywheelStatesSelect)

        
class OptionSeriesDependencywheelStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesDependencywheelStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesDependencywheelStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesDependencywheelStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesDependencywheelStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesDependencywheelStatesHoverMarker)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesDependencywheelSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesDependencywheelSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesDependencywheelSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDependencywheelSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDependencywheelSonificationTracksMappingLowpassResonance)

        
class OptionSeriesDependencywheelSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesDependencywheelSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesDependencywheelSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesDependencywheelSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesDependencywheelSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesDependencywheelSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesDependencywheelSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesDependencywheelSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesDependencywheelSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesDependencywheelSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesDependencywheelSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesDependencywheelSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesDependencywheelSonificationTracksMappingVolume)

        
class OptionSeriesDependencywheelSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDependencywheelSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDependencywheelSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDependencywheelSonificationTracksMappingHighpassResonance)

        
class OptionSeriesDependencywheelSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesDependencywheelSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesDependencywheelSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesDependencywheelSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesDependencywheelSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesDependencywheelSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesDependencywheelSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesDependencywheelSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesDependencywheelSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesDependencywheelSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesDependencywheelSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesDependencywheelSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesDependencywheelSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesDependencywheelSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesDependencywheelSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesDependencywheelSonificationTracks)

        
class OptionSeriesDependencywheelSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesDependencywheelSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesDependencywheelSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesDependencywheelSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesDependencywheelSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesDependencywheelSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesDependencywheelSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesDependencywheelSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesDependencywheelSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDependencywheelSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesDependencywheelSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesDependencywheelSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesDependencywheelSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDependencywheelSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDependencywheelSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesDependencywheelSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesDependencywheelSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesDependencywheelSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesDependencywheelSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesDependencywheelSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesDependencywheelSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesDependencywheelSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesDependencywheelSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesDependencywheelSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesDependencywheelSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesDependencywheelSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesDependencywheelSonificationContexttracksMappingVolume)

        
class OptionSeriesDependencywheelSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesDependencywheelSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesDependencywheelSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesDependencywheelSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesDependencywheelSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesDependencywheelSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesDependencywheelSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesDependencywheelSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesDependencywheelSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesDependencywheelPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelPoint(Options):

    @property
    def events(self) -> 'OptionSeriesDependencywheelPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesDependencywheelPointEvents)

        
class OptionSeriesDependencywheelOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelNodesDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelNodesDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesDependencywheelOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesDependencywheelOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesDependencywheelOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesDependencywheelOnpointPosition)

        
class OptionSeriesDependencywheelNodes(Options):

    @property
    def color(self):
        """The color of the auto generated node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """The color index of the auto generated node, especially for use in styled mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def column(self):
        """An optional column index of where to place the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @column.setter
    def column(self, num: float): self._config(num, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesDependencywheelNodesDatalabels':
        """Individual data label for each node. """
        return self._config_sub_data("dataLabels", OptionSeriesDependencywheelNodesDatalabels)

    @property
    def id(self):
        """The id of the auto-generated node, refering to the <code>from</code> or <code>to</code> setting of the link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def level(self):
        """An optional level index of where to place the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name to display for the node in data labels and tooltips.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def offsetHorizontal(self):
        """The horizontal offset of a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @offsetHorizontal.setter
    def offsetHorizontal(self, num: float): self._config(num, js_type=False)

    @property
    def offsetVertical(self):
        """The vertical offset of a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @offsetVertical.setter
    def offsetVertical(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelNodesDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheelNodesDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesDependencywheelNodesDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelNodesDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesDependencywheelNodesDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesDependencywheelNodesDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesDependencywheelNodesDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesDependencywheelNodesDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheelMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesDependencywheelMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesDependencywheelMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesDependencywheelMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesDependencywheelMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesDependencywheelMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesDependencywheelMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesDependencywheelMarkerStatesSelect)

        
class OptionSeriesDependencywheelMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesDependencywheelMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesDependencywheelMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelLevelsStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelLevelsStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesDependencywheelLevelsStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelLevelsStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheelLevelsStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheelLevelsStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelLevelsStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelLevelsStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesDependencywheelLevelsStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelLevelsStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelLevelsStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesDependencywheelLevelsStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelLevelsStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelLevelsStates(Options):

    @property
    def hover(self) -> 'OptionSeriesDependencywheelLevelsStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesDependencywheelLevelsStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesDependencywheelLevelsStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionSeriesDependencywheelLevelsStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesDependencywheelLevelsStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesDependencywheelLevelsStatesNormal)

    @property
    def select(self) -> 'OptionSeriesDependencywheelLevelsStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesDependencywheelLevelsStatesSelect)

        
class OptionSeriesDependencywheelLevels(Options):

    @property
    def borderColor(self):
        """Can set <code>borderColor</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set <code>borderWidth</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set <code>color</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Can set <code>colorByPoint</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesDependencywheelLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lay on the same level. """
        return self._config_sub_data("dataLabels", OptionSeriesDependencywheelLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Can set <code>linkOpacity</code> on all points which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesDependencywheelLevelsStates':
        """Can set <code>states</code> on all nodes and points which lay on the same level. """
        return self._config_sub_data("states", OptionSeriesDependencywheelLevelsStates)

        
class OptionSeriesDependencywheelLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheelLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesDependencywheelLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesDependencywheelLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesDependencywheelLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesDependencywheelLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesDependencywheelLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesDependencywheelLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesDependencywheelLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheel(Options):

    @property
    def accessibility(self) -> 'OptionSeriesDependencywheelAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesDependencywheelAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def center(self):
        """The center of the wheel relative to the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get([null, null])

    @center.setter
    def center(self, value: Any): self._config(value, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def curveFactor(self):
        """Higher numbers makes the links in a sankey diagram or dependency wheelrender more curved.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(0.6)

    @curveFactor.setter
    def curveFactor(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesDependencywheelData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesDependencywheelData)

    @property
    def dataLabels(self) -> 'OptionSeriesDependencywheelDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionSeriesDependencywheelDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesDependencywheelDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesDependencywheelDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesDependencywheelEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesDependencywheelEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesDependencywheelLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesDependencywheelLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionSeriesDependencywheelLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionSeriesDependencywheelLevels)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkColorMode(self):
        """Determines color mode for sankey links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("from")

    @linkColorMode.setter
    def linkColorMode(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesDependencywheelMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesDependencywheelMarker)

    @property
    def minLinkWidth(self):
        """The minimal width for a line of a sankey.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @minLinkWidth.setter
    def minLinkWidth(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def nodePadding(self):
        """The padding between nodes in a sankey diagram or dependency wheel, in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(10)

    @nodePadding.setter
    def nodePadding(self, num: float): self._config(num, js_type=False)

    @property
    def nodes(self) -> 'OptionSeriesDependencywheelNodes':
        """A collection of options for the individual nodes. """
        return self._config_sub_data("nodes", OptionSeriesDependencywheelNodes)

    @property
    def nodeWidth(self):
        """The pixel width of each node in a sankey diagram or dependency wheel, or the height in case the chart is inverted.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(20)

    @nodeWidth.setter
    def nodeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesDependencywheelOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesDependencywheelOnpoint)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesDependencywheelPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesDependencywheelPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def size(self):
        """Size of the wheel in pixel or percent relative to the canvas space.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get("100%")

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesDependencywheelSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesDependencywheelSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def startAngle(self):
        """The start angle of the dependency wheel, in degrees where 0 is up.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(0)

    @startAngle.setter
    def startAngle(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesDependencywheelStates':
        """. """
        return self._config_sub_data("states", OptionSeriesDependencywheelStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesDependencywheelTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesDependencywheelTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesDependencywheelZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesDependencywheelZones)

        
class OptionSeriesDependencywheelDatalabelsTextpathAttributes(Options):

    @property
    def dy(self):
        """Text path shift along its y-axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(5)

    @dy.setter
    def dy(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesDependencywheelDatalabelsTextpath(Options):

    @property
    def attributes(self) -> 'OptionSeriesDependencywheelDatalabelsTextpathAttributes':
        """Presentation attributes for the text path. """
        return self._config_sub_data("attributes", OptionSeriesDependencywheelDatalabelsTextpathAttributes)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheelDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesDependencywheelDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesDependencywheelDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def distance(self):
        """Distance between the data label and the center of the node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(0)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesDependencywheelDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesDependencywheelDatalabelsFilter)

    @property
    def format(self):
        """A format string for data labels of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback to format data labels of the links between nodes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The format string specifying what to show for nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels of nodes in the dependency wheel.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/DependencyWheel/DependencyWheelSeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesDependencywheelDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesDependencywheelDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesDependencywheelAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesDependencywheelAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesDependencywheelAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesDependencywheelAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesDependencywheelAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesDependencywheelAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesDependencywheelAccessibilityPoint)

        
class OptionSeriesCylinderZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesCylinderTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesCylinderTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesCylinderStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesCylinderStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesCylinderStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesCylinderStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesCylinderStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesCylinderStatesSelectMarker)

        
class OptionSeriesCylinderStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinderStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesCylinderStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesCylinderStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderStates(Options):

    @property
    def hover(self) -> 'OptionSeriesCylinderStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesCylinderStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesCylinderStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesCylinderStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesCylinderStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesCylinderStatesNormal)

    @property
    def select(self) -> 'OptionSeriesCylinderStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesCylinderStatesSelect)

        
class OptionSeriesCylinderStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesCylinderStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesCylinderStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesCylinderStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesCylinderStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesCylinderStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesCylinderStatesHoverMarker)

        
class OptionSeriesCylinderSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesCylinderSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesCylinderSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesCylinderSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesCylinderSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesCylinderSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesCylinderSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesCylinderSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesCylinderSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesCylinderSonificationTracksMappingLowpassResonance)

        
class OptionSeriesCylinderSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesCylinderSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesCylinderSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesCylinderSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesCylinderSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesCylinderSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesCylinderSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesCylinderSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesCylinderSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesCylinderSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesCylinderSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesCylinderSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesCylinderSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesCylinderSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesCylinderSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesCylinderSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesCylinderSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesCylinderSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesCylinderSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesCylinderSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesCylinderSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesCylinderSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesCylinderSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesCylinderSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesCylinderSonificationTracksMappingVolume)

        
class OptionSeriesCylinderSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesCylinderSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesCylinderSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesCylinderSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesCylinderSonificationTracksMappingHighpassResonance)

        
class OptionSeriesCylinderSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesCylinderSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesCylinderSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesCylinderSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesCylinderSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesCylinderSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesCylinderSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesCylinderSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesCylinderSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesCylinderSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesCylinderSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesCylinderSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesCylinderSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesCylinderSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesCylinderSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesCylinderSonificationTracks)

        
class OptionSeriesCylinderSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesCylinderSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesCylinderSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesCylinderSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesCylinderSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesCylinderSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesCylinderSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesCylinderSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesCylinderSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesCylinderSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesCylinderSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesCylinderSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesCylinderSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesCylinderSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesCylinderSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesCylinderSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesCylinderSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesCylinderSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesCylinderSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesCylinderSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesCylinderSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesCylinderSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesCylinderSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesCylinderSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesCylinderSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesCylinderSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesCylinderSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesCylinderSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesCylinderSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesCylinderSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesCylinderSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesCylinderSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesCylinderSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesCylinderSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesCylinderSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesCylinderSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesCylinderSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesCylinderSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesCylinderSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesCylinderSonificationContexttracksMappingVolume)

        
class OptionSeriesCylinderSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesCylinderSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesCylinderSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesCylinderSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesCylinderSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesCylinderSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesCylinderSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesCylinderSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesCylinderSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesCylinderSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesCylinderPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesCylinderPoint(Options):

    @property
    def events(self) -> 'OptionSeriesCylinderPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesCylinderPointEvents)

        
class OptionSeriesCylinderOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesCylinderOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesCylinderOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesCylinderOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesCylinderOnpointPosition)

        
class OptionSeriesCylinderMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinderMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesCylinderMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesCylinderMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesCylinderMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesCylinderMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesCylinderMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesCylinderMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesCylinderMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesCylinderMarkerStatesSelect)

        
class OptionSeriesCylinderMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesCylinderMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesCylinderMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesCylinderLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesCylinderLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinder(Options):

    @property
    def accessibility(self) -> 'OptionSeriesCylinderAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesCylinderAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesCylinderData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesCylinderData)

    @property
    def dataLabels(self) -> 'OptionSeriesCylinderDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesCylinderDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesCylinderDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesCylinderDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesCylinderDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesCylinderDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesCylinderEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesCylinderEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesCylinderLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesCylinderLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesCylinderMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesCylinderMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesCylinderOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesCylinderOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesCylinderPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesCylinderPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesCylinderSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesCylinderSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesCylinderStates':
        """. """
        return self._config_sub_data("states", OptionSeriesCylinderStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesCylinderTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesCylinderTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesCylinderZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesCylinderZones)

        
class OptionSeriesCylinderDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinderDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesCylinderDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesCylinderDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesCylinderDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesCylinderDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesCylinderDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesCylinderDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinderDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesCylinderDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesCylinderDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesCylinderDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesCylinderDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesCylinderDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesCylinderDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesCylinderAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesCylinderAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesCylinderAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesCylinderAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesCylinderAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesCylinderAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesCylinderAccessibilityPoint)

        
class OptionSeriesColumnrangeZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesColumnrangeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesColumnrangeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnrangeStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesColumnrangeStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrangeStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrangeStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnrangeStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesColumnrangeStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrangeStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnrangeStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesColumnrangeStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeStates(Options):

    @property
    def hover(self) -> 'OptionSeriesColumnrangeStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesColumnrangeStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesColumnrangeStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesColumnrangeStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesColumnrangeStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesColumnrangeStatesNormal)

    @property
    def select(self) -> 'OptionSeriesColumnrangeStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesColumnrangeStatesSelect)

        
class OptionSeriesColumnrangeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesColumnrangeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesColumnrangeSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesColumnrangeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnrangeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnrangeSonificationTracksMappingLowpassResonance)

        
class OptionSeriesColumnrangeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesColumnrangeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesColumnrangeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesColumnrangeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesColumnrangeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesColumnrangeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesColumnrangeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesColumnrangeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnrangeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesColumnrangeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnrangeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesColumnrangeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesColumnrangeSonificationTracksMappingVolume)

        
class OptionSeriesColumnrangeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnrangeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnrangeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnrangeSonificationTracksMappingHighpassResonance)

        
class OptionSeriesColumnrangeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnrangeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnrangeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnrangeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnrangeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnrangeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnrangeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesColumnrangeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesColumnrangeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesColumnrangeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesColumnrangeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesColumnrangeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnrangeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnrangeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesColumnrangeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesColumnrangeSonificationTracks)

        
class OptionSeriesColumnrangeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesColumnrangeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesColumnrangeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnrangeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnrangeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnrangeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnrangeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnrangeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnrangeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnrangeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesColumnrangeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesColumnrangeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesColumnrangeSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnrangeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnrangeSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesColumnrangeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesColumnrangeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesColumnrangeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesColumnrangeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesColumnrangeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesColumnrangeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesColumnrangeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnrangeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesColumnrangeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnrangeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesColumnrangeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesColumnrangeSonificationContexttracksMappingVolume)

        
class OptionSeriesColumnrangeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnrangeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnrangeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnrangeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnrangeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnrangeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnrangeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnrangeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnrangeSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesColumnrangePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnrangePoint(Options):

    @property
    def events(self) -> 'OptionSeriesColumnrangePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesColumnrangePointEvents)

        
class OptionSeriesColumnrangeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesColumnrangeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesColumnrangeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesColumnrangeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesColumnrangeOnpointPosition)

        
class OptionSeriesColumnrangeMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrangeMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnrangeMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesColumnrangeMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesColumnrangeMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesColumnrangeMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesColumnrangeMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesColumnrangeMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesColumnrangeMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesColumnrangeMarkerStatesSelect)

        
class OptionSeriesColumnrangeMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesColumnrangeMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesColumnrangeMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesColumnrangeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesColumnrangeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrange(Options):

    @property
    def accessibility(self) -> 'OptionSeriesColumnrangeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesColumnrangeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self) -> 'OptionSeriesColumnrangeBorderradius':
        """The corner radius of the border surrounding each column or bar. """
        return self._config_sub_data("borderRadius", OptionSeriesColumnrangeBorderradius)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesColumnrangeData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesColumnrangeData)

    @property
    def dataLabels(self) -> 'OptionSeriesColumnrangeDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionSeriesColumnrangeDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesColumnrangeDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesColumnrangeDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesColumnrangeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesColumnrangeDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesColumnrangeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesColumnrangeEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesColumnrangeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesColumnrangeLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesColumnrangeMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesColumnrangeMarker)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesColumnrangeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesColumnrangeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesColumnrangePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesColumnrangePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ColumnRange/ColumnRangeSeries.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, value: Any): self._config(value, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesColumnrangeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesColumnrangeSonification)

    @property
    def states(self) -> 'OptionSeriesColumnrangeStates':
        """. """
        return self._config_sub_data("states", OptionSeriesColumnrangeStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesColumnrangeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesColumnrangeTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesColumnrangeZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesColumnrangeZones)

        
class OptionSeriesColumnrangeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrangeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesColumnrangeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesColumnrangeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesColumnrangeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesColumnrangeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesColumnrangeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesColumnrangeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrangeDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesColumnrangeDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesColumnrangeDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesColumnrangeDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesColumnrangeDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesColumnrangeDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesColumnrangeDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnrangeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnrangeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnrangeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesColumnrangeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesColumnrangeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesColumnrangeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesColumnrangeAccessibilityPoint)

        
class OptionSeriesColumnpyramidZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesColumnpyramidTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesColumnpyramidTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnpyramidStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesColumnpyramidStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnpyramidStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesColumnpyramidStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnpyramidStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesColumnpyramidStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidStates(Options):

    @property
    def hover(self) -> 'OptionSeriesColumnpyramidStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesColumnpyramidStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesColumnpyramidStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesColumnpyramidStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesColumnpyramidStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesColumnpyramidStatesNormal)

    @property
    def select(self) -> 'OptionSeriesColumnpyramidStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesColumnpyramidStatesSelect)

        
class OptionSeriesColumnpyramidSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesColumnpyramidSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesColumnpyramidSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesColumnpyramidSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnpyramidSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnpyramidSonificationTracksMappingLowpassResonance)

        
class OptionSeriesColumnpyramidSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesColumnpyramidSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesColumnpyramidSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesColumnpyramidSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesColumnpyramidSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesColumnpyramidSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesColumnpyramidSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesColumnpyramidSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnpyramidSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesColumnpyramidSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnpyramidSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesColumnpyramidSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesColumnpyramidSonificationTracksMappingVolume)

        
class OptionSeriesColumnpyramidSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnpyramidSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnpyramidSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnpyramidSonificationTracksMappingHighpassResonance)

        
class OptionSeriesColumnpyramidSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnpyramidSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnpyramidSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnpyramidSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnpyramidSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnpyramidSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnpyramidSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesColumnpyramidSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesColumnpyramidSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesColumnpyramidSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesColumnpyramidSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnpyramidSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnpyramidSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesColumnpyramidSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesColumnpyramidSonificationTracks)

        
class OptionSeriesColumnpyramidSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesColumnpyramidSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnpyramidSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnpyramidSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnpyramidSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnpyramidSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnpyramidSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnpyramidSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesColumnpyramidSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesColumnpyramidSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesColumnpyramidSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnpyramidSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnpyramidSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesColumnpyramidSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesColumnpyramidSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesColumnpyramidSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesColumnpyramidSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesColumnpyramidSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesColumnpyramidSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesColumnpyramidSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnpyramidSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesColumnpyramidSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnpyramidSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesColumnpyramidSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesColumnpyramidSonificationContexttracksMappingVolume)

        
class OptionSeriesColumnpyramidSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnpyramidSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnpyramidSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnpyramidSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnpyramidSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnpyramidSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnpyramidSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesColumnpyramidPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnpyramidPoint(Options):

    @property
    def events(self) -> 'OptionSeriesColumnpyramidPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesColumnpyramidPointEvents)

        
class OptionSeriesColumnpyramidOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesColumnpyramidOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesColumnpyramidOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesColumnpyramidOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesColumnpyramidOnpointPosition)

        
class OptionSeriesColumnpyramidLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesColumnpyramidLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesColumnpyramidLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramid(Options):

    @property
    def accessibility(self) -> 'OptionSeriesColumnpyramidAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesColumnpyramidAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def data(self) -> 'OptionSeriesColumnpyramidData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesColumnpyramidData)

    @property
    def dataLabels(self) -> 'OptionSeriesColumnpyramidDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesColumnpyramidDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesColumnpyramidDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesColumnpyramidDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesColumnpyramidDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesColumnpyramidDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesColumnpyramidEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesColumnpyramidEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesColumnpyramidLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesColumnpyramidLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesColumnpyramidOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesColumnpyramidOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesColumnpyramidPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesColumnpyramidPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesColumnpyramidSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesColumnpyramidSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesColumnpyramidStates':
        """. """
        return self._config_sub_data("states", OptionSeriesColumnpyramidStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesColumnpyramidTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesColumnpyramidTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesColumnpyramidZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesColumnpyramidZones)

        
class OptionSeriesColumnpyramidDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesColumnpyramidDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesColumnpyramidDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesColumnpyramidDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesColumnpyramidDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesColumnpyramidDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesColumnpyramidDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesColumnpyramidDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesColumnpyramidDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesColumnpyramidDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesColumnpyramidDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesColumnpyramidDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesColumnpyramidDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnpyramidAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnpyramidAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnpyramidAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesColumnpyramidAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesColumnpyramidAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesColumnpyramidAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesColumnpyramidAccessibilityPoint)

        
class OptionSeriesColumnZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesColumnTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesColumnTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesColumnStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesColumnStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesColumnStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesColumnStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnStates(Options):

    @property
    def hover(self) -> 'OptionSeriesColumnStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesColumnStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesColumnStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesColumnStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesColumnStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesColumnStatesNormal)

    @property
    def select(self) -> 'OptionSeriesColumnStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesColumnStatesSelect)

        
class OptionSeriesColumnSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesColumnSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesColumnSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesColumnSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesColumnSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesColumnSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnSonificationTracksMappingLowpassResonance)

        
class OptionSeriesColumnSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesColumnSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesColumnSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesColumnSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesColumnSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesColumnSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesColumnSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesColumnSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesColumnSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesColumnSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesColumnSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesColumnSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesColumnSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesColumnSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesColumnSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesColumnSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesColumnSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesColumnSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesColumnSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesColumnSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesColumnSonificationTracksMappingVolume)

        
class OptionSeriesColumnSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnSonificationTracksMappingHighpassResonance)

        
class OptionSeriesColumnSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesColumnSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesColumnSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesColumnSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesColumnSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesColumnSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesColumnSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesColumnSonificationTracks)

        
class OptionSeriesColumnSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesColumnSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesColumnSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesColumnSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesColumnSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesColumnSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesColumnSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesColumnSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesColumnSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesColumnSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesColumnSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesColumnSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesColumnSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesColumnSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesColumnSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesColumnSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesColumnSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesColumnSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesColumnSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesColumnSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesColumnSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesColumnSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesColumnSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesColumnSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesColumnSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesColumnSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesColumnSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesColumnSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesColumnSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesColumnSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesColumnSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesColumnSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesColumnSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesColumnSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesColumnSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesColumnSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesColumnSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesColumnSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesColumnSonificationContexttracksMappingVolume)

        
class OptionSeriesColumnSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesColumnSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesColumnSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesColumnSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesColumnSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesColumnSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesColumnSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesColumnSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesColumnSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesColumnSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesColumnSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesColumnPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesColumnPoint(Options):

    @property
    def events(self) -> 'OptionSeriesColumnPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesColumnPointEvents)

        
class OptionSeriesColumnOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesColumnOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesColumnOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesColumnOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesColumnOnpointPosition)

        
class OptionSeriesColumnLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesColumnLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesColumnLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumn(Options):

    @property
    def accessibility(self) -> 'OptionSeriesColumnAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesColumnAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesColumnData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesColumnData)

    @property
    def dataLabels(self) -> 'OptionSeriesColumnDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesColumnDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesColumnDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesColumnDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesColumnDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesColumnDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesColumnEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesColumnEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesColumnLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesColumnLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesColumnOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesColumnOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesColumnPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesColumnPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesColumnSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesColumnSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesColumnStates':
        """. """
        return self._config_sub_data("states", OptionSeriesColumnStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesColumnTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesColumnTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesColumnZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesColumnZones)

        
class OptionSeriesColumnDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesColumnDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesColumnDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesColumnDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesColumnDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesColumnDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesColumnDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesColumnDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesColumnDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesColumnDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesColumnDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesColumnDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesColumnDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesColumnAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesColumnAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesColumnAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesColumnAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesColumnAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesColumnAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesColumnAccessibilityPoint)

        
class OptionSeriesBulletZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesBulletTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesBulletTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.y}</b>. Target: <b>{point.target}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletTargetoptions(Options):

    @property
    def borderColor(self):
        """The border color of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """The color of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """The height of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(3)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """The width of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get("140%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesBulletStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesBulletStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesBulletStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesBulletStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesBulletStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesBulletStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletStates(Options):

    @property
    def hover(self) -> 'OptionSeriesBulletStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesBulletStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesBulletStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesBulletStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesBulletStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesBulletStatesNormal)

    @property
    def select(self) -> 'OptionSeriesBulletStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesBulletStatesSelect)

        
class OptionSeriesBulletSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBulletSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBulletSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBulletSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBulletSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesBulletSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBulletSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBulletSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBulletSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBulletSonificationTracksMappingLowpassResonance)

        
class OptionSeriesBulletSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBulletSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBulletSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBulletSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBulletSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBulletSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBulletSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBulletSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBulletSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBulletSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBulletSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBulletSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBulletSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBulletSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBulletSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBulletSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBulletSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBulletSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBulletSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBulletSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBulletSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBulletSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBulletSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBulletSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBulletSonificationTracksMappingVolume)

        
class OptionSeriesBulletSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBulletSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBulletSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBulletSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBulletSonificationTracksMappingHighpassResonance)

        
class OptionSeriesBulletSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBulletSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBulletSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBulletSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBulletSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBulletSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBulletSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesBulletSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesBulletSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesBulletSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesBulletSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesBulletSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBulletSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesBulletSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesBulletSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesBulletSonificationTracks)

        
class OptionSeriesBulletSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesBulletSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesBulletSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBulletSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBulletSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBulletSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesBulletSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBulletSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBulletSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesBulletSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesBulletSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesBulletSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBulletSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBulletSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBulletSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBulletSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesBulletSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBulletSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBulletSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBulletSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBulletSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBulletSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesBulletSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBulletSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBulletSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBulletSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBulletSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesBulletSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBulletSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBulletSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBulletSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBulletSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesBulletSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBulletSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBulletSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBulletSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBulletSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBulletSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBulletSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBulletSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBulletSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBulletSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBulletSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBulletSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBulletSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBulletSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBulletSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBulletSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBulletSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBulletSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBulletSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBulletSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBulletSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBulletSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBulletSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBulletSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBulletSonificationContexttracksMappingVolume)

        
class OptionSeriesBulletSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBulletSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBulletSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBulletSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBulletSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBulletSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBulletSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBulletSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBulletSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBulletSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBulletSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesBulletPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBulletPoint(Options):

    @property
    def events(self) -> 'OptionSeriesBulletPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesBulletPointEvents)

        
class OptionSeriesBulletOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesBulletOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesBulletOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesBulletOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesBulletOnpointPosition)

        
class OptionSeriesBulletLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesBulletLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesBulletLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBullet(Options):

    @property
    def accessibility(self) -> 'OptionSeriesBulletAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesBulletAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesBulletData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesBulletData)

    @property
    def dataLabels(self) -> 'OptionSeriesBulletDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesBulletDatalabels)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesBulletDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesBulletDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesBulletEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesBulletEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesBulletLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesBulletLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesBulletOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesBulletOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesBulletPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesBulletPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesBulletSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesBulletSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesBulletStates':
        """. """
        return self._config_sub_data("states", OptionSeriesBulletStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def targetOptions(self) -> 'OptionSeriesBulletTargetoptions':
        """All options related with look and positiong of targets. """
        return self._config_sub_data("targetOptions", OptionSeriesBulletTargetoptions)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesBulletTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesBulletTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesBulletZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesBulletZones)

        
class OptionSeriesBulletDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesBulletDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesBulletDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesBulletDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesBulletDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesBulletDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesBulletDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletDataTargetoptions(Options):

    @property
    def borderColor(self):
        """The border color of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """The color of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """The height of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(3)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """The width of the rectangle representing the target.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get("140%")

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesBulletDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesBulletDataAccessibility)

    @property
    def borderColor(self):
        """The color of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesBulletDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesBulletDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesBulletDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesBulletDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesBulletDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesBulletDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for the column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def target(self):
        """The target value of a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bullet/BulletSeriesDefaults.ts
        """
        return self._config_get(None)

    @target.setter
    def target(self, num: float): self._config(num, js_type=False)

    @property
    def targetOptions(self) -> 'OptionSeriesBulletDataTargetoptions':
        """Individual target options for each point. """
        return self._config_sub_data("targetOptions", OptionSeriesBulletDataTargetoptions)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesBulletDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesBulletDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesBulletDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesBulletDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesBulletDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesBulletDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBulletAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBulletAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBulletAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesBulletAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesBulletAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesBulletAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesBulletAccessibilityPoint)

        
class OptionSeriesBubbleZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesBubbleTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesBubbleTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <span style="font-size: 0.8em"> {series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("({point.x}, {point.y}), Size: {point.z}")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesBubbleStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesBubbleStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesBubbleStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesBubbleStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesBubbleStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesBubbleStatesSelectMarker)

        
class OptionSeriesBubbleStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubbleStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(5)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesBubbleStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesBubbleStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleStates(Options):

    @property
    def hover(self) -> 'OptionSeriesBubbleStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesBubbleStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesBubbleStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesBubbleStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesBubbleStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesBubbleStatesNormal)

    @property
    def select(self) -> 'OptionSeriesBubbleStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesBubbleStatesSelect)

        
class OptionSeriesBubbleStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesBubbleStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesBubbleStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesBubbleStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesBubbleStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesBubbleStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesBubbleStatesHoverMarker)

        
class OptionSeriesBubbleSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBubbleSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBubbleSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBubbleSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBubbleSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesBubbleSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBubbleSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBubbleSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBubbleSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBubbleSonificationTracksMappingLowpassResonance)

        
class OptionSeriesBubbleSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBubbleSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBubbleSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBubbleSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBubbleSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBubbleSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBubbleSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBubbleSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBubbleSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBubbleSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBubbleSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBubbleSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBubbleSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBubbleSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBubbleSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBubbleSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBubbleSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBubbleSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBubbleSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBubbleSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBubbleSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBubbleSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBubbleSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBubbleSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBubbleSonificationTracksMappingVolume)

        
class OptionSeriesBubbleSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBubbleSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBubbleSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBubbleSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBubbleSonificationTracksMappingHighpassResonance)

        
class OptionSeriesBubbleSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBubbleSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBubbleSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBubbleSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBubbleSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBubbleSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBubbleSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesBubbleSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesBubbleSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesBubbleSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesBubbleSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesBubbleSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBubbleSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesBubbleSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesBubbleSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesBubbleSonificationTracks)

        
class OptionSeriesBubbleSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesBubbleSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesBubbleSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBubbleSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBubbleSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBubbleSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesBubbleSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBubbleSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBubbleSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesBubbleSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesBubbleSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesBubbleSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBubbleSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBubbleSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBubbleSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBubbleSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesBubbleSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBubbleSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBubbleSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBubbleSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBubbleSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesBubbleSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBubbleSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBubbleSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesBubbleSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBubbleSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBubbleSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesBubbleSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBubbleSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBubbleSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBubbleSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBubbleSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBubbleSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBubbleSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBubbleSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBubbleSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBubbleSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBubbleSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBubbleSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBubbleSonificationContexttracksMappingVolume)

        
class OptionSeriesBubbleSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBubbleSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBubbleSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBubbleSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBubbleSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBubbleSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBubbleSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubbleSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBubbleSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBubbleSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBubbleSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesBubblePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBubblePoint(Options):

    @property
    def events(self) -> 'OptionSeriesBubblePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesBubblePointEvents)

        
class OptionSeriesBubbleOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesBubbleOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesBubbleOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesBubbleOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesBubbleOnpointPosition)

        
class OptionSeriesBubbleMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubbleMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesBubbleMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesBubbleMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesBubbleMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesBubbleMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesBubbleMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesBubbleMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesBubbleMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesBubbleMarkerStatesSelect)

        
class OptionSeriesBubbleMarker(Options):

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """The fill opacity of the bubble markers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0.5)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesBubbleMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesBubbleMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesBubbleLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesBubbleLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubble(Options):

    @property
    def accessibility(self) -> 'OptionSeriesBubbleAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesBubbleAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """If there are more points in the series than the <code>animationLimit</code>, the animation won&#39;t run.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(250)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("z")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesBubbleData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesBubbleData)

    @property
    def dataLabels(self) -> 'OptionSeriesBubbleDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesBubbleDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesBubbleDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesBubbleDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def displayNegative(self):
        """Whether to display negative sized bubbles.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(True)

    @displayNegative.setter
    def displayNegative(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesBubbleDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesBubbleDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesBubbleEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesBubbleEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get("xy")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def jitter(self) -> 'OptionSeriesBubbleJitter':
        """Apply a jitter effect for the rendered markers. """
        return self._config_sub_data("jitter", OptionSeriesBubbleJitter)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesBubbleLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesBubbleLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line connecting the data points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesBubbleMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesBubbleMarker)

    @property
    def maxSize(self):
        """Maximum bubble size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("20%")

    @maxSize.setter
    def maxSize(self, num: float): self._config(num, js_type=False)

    @property
    def minSize(self):
        """Minimum bubble size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(8)

    @minSize.setter
    def minSize(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """When a point&#39;s Z value is below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesBubbleOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesBubbleOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesBubblePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesBubblePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sizeBy(self):
        """Whether the bubble&#39;s value should be represented by the area or the width of the bubble.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("area")

    @sizeBy.setter
    def sizeBy(self, text: str): self._config(text, js_type=False)

    @property
    def sizeByAbsoluteValue(self):
        """When this is true, the absolute value of z determines the size of the bubble.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(False)

    @sizeByAbsoluteValue.setter
    def sizeByAbsoluteValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(False)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesBubbleSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesBubbleSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesBubbleStates':
        """. """
        return self._config_sub_data("states", OptionSeriesBubbleStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Scatter/ScatterSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesBubbleTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesBubbleTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zMax(self):
        """The minimum for the Z value range.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @zMax.setter
    def zMax(self, num: float): self._config(num, js_type=False)

    @property
    def zMin(self):
        """The minimum for the Z value range.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @zMin.setter
    def zMin(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("z")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesBubbleZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesBubbleZones)

    @property
    def zThreshold(self):
        """When <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(0)

    @zThreshold.setter
    def zThreshold(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubbleDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesBubbleDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesBubbleDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesBubbleDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesBubbleDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesBubbleDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesBubbleDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get("middle")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubbleDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesBubbleDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesBubbleDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesBubbleDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesBubbleDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesBubbleDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesBubbleDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesBubbleDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesBubbleDataMarkerStatesSelect)

        
class OptionSeriesBubbleDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesBubbleDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesBubbleDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesBubbleDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesBubbleDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesBubbleDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesBubbleDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesBubbleDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesBubbleDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesBubbleDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesBubbleDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesBubbleDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesBubbleDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def z(self):
        """The size value for each bubble.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bubble/BubbleSeries.ts
        """
        return self._config_get(None)

    @z.setter
    def z(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubbleDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesBubbleDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesBubbleDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesBubbleDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesBubbleDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesBubbleDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesBubbleDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBubbleAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBubbleAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBubbleAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesBubbleAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesBubbleAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesBubbleAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesBubbleAccessibilityPoint)

        
class OptionSeriesBoxplotZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesBoxplotTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesBoxplotTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get('<span style="color:{point.color}">●</span> <b>{series.name}</b><br/>Maximum: {point.high}<br/>Upper quartile: {point.q3}<br/>Median: {point.median}<br/>Lower quartile: {point.q1}<br/>Minimum: {point.low}<br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBoxplotSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBoxplotSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBoxplotSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBoxplotSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesBoxplotSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBoxplotSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBoxplotSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBoxplotSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBoxplotSonificationTracksMappingLowpassResonance)

        
class OptionSeriesBoxplotSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBoxplotSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBoxplotSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBoxplotSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBoxplotSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBoxplotSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBoxplotSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBoxplotSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBoxplotSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBoxplotSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBoxplotSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBoxplotSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBoxplotSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBoxplotSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBoxplotSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBoxplotSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBoxplotSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBoxplotSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBoxplotSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBoxplotSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBoxplotSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBoxplotSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBoxplotSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBoxplotSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBoxplotSonificationTracksMappingVolume)

        
class OptionSeriesBoxplotSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBoxplotSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBoxplotSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBoxplotSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBoxplotSonificationTracksMappingHighpassResonance)

        
class OptionSeriesBoxplotSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBoxplotSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBoxplotSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBoxplotSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBoxplotSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBoxplotSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBoxplotSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesBoxplotSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesBoxplotSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesBoxplotSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesBoxplotSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesBoxplotSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBoxplotSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesBoxplotSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesBoxplotSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesBoxplotSonificationTracks)

        
class OptionSeriesBoxplotSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesBoxplotSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesBoxplotSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBoxplotSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBoxplotSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBoxplotSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBoxplotSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesBoxplotSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBoxplotSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBoxplotSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesBoxplotSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBoxplotSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBoxplotSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesBoxplotSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBoxplotSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBoxplotSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesBoxplotSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBoxplotSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBoxplotSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBoxplotSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBoxplotSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBoxplotSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBoxplotSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBoxplotSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBoxplotSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBoxplotSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBoxplotSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBoxplotSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBoxplotSonificationContexttracksMappingVolume)

        
class OptionSeriesBoxplotSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBoxplotSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBoxplotSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBoxplotSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBoxplotSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBoxplotSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBoxplotSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBoxplotSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBoxplotSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBoxplotSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesBoxplotPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBoxplotPoint(Options):

    @property
    def events(self) -> 'OptionSeriesBoxplotPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesBoxplotPointEvents)

        
class OptionSeriesBoxplotOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesBoxplotOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesBoxplotOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesBoxplotOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesBoxplotOnpointPosition)

        
class OptionSeriesBoxplotLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesBoxplotLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesBoxplotLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBoxplot(Options):

    @property
    def accessibility(self) -> 'OptionSeriesBoxplotAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesBoxplotAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boxDashStyle(self):
        """The dash style of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @boxDashStyle.setter
    def boxDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("high")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesBoxplotData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesBoxplotData)

    @property
    def dataLabels(self) -> 'OptionSeriesBoxplotDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesBoxplotDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesBoxplotDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesBoxplotDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesBoxplotDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesBoxplotDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesBoxplotEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesBoxplotEvents)

    @property
    def fillColor(self):
        """The fill color of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesBoxplotLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesBoxplotLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """The width of the line surrounding the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def medianColor(self):
        """The color of the median line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @medianColor.setter
    def medianColor(self, text: str): self._config(text, js_type=False)

    @property
    def medianDashStyle(self):
        """The dash style of the median.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @medianDashStyle.setter
    def medianDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def medianWidth(self):
        """The pixel width of the median line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(2)

    @medianWidth.setter
    def medianWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesBoxplotOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesBoxplotOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesBoxplotPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesBoxplotPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesBoxplotSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesBoxplotSonification)

    @property
    def stemColor(self):
        """The color of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @stemColor.setter
    def stemColor(self, text: str): self._config(text, js_type=False)

    @property
    def stemDashStyle(self):
        """The dash style of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @stemDashStyle.setter
    def stemDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def stemWidth(self):
        """The width of the stem, the vertical line extending from the box to the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @stemWidth.setter
    def stemWidth(self, num: float): self._config(num, js_type=False)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesBoxplotTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesBoxplotTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def whiskerColor(self):
        """The color of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(None)

    @whiskerColor.setter
    def whiskerColor(self, text: str): self._config(text, js_type=False)

    @property
    def whiskerDashStyle(self):
        """The dash style of the whiskers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("Solid")

    @whiskerDashStyle.setter
    def whiskerDashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def whiskerLength(self):
        """The length of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get("50%")

    @whiskerLength.setter
    def whiskerLength(self, num: float): self._config(num, js_type=False)

    @property
    def whiskerWidth(self):
        """The line width of the whiskers, the horizontal lines marking low and high values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/BoxPlot/BoxPlotSeriesDefaults.ts
        """
        return self._config_get(2)

    @whiskerWidth.setter
    def whiskerWidth(self, num: float): self._config(num, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesBoxplotZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesBoxplotZones)

        
class OptionSeriesBoxplotDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBoxplotDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesBoxplotDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesBoxplotDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesBoxplotDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesBoxplotDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesBoxplotDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesBoxplotDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBoxplotDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesBoxplotDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesBoxplotDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesBoxplotDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesBoxplotDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesBoxplotDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesBoxplotDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBoxplotAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBoxplotAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBoxplotAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesBoxplotAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesBoxplotAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesBoxplotAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesBoxplotAccessibilityPoint)

        
class OptionSeriesBellcurveZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesBellcurveTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesBellcurveTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesBellcurveStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesBellcurveStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesBellcurveStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesBellcurveStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesBellcurveStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesBellcurveStatesSelectMarker)

        
class OptionSeriesBellcurveStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBellcurveStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesBellcurveStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesBellcurveStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveStates(Options):

    @property
    def hover(self) -> 'OptionSeriesBellcurveStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesBellcurveStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesBellcurveStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesBellcurveStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesBellcurveStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesBellcurveStatesNormal)

    @property
    def select(self) -> 'OptionSeriesBellcurveStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesBellcurveStatesSelect)

        
class OptionSeriesBellcurveStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesBellcurveStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesBellcurveStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesBellcurveStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesBellcurveStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesBellcurveStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesBellcurveStatesHoverMarker)

        
class OptionSeriesBellcurveSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBellcurveSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBellcurveSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBellcurveSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBellcurveSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesBellcurveSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBellcurveSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBellcurveSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBellcurveSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBellcurveSonificationTracksMappingLowpassResonance)

        
class OptionSeriesBellcurveSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBellcurveSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBellcurveSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBellcurveSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBellcurveSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBellcurveSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBellcurveSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBellcurveSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBellcurveSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBellcurveSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBellcurveSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBellcurveSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBellcurveSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBellcurveSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBellcurveSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBellcurveSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBellcurveSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBellcurveSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBellcurveSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBellcurveSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBellcurveSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBellcurveSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBellcurveSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBellcurveSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBellcurveSonificationTracksMappingVolume)

        
class OptionSeriesBellcurveSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBellcurveSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBellcurveSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBellcurveSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBellcurveSonificationTracksMappingHighpassResonance)

        
class OptionSeriesBellcurveSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBellcurveSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBellcurveSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBellcurveSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBellcurveSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBellcurveSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBellcurveSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesBellcurveSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesBellcurveSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesBellcurveSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesBellcurveSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesBellcurveSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBellcurveSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesBellcurveSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesBellcurveSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesBellcurveSonificationTracks)

        
class OptionSeriesBellcurveSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesBellcurveSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesBellcurveSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBellcurveSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBellcurveSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBellcurveSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBellcurveSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesBellcurveSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBellcurveSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBellcurveSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesBellcurveSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBellcurveSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBellcurveSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesBellcurveSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBellcurveSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBellcurveSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesBellcurveSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBellcurveSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBellcurveSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBellcurveSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBellcurveSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBellcurveSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBellcurveSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBellcurveSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBellcurveSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBellcurveSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBellcurveSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBellcurveSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBellcurveSonificationContexttracksMappingVolume)

        
class OptionSeriesBellcurveSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBellcurveSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBellcurveSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBellcurveSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBellcurveSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBellcurveSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBellcurveSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurveSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBellcurveSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBellcurveSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBellcurveSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesBellcurvePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBellcurvePoint(Options):

    @property
    def events(self) -> 'OptionSeriesBellcurvePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesBellcurvePointEvents)

        
class OptionSeriesBellcurveOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesBellcurveOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesBellcurveOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesBellcurveOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesBellcurveOnpointPosition)

        
class OptionSeriesBellcurveMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBellcurveMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesBellcurveMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesBellcurveMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesBellcurveMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesBellcurveMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesBellcurveMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesBellcurveMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesBellcurveMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesBellcurveMarkerStatesSelect)

        
class OptionSeriesBellcurveMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesBellcurveMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesBellcurveMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesBellcurveLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesBellcurveLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBellcurve(Options):

    @property
    def accessibility(self) -> 'OptionSeriesBellcurveAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesBellcurveAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def baseSeries(self):
        """An integer identifying the index to use for the base series, or a string representing the id of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(None)

    @baseSeries.setter
    def baseSeries(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesBellcurveDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesBellcurveDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesBellcurveDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesBellcurveDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesBellcurveDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesBellcurveDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesBellcurveEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesBellcurveEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def intervals(self):
        """This option allows to define the length of the bell curve.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(3)

    @intervals.setter
    def intervals(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesBellcurveLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesBellcurveLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesBellcurveMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesBellcurveMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesBellcurveOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesBellcurveOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesBellcurvePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesBellcurvePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointsInInterval(self):
        """Defines how many points should be plotted within 1 interval.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Bellcurve/BellcurveSeriesDefaults.ts
        """
        return self._config_get(3)

    @pointsInInterval.setter
    def pointsInInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesBellcurveSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesBellcurveSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesBellcurveStates':
        """. """
        return self._config_sub_data("states", OptionSeriesBellcurveStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesBellcurveTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesBellcurveTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(False)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesBellcurveZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesBellcurveZones)

        
class OptionSeriesBellcurveDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBellcurveDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesBellcurveDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesBellcurveDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesBellcurveDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesBellcurveDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesBellcurveDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesBellcurveDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBellcurveAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBellcurveAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBellcurveAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesBellcurveAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesBellcurveAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesBellcurveAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesBellcurveAccessibilityPoint)

        
class OptionSeriesBarZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesBarTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesBarTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesBarStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesBarStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesBarStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesBarStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesBarStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesBarStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarStates(Options):

    @property
    def hover(self) -> 'OptionSeriesBarStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesBarStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesBarStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesBarStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesBarStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesBarStatesNormal)

    @property
    def select(self) -> 'OptionSeriesBarStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesBarStatesSelect)

        
class OptionSeriesBarSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBarSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBarSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBarSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBarSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesBarSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBarSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBarSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBarSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBarSonificationTracksMappingLowpassResonance)

        
class OptionSeriesBarSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBarSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBarSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBarSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBarSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBarSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBarSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBarSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBarSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBarSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBarSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBarSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBarSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBarSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBarSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBarSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBarSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBarSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBarSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBarSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBarSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBarSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBarSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBarSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBarSonificationTracksMappingVolume)

        
class OptionSeriesBarSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBarSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBarSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBarSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBarSonificationTracksMappingHighpassResonance)

        
class OptionSeriesBarSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBarSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBarSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBarSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBarSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBarSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBarSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesBarSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesBarSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesBarSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesBarSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesBarSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBarSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesBarSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesBarSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesBarSonificationTracks)

        
class OptionSeriesBarSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesBarSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesBarSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBarSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBarSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBarSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesBarSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBarSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBarSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesBarSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesBarSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesBarSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBarSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBarSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBarSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBarSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesBarSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBarSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesBarSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBarSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBarSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBarSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBarSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBarSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesBarSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesBarSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesBarSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesBarSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesBarSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesBarSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBarSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBarSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBarSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBarSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesBarSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesBarSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesBarSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesBarSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesBarSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesBarSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesBarSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesBarSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesBarSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesBarSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesBarSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesBarSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesBarSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesBarSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesBarSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesBarSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesBarSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesBarSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesBarSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesBarSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesBarSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesBarSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesBarSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesBarSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesBarSonificationContexttracksMappingVolume)

        
class OptionSeriesBarSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesBarSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesBarSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesBarSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesBarSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesBarSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesBarSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesBarSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesBarSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesBarSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesBarSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesBarPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesBarPoint(Options):

    @property
    def events(self) -> 'OptionSeriesBarPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesBarPointEvents)

        
class OptionSeriesBarOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesBarOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesBarOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesBarOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesBarOnpointPosition)

        
class OptionSeriesBarLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesBarLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesBarLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBar(Options):

    @property
    def accessibility(self) -> 'OptionSeriesBarAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesBarAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The corner radius of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(3)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centerInCategory(self):
        """When <code>true</code>, the columns will center in the category, ignoring null or missing points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @centerInCategory.setter
    def centerInCategory(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, event if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(50)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def data(self) -> 'OptionSeriesBarData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesBarData)

    @property
    def dataLabels(self) -> 'OptionSeriesBarDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesBarDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesBarDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesBarDatasorting)

    @property
    def depth(self):
        """Depth of the columns in a 3D column chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(25)

    @depth.setter
    def depth(self, num: float): self._config(num, js_type=False)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesBarDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesBarDragdrop)

    @property
    def edgeColor(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(None)

    @edgeColor.setter
    def edgeColor(self, text: str): self._config(text, js_type=False)

    @property
    def edgeWidth(self):
        """3D columns only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @edgeWidth.setter
    def edgeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesBarEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesBarEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def grouping(self):
        """Whether to group non-stacked columns or to let them render independent of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(True)

    @grouping.setter
    def grouping(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupPadding(self):
        """Padding between each value groups, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.2)

    @groupPadding.setter
    def groupPadding(self, num: float): self._config(num, js_type=False)

    @property
    def groupZPadding(self):
        """The spacing between columns on the Z Axis in a 3D chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column3D/Column3DComposition.ts
        """
        return self._config_get(1)

    @groupZPadding.setter
    def groupZPadding(self, num: float): self._config(num, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesBarLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesBarLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def maxPointWidth(self):
        """The maximum allowed pixel width for a column, translated to the height of a bar in a bar chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @maxPointWidth.setter
    def maxPointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def minPointLength(self):
        """The minimal height for a column or width for a bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @minPointLength.setter
    def minPointLength(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesBarOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesBarOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesBarPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesBarPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPadding(self):
        """Padding between each column or bar, in x axis units.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @pointPadding.setter
    def pointPadding(self, num: float): self._config(num, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointRange(self):
        """The X axis range that each point is valid for.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointRange.setter
    def pointRange(self, num: float): self._config(num, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def pointWidth(self):
        """A pixel value specifying a fixed width for each column or bar point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @pointWidth.setter
    def pointWidth(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesBarSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesBarSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesBarStates':
        """. """
        return self._config_sub_data("states", OptionSeriesBarStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the columns, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesBarTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesBarTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesBarZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesBarZones)

        
class OptionSeriesBarDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesBarDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesBarDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesBarDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesBarDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesBarDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesBarDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesBarDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesBarDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesBarDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesBarDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesBarDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesBarDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesBarAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesBarAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesBarAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesBarAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesBarAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesBarAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesBarAccessibilityPoint)

        
class OptionSeriesAreasplinerangeZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesAreasplinerangeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesAreasplinerangeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplinerangeStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesAreasplinerangeStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesAreasplinerangeStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesAreasplinerangeStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreasplinerangeStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesAreasplinerangeStatesSelectMarker)

        
class OptionSeriesAreasplinerangeStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplinerangeStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplinerangeStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesAreasplinerangeStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeStates(Options):

    @property
    def hover(self) -> 'OptionSeriesAreasplinerangeStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesAreasplinerangeStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesAreasplinerangeStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesAreasplinerangeStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesAreasplinerangeStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesAreasplinerangeStatesNormal)

    @property
    def select(self) -> 'OptionSeriesAreasplinerangeStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesAreasplinerangeStatesSelect)

        
class OptionSeriesAreasplinerangeStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplinerangeStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesAreasplinerangeStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesAreasplinerangeStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesAreasplinerangeStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreasplinerangeStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesAreasplinerangeStatesHoverMarker)

        
class OptionSeriesAreasplinerangeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesAreasplinerangeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesAreasplinerangeSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplinerangeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplinerangeSonificationTracksMappingLowpassResonance)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesAreasplinerangeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesAreasplinerangeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesAreasplinerangeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesAreasplinerangeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesAreasplinerangeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesAreasplinerangeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesAreasplinerangeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreasplinerangeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesAreasplinerangeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreasplinerangeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesAreasplinerangeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesAreasplinerangeSonificationTracksMappingVolume)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplinerangeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplinerangeSonificationTracksMappingHighpassResonance)

        
class OptionSeriesAreasplinerangeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreasplinerangeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreasplinerangeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreasplinerangeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreasplinerangeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplinerangeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplinerangeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesAreasplinerangeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesAreasplinerangeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplinerangeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplinerangeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesAreasplinerangeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesAreasplinerangeSonificationTracks)

        
class OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesAreasplinerangeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplinerangeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplinerangeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesAreasplinerangeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesAreasplinerangeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesAreasplinerangeSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplinerangeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplinerangeSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesAreasplinerangeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesAreasplinerangeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesAreasplinerangeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesAreasplinerangeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesAreasplinerangeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesAreasplinerangeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesAreasplinerangeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreasplinerangeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesAreasplinerangeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreasplinerangeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesAreasplinerangeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesAreasplinerangeSonificationContexttracksMappingVolume)

        
class OptionSeriesAreasplinerangeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreasplinerangeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreasplinerangeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplinerangeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplinerangeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplinerangeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplinerangeSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesAreasplinerangePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinerangePoint(Options):

    @property
    def events(self) -> 'OptionSeriesAreasplinerangePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesAreasplinerangePointEvents)

        
class OptionSeriesAreasplinerangeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesAreasplinerangeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesAreasplinerangeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesAreasplinerangeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesAreasplinerangeOnpointPosition)

        
class OptionSeriesAreasplinerangeMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplinerangeMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplinerangeMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesAreasplinerangeMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesAreasplinerangeMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesAreasplinerangeMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesAreasplinerangeMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesAreasplinerangeMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesAreasplinerangeMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesAreasplinerangeMarkerStatesSelect)

        
class OptionSeriesAreasplinerangeMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesAreasplinerangeMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesAreasplinerangeMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeLowmarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeLowmarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeLowmarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplinerangeLowmarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplinerangeLowmarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesAreasplinerangeLowmarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeLowmarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesAreasplinerangeLowmarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesAreasplinerangeLowmarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesAreasplinerangeLowmarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesAreasplinerangeLowmarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesAreasplinerangeLowmarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesAreasplinerangeLowmarkerStatesSelect)

        
class OptionSeriesAreasplinerangeLowmarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesAreasplinerangeLowmarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesAreasplinerangeLowmarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesAreasplinerangeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesAreasplinerangeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplinerange(Options):

    @property
    def accessibility(self) -> 'OptionSeriesAreasplinerangeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesAreasplinerangeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSplineRange/AreaSplineRangeSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("low")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesAreasplinerangeData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesAreasplinerangeData)

    @property
    def dataLabels(self) -> 'OptionSeriesAreasplinerangeDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionSeriesAreasplinerangeDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesAreasplinerangeDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesAreasplinerangeDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesAreasplinerangeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesAreasplinerangeDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesAreasplinerangeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesAreasplinerangeEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSplineRange/AreaSplineRangeSeries.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSplineRange/AreaSplineRangeSeries.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesAreasplinerangeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesAreasplinerangeLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the arearange graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def lowMarker(self) -> 'OptionSeriesAreasplinerangeLowmarker':
        """Options for the lower markers of the arearange-like series. """
        return self._config_sub_data("lowMarker", OptionSeriesAreasplinerangeLowmarker)

    @property
    def marker(self) -> 'OptionSeriesAreasplinerangeMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesAreasplinerangeMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesAreasplinerangeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesAreasplinerangeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesAreasplinerangePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesAreasplinerangePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesAreasplinerangeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesAreasplinerangeSonification)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesAreasplinerangeStates':
        """. """
        return self._config_sub_data("states", OptionSeriesAreasplinerangeStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesAreasplinerangeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesAreasplinerangeTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(True)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesAreasplinerangeZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesAreasplinerangeZones)

        
class OptionSeriesAreasplinerangeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplinerangeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesAreasplinerangeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesAreasplinerangeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesAreasplinerangeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesAreasplinerangeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesAreasplinerangeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesAreasplinerangeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplinerangeDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesAreasplinerangeDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesAreasplinerangeDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesAreasplinerangeDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesAreasplinerangeDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesAreasplinerangeDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesAreasplinerangeDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplinerangeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplinerangeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplinerangeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesAreasplinerangeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesAreasplinerangeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesAreasplinerangeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesAreasplinerangeAccessibilityPoint)

        
class OptionSeriesAreasplineZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesAreasplineTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesAreasplineTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplineStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesAreasplineStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesAreasplineStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesAreasplineStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreasplineStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesAreasplineStatesSelectMarker)

        
class OptionSeriesAreasplineStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplineStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesAreasplineStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineStates(Options):

    @property
    def hover(self) -> 'OptionSeriesAreasplineStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesAreasplineStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesAreasplineStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesAreasplineStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesAreasplineStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesAreasplineStatesNormal)

    @property
    def select(self) -> 'OptionSeriesAreasplineStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesAreasplineStatesSelect)

        
class OptionSeriesAreasplineStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplineStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesAreasplineStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesAreasplineStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesAreasplineStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreasplineStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesAreasplineStatesHoverMarker)

        
class OptionSeriesAreasplineSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesAreasplineSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesAreasplineSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesAreasplineSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesAreasplineSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesAreasplineSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplineSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplineSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplineSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplineSonificationTracksMappingLowpassResonance)

        
class OptionSeriesAreasplineSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplineSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesAreasplineSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesAreasplineSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesAreasplineSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesAreasplineSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesAreasplineSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesAreasplineSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesAreasplineSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesAreasplineSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesAreasplineSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesAreasplineSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesAreasplineSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesAreasplineSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesAreasplineSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreasplineSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreasplineSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesAreasplineSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesAreasplineSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesAreasplineSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreasplineSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesAreasplineSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesAreasplineSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesAreasplineSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesAreasplineSonificationTracksMappingVolume)

        
class OptionSeriesAreasplineSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplineSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplineSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplineSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplineSonificationTracksMappingHighpassResonance)

        
class OptionSeriesAreasplineSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreasplineSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreasplineSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreasplineSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreasplineSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplineSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplineSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesAreasplineSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesAreasplineSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesAreasplineSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesAreasplineSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesAreasplineSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplineSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplineSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesAreasplineSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesAreasplineSonificationTracks)

        
class OptionSeriesAreasplineSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesAreasplineSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesAreasplineSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreasplineSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreasplineSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreasplineSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreasplineSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplineSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplineSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplineSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesAreasplineSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesAreasplineSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesAreasplineSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesAreasplineSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplineSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplineSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesAreasplineSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesAreasplineSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesAreasplineSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesAreasplineSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesAreasplineSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesAreasplineSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesAreasplineSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesAreasplineSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreasplineSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesAreasplineSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreasplineSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesAreasplineSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesAreasplineSonificationContexttracksMappingVolume)

        
class OptionSeriesAreasplineSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreasplineSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreasplineSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreasplineSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreasplineSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreasplineSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreasplineSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplineSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreasplineSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreasplineSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreasplineSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesAreasplinePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreasplinePoint(Options):

    @property
    def events(self) -> 'OptionSeriesAreasplinePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesAreasplinePointEvents)

        
class OptionSeriesAreasplineOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesAreasplineOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesAreasplineOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesAreasplineOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesAreasplineOnpointPosition)

        
class OptionSeriesAreasplineMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplineMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesAreasplineMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesAreasplineMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesAreasplineMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesAreasplineMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesAreasplineMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesAreasplineMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesAreasplineMarkerStatesSelect)

        
class OptionSeriesAreasplineMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesAreasplineMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesAreasplineMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesAreasplineLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesAreasplineLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaspline(Options):

    @property
    def accessibility(self) -> 'OptionSeriesAreasplineAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesAreasplineAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSpline/AreaSplineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesAreasplineData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesAreasplineData)

    @property
    def dataLabels(self) -> 'OptionSeriesAreasplineDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesAreasplineDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesAreasplineDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesAreasplineDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesAreasplineDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesAreasplineDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesAreasplineEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesAreasplineEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSpline/AreaSplineSeries.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaSpline/AreaSplineSeries.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesAreasplineLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesAreasplineLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreasplineMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesAreasplineMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesAreasplineOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesAreasplineOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesAreasplinePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesAreasplinePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesAreasplineSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesAreasplineSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesAreasplineStates':
        """. """
        return self._config_sub_data("states", OptionSeriesAreasplineStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesAreasplineTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesAreasplineTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(False)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesAreasplineZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesAreasplineZones)

        
class OptionSeriesAreasplineDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesAreasplineDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesAreasplineDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesAreasplineDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesAreasplineDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesAreasplineDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesAreasplineDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesAreasplineDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesAreasplineDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesAreasplineDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesAreasplineDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesAreasplineDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesAreasplineDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesAreasplineDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesAreasplineDataMarkerStatesSelect)

        
class OptionSeriesAreasplineDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesAreasplineDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesAreasplineDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesAreasplineDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesAreasplineDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesAreasplineDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesAreasplineDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesAreasplineDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesAreasplineDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesAreasplineDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesAreasplineDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreasplineDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesAreasplineDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesAreasplineDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesAreasplineDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesAreasplineDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesAreasplineDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesAreasplineDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesAreasplineDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreasplineAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreasplineAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreasplineAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesAreasplineAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesAreasplineAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesAreasplineAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesAreasplineAccessibilityPoint)

        
class OptionSeriesArearangeZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesArearangeTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesArearangeTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get('<span style="color:{series.color}">●</span> {series.name}: <b>{point.low}</b> - <b>{point.high}</b><br/>')

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesArearangeStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesArearangeStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesArearangeStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesArearangeStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesArearangeStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesArearangeStatesSelectMarker)

        
class OptionSeriesArearangeStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArearangeStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesArearangeStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesArearangeStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeStates(Options):

    @property
    def hover(self) -> 'OptionSeriesArearangeStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesArearangeStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesArearangeStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesArearangeStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesArearangeStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesArearangeStatesNormal)

    @property
    def select(self) -> 'OptionSeriesArearangeStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesArearangeStatesSelect)

        
class OptionSeriesArearangeStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesArearangeStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesArearangeStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesArearangeStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesArearangeStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesArearangeStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesArearangeStatesHoverMarker)

        
class OptionSeriesArearangeSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesArearangeSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesArearangeSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesArearangeSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesArearangeSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesArearangeSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArearangeSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArearangeSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArearangeSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArearangeSonificationTracksMappingLowpassResonance)

        
class OptionSeriesArearangeSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesArearangeSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesArearangeSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesArearangeSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesArearangeSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesArearangeSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesArearangeSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesArearangeSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesArearangeSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesArearangeSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesArearangeSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesArearangeSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesArearangeSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesArearangeSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesArearangeSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesArearangeSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesArearangeSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesArearangeSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesArearangeSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesArearangeSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesArearangeSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesArearangeSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesArearangeSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesArearangeSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesArearangeSonificationTracksMappingVolume)

        
class OptionSeriesArearangeSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArearangeSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArearangeSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArearangeSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArearangeSonificationTracksMappingHighpassResonance)

        
class OptionSeriesArearangeSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesArearangeSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesArearangeSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesArearangeSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesArearangeSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesArearangeSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesArearangeSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesArearangeSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesArearangeSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesArearangeSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesArearangeSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesArearangeSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesArearangeSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesArearangeSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesArearangeSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesArearangeSonificationTracks)

        
class OptionSeriesArearangeSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesArearangeSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesArearangeSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesArearangeSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesArearangeSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesArearangeSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesArearangeSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesArearangeSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesArearangeSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesArearangeSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesArearangeSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesArearangeSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesArearangeSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesArearangeSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesArearangeSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesArearangeSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesArearangeSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesArearangeSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesArearangeSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesArearangeSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArearangeSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesArearangeSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesArearangeSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesArearangeSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesArearangeSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArearangeSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArearangeSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesArearangeSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesArearangeSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesArearangeSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesArearangeSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesArearangeSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesArearangeSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesArearangeSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesArearangeSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesArearangeSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesArearangeSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesArearangeSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesArearangeSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesArearangeSonificationContexttracksMappingVolume)

        
class OptionSeriesArearangeSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesArearangeSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesArearangeSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesArearangeSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesArearangeSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesArearangeSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesArearangeSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangeSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArearangeSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArearangeSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArearangeSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesArearangePointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArearangePoint(Options):

    @property
    def events(self) -> 'OptionSeriesArearangePointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesArearangePointEvents)

        
class OptionSeriesArearangeOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesArearangeOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesArearangeOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesArearangeOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesArearangeOnpointPosition)

        
class OptionSeriesArearangeMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArearangeMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesArearangeMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesArearangeMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesArearangeMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesArearangeMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesArearangeMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesArearangeMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesArearangeMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesArearangeMarkerStatesSelect)

        
class OptionSeriesArearangeMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesArearangeMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesArearangeMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeLowmarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeLowmarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeLowmarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArearangeLowmarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesArearangeLowmarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesArearangeLowmarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeLowmarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesArearangeLowmarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesArearangeLowmarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesArearangeLowmarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesArearangeLowmarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesArearangeLowmarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesArearangeLowmarkerStatesSelect)

        
class OptionSeriesArearangeLowmarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesArearangeLowmarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesArearangeLowmarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesArearangeLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesArearangeLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArearange(Options):

    @property
    def accessibility(self) -> 'OptionSeriesArearangeAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesArearangeAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("low")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesArearangeData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesArearangeData)

    @property
    def dataLabels(self) -> 'OptionSeriesArearangeDatalabels':
        """Extended data labels for range series types. """
        return self._config_sub_data("dataLabels", OptionSeriesArearangeDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesArearangeDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesArearangeDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesArearangeDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesArearangeDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesArearangeEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesArearangeEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesArearangeLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesArearangeLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the arearange graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(1)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def lowMarker(self) -> 'OptionSeriesArearangeLowmarker':
        """Options for the lower markers of the arearange-like series. """
        return self._config_sub_data("lowMarker", OptionSeriesArearangeLowmarker)

    @property
    def marker(self) -> 'OptionSeriesArearangeMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesArearangeMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesArearangeOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesArearangeOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesArearangePoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesArearangePoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesArearangeSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesArearangeSonification)

    @property
    def states(self) -> 'OptionSeriesArearangeStates':
        """. """
        return self._config_sub_data("states", OptionSeriesArearangeStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(None)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesArearangeTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesArearangeTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(True)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesArearangeZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesArearangeZones)

        
class OptionSeriesArearangeDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArearangeDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesArearangeDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesArearangeDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesArearangeDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesArearangeDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesArearangeDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesArearangeDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArearangeDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesArearangeDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesArearangeDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesArearangeDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesArearangeDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesArearangeDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesArearangeDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def xHigh(self):
        """X offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xHigh.setter
    def xHigh(self, num: float): self._config(num, js_type=False)

    @property
    def xLow(self):
        """X offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @xLow.setter
    def xLow(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def yHigh(self):
        """Y offset of the higher data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yHigh.setter
    def yHigh(self, num: float): self._config(num, js_type=False)

    @property
    def yLow(self):
        """Y offset of the lower data labels relative to the point value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/AreaRange/AreaRangeSeries.ts
        """
        return self._config_get(0)

    @yLow.setter
    def yLow(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArearangeAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArearangeAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArearangeAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesArearangeAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesArearangeAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesArearangeAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesArearangeAccessibilityPoint)

        
class OptionSeriesAreaZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesAreaTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesAreaTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(16)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the mouse as it moves across columns, pie slices and other point types with an extent.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(False)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesAreaStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesAreaStatesSelectAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesAreaStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesAreaStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreaStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesAreaStatesSelectMarker)

        
class OptionSeriesAreaStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesAreaStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesAreaStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def opacity(self):
        """Opacity of series elements (dataLabels, line, area).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.2)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaStates(Options):

    @property
    def hover(self) -> 'OptionSeriesAreaStatesHover':
        """Options for the hovered series. """
        return self._config_sub_data("hover", OptionSeriesAreaStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesAreaStatesInactive':
        """The opposite state of a hover for series. """
        return self._config_sub_data("inactive", OptionSeriesAreaStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesAreaStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesAreaStatesNormal)

    @property
    def select(self) -> 'OptionSeriesAreaStatesSelect':
        """Specific options for point in selected states, after being selected by <a href="#plotOptions. """
        return self._config_sub_data("select", OptionSeriesAreaStatesSelect)

        
class OptionSeriesAreaStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesAreaStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesAreaStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesAreaStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesAreaStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreaStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesAreaStatesHoverMarker)

        
class OptionSeriesAreaSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesAreaSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesAreaSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesAreaSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesAreaSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesAreaSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreaSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreaSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreaSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreaSonificationTracksMappingLowpassResonance)

        
class OptionSeriesAreaSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreaSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesAreaSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesAreaSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesAreaSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesAreaSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesAreaSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesAreaSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesAreaSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesAreaSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesAreaSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesAreaSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesAreaSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesAreaSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesAreaSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreaSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreaSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesAreaSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesAreaSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesAreaSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreaSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesAreaSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesAreaSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesAreaSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesAreaSonificationTracksMappingVolume)

        
class OptionSeriesAreaSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreaSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreaSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreaSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreaSonificationTracksMappingHighpassResonance)

        
class OptionSeriesAreaSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreaSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreaSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreaSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreaSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreaSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreaSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesAreaSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesAreaSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesAreaSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesAreaSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesAreaSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreaSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreaSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesAreaSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesAreaSonificationTracks)

        
class OptionSeriesAreaSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesAreaSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesAreaSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreaSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreaSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesAreaSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesAreaSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesAreaSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreaSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesAreaSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesAreaSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesAreaSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreaSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreaSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreaSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreaSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreaSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreaSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreaSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreaSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreaSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreaSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesAreaSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesAreaSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesAreaSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesAreaSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesAreaSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesAreaSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreaSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreaSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreaSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreaSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesAreaSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreaSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesAreaSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesAreaSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesAreaSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesAreaSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesAreaSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesAreaSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesAreaSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesAreaSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesAreaSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesAreaSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesAreaSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesAreaSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesAreaSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesAreaSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesAreaSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesAreaSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesAreaSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesAreaSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesAreaSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesAreaSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesAreaSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesAreaSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesAreaSonificationContexttracksMappingVolume)

        
class OptionSeriesAreaSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesAreaSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesAreaSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesAreaSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesAreaSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesAreaSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesAreaSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesAreaSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesAreaSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesAreaSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesAreaSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesAreaPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesAreaPoint(Options):

    @property
    def events(self) -> 'OptionSeriesAreaPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesAreaPointEvents)

        
class OptionSeriesAreaOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesAreaOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesAreaOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesAreaOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesAreaOnpointPosition)

        
class OptionSeriesAreaMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesAreaMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesAreaMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesAreaMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesAreaMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesAreaMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesAreaMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesAreaMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesAreaMarkerStatesSelect)

        
class OptionSeriesAreaMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesAreaMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesAreaMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesAreaLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesAreaLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArea(Options):

    @property
    def accessibility(self) -> 'OptionSeriesAreaAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesAreaAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def boostBlending(self):
        """Sets the color blending in the boost module.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get("undefined")

    @boostBlending.setter
    def boostBlending(self, value: Any): self._config(value, js_type=False)

    @property
    def boostThreshold(self):
        """Set the point threshold for when a series should enter boost mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Boost/Boost.ts
        """
        return self._config_get(5000)

    @boostThreshold.setter
    def boostThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorAxis(self):
        """When using dual or multiple color axes, this number defines which colorAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @colorAxis.setter
    def colorAxis(self, num: float): self._config(num, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colorKey(self):
        """Determines what data value should be used to calculate point color if <code>colorAxis</code> is used.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @colorKey.setter
    def colorKey(self, text: str): self._config(text, js_type=False)

    @property
    def connectEnds(self):
        """Polar charts only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/PolarComposition.ts
        """
        return self._config_get(None)

    @connectEnds.setter
    def connectEnds(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectNulls(self):
        """Whether to connect a graph line across null points, or render a gap between the two points on either side of the null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @connectNulls.setter
    def connectNulls(self, flag: bool): self._config(flag, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesAreaData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesAreaData)

    @property
    def dataLabels(self) -> 'OptionSeriesAreaDatalabels':
        """Options for the series data labels, appearing next to each data point. """
        return self._config_sub_data("dataLabels", OptionSeriesAreaDatalabels)

    @property
    def dataSorting(self) -> 'OptionSeriesAreaDatasorting':
        """Options for the series data sorting. """
        return self._config_sub_data("dataSorting", OptionSeriesAreaDatasorting)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesAreaDragdrop':
        """The draggable-points module allows points to be moved around or modified in the chart. """
        return self._config_sub_data("dragDrop", OptionSeriesAreaDragdrop)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesAreaEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesAreaEvents)

    @property
    def fillColor(self):
        """Fill color or gradient for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """Fill opacity for the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0.75)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def getExtremesFromAll(self):
        """Whether to use the Y extremes of the total chart width or only the zoomed area when zooming in on parts of the X axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @getExtremesFromAll.setter
    def getExtremesFromAll(self, flag: bool): self._config(flag, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesAreaLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesAreaLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def linecap(self):
        """The SVG value used for the <code>stroke-linecap</code> and <code>stroke-linejoin</code> of a line graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineColor(self):
        """A separate color for the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreaMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesAreaMarker)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def negativeFillColor(self):
        """A separate color for the negative part of the area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(None)

    @negativeFillColor.setter
    def negativeFillColor(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesAreaOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesAreaOnpoint)

    @property
    def opacity(self):
        """Opacity of a series parts: line, fill (e.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesAreaPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesAreaPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointInterval(self):
        """If no x values are given for the points in a series, <code>pointInterval</code> defines the interval of the x values.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @pointInterval.setter
    def pointInterval(self, num: float): self._config(num, js_type=False)

    @property
    def pointIntervalUnit(self):
        """On datetime series, this allows for setting the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointIntervalUnit.setter
    def pointIntervalUnit(self, value: Any): self._config(value, js_type=False)

    @property
    def pointPlacement(self):
        """Possible values: <code>&quot;on&quot;</code>, <code>&quot;between&quot;</code>, <code>number</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointPlacement.setter
    def pointPlacement(self, text: str): self._config(text, js_type=False)

    @property
    def pointStart(self):
        """If no x values are given for the points in a series, pointStart defines on what value to start.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @pointStart.setter
    def pointStart(self, num: float): self._config(num, js_type=False)

    @property
    def relativeXValue(self):
        """When true, X values in the data set are relative to the current <code>pointStart</code>, <code>pointInterval</code> and <code>pointIntervalUnit</code> settings.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @relativeXValue.setter
    def relativeXValue(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def softThreshold(self):
        """When this is true, the series will not cause the Y axis to cross the zero plane (or <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @softThreshold.setter
    def softThreshold(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesAreaSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesAreaSonification)

    @property
    def stack(self):
        """This option allows grouping series in a stacked chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @stack.setter
    def stack(self, num: float): self._config(num, js_type=False)

    @property
    def stacking(self):
        """Whether to stack the values of each series on top of each other.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @stacking.setter
    def stacking(self, text: str): self._config(text, js_type=False)

    @property
    def states(self) -> 'OptionSeriesAreaStates':
        """. """
        return self._config_sub_data("states", OptionSeriesAreaStates)

    @property
    def step(self):
        """Whether to apply steps to the line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @step.setter
    def step(self, value: Any): self._config(value, js_type=False)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The Y axis value to serve as the base for the area, for distinguishing between values above and below a threshold.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesAreaTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesAreaTooltip)

    @property
    def trackByArea(self):
        """Whether the whole area or just the line should respond to mouseover tooltips and other mouse or touch events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Area/AreaSeries.ts
        """
        return self._config_get(False)

    @trackByArea.setter
    def trackByArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def xAxis(self):
        """When using dual or multiple x axes, this number defines which xAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @xAxis.setter
    def xAxis(self, num: float): self._config(num, js_type=False)

    @property
    def yAxis(self):
        """When using dual or multiple y axes, this number defines which yAxis the particular series is connected to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(0)

    @yAxis.setter
    def yAxis(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesAreaZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesAreaZones)

        
class OptionSeriesAreaDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesAreaDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesAreaDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesAreaDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesAreaDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesAreaDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesAreaDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDataMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDataMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDataMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaDataMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesAreaDataMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesAreaDataMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDataMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesAreaDataMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesAreaDataMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesAreaDataMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesAreaDataMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesAreaDataMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesAreaDataMarkerStatesSelect)

        
class OptionSeriesAreaDataMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesAreaDataMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesAreaDataMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaData(Options):

    @property
    def accessibility(self) -> 'OptionSeriesAreaDataAccessibility':
        """Accessibility options for a data point. """
        return self._config_sub_data("accessibility", OptionSeriesAreaDataAccessibility)

    @property
    def className(self):
        """An additional, individual class name for the data point&#39;s graphic representation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Individual color for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """A specific color index to use for the point, so its graphic representations are given the class name <code>highcharts-color-{n}</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesAreaDataDatalabels':
        """Individual data label for each point. """
        return self._config_sub_data("dataLabels", OptionSeriesAreaDataDatalabels)

    @property
    def description(self):
        """A description of the point to add to the screen reader information about the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def dragDrop(self) -> 'OptionSeriesAreaDataDragdrop':
        """Point specific options for the draggable-points module. """
        return self._config_sub_data("dragDrop", OptionSeriesAreaDataDragdrop)

    @property
    def drilldown(self):
        """The <code>id</code> of a series in the <a href="#drilldown.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Drilldown/DrilldownDefaults.ts
        """
        return self._config_get(None)

    @drilldown.setter
    def drilldown(self, text: str): self._config(text, js_type=False)

    @property
    def events(self) -> 'OptionSeriesAreaDataEvents':
        """The individual point events. """
        return self._config_sub_data("events", OptionSeriesAreaDataEvents)

    @property
    def id(self):
        """An id for the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def labelrank(self):
        """The rank for this point&#39;s data label in case of collision.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @labelrank.setter
    def labelrank(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesAreaDataMarker':
        """Options for the point markers of line-like series. """
        return self._config_sub_data("marker", OptionSeriesAreaDataMarker)

    @property
    def name(self):
        """The name of the point as shown in the legend, tooltip, dataLabels, etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def selected(self):
        """Whether the data point is selected initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def x(self):
        """The x value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y value of the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaDataDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaDataDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesAreaDataDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesAreaDataDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesAreaDataDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesAreaDataDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("point.value")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesAreaDataDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesAreaDataDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("bottom")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesAreaAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesAreaAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesAreaAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesAreaAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesAreaAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesAreaAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesAreaAccessibilityPoint)

        
class OptionSeriesArcdiagramZones(Options):

    @property
    def className(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """Defines the color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def dashStyle(self):
        """A name for the dash style to use for the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def fillColor(self):
        """Defines the fill color for the series (in area type series).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramTooltipDatetimelabelformats(Options):

    @property
    def day(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b %Y")

    @day.setter
    def day(self, text: str): self._config(text, js_type=False)

    @property
    def hour(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @hour.setter
    def hour(self, text: str): self._config(text, js_type=False)

    @property
    def millisecond(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S.%L")

    @millisecond.setter
    def millisecond(self, text: str): self._config(text, js_type=False)

    @property
    def minute(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M")

    @minute.setter
    def minute(self, text: str): self._config(text, js_type=False)

    @property
    def month(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%B %Y")

    @month.setter
    def month(self, text: str): self._config(text, js_type=False)

    @property
    def second(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%A, %e %b, %H:%M:%S")

    @second.setter
    def second(self, text: str): self._config(text, js_type=False)

    @property
    def week(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("Week from %A, %e %b %Y")

    @week.setter
    def week(self, text: str): self._config(text, js_type=False)

    @property
    def year(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("%Y")

    @year.setter
    def year(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramTooltip(Options):

    @property
    def clusterFormat(self):
        """The HTML of the cluster point&#39;s in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/MarkerClusters/MarkerClusterDefaults.ts
        """
        return self._config_get("Clustered points: {point.clusterPointsAmount}")

    @clusterFormat.setter
    def clusterFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateTimeLabelFormats(self) -> 'OptionSeriesArcdiagramTooltipDatetimelabelformats':
        """For series on datetime axes, the date format in the tooltip&#39;s header will by default be guessed based on the closest data points. """
        return self._config_sub_data("dateTimeLabelFormats", OptionSeriesArcdiagramTooltipDatetimelabelformats)

    @property
    def distance(self):
        """Distance from point to tooltip in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(6)

    @distance.setter
    def distance(self, num: float): self._config(num, js_type=False)

    @property
    def followPointer(self):
        """Whether the tooltip should follow the pointer or stay fixed on the item.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @followPointer.setter
    def followPointer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def followTouchMove(self):
        """Whether the tooltip should update as the finger moves on a touch device.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(True)

    @followTouchMove.setter
    def followTouchMove(self, flag: bool): self._config(flag, js_type=False)

    @property
    def footerFormat(self):
        """A string to append to the tooltip format.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("")

    @footerFormat.setter
    def footerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def headerFormat(self):
        """The HTML of the tooltip header line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get('<span style="font-size: 0.8em">{series.name}</span><br/>')

    @headerFormat.setter
    def headerFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.name}: <b>{point.sum}</b><br/>")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """A callback for defining the format for <em>nodes</em> in the chart&#39;s tooltip, as opposed to links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """The HTML of the null point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nullFormatter(self):
        """Callback function to format the text of the tooltip for visible null points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def pointFormat(self):
        """The HTML of the point&#39;s line in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("{point.fromNode.name} → {point.toNode.name}: <b>{point.weight}</b><br/>")

    @pointFormat.setter
    def pointFormat(self, text: str): self._config(text, js_type=False)

    @property
    def pointFormatter(self):
        """A callback function for formatting the HTML output for a single point in the tooltip.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @pointFormatter.setter
    def pointFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """How many decimals to show in each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valuePrefix(self):
        """A string to prepend to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """A string to append to each series&#39; y value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

    @property
    def xDateFormat(self):
        """The format for the date in the tooltip header if the X axis is a datetime axis.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Defaults.ts
        """
        return self._config_get(None)

    @xDateFormat.setter
    def xDateFormat(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramStatesSelectMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramStatesSelectHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesArcdiagramStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesArcdiagramStatesSelectHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesArcdiagramStatesSelectHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesArcdiagramStatesSelectMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesArcdiagramStatesSelectMarker)

        
class OptionSeriesArcdiagramStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramStatesHoverHalo(Options):

    @property
    def attributes(self):
        """A collection of SVG attributes to override the appearance of the halo, for example <code>fill</code>, <code>stroke</code> and <code>stroke-width</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def opacity(self):
        """Opacity for the halo unless a specific fill is overridden using the <code>attributes</code> setting.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0.25)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def size(self):
        """The pixel size of the halo.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(10)

    @size.setter
    def size(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesArcdiagramStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramStates(Options):

    @property
    def hover(self) -> 'OptionSeriesArcdiagramStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesArcdiagramStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesArcdiagramStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionSeriesArcdiagramStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesArcdiagramStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesArcdiagramStatesNormal)

    @property
    def select(self) -> 'OptionSeriesArcdiagramStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesArcdiagramStatesSelect)

        
class OptionSeriesArcdiagramStatesHoverMarker(Options):

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabledThreshold(self):
        """The threshold for how dense the point markers should be before they are hidden, given that <code>enabled</code> is not defined.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @enabledThreshold.setter
    def enabledThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def height(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @height.setter
    def height(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(4)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def width(self):
        """Image markers only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesArcdiagramStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def halo(self) -> 'OptionSeriesArcdiagramStatesHoverHalo':
        """Options for the halo appearing around the hovered point in line-type series as well as outside the hovered slice in pie charts. """
        return self._config_sub_data("halo", OptionSeriesArcdiagramStatesHoverHalo)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for the graph of a hovered series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesArcdiagramStatesHoverMarker':
        """In Highcharts 1. """
        return self._config_sub_data("marker", OptionSeriesArcdiagramStatesHoverMarker)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesArcdiagramSonificationTracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesArcdiagramSonificationTracksMappingTremoloSpeed)

        
class OptionSeriesArcdiagramSonificationTracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArcdiagramSonificationTracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArcdiagramSonificationTracksMappingLowpassResonance)

        
class OptionSeriesArcdiagramSonificationTracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesArcdiagramSonificationTracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesArcdiagramSonificationTracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesArcdiagramSonificationTracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesArcdiagramSonificationTracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesArcdiagramSonificationTracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesArcdiagramSonificationTracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesArcdiagramSonificationTracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesArcdiagramSonificationTracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesArcdiagramSonificationTracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesArcdiagramSonificationTracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesArcdiagramSonificationTracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesArcdiagramSonificationTracksMappingVolume)

        
class OptionSeriesArcdiagramSonificationTracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArcdiagramSonificationTracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArcdiagramSonificationTracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArcdiagramSonificationTracksMappingHighpassResonance)

        
class OptionSeriesArcdiagramSonificationTracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationTracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesArcdiagramSonificationTracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesArcdiagramSonificationTracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesArcdiagramSonificationTracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesArcdiagramSonificationTracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesArcdiagramSonificationTracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesArcdiagramSonificationTracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultspeechoptionsActivewhen(Options):

    @property
    def crossingDown(self):
        """Track is only active when <code>prop</code> was above, and is now at or below this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingDown.setter
    def crossingDown(self, num: float): self._config(num, js_type=False)

    @property
    def crossingUp(self):
        """Track is only active when <code>prop</code> was below, and is now at or above this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @crossingUp.setter
    def crossingUp(self, num: float): self._config(num, js_type=False)

    @property
    def max(self):
        """Track is only active when <code>prop</code> is below or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """Track is only active when <code>prop</code> is above or at this value.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The point property to compare, for example <code>y</code> or <code>x</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonification(Options):

    @property
    def contextTracks(self) -> 'OptionSeriesArcdiagramSonificationContexttracks':
        """Context tracks for this series. """
        return self._config_sub_data("contextTracks", OptionSeriesArcdiagramSonificationContexttracks)

    @property
    def defaultInstrumentOptions(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptions':
        """Default options for all this series&#39; instrument tracks. """
        return self._config_sub_data("defaultInstrumentOptions", OptionSeriesArcdiagramSonificationDefaultinstrumentoptions)

    @property
    def defaultSpeechOptions(self) -> 'OptionSeriesArcdiagramSonificationDefaultspeechoptions':
        """Default options for all this series&#39; speech tracks. """
        return self._config_sub_data("defaultSpeechOptions", OptionSeriesArcdiagramSonificationDefaultspeechoptions)

    @property
    def enabled(self):
        """Whether or not sonification is enabled for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesArcdiagramSonificationPointgrouping':
        """Sonification point grouping options for this series. """
        return self._config_sub_data("pointGrouping", OptionSeriesArcdiagramSonificationPointgrouping)

    @property
    def tracks(self) -> 'OptionSeriesArcdiagramSonificationTracks':
        """Tracks for this series. """
        return self._config_sub_data("tracks", OptionSeriesArcdiagramSonificationTracks)

        
class OptionSeriesArcdiagramSonificationDefaultspeechoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("last")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("undefined")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultspeechoptionsMapping(Options):

    @property
    def pitch(self) -> 'OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingPitch':
        """Speech pitch (how high/low the voice is) multiplier. """
        return self._config_sub_data("pitch", OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingRate':
        """Speech rate (speed) multiplier. """
        return self._config_sub_data("rate", OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingRate)

    @property
    def text(self):
        """The text to announce for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingTime)

    @property
    def volume(self) -> 'OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingVolume':
        """Volume of the speech announcement. """
        return self._config_sub_data("volume", OptionSeriesArcdiagramSonificationDefaultspeechoptionsMappingVolume)

        
class OptionSeriesArcdiagramSonificationDefaultspeechoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesArcdiagramSonificationDefaultspeechoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesArcdiagramSonificationDefaultspeechoptionsActivewhen)

    @property
    def language(self):
        """The language to speak in for speech tracks, as an IETF BCP 47 language tag.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("en-US")

    @language.setter
    def language(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesArcdiagramSonificationDefaultspeechoptionsMapping':
        """Mapping configuration for the speech/audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesArcdiagramSonificationDefaultspeechoptionsMapping)

    @property
    def pointGrouping(self) -> 'OptionSeriesArcdiagramSonificationDefaultspeechoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesArcdiagramSonificationDefaultspeechoptionsPointgrouping)

    @property
    def preferredVoice(self):
        """Name of the voice synthesis to prefer for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @preferredVoice.setter
    def preferredVoice(self, text: str): self._config(text, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("speech")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTremoloSpeed)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingLowpassResonance)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingPlaydelay)

    @property
    def time(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingVolume)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptions(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArcdiagramSonificationDefaultinstrumentoptionsMappingHighpassResonance)

        
class OptionSeriesArcdiagramSonificationContexttracksPointgrouping(Options):

    @property
    def algorithm(self):
        """The grouping algorithm, deciding which points to keep when grouping a set of points together.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("minmax")

    @algorithm.setter
    def algorithm(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Whether or not to group points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def groupTimespan(self):
        """The size of each group in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(15)

    @groupTimespan.setter
    def groupTimespan(self, num: float): self._config(num, js_type=False)

    @property
    def prop(self):
        """The data property for each point to compare when deciding which points to keep in the group.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @prop.setter
    def prop(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingVolume(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingTremoloSpeed(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingTremoloDepth(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingTremolo(Options):

    @property
    def depth(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingTremoloDepth':
        """Map to tremolo depth, from 0 to 1. """
        return self._config_sub_data("depth", OptionSeriesArcdiagramSonificationContexttracksMappingTremoloDepth)

    @property
    def speed(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingTremoloSpeed':
        """Map to tremolo speed, from 0 to 1. """
        return self._config_sub_data("speed", OptionSeriesArcdiagramSonificationContexttracksMappingTremoloSpeed)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingTime(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingRate(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingPlaydelay(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingPitch(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("y")

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c6")

    @max.setter
    def max(self, text: str): self._config(text, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("c2")

    @min.setter
    def min(self, text: str): self._config(text, js_type=False)

    @property
    def scale(self):
        """Map pitches to a musical scale.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @scale.setter
    def scale(self, value: Any): self._config(value, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("yAxis")

    @within.setter
    def within(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingPan(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingNoteduration(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingLowpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingLowpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingLowpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingLowpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArcdiagramSonificationContexttracksMappingLowpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingLowpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArcdiagramSonificationContexttracksMappingLowpassResonance)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingHighpassFrequency(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingGapbetweennotes(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMapping(Options):

    @property
    def frequency(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingFrequency':
        """Frequency in Hertz of notes. """
        return self._config_sub_data("frequency", OptionSeriesArcdiagramSonificationContexttracksMappingFrequency)

    @property
    def gapBetweenNotes(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingGapbetweennotes':
        """Gap in milliseconds between notes if pitch is mapped to an array of notes. """
        return self._config_sub_data("gapBetweenNotes", OptionSeriesArcdiagramSonificationContexttracksMappingGapbetweennotes)

    @property
    def highpass(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingHighpass':
        """Mapping options for the highpass filter. """
        return self._config_sub_data("highpass", OptionSeriesArcdiagramSonificationContexttracksMappingHighpass)

    @property
    def lowpass(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingLowpass':
        """Mapping options for the lowpass filter. """
        return self._config_sub_data("lowpass", OptionSeriesArcdiagramSonificationContexttracksMappingLowpass)

    @property
    def noteDuration(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingNoteduration':
        """Note duration determines for how long a note plays, in milliseconds. """
        return self._config_sub_data("noteDuration", OptionSeriesArcdiagramSonificationContexttracksMappingNoteduration)

    @property
    def pan(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingPan':
        """Pan refers to the stereo panning position of the sound. """
        return self._config_sub_data("pan", OptionSeriesArcdiagramSonificationContexttracksMappingPan)

    @property
    def pitch(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingPitch':
        """Musical pitch refers to how high or low notes are played. """
        return self._config_sub_data("pitch", OptionSeriesArcdiagramSonificationContexttracksMappingPitch)

    @property
    def playDelay(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingPlaydelay':
        """Milliseconds to wait before playing, comes in addition to the time determined by the <code>time</code> mapping. """
        return self._config_sub_data("playDelay", OptionSeriesArcdiagramSonificationContexttracksMappingPlaydelay)

    @property
    def rate(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingRate':
        """Rate mapping for speech tracks. """
        return self._config_sub_data("rate", OptionSeriesArcdiagramSonificationContexttracksMappingRate)

    @property
    def text(self):
        """Text mapping for speech tracks.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @text.setter
    def text(self, text: str): self._config(text, js_type=False)

    @property
    def time(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingTime':
        """Time mapping determines what time each point plays. """
        return self._config_sub_data("time", OptionSeriesArcdiagramSonificationContexttracksMappingTime)

    @property
    def tremolo(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingTremolo':
        """Mapping options for tremolo effects. """
        return self._config_sub_data("tremolo", OptionSeriesArcdiagramSonificationContexttracksMappingTremolo)

    @property
    def volume(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingVolume':
        """The volume of notes, from 0 to 1. """
        return self._config_sub_data("volume", OptionSeriesArcdiagramSonificationContexttracksMappingVolume)

        
class OptionSeriesArcdiagramSonificationContexttracks(Options):

    @property
    def activeWhen(self) -> 'OptionSeriesArcdiagramSonificationContexttracksActivewhen':
        """Define a condition for when a track should be active and not. """
        return self._config_sub_data("activeWhen", OptionSeriesArcdiagramSonificationContexttracksActivewhen)

    @property
    def instrument(self):
        """Instrument to use for playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("piano")

    @instrument.setter
    def instrument(self, text: str): self._config(text, js_type=False)

    @property
    def mapping(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMapping':
        """Mapping options for the audio parameters. """
        return self._config_sub_data("mapping", OptionSeriesArcdiagramSonificationContexttracksMapping)

    @property
    def midiName(self):
        """Name to use for a track when exporting to MIDI.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @midiName.setter
    def midiName(self, text: str): self._config(text, js_type=False)

    @property
    def pointGrouping(self) -> 'OptionSeriesArcdiagramSonificationContexttracksPointgrouping':
        """Options for point grouping, specifically for instrument tracks. """
        return self._config_sub_data("pointGrouping", OptionSeriesArcdiagramSonificationContexttracksPointgrouping)

    @property
    def roundToMusicalNotes(self):
        """Round pitch mapping to musical notes.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @roundToMusicalNotes.setter
    def roundToMusicalNotes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showPlayMarker(self):
        """Show play marker (tooltip and/or crosshair) for a track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(True)

    @showPlayMarker.setter
    def showPlayMarker(self, flag: bool): self._config(flag, js_type=False)

    @property
    def timeInterval(self):
        """Set a context track to play periodically every <code>timeInterval</code> milliseconds while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @timeInterval.setter
    def timeInterval(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """Type of track.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("instrument")

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def valueInterval(self):
        """Set a context track to play periodically every <code>valueInterval</code> units of a data property <code>valueProp</code> while the sonification is playing.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @valueInterval.setter
    def valueInterval(self, num: float): self._config(num, js_type=False)

    @property
    def valueMapFunction(self):
        """How to map context events to time when using the <code>valueInterval</code> option.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get("linear")

    @valueMapFunction.setter
    def valueMapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def valueProp(self):
        """The point property to play context for when using <code>valueInterval</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get('"x"')

    @valueProp.setter
    def valueProp(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingHighpassResonance(Options):

    @property
    def mapFunction(self):
        """How to perform the mapping.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapFunction.setter
    def mapFunction(self, value: Any): self._config(value, js_type=False)

    @property
    def mapTo(self):
        """A point property to map the mapping parameter to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @mapTo.setter
    def mapTo(self, text: str): self._config(text, js_type=False)

    @property
    def max(self):
        """The maximum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @max.setter
    def max(self, num: float): self._config(num, js_type=False)

    @property
    def min(self):
        """The minimum value for the audio parameter.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @min.setter
    def min(self, num: float): self._config(num, js_type=False)

    @property
    def within(self):
        """What data values to map the parameter within.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/Sonification/Options.ts
        """
        return self._config_get(None)

    @within.setter
    def within(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramSonificationContexttracksMappingHighpass(Options):

    @property
    def frequency(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingHighpassFrequency':
        """Map to filter frequency in Hertz from 1 to 20,000Hz. """
        return self._config_sub_data("frequency", OptionSeriesArcdiagramSonificationContexttracksMappingHighpassFrequency)

    @property
    def resonance(self) -> 'OptionSeriesArcdiagramSonificationContexttracksMappingHighpassResonance':
        """Map to filter resonance in dB. """
        return self._config_sub_data("resonance", OptionSeriesArcdiagramSonificationContexttracksMappingHighpassResonance)

        
class OptionSeriesArcdiagramPointEvents(Options):

    @property
    def click(self):
        """Fires when a point is clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @click.setter
    def click(self, value: Any): self._config(value, js_type=False)

    @property
    def drag(self):
        """Callback that fires while dragging a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drag.setter
    def drag(self, value: Any): self._config(value, js_type=False)

    @property
    def dragStart(self):
        """Callback that fires when starting to drag a point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @dragStart.setter
    def dragStart(self, value: Any): self._config(value, js_type=False)

    @property
    def drop(self):
        """Callback that fires when the point is dropped.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/DraggablePoints/DragDropDefaults.ts
        """
        return self._config_get(None)

    @drop.setter
    def drop(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOut(self):
        """Fires when the mouse leaves the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOut.setter
    def mouseOut(self, value: Any): self._config(value, js_type=False)

    @property
    def mouseOver(self):
        """Fires when the mouse enters the area close to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @mouseOver.setter
    def mouseOver(self, value: Any): self._config(value, js_type=False)

    @property
    def remove(self):
        """Fires when the point is removed using the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @remove.setter
    def remove(self, value: Any): self._config(value, js_type=False)

    @property
    def select(self):
        """Fires when the point is selected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @select.setter
    def select(self, value: Any): self._config(value, js_type=False)

    @property
    def unselect(self):
        """Fires when the point is unselected either programmatically or following a click on the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @unselect.setter
    def unselect(self, value: Any): self._config(value, js_type=False)

    @property
    def update(self):
        """Fires when the point is updated programmatically through the <code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @update.setter
    def update(self, value: Any): self._config(value, js_type=False)

        
class OptionSeriesArcdiagramPoint(Options):

    @property
    def events(self) -> 'OptionSeriesArcdiagramPointEvents':
        """Events for each single point. """
        return self._config_sub_data("events", OptionSeriesArcdiagramPointEvents)

        
class OptionSeriesArcdiagramOnpointPosition(Options):

    @property
    def offsetX(self):
        """Series center offset from the original x position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetX.setter
    def offsetX(self, num: float): self._config(num, js_type=False)

    @property
    def offsetY(self):
        """Series center offset from the original y position.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @offsetY.setter
    def offsetY(self, num: float): self._config(num, js_type=False)

    @property
    def x(self):
        """X position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """Y position of the series center.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramOnpointConnectoroptions(Options):

    @property
    def dashstyle(self):
        """A name for the dash style to use for the connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @dashstyle.setter
    def dashstyle(self, text: str): self._config(text, js_type=False)

    @property
    def stroke(self):
        """Color of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @stroke.setter
    def stroke(self, text: str): self._config(text, js_type=False)

    @property
    def width(self):
        """Pixel width of the connector line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(1)

    @width.setter
    def width(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramNodesDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramNodesDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramOnpoint(Options):

    @property
    def connectorOptions(self) -> 'OptionSeriesArcdiagramOnpointConnectoroptions':
        """Options for the connector in the <em>Series on point</em> feature. """
        return self._config_sub_data("connectorOptions", OptionSeriesArcdiagramOnpointConnectoroptions)

    @property
    def id(self):
        """The <code>id</code> of the point that we connect the series to.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/SeriesOnPointComposition.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def position(self) -> 'OptionSeriesArcdiagramOnpointPosition':
        """Options allowing to set a position and an offset of the series in the <em>Series on point</em> feature. """
        return self._config_sub_data("position", OptionSeriesArcdiagramOnpointPosition)

        
class OptionSeriesArcdiagramNodes(Options):

    @property
    def color(self):
        """The color of the auto generated node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorIndex(self):
        """The color index of the auto generated node, especially for use in styled mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesArcdiagramNodesDatalabels':
        """Individual data label for each node. """
        return self._config_sub_data("dataLabels", OptionSeriesArcdiagramNodesDatalabels)

    @property
    def id(self):
        """The id of the auto-generated node, refering to the <code>from</code> or <code>to</code> setting of the link.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def name(self):
        """The name to display for the node in data labels and tooltips.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def offset(self):
        """This option is deprecated, use <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @offset.setter
    def offset(self, num: float): self._config(num, js_type=False)

    @property
    def offsetHorizontal(self):
        """The horizontal offset of a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @offsetHorizontal.setter
    def offsetHorizontal(self, num: float): self._config(num, js_type=False)

    @property
    def offsetVertical(self):
        """The vertical offset of a node.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @offsetVertical.setter
    def offsetVertical(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramNodesDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramNodesDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesArcdiagramNodesDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramNodesDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesArcdiagramNodesDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesArcdiagramNodesDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesArcdiagramNodesDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesArcdiagramNodesDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramMarkerStatesSelect(Options):

    @property
    def enabled(self):
        """Enable or disable visible feedback for selection.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#000000")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramMarkerStatesHoverAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramMarkerStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramMarkerStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesArcdiagramMarkerStatesHoverAnimation':
        """Animation when hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramMarkerStatesHoverAnimation)

    @property
    def enabled(self):
        """Enable or disable the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def fillColor(self):
        """The fill color of the marker in hover state.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def lineWidthPlus(self):
        """The additional line width for a hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1)

    @lineWidthPlus.setter
    def lineWidthPlus(self, num: float): self._config(num, js_type=False)

    @property
    def radius(self):
        """The radius of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @radius.setter
    def radius(self, num: float): self._config(num, js_type=False)

    @property
    def radiusPlus(self):
        """The number of pixels to increase the radius of the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @radiusPlus.setter
    def radiusPlus(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramMarkerStates(Options):

    @property
    def hover(self) -> 'OptionSeriesArcdiagramMarkerStatesHover':
        """The hover state for a single point marker. """
        return self._config_sub_data("hover", OptionSeriesArcdiagramMarkerStatesHover)

    @property
    def normal(self) -> 'OptionSeriesArcdiagramMarkerStatesNormal':
        """The normal state of a single point marker. """
        return self._config_sub_data("normal", OptionSeriesArcdiagramMarkerStatesNormal)

    @property
    def select(self) -> 'OptionSeriesArcdiagramMarkerStatesSelect':
        """The appearance of the point marker when selected. """
        return self._config_sub_data("select", OptionSeriesArcdiagramMarkerStatesSelect)

        
class OptionSeriesArcdiagramMarker(Options):

    @property
    def fillColor(self):
        """The fill color of the point marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @fillColor.setter
    def fillColor(self, text: str): self._config(text, js_type=False)

    @property
    def fillOpacity(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(1)

    @fillOpacity.setter
    def fillOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def lineColor(self):
        """The color of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @lineColor.setter
    def lineColor(self, text: str): self._config(text, js_type=False)

    @property
    def lineWidth(self):
        """The width of the point marker&#39;s outline.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(0)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesArcdiagramMarkerStates':
        """States for a single point marker. """
        return self._config_sub_data("states", OptionSeriesArcdiagramMarkerStates)

    @property
    def symbol(self):
        """A predefined shape or symbol for the marker.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get("circle")

    @symbol.setter
    def symbol(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramLevelsStatesSelectAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramLevelsStatesSelect(Options):

    @property
    def animation(self) -> 'OptionSeriesArcdiagramLevelsStatesSelectAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramLevelsStatesSelectAnimation)

    @property
    def borderColor(self):
        """A specific border color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#000000")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """A specific color for the selected point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#cccccc")

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramLevelsStatesNormal(Options):

    @property
    def animation(self):
        """Animation when returning to normal state after hovering.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramLevelsStatesHoverAnimation(Options):

    @property
    def duration(self):
        """The duration of the hover animation in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramLevelsStatesInactiveAnimation(Options):

    @property
    def duration(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(150)

    @duration.setter
    def duration(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramLevelsStatesHover(Options):

    @property
    def animation(self) -> 'OptionSeriesArcdiagramLevelsStatesHoverAnimation':
        """Animation setting for hovering the graph in line-type series. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramLevelsStatesHoverAnimation)

    @property
    def borderColor(self):
        """A specific border color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def brightness(self):
        """How much to brighten the point on interaction.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(0.1)

    @brightness.setter
    def brightness(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """A specific color for the hovered point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable separate styles for the hovered series to visualize that the user hovers either the series itself or the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram in hover mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramLevelsStatesInactive(Options):

    @property
    def animation(self) -> 'OptionSeriesArcdiagramLevelsStatesInactiveAnimation':
        """Animation when not hovering over the marker. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramLevelsStatesInactiveAnimation)

    @property
    def enabled(self):
        """Enable or disable the inactive state for a series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def opacity(self):
        """Opacity of the nodes in the sankey diagram in inactive mode.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramLevelsDatalabelsAnimation(Options):

    @property
    def defer(self):
        """The animation delay time in milliseconds.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @defer.setter
    def defer(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramLevelsDatalabelsFilter(Options):

    @property
    def operator(self):
        """The operator to compare by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @operator.setter
    def operator(self, value: Any): self._config(value, js_type=False)

    @property
    def property(self):
        """The point property to filter by.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @property.setter
    def property(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramLevelsStates(Options):

    @property
    def hover(self) -> 'OptionSeriesArcdiagramLevelsStatesHover':
        """Options for the hovered point. """
        return self._config_sub_data("hover", OptionSeriesArcdiagramLevelsStatesHover)

    @property
    def inactive(self) -> 'OptionSeriesArcdiagramLevelsStatesInactive':
        """The opposite state of a hover for a single point node/link. """
        return self._config_sub_data("inactive", OptionSeriesArcdiagramLevelsStatesInactive)

    @property
    def normal(self) -> 'OptionSeriesArcdiagramLevelsStatesNormal':
        """The normal state of a series, or for point items in column, pie and similar series. """
        return self._config_sub_data("normal", OptionSeriesArcdiagramLevelsStatesNormal)

    @property
    def select(self) -> 'OptionSeriesArcdiagramLevelsStatesSelect':
        """Options for the selected point. """
        return self._config_sub_data("select", OptionSeriesArcdiagramLevelsStatesSelect)

        
class OptionSeriesArcdiagramLevels(Options):

    @property
    def borderColor(self):
        """Can set <code>borderColor</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """Can set <code>borderWidth</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def color(self):
        """Can set <code>color</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """Can set <code>colorByPoint</code> on all nodes which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def dataLabels(self) -> 'OptionSeriesArcdiagramLevelsDatalabels':
        """Can set <code>dataLabels</code> on all points which lay on the same level. """
        return self._config_sub_data("dataLabels", OptionSeriesArcdiagramLevelsDatalabels)

    @property
    def level(self):
        """Decides which level takes effect from the options set in the levels object.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @level.setter
    def level(self, num: float): self._config(num, js_type=False)

    @property
    def linkOpacity(self):
        """Can set <code>linkOpacity</code> on all points which lay on the same level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def states(self) -> 'OptionSeriesArcdiagramLevelsStates':
        """Can set <code>states</code> on all nodes and points which lay on the same level. """
        return self._config_sub_data("states", OptionSeriesArcdiagramLevelsStates)

        
class OptionSeriesArcdiagramLevelsDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramLevelsDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesArcdiagramLevelsDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramLevelsDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesArcdiagramLevelsDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesArcdiagramLevelsDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesArcdiagramLevelsDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesArcdiagramLevelsDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramLabelStyle(Options):

    @property
    def fontSize(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("0.8em")

    @fontSize.setter
    def fontSize(self, num: float): self._config(num, js_type=False)

    @property
    def fontWeight(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("bold")

    @fontWeight.setter
    def fontWeight(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramLabel(Options):

    @property
    def boxesToAvoid(self):
        """An array of boxes to avoid when laying out the labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @boxesToAvoid.setter
    def boxesToAvoid(self, value: Any): self._config(value, js_type=False)

    @property
    def connectorAllowed(self):
        """Allow labels to be placed distant to the graph if necessary, and draw a connector line to the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @connectorAllowed.setter
    def connectorAllowed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def connectorNeighbourDistance(self):
        """If the label is closer than this to a neighbour graph, draw a connector.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(24)

    @connectorNeighbourDistance.setter
    def connectorNeighbourDistance(self, num: float): self._config(num, js_type=False)

    @property
    def enabled(self):
        """Enable the series label per series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def format(self):
        """A format string for the label, with support for a subset of HTML.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback function to format each of the series&#39; labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get("undefined")

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def maxFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @maxFontSize.setter
    def maxFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def minFontSize(self):
        """For area-like series, allow the font size to vary so that small areas get a smaller font size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @minFontSize.setter
    def minFontSize(self, num: float): self._config(num, js_type=False)

    @property
    def onArea(self):
        """Draw the label on the area of an area series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(None)

    @onArea.setter
    def onArea(self, flag: bool): self._config(flag, js_type=False)

    @property
    def style(self) -> 'OptionSeriesArcdiagramLabelStyle':
        """Styles for the series label. """
        return self._config_sub_data("style", OptionSeriesArcdiagramLabelStyle)

    @property
    def useHTML(self):
        """Whether to use HTML to render the series label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/SeriesLabel/SeriesLabelDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagram(Options):

    @property
    def accessibility(self) -> 'OptionSeriesArcdiagramAccessibility':
        """Accessibility options for a series. """
        return self._config_sub_data("accessibility", OptionSeriesArcdiagramAccessibility)

    @property
    def allowPointSelect(self):
        """Allow this series&#39; points to be selected by clicking on the graphic (columns, point markers, pie slices, map areas etc).

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowPointSelect.setter
    def allowPointSelect(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self):
        """Enable or disable the initial animation when a series is displayed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @animation.setter
    def animation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animationLimit(self):
        """For some series, there is a limit that shuts down animation by default when the total number of points in the chart is too high.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @animationLimit.setter
    def animationLimit(self, num: float): self._config(num, js_type=False)

    @property
    def borderColor(self):
        """The color of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("#ffffff")

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderWidth(self):
        """The width of the border surrounding each column or bar.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def centeredLinks(self):
        """The option to center links rather than position them one after another.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(False)

    @centeredLinks.setter
    def centeredLinks(self, flag: bool): self._config(flag, js_type=False)

    @property
    def className(self):
        """An additional class name to apply to the series&#39; graphical elements.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def clip(self):
        """Disable this option to allow series rendering in the whole plotting area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @clip.setter
    def clip(self, flag: bool): self._config(flag, js_type=False)

    @property
    def color(self):
        """The main color of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def colorByPoint(self):
        """When using automatic point colors pulled from the global <a href="colors">colors</a> or series-specific <a href="series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @colorByPoint.setter
    def colorByPoint(self, flag: bool): self._config(flag, js_type=False)

    @property
    def colorIndex(self):
        """Styled mode only.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @colorIndex.setter
    def colorIndex(self, num: float): self._config(num, js_type=False)

    @property
    def colors(self):
        """A series specific or series type specific color set to apply instead of the global <a href="#colors">colors</a> when <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(None)

    @colors.setter
    def colors(self, value: Any): self._config(value, js_type=False)

    @property
    def crisp(self):
        """When true, each point or column edge is rounded to its nearest pixel in order to render sharp on screen.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @crisp.setter
    def crisp(self, flag: bool): self._config(flag, js_type=False)

    @property
    def cropThreshold(self):
        """When the series contains less points than the crop threshold, all points are drawn, even if the points fall outside the visible plot area at the current zoom.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(300)

    @cropThreshold.setter
    def cropThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def cursor(self):
        """You can set the cursor to &quot;pointer&quot; if you have click events attached to the series, to signal to the user that the points and lines can be clicked.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @cursor.setter
    def cursor(self, text: str): self._config(text, js_type=False)

    @property
    def custom(self):
        """A reserved subspace to store options and values for customized functionality.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @custom.setter
    def custom(self, value: Any): self._config(value, js_type=False)

    @property
    def dashStyle(self):
        """Name of the dash style to use for the graph, or for some series types the outline of each shape.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("Solid")

    @dashStyle.setter
    def dashStyle(self, text: str): self._config(text, js_type=False)

    @property
    def data(self) -> 'OptionSeriesArcdiagramData':
        """An array of data points for the series. """
        return self._config_sub_data("data", OptionSeriesArcdiagramData)

    @property
    def dataLabels(self) -> 'OptionSeriesArcdiagramDatalabels':
        """Options for the data labels appearing on top of the nodes and links. """
        return self._config_sub_data("dataLabels", OptionSeriesArcdiagramDatalabels)

    @property
    def description(self):
        """A description of the series to add to the screen reader information about the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def enableMouseTracking(self):
        """Enable or disable the mouse tracking for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @enableMouseTracking.setter
    def enableMouseTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def equalNodes(self):
        """Whether nodes with different values should have the same size.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(False)

    @equalNodes.setter
    def equalNodes(self, flag: bool): self._config(flag, js_type=False)

    @property
    def events(self) -> 'OptionSeriesArcdiagramEvents':
        """General event handlers for the series items. """
        return self._config_sub_data("events", OptionSeriesArcdiagramEvents)

    @property
    def findNearestPointBy(self):
        """Determines whether the series should look for the nearest point in both dimensions or just the x-dimension when hovering the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("x")

    @findNearestPointBy.setter
    def findNearestPointBy(self, text: str): self._config(text, js_type=False)

    @property
    def id(self):
        """An id for the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @id.setter
    def id(self, text: str): self._config(text, js_type=False)

    @property
    def inactiveOtherPoints(self):
        """Highlight only the hovered point and fade the remaining points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inactiveOtherPoints.setter
    def inactiveOtherPoints(self, flag: bool): self._config(flag, js_type=False)

    @property
    def includeInDataExport(self):
        """When set to <code>false</code> will prevent the series data from being included in any form of data export.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Extensions/ExportData/ExportDataDefaults.ts
        """
        return self._config_get(None)

    @includeInDataExport.setter
    def includeInDataExport(self, flag: bool): self._config(flag, js_type=False)

    @property
    def index(self):
        """The index of the series in the chart, affecting the internal index in the <code>chart.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @index.setter
    def index(self, num: float): self._config(num, js_type=False)

    @property
    def keys(self):
        """An array specifying which option maps to which key in the data point array.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @keys.setter
    def keys(self, value: Any): self._config(value, js_type=False)

    @property
    def label(self) -> 'OptionSeriesArcdiagramLabel':
        """Series labels are placed as close to the series as possible in a natural way, seeking to avoid other series. """
        return self._config_sub_data("label", OptionSeriesArcdiagramLabel)

    @property
    def legendIndex(self):
        """The sequential index of the series in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @legendIndex.setter
    def legendIndex(self, num: float): self._config(num, js_type=False)

    @property
    def legendSymbol(self):
        """What type of legend symbol to render for this series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Line/LineSeries.ts
        """
        return self._config_get("rectangle")

    @legendSymbol.setter
    def legendSymbol(self, text: str): self._config(text, js_type=False)

    @property
    def levels(self) -> 'OptionSeriesArcdiagramLevels':
        """Set options on specific levels. """
        return self._config_sub_data("levels", OptionSeriesArcdiagramLevels)

    @property
    def linecap(self):
        """The line cap used for line ends and line joins on the graph.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(round)

    @linecap.setter
    def linecap(self, value: Any): self._config(value, js_type=False)

    @property
    def lineWidth(self):
        """Pixel width of the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(2)

    @lineWidth.setter
    def lineWidth(self, num: float): self._config(num, js_type=False)

    @property
    def linkColorMode(self):
        """Determines color mode for sankey links.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("from")

    @linkColorMode.setter
    def linkColorMode(self, text: str): self._config(text, js_type=False)

    @property
    def linkedTo(self):
        """The <a href="#series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @linkedTo.setter
    def linkedTo(self, text: str): self._config(text, js_type=False)

    @property
    def linkOpacity(self):
        """Opacity for the links between nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0.5)

    @linkOpacity.setter
    def linkOpacity(self, num: float): self._config(num, js_type=False)

    @property
    def linkRadius(self):
        """The radius of the link arc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get("undefined")

    @linkRadius.setter
    def linkRadius(self, num: float): self._config(num, js_type=False)

    @property
    def linkWeight(self):
        """The global link weight.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get("undefined")

    @linkWeight.setter
    def linkWeight(self, num: float): self._config(num, js_type=False)

    @property
    def marker(self) -> 'OptionSeriesArcdiagramMarker':
        """Options for the point markers of line and scatter-like series. """
        return self._config_sub_data("marker", OptionSeriesArcdiagramMarker)

    @property
    def minLinkWidth(self):
        """The minimal width for a line of a sankey.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(0)

    @minLinkWidth.setter
    def minLinkWidth(self, num: float): self._config(num, js_type=False)

    @property
    def name(self):
        """The name of the series as shown in the legend, tooltip etc.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @name.setter
    def name(self, text: str): self._config(text, js_type=False)

    @property
    def negativeColor(self):
        """The color for the parts of the graph or points that are below the <a href="#plotOptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @negativeColor.setter
    def negativeColor(self, text: str): self._config(text, js_type=False)

    @property
    def nodes(self) -> 'OptionSeriesArcdiagramNodes':
        """A collection of options for the individual nodes. """
        return self._config_sub_data("nodes", OptionSeriesArcdiagramNodes)

    @property
    def nodeWidth(self):
        """The pixel width of each node in a sankey diagram or dependency wheel, or the height in case the chart is inverted.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(20)

    @nodeWidth.setter
    def nodeWidth(self, num: float): self._config(num, js_type=False)

    @property
    def offset(self):
        """The offset of an arc diagram nodes column in relation to the <code>plotArea</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get("'100%'")

    @offset.setter
    def offset(self, text: str): self._config(text, js_type=False)

    @property
    def onPoint(self) -> 'OptionSeriesArcdiagramOnpoint':
        """Options for the <em>Series on point</em> feature. """
        return self._config_sub_data("onPoint", OptionSeriesArcdiagramOnpoint)

    @property
    def opacity(self):
        """Opacity for the nodes in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(1)

    @opacity.setter
    def opacity(self, num: float): self._config(num, js_type=False)

    @property
    def point(self) -> 'OptionSeriesArcdiagramPoint':
        """Properties for each single point. """
        return self._config_sub_data("point", OptionSeriesArcdiagramPoint)

    @property
    def pointDescriptionFormat(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormat.setter
    def pointDescriptionFormat(self, value: Any): self._config(value, js_type=False)

    @property
    def pointDescriptionFormatter(self):
        """Same as <a href="#accessibility.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @pointDescriptionFormatter.setter
    def pointDescriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def reversed(self):
        """Whether the series should be placed on the other side of the <code>plotArea</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get(False)

    @reversed.setter
    def reversed(self, flag: bool): self._config(flag, js_type=False)

    @property
    def selected(self):
        """Whether to select the series initially.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @selected.setter
    def selected(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shadow(self):
        """Whether to apply a drop shadow to the graph line.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showCheckbox(self):
        """If true, a checkbox is displayed next to the legend item to allow selecting the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @showCheckbox.setter
    def showCheckbox(self, flag: bool): self._config(flag, js_type=False)

    @property
    def showInLegend(self):
        """Whether to display this particular series or series type in the legend.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @showInLegend.setter
    def showInLegend(self, flag: bool): self._config(flag, js_type=False)

    @property
    def skipKeyboardNavigation(self):
        """If set to <code>true</code>, the accessibility module will skip past the points in this series for keyboard navigation.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @skipKeyboardNavigation.setter
    def skipKeyboardNavigation(self, flag: bool): self._config(flag, js_type=False)

    @property
    def sonification(self) -> 'OptionSeriesArcdiagramSonification':
        """Sonification/audio chart options for a series. """
        return self._config_sub_data("sonification", OptionSeriesArcdiagramSonification)

    @property
    def states(self) -> 'OptionSeriesArcdiagramStates':
        """. """
        return self._config_sub_data("states", OptionSeriesArcdiagramStates)

    @property
    def stickyTracking(self):
        """Sticky tracking of mouse events.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get(False)

    @stickyTracking.setter
    def stickyTracking(self, flag: bool): self._config(flag, js_type=False)

    @property
    def threshold(self):
        """The threshold, also called zero level or base level.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @threshold.setter
    def threshold(self, num: float): self._config(num, js_type=False)

    @property
    def tooltip(self) -> 'OptionSeriesArcdiagramTooltip':
        """A configuration object for the tooltip rendering of each single series. """
        return self._config_sub_data("tooltip", OptionSeriesArcdiagramTooltip)

    @property
    def turboThreshold(self):
        """When a series contains a data array that is longer than this, only one dimensional arrays of numbers, or two dimensional arrays with x and y values are allowed.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(1000)

    @turboThreshold.setter
    def turboThreshold(self, num: float): self._config(num, js_type=False)

    @property
    def type(self):
        """The type of series, for example <code>line</code> or <code>column</code>.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @type.setter
    def type(self, text: str): self._config(text, js_type=False)

    @property
    def visible(self):
        """Set the initial visibility of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @visible.setter
    def visible(self, flag: bool): self._config(flag, js_type=False)

    @property
    def zIndex(self):
        """Define the visual z index of the series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/Series.ts
        """
        return self._config_get(None)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

    @property
    def zoneAxis(self):
        """Defines the Axis on which the zones are applied.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("y")

    @zoneAxis.setter
    def zoneAxis(self, text: str): self._config(text, js_type=False)

    @property
    def zones(self) -> 'OptionSeriesArcdiagramZones':
        """An array defining zones within a series. """
        return self._config_sub_data("zones", OptionSeriesArcdiagramZones)

        
class OptionSeriesArcdiagramDatalabelsTextpath(Options):

    @property
    def attributes(self):
        """Presentation attributes for the text path.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """Enable or disable <code>textPath</code> option for link&#39;s or marker&#39;s data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramDatalabelsLinktextpath(Options):

    @property
    def attributes(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/ArcDiagram/ArcDiagramSeries.ts
        """
        return self._config_get({"startOffset":"25%"})

    @attributes.setter
    def attributes(self, value: Any): self._config(value, js_type=False)

    @property
    def enabled(self):
        """.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Networkgraph/NetworkgraphSeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramDatalabels(Options):

    @property
    def align(self):
        """The alignment of the data label compared to the point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @align.setter
    def align(self, text: str): self._config(text, js_type=False)

    @property
    def allowOverlap(self):
        """Whether to allow data labels to overlap.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @allowOverlap.setter
    def allowOverlap(self, flag: bool): self._config(flag, js_type=False)

    @property
    def animation(self) -> 'OptionSeriesArcdiagramDatalabelsAnimation':
        """Enable or disable the initial animation when a series is displayed for the <code>dataLabels</code>. """
        return self._config_sub_data("animation", OptionSeriesArcdiagramDatalabelsAnimation)

    @property
    def backgroundColor(self):
        """The background color or gradient for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("none")

    @backgroundColor.setter
    def backgroundColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderColor(self):
        """The border color for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @borderColor.setter
    def borderColor(self, text: str): self._config(text, js_type=False)

    @property
    def borderRadius(self):
        """The border radius in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderRadius.setter
    def borderRadius(self, num: float): self._config(num, js_type=False)

    @property
    def borderWidth(self):
        """The border width in pixels for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @borderWidth.setter
    def borderWidth(self, num: float): self._config(num, js_type=False)

    @property
    def className(self):
        """A class name for the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @className.setter
    def className(self, text: str): self._config(text, js_type=False)

    @property
    def color(self):
        """This options is deprecated.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @color.setter
    def color(self, text: str): self._config(text, js_type=False)

    @property
    def crop(self):
        """Whether to hide data labels that are outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(False)

    @crop.setter
    def crop(self, flag: bool): self._config(flag, js_type=False)

    @property
    def defer(self):
        """Whether to defer displaying the data labels until the initial series animation has finished.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(True)

    @defer.setter
    def defer(self, flag: bool): self._config(flag, js_type=False)

    @property
    def enabled(self):
        """Enable or disable the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def filter(self) -> 'OptionSeriesArcdiagramDatalabelsFilter':
        """A declarative filter to control of which data labels to display. """
        return self._config_sub_data("filter", OptionSeriesArcdiagramDatalabelsFilter)

    @property
    def format(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @format.setter
    def format(self, text: str): self._config(text, js_type=False)

    @property
    def formatter(self):
        """Callback JavaScript function to format the data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @formatter.setter
    def formatter(self, value: Any): self._config(value, js_type=False)

    @property
    def inside(self):
        """For points with an extent, like columns or map areas, whether to align the data label inside the box or to the actual value point.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(True)

    @inside.setter
    def inside(self, flag: bool): self._config(flag, js_type=False)

    @property
    def linkTextPath(self) -> 'OptionSeriesArcdiagramDatalabelsLinktextpath':
        """Options for a <em>link</em> label text which should follow link connection. """
        return self._config_sub_data("linkTextPath", OptionSeriesArcdiagramDatalabelsLinktextpath)

    @property
    def nodeFormat(self):
        """The <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get("undefined")

    @nodeFormat.setter
    def nodeFormat(self, text: str): self._config(text, js_type=False)

    @property
    def nodeFormatter(self):
        """Callback to format data labels for <em>nodes</em> in the sankey diagram.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Sankey/SankeySeriesDefaults.ts
        """
        return self._config_get(None)

    @nodeFormatter.setter
    def nodeFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def nullFormat(self):
        """Format for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormat.setter
    def nullFormat(self, flag: bool): self._config(flag, js_type=False)

    @property
    def nullFormatter(self):
        """Callback JavaScript function that defines formatting for points with the value of null.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @nullFormatter.setter
    def nullFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def overflow(self):
        """How to handle data labels that flow outside the plot area.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("justify")

    @overflow.setter
    def overflow(self, text: str): self._config(text, js_type=False)

    @property
    def padding(self):
        """When either the <code>borderWidth</code> or the <code>backgroundColor</code> is set, this is the padding within the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(5)

    @padding.setter
    def padding(self, num: float): self._config(num, js_type=False)

    @property
    def position(self):
        """Aligns data labels relative to points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("center")

    @position.setter
    def position(self, text: str): self._config(text, js_type=False)

    @property
    def rotation(self):
        """Text rotation in degrees.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @rotation.setter
    def rotation(self, num: float): self._config(num, js_type=False)

    @property
    def shadow(self):
        """The shadow of the box.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @shadow.setter
    def shadow(self, flag: bool): self._config(flag, js_type=False)

    @property
    def shape(self):
        """The name of a symbol to use for the border around the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get("square")

    @shape.setter
    def shape(self, text: str): self._config(text, js_type=False)

    @property
    def style(self):
        """Styles for the label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(None)

    @style.setter
    def style(self, value: Any): self._config(value, js_type=False)

    @property
    def textPath(self) -> 'OptionSeriesArcdiagramDatalabelsTextpath':
        """Options for a label text which should follow marker&#39;s shape. """
        return self._config_sub_data("textPath", OptionSeriesArcdiagramDatalabelsTextpath)

    @property
    def useHTML(self):
        """Whether to <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(False)

    @useHTML.setter
    def useHTML(self, flag: bool): self._config(flag, js_type=False)

    @property
    def verticalAlign(self):
        """The vertical alignment of a data label.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @verticalAlign.setter
    def verticalAlign(self, text: str): self._config(text, js_type=False)

    @property
    def x(self):
        """The x position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(0)

    @x.setter
    def x(self, num: float): self._config(num, js_type=False)

    @property
    def y(self):
        """The y position offset of the label relative to the point in pixels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Series/Column/ColumnSeriesDefaults.ts
        """
        return self._config_get("undefined")

    @y.setter
    def y(self, num: float): self._config(num, js_type=False)

    @property
    def zIndex(self):
        """The z index of the data labels.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Core/Series/SeriesDefaults.ts
        """
        return self._config_get(6)

    @zIndex.setter
    def zIndex(self, num: float): self._config(num, js_type=False)

        
class OptionSeriesArcdiagramAccessibilityPoint(Options):

    @property
    def dateFormat(self):
        """Date format to use for points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormat.setter
    def dateFormat(self, text: str): self._config(text, js_type=False)

    @property
    def dateFormatter(self):
        """Formatter function to determine the date/time format used with points on datetime axes when describing them to screen reader users.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @dateFormatter.setter
    def dateFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def describeNull(self):
        """Whether or not to describe points with the value <code>null</code> to assistive technology, such as screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(True)

    @describeNull.setter
    def describeNull(self, flag: bool): self._config(flag, js_type=False)

    @property
    def descriptionFormat(self):
        """A <a href="https://www.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormatter(self):
        """Formatter function to use instead of the default for point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormatter.setter
    def descriptionFormatter(self, value: Any): self._config(value, js_type=False)

    @property
    def valueDecimals(self):
        """Decimals to use for the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueDecimals.setter
    def valueDecimals(self, num: float): self._config(num, js_type=False)

    @property
    def valueDescriptionFormat(self):
        """Format to use for describing the values of data points to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get("{xDescription}{separator}{value}.")

    @valueDescriptionFormat.setter
    def valueDescriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def valuePrefix(self):
        """Prefix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valuePrefix.setter
    def valuePrefix(self, text: str): self._config(text, js_type=False)

    @property
    def valueSuffix(self):
        """Suffix to add to the values in the point descriptions.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @valueSuffix.setter
    def valueSuffix(self, text: str): self._config(text, js_type=False)

        
class OptionSeriesArcdiagramAccessibilityKeyboardnavigation(Options):

    @property
    def enabled(self):
        """Enable/disable keyboard navigation support for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

        
class OptionSeriesArcdiagramAccessibility(Options):

    @property
    def description(self):
        """Provide a description of the series, announced to screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @description.setter
    def description(self, text: str): self._config(text, js_type=False)

    @property
    def descriptionFormat(self):
        """Format to use for describing the data series group to assistive technology - including screen readers.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @descriptionFormat.setter
    def descriptionFormat(self, text: str): self._config(text, js_type=False)

    @property
    def enabled(self):
        """Enable/disable accessibility functionality for a specific series.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @enabled.setter
    def enabled(self, flag: bool): self._config(flag, js_type=False)

    @property
    def exposeAsGroupOnly(self):
        """Expose only the series element to screen readers, not its points.

        :link: https://github.com/highcharts/highcharts/blob/master/ts/Accessibility/Options/A11yDefaults.ts
        """
        return self._config_get(None)

    @exposeAsGroupOnly.setter
    def exposeAsGroupOnly(self, flag: bool): self._config(flag, js_type=False)

    @property
    def keyboardNavigation(self) -> 'OptionSeriesArcdiagramAccessibilityKeyboardnavigation':
        """Keyboard navigation for a series. """
        return self._config_sub_data("keyboardNavigation", OptionSeriesArcdiagramAccessibilityKeyboardnavigation)

    @property
    def point(self) -> 'OptionSeriesArcdiagramAccessibilityPoint':
        """Point accessibility options for a series. """
        return self._config_sub_data("point", OptionSeriesArcdiagramAccessibilityPoint)
